---@type number @enum AnimControllerType
BUILDINBIT = 0


---@type number @enum AnimControllerType
SKEL_ANIMCONTROLLER = 0


---@type number @enum AnimControllerType
SKEL_BLENDSHAPE_ANIMCONTROLLER = 0


---@class XAnimMultiLayer : IXAnimatable
XAnimMultiLayer = {}


---@public 设置播放器当前时间
---@param fValue number 输入的时间
---@return void
function XAnimMultiLayer:SetCurrentTime(fValue) end


---@public 设置播放器结束时间
---@param fValue number 输入的时间
---@return void
function XAnimMultiLayer:SetEndTime(fValue) end


---@public 激活指定的Layer
---@param nIndex number 要激活的Layer索引
---@return boolean
function XAnimMultiLayer:ActivateLayer(nIndex) end


---@public 将指定的Layer置为非激活态
---@param nIndex number 要置为非激活的Layer索引
---@return boolean
function XAnimMultiLayer:DeactivateLayer(nIndex) end


---@public 激活所有Layer
---@return void
function XAnimMultiLayer:ActivateAll() end


---@public 将所有Layer置为非激活态
---@return void
function XAnimMultiLayer:DeactivateAll() end


---@public 添加一个Layer
---@param eType number 控制器类型
---@param szLayerName string Layer名称
---@param pAsset IXAnimationBase 动画资源指针
---@return number 添加成功后，返回该Layer对应的索引
function XAnimMultiLayer:AddLayer(eType, szLayerName, pAsset) end


---@public XAnimMultiLayer_AddAnimatableLayer00
---@param szLayerName string
---@param pAnimatable XAnimMultiLayer
---@return number
function XAnimMultiLayer:AddAnimatableLayer(szLayerName, pAnimatable) end


---@public 移除一个Layer
---@param nIndex number 要移除的Layer的索引
---@return void
function XAnimMultiLayer:RemoveLayer(nIndex) end


---@public 移除一个Layer
---@param szName string 要移除的Layer的名称
---@return void
function XAnimMultiLayer:RemoveLayer(szName) end


---@public 移除所有Layer
---@return void
function XAnimMultiLayer:RemoveAllLayers() end


---@public 获取到所有Layer的个数
---@return number 所有Layer的个数
function XAnimMultiLayer:GetLayerNum() end


---@public 获取到指定的Layer
---@param nIndex number 要获取的Layer的索引
---@return XAnimController
function XAnimMultiLayer:GetLayer(nIndex) end


---@public 获取到指定的Layer
---@param szName string 要获取的Layer的名称
---@return XAnimController
function XAnimMultiLayer:GetLayer(szName) end


