---@class IXAudioListener
IXAudioListener = {}


---@public 获取监听位置，用于更新
---@return XVECTOR3 位置
function IXAudioListener:GetPosition() end


---@public 设置监听位置
---@param position XVECTOR3 位置
---@return void
function IXAudioListener:SetPosition(position) end


---@public 设置监听位置
---@param x number 在X方向上的位置
---@param y number 在Y方向上的位置
---@param z number 在Z方向上的位置
---@return void
function IXAudioListener:SetPosition(x, y, z) end


---@public 获取增益
---@return number 增益
function IXAudioListener:GetGain() end


---@public 设置增益
---@param gain number 增益
---@return void
function IXAudioListener:SetGain(gain) end


---@public 获取监听速度，用于更新
---@return XVECTOR3 速度
function IXAudioListener:GetVelocity() end


---@public 设置监听速度
---@param velocity XVECTOR3 速度
---@return void
function IXAudioListener:SetVelocity(velocity) end


---@public 设置监听速度
---@param x number 在X方向上的速度
---@param y number 在Y方向上的速度
---@param z number 在Z方向上的速度
---@return void
function IXAudioListener:SetVelocity(x, y, z) end


---@public 获取监听方位，用于更新
---@return userdata 方位
function IXAudioListener:GetOrientation() end


---@public 获取监听方位前向量，用于更新
---@return XVECTOR3 方位前向量
function IXAudioListener:GetOrientationForward() end


---@public 获取监听方位上向量，用于更新
---@return XVECTOR3 方位上向量
function IXAudioListener:GetOrientationUp() end


---@public 设置监听方位
---@param forward XVECTOR3 方位前向量
---@param up XVECTOR3 方位上向量
---@return void
function IXAudioListener:SetOrientation(forward, up) end


---@public 设置监听方位
---@param forwardX number 方位前向量的x分量
---@param forwardY number 方位前向量的y分量
---@param forwardZ number 方位前向量的z分量
---@param upX number 方位上向量的x分量
---@param upY number 方位上向量的y分量
---@param upZ number 方位上向量的z分量
---@return void
function IXAudioListener:SetOrientation(forwardX, forwardY, forwardZ, upX, upY, upZ) end


