---@class IXAudioEngine
IXAudioEngine = {}


---@type number @enum XAudioEnginePlayerType
IXAudioEngine.XAudioEnginePlayerTypeUninit = 0


---@type number @enum XAudioEnginePlayerType
IXAudioEngine.XAudioEnginePlayerTypeOpenAL = 0


---@type number @enum XAudioEnginePlayerType
IXAudioEngine.XAudioEnginePlayerTypeUser = 0


---@public IXAudioEngine_SetPlayerType00
---@param type number
---@return void
function IXAudioEngine:SetPlayerType(type) end


---@public IXAudioEngine_PreloadBackgroundMusic00
---@param filePath string
---@return void
function IXAudioEngine:PreloadBackgroundMusic(filePath) end


---@public 播放背景音乐
---@param filePath string 文件路径
---@param loop boolean 是否循环播放
---@return void
function IXAudioEngine:PlayBackgroundMusic(filePath, loop) end


---@public 获取背景音乐总时长
---@return number 毫秒
function IXAudioEngine:GetBackgroundMusicDuration() end


---@public 获取背景音乐当前播放进度
---@return number 毫秒
function IXAudioEngine:GetBackgroundMusicCurrentPosition() end


---@public 设置背景音乐当前播放进度
---@param position number 毫秒
---@return void
function IXAudioEngine:SetBackgroundMusicCurrentPosition(position) end


---@public 停止播放背景音乐
---@param releaseData boolean 是否释放资源
---@return void
function IXAudioEngine:StopBackgroundMusic(releaseData) end


---@public 暂停背景音乐播放
---@return void
function IXAudioEngine:PauseBackgroundMusic() end


---@public 恢复背景音乐播放
---@return void
function IXAudioEngine:ResumeBackgroundMusic() end


---@public 回滚背景音乐
---@return void
function IXAudioEngine:RewindBackgroundMusic() end


---@public 背景音乐是否正在播放
---@return boolean
function IXAudioEngine:IsBackgroundMusicPlaying() end


---@public 获取背景音乐音量
---@return number 0～1
function IXAudioEngine:GetBackgroundMusicVolume() end


---@public 设置背景音乐播放音量
---@param volume number 0～1
---@return void
function IXAudioEngine:SetBackgroundMusicVolume(volume) end


---@public IXAudioEngine_PreloadEffect00
---@param filePath string
---@return void
function IXAudioEngine:PreloadEffect(filePath) end


---@public 获取音效音量
---@return number 0～1
function IXAudioEngine:GetEffectsVolume() end


---@public 设置音效音量   0～1
---@param volume number
---@return void
function IXAudioEngine:SetEffectsVolume(volume) end


---@public 播放音效
---@param filePath string 音效文件路径
---@param loop boolean 是否循环播放
---@param gain number 音量0～1
---@return number 音效ID
function IXAudioEngine:PlayEffect(filePath, loop, gain) end


---@public 暂停音效播放
---@param soundId number 音效ID
---@return void
function IXAudioEngine:PauseEffect(soundId) end


---@public 暂停所有音效
---@return void
function IXAudioEngine:PauseAllEffects() end


---@public 恢复音效播放
---@param soundId number 音效ID
---@return void
function IXAudioEngine:ResumeEffect(soundId) end


---@public 恢复所有音效播放
---@return void
function IXAudioEngine:ResumeAllEffects() end


---@public 停止音效播放
---@param soundId number 音效ID
---@return void
function IXAudioEngine:StopEffect(soundId) end


---@public IXAudioEngine_UnloadEffect00
---@param filePath string
---@return void
function IXAudioEngine:UnloadEffect(filePath) end


---@public 停止所有音效播放
---@return void
function IXAudioEngine:StopAllEffects() end


---@public 创建一个3D音频源
---@param szfileName string 音频资源名称
---@param loop boolean 是否循环播放
---@param volume number 音量
---@param sourceRelative boolean
---@return IXAudioSource 音频源指针，创建失败返回NULL
function IXAudioEngine:CreateAudio(szfileName, loop, volume, sourceRelative) end


---@public 删除一个3D音频源，但并不释放音频缓存，音频缓存可用于快速加载播放
---@param source IXAudioSource 音频资源
---@return void
function IXAudioEngine:RemoveAudio(source) end


---@public 设置3D音频聆听者
---@param Location XVECTOR3
---@param Up XVECTOR3
---@param Front XVECTOR3
---@return void
function IXAudioEngine:SetAudioListener(Location, Up, Front) end


---@public 获取音频聆听者
---@return IXAudioListener 音频聆听者
function IXAudioEngine:GetOrCreateAudioListener() end


---@manual xelua_XEngine_IXAudioEngine_PreloadAudio_manual
---@public IXAudioEngine_PreloadAudio_manual
---@param filePath string
---@param callback std::function<void(xbool, std::string)>
---@return boolean
function IXAudioEngine:PreloadAudio(filePath, callback) end


---@public IXAudioEngine_SetEffectMaxNum00
---@param n number
---@return void
function IXAudioEngine:SetEffectMaxNum(n) end


---@public IXAudioEngine_GetEffectMaxNum00
---@return number
function IXAudioEngine:GetEffectMaxNum() end


