---@type number @readonly 
DEFAULTFOVDEGREE = 0


---@type number @readonly 
DEFAULTZNEAR = 0


---@type number @readonly 
DEFAULTZFAR = 0


---@type number @readonly 
DEFAULTRADIO = 0


---@public XRT_RayToAABB300
---@param vStart XVECTOR3
---@param vDelta XVECTOR3
---@param vMins XVECTOR3
---@param vMaxs XVECTOR3
---@return XVECTOR3
---@return number
---@return XVECTOR3
---@return boolean
function XRT_RayToAABB3(vStart, vDelta, vMins, vMaxs) end


---@public 检测平面是否与AABB包围盒碰撞(或重叠)
---@param Plane  XCusSPlane 引擎中封装的代表平面的对象
---@param _vMins XVECTOR3 AABB包围盒“最小”点
---@param _vMaxs XVECTOR3 AABB包围盒“最大”点
---@return number -1表示AABB在平面后面，0表示平面与AABB交叉，1表示AABB在平面前面
function XRT_PlaneAABBOverlap(Plane, _vMins, _vMaxs) end


---@public 检测平面是否与球体碰撞(或重叠)
---@param Plane  XCusSPlane 引擎中封装的代表平面的对象
---@param vCenter XVECTOR3 空间中球的中心坐标
---@param fRadius number 球的半径
---@return number -1：表示球在平面的后面;0：表示球与平面交叉;1：表示球在平面的前面
function XRT_PlaneSphereOverlap(Plane, vCenter, fRadius) end


---@public 检测平面是否与球体碰撞(或重叠)
---@param vNormal XVECTOR3 空间中平面的法向量(单位化后的)
---@param fDist number 标准平面方程的常量值d(ax+by+cz+d=0)
---@param vCenter XVECTOR3 空间中球的中心坐标
---@param fRadius number 球的半径
---@return number -1：表示球在平面的后面;0：表示球与平面交叉;1：表示球在平面的前面
function XRT_PlaneSphereOverlap(vNormal, fDist, vCenter, fRadius) end


---@public 计算 v 的平方根的倒数，并返回
---@param v number 待计算的浮点数
---@return number v的平方根的倒数
function XG_InvSqrt(v) end


---@public 计算向量模的平方
---@param v XVECTOR3 用于计算的向量
---@return number 向量模的平方值
function XG_SquareMagnitude(v) end


---@public 计算向量的模
---@param v XVECTOR3 用于计算的向量
---@return number 用于计算的向量
function XG_Magnitude(v) end


---@public 计算向量 x 分量和 z 分量平方和的平方根
---@param v XVECTOR3 用于计算的向量
---@return number 向量x分量和z分量平方和的平方根
function XG_MagnitudeH(v) end


---@public XG_Vector42300
---@param v XVECTOR4
---@return XVECTOR3
function XG_Vector423(v) end


---@public 将2D向量单位化
---@param v XVECTOR2 用于单位化的向量
---@return XVECTOR2 单位化之后的向量
function XG_Normalize(v) end


---@public 将3D向量单位化
---@param v XVECTOR3 用于单位化的向量
---@return XVECTOR3 单位化之后的向量
function XG_Normalize(v) end


---@public XG_CompressDir00
---@param v XVECTOR3
---@return number
---@return number
---@return void
function XG_CompressDir(v) end


---@public 从两个字符中解压出3D向量
---@param b1 number 压缩输第一个字符
---@param b2 number 压缩输第二个字符
---@return XVECTOR3
function XG_DecompressDir(b1, b2) end


---@public 比较两个向量的各分量大小，返回每个分量取最小值组成的向量
---@param v1 XVECTOR3 用于比较的向量1
---@param v2 XVECTOR3 用于比较的向量2
---@return XVECTOR3 计算后的向量
function XG_VecMin(v1, v2) end


---@public 比较两个向量的各分量大小，返回每个分量取最大值组成的向量
---@param v1 XVECTOR3 用于比较的向量1
---@param v2 XVECTOR3 用于比较的向量2
---@return XVECTOR3 计算后的向量
function XG_VecMax(v1, v2) end


---@public 将3D向量从相机空间转到世界空间
---@param vIn XVECTOR3 1
---@param matView XMATRIX4 2
---@return XVECTOR3
function XG_ViewToWorld(vIn, matView) end


---@public 初始化一个 3 x 3 的单位矩阵并将其返回
---@return XMATRIX3 单位矩阵
function XG_IdentityMatrix3() end


---@public 构建3X3变换矩阵，并将其返回
---@param fRad number 旋转弧度
---@param vecPos XVECTOR2 位移信息
---@return XMATRIX3 构建的变换矩阵
function XG_TransformMatrix3(fRad, vecPos) end


---@public 构建3X3变换矩阵，并将其返回
---@param fRad number
---@param vecPos XVECTOR2 位移
---@param vecScale XVECTOR2 缩放
---@return XMATRIX3 构建的变换矩阵
function XG_TransformMatrix3(fRad, vecPos, vecScale) end


---@public XG_TransformMatrix302
---@param vecXDir XVECTOR2
---@param vecPos XVECTOR2
---@return XMATRIX3
function XG_TransformMatrix3(vecXDir, vecPos) end


---@public XG_TransformMatrix303
---@param vecXDir XVECTOR2
---@param vecPos XVECTOR2
---@param vecScale XVECTOR2
---@return XMATRIX3
function XG_TransformMatrix3(vecXDir, vecPos, vecScale) end


---@public 初始化一个 4 x 4 的单位矩阵并将其返回
---@return XMATRIX4 单位矩阵
function XG_IdentityMatrix() end


---@public 初始化一个 4 x 4 ，且元素全为 0 的矩阵并将其返回
---@return XMATRIX4 元素全为0的4x4矩阵
function XG_ZeroMatrix() end


---@public 根据观察点坐标、视线方向、Up向量构建视图矩阵，如果 roll 不为0 ，还需将构建的视图矩阵绕 z 轴旋转 -roll 弧度
---@param from XVECTOR3 观察点坐标，即相机的目标点
---@param dir XVECTOR3 视线方向向量
---@param vecUp XVECTOR3 UP向量
---@param roll number 绕z轴负方向的旋转角(弧度)
---@return XMATRIX4 视图矩阵
function XG_ViewMatrix(from, dir, vecUp, roll) end


---@public 根据起点位置坐标、“看向的”终点坐标、Up向量构建视图矩阵，如果 roll 不为0 ，还需将构建的视图矩阵绕 z 轴旋转 -roll 弧度
---@param from XVECTOR3 起点坐标，即相机的位置坐标
---@param to XVECTOR3 终点坐标，即相机“看向”的坐标
---@param vecUp XVECTOR3 UP向量
---@param roll number 绕z轴负方向的旋转角(弧度)
---@return XMATRIX4 视图矩阵
function XG_LookAtMatrix(from, to, vecUp, roll) end


---@public 构建变换矩阵，并将其返回
---@param vecDir XVECTOR3
---@param vecUp XVECTOR3 上方向
---@param vecPos XVECTOR3 位置坐标
---@return XMATRIX4 构建的变换矩阵
function XG_TransformMatrix(vecDir, vecUp, vecPos) end


---@public 计算绕 x 轴旋转的矩阵并返回
---@param vRad number 绕x轴旋转的弧度角
---@return XMATRIX4 绕x轴旋转后的变换矩阵
function XG_RotateX(vRad) end


---@public 计算矩阵 mat 绕 x 轴旋转后的新矩阵，并将其返回
---@param mat XMATRIX4 待旋转的原始矩阵
---@param vRad number 绕x轴旋转的弧度角
---@return XMATRIX4 矩阵绕x轴旋转后的新矩阵
function XG_RotateX(mat, vRad) end


---@public 计算绕 y 轴旋转的矩阵并返回
---@param vRad number 绕y轴旋转的弧度角
---@return XMATRIX4 绕y轴旋转后的变换矩阵
function XG_RotateY(vRad) end


---@public 计算矩阵 mat 绕 y 轴旋转后的新矩阵，并将其返回
---@param mat XMATRIX4 待旋转的原始矩阵
---@param vRad number 绕y轴旋转的弧度角
---@return XMATRIX4 mat矩阵绕y轴旋转后的新矩阵
function XG_RotateY(mat, vRad) end


---@public 计算绕 z 轴旋转的矩阵并返回
---@param vRad number 绕z轴旋转的弧度角
---@return XMATRIX4 绕z轴旋转后的变换矩阵
function XG_RotateZ(vRad) end


---@public 计算矩阵 mat 绕 z 轴旋转后的新矩阵，并将其返回
---@param mat XMATRIX4 待旋转的原始矩阵
---@param vRad number 绕z轴旋转的弧度角
---@return XMATRIX4 mat矩阵绕z轴旋转后的新矩阵
function XG_RotateZ(mat, vRad) end


---@public 计算绕指定轴（vecAxis）旋转的矩阵并返回。旋转后的矩阵不包含平移和缩放信息
---@param vecAxis XVECTOR3 表示旋转轴的向量，单位化的向量
---@param vRad number 绕指定轴旋转的弧度角
---@return XMATRIX4 绕向量vecAxis旋转vRad弧度的矩阵
function XG_RotateAxis(vecAxis, vRad) end


---@public 计算以 vecPos为参考点，绕向量 vecAxis旋转 vRad弧度的矩阵，并将其返回。旋转后的矩阵不包含平移和缩放信息
---@param vecPos XVECTOR3 参考点
---@param vecAxis XVECTOR3 表示旋转轴的向量，单位化的向量
---@param vRad number 绕指定轴旋转的弧度角
---@return XMATRIX4 以vecPos为参考点，绕向量vecAxis旋转vRad弧度的矩阵
function XG_RotateAxis(vecPos, vecAxis, vRad) end


---@public 计算欧拉角对应的旋转矩阵并返回。
---@param xRad number 绕x轴旋转的欧拉角
---@param yRad number 绕y轴旋转的欧拉角
---@param zRad number 绕z轴旋转的欧拉角
---@return XMATRIX4 绕三个轴旋转后的矩阵
function XG_RotateEuler(xRad, yRad, zRad) end


---@public 计算点 vPos 绕 x 轴旋转 fRad 弧度的坐标值
---@param vPos XVECTOR3 待旋转的原始坐标点
---@param fRad number 绕x轴旋转的弧度角
---@return XVECTOR3 绕x轴旋转fRad弧度的坐标点
function XG_RotatePosAroundX(vPos, fRad) end


---@public 计算点 vPos 绕 y 轴旋转 fRad 弧度的坐标值
---@param vPos XVECTOR3 待旋转的原始坐标点
---@param fRad number 绕y轴旋转的弧度角
---@return XVECTOR3 绕y轴旋转fRad弧度的坐标点
function XG_RotatePosAroundY(vPos, fRad) end


---@public 计算点 vPos 绕 z 轴旋转 fRad 弧度的坐标值
---@param vPos XVECTOR3 待旋转的原始坐标点
---@param fRad number 绕z轴旋转的弧度角
---@return XVECTOR3 绕z轴旋转fRad弧度的坐标点
function XG_RotatePosAroundZ(vPos, fRad) end


---@public 计算点 vPos 绕 vAxis 轴旋转 fRad 弧度的坐标值。vAxis 需要是单位化的向量
---@param vPos XVECTOR3 待旋转的原始坐标点
---@param vAxis XVECTOR3
---@param fRad number 绕vAxis轴旋转的弧度角
---@return XVECTOR3 绕vAxis轴旋转fRad弧度的坐标点
function XG_RotatePosAroundAxis(vPos, vAxis, fRad) end


---@public 计算点 vPos 绕直线旋转 fRad 弧度的坐标值。其中可以根据点vOrigin 和方向向量 vDir 确定一条直线，此处的方向向量要求是单位化的
---@param vPos XVECTOR3 待旋转的原始坐标点
---@param vOrigin XVECTOR3 空间直线上一个点的坐标
---@param vDir XVECTOR3 空间直线的方向向量(单位化)
---@param fRad number 绕直线旋转的弧度角
---@return XVECTOR3 点vPos绕直线旋转fRad弧度的坐标点
function XG_RotatePosAroundLine(vPos, vOrigin, vDir, fRad) end


---@public 计算向量 v 绕直线旋转 fRad 弧度的坐标值。其中可以根据点vOrigin 和方向向量 vDir 确定一条直线，此处的方向向量 vDir 要求是单位化的
---@param v XVECTOR3
---@param vOrigin XVECTOR3 空间直线上一个点的坐标
---@param vDir XVECTOR3 空间直线的方向向量(单位化)
---@param fRad number 绕直线旋转的弧度角
---@return XVECTOR3 向量v绕直线旋转fRad弧度的向量值
function XG_RotateVecAroundLine(v, vOrigin, vDir, fRad) end


---@public 初始化仅包含缩放信息的矩阵
---@param sx number x轴上的缩放分量
---@param sy number y轴上的缩放分量
---@param sz number z轴上的缩放分量
---@return XMATRIX4 已初始化仅包含缩放信息的变换矩阵
function XG_Scaling(sx, sy, sz) end


---@public 在矩阵 mat 的基础上进行缩放，并返回缩放后的变换矩阵
---@param mat XMATRIX4 原始变换矩阵
---@param sx number x轴上的缩放分量
---@param sy number y轴上的缩放分量
---@param sz number z轴上的缩放分量
---@return XMATRIX4 对矩阵mat缩放后的变换矩阵
function XG_Scaling(mat, sx, sy, sz) end


---@public 以matroot为根矩阵进行缩放，并返回缩放后的变换矩阵
---@param matRoot XMATRIX4 原始变换矩阵
---@param sx number x轴上的缩放分量
---@param sy number y轴上的缩放分量
---@param sz number z轴上的缩放分量
---@return XMATRIX4 以matroot为根矩阵进行缩放后的变换矩阵
function XG_ScalingRelative(matRoot, sx, sy, sz) end


---@public 构建平移矩阵并将其返回，返回的矩阵不包含旋转和缩放信息
---@param x number x轴上的平移量
---@param y number y轴上的平移量
---@param z number z轴上的平移量
---@return XMATRIX4 仅包含平移信息的变换矩阵
function XG_Translate(x, y, z) end


---@public 构建一个沿向量vAxis缩放的矩阵
---@param vAxis XVECTOR3
---@param fScale number
---@return XMATRIX4
function XG_ScaleAlongAxis(vAxis, fScale) end


---@public 计算矩阵 mat 的转置矩阵并将其返回
---@param mat XMATRIX4 原始矩阵
---@return XMATRIX4 原始矩阵的转置矩阵
function XG_Transpose(mat) end


---@public XG_Transpose01
---@param matIn XMATRIX4
---@return XMATRIX4
---@return void
function XG_Transpose(matIn) end


---@public XG_DecomposeMatrix00
---@param mat XMATRIX4
---@return XVECTOR3
---@return XQUATERNION
---@return XVECTOR3
---@return void
function XG_DecomposeMatrix(mat) end


---@public XG_DecomposeStrechedMatrixDiscardScale00
---@param mat XMATRIX4
---@return XQUATERNION
---@return XVECTOR3
---@return number
---@return void
function XG_DecomposeStrechedMatrixDiscardScale(mat) end


---@public XG_GetCubeMapDirAndUp00
---@param nFaceIndex number
---@return XVECTOR3
---@return XVECTOR3
---@return boolean
function XG_GetCubeMapDirAndUp(nFaceIndex) end


---@public XCOLORBASE格式转换为XCOLOR格式
---@param colorValue XCOLORBASE XCOLORBASE（4个xfloat32颜色分量r,g,b,a）格式颜色信息
---@return number XCOLOR(一个xuint32)格式颜色信息
function XG_ColorValueToColorRGBA(colorValue) end


---@public XCOLOR格式转换为XCOLORBASE格式
---@param colorRGBA number XCOLOR(一个xuint32)格式颜色信息
---@return XCOLORBASE XCOLORBASE（4个xfloat32颜色分量r,g,b,a）格式颜色信息
function XG_ColorRGBAToColorValue(colorRGBA) end


---@public 计算镜像矩阵
---@param p XVECTOR3
---@param n XVECTOR3 镜像平面方向
---@return XMATRIX4 镜像矩阵
function XG_MirrorMatrix(p, n) end


---@public 计算矩阵 mat 的逆矩阵并将其返回，只有平移、旋转、缩放的矩阵求逆
---@param mat XMATRIX4 原始矩阵
---@return XMATRIX4 原始矩阵的逆矩阵
function XG_InverseTM(mat) end


---@public XG_InverseTM01
---@param matIn XMATRIX4
---@return XMATRIX4
---@return void
function XG_InverseTM(matIn) end


---@public 计算矩阵 mat 的逆矩阵并将其返回
---@param mat XMATRIX4 原始矩阵
---@return XMATRIX4 原始矩阵的逆矩阵
function XG_InverseMatrix(mat) end


---@public XG_InverseMatrix01
---@param matIn XMATRIX4
---@return XMATRIX4
---@return void
function XG_InverseMatrix(matIn) end


---@public [引擎内部模块间调用接口]
---@param mat XMATRIX4
---@return XMATRIX4
function XG_InverseAffineMatrix(mat) end


---@public XG_InverseAffineMatrix01
---@param matIn XMATRIX4
---@return XMATRIX4
---@return void
function XG_InverseAffineMatrix(matIn) end


---@public 根据宽、高、远近距离构建正交投影矩阵并返回，此时投影平面的中心与屏幕的几何中心点重合
---@param fWidth number 视口的宽
---@param fHeight number 视口的高
---@param fZNear number 近裁剪平面到相机的距离
---@param fZFar number 远裁剪平面到相机的距离
---@return XMATRIX4 正交投影矩阵
function XG_OrthoMatrix(fWidth, fHeight, fZNear, fZFar) end


---@public 根据上下左右远近距离构建正交投影矩阵并返回
---@param fLeft number 视椎体左平面到相机的距离
---@param fRight number 视椎体右平面到相机的距离
---@param fBottom number 视椎体底部平面到相机的距离
---@param fTop number 视椎体顶部平面到相机的距离
---@param fZNear number 近裁剪平面到相机的距离
---@param fZFar number 远裁剪平面到相机的距离
---@return XMATRIX4 正交投影矩阵
function XG_OrthoOffCenterMatrix(fLeft, fRight, fBottom, fTop, fZNear, fZFar) end


---@public 根据宽、高、远近距离构建透视投影矩阵并返回
---@param fWidth number 视口的宽
---@param fHeight number 视口的高
---@param fZNear number 近裁剪平面到相机的距离
---@param fZFar number 远裁剪平面到相机的距离
---@return XMATRIX4 透视投影矩阵
function XG_PerspectiveMatrix(fWidth, fHeight, fZNear, fZFar) end


---@public 根据竖直方向的视角、近裁剪平面的宽高比、远近距离构建透视投影矩阵并返回
---@param fFovY number 竖直方向的视角(弧度)
---@param fAspect number 视口的宽高比
---@param fZNear number 近裁剪平面到相机的距离
---@param fZFar number 远裁剪平面到相机的距离
---@return XMATRIX4 透视投影矩阵
function XG_PerspectiveFovMatrix(fFovY, fAspect, fZNear, fZFar) end


---@public 根据上下左右远近远近距离构建透视投影矩阵并返回
---@param fLeft number 视椎体左平面到相机的距离
---@param fRight number 视椎体右平面到相机的距离
---@param fBottom number 视椎体底部平面到相机的距离
---@param fTop number 视椎体顶部平面到相机的距离
---@param fZNear number 近裁剪平面到相机的距离
---@param fZFar number 远裁剪平面到相机的距离
---@return XMATRIX4 透视投影矩阵
function XG_PerspectiveOffCenterMatrix(fLeft, fRight, fBottom, fTop, fZNear, fZFar) end


---@public 计算右手的正交矩阵
---@param fWidth number 宽度
---@param fHeight number 高度
---@param fZNear number 近裁剪
---@param fZFar number 远裁剪
---@return XMATRIX4 正交矩阵
function XG_OrthoMatrixRH(fWidth, fHeight, fZNear, fZFar) end


---@public 计算左右，上下不等值的正交矩阵
---@param fLeft number 左侧值
---@param fRight number 右侧值
---@param fBottom number 下侧值
---@param fTop number 上侧值
---@param fZNear number 近裁剪
---@param fZFar number 远裁剪
---@return XMATRIX4 正交矩阵
function XG_OrthoOffCenterMatrixRH(fLeft, fRight, fBottom, fTop, fZNear, fZFar) end


---@public 计算一个右手透视矩阵
---@param fWidth number 宽度
---@param fHeight number 高度
---@param fZNear number 近裁剪
---@param fZFar number 远裁剪
---@return XMATRIX4 透视矩阵
function XG_PerspectiveMatrixRH(fWidth, fHeight, fZNear, fZFar) end


---@public 由于fov计算一个右手透视矩阵
---@param fFovY number fov值
---@param fAspect number 宽高比
---@param fZNear number 近裁剪
---@param fZFar number 远裁剪
---@return XMATRIX4 透视矩阵
function XG_PerspectiveFovMatrixRH(fFovY, fAspect, fZNear, fZFar) end


---@public 计算一个左右，上下不对称的透视矩阵
---@param fLeft number 左侧值
---@param fRight number 右侧值
---@param fBottom number 下侧值
---@param fTop number 上侧值
---@param fZNear number 近裁剪
---@param fZFar number 远裁剪
---@return XMATRIX4 透视矩阵
function XG_PerspectiveOffCenterMatrixRH(fLeft, fRight, fBottom, fTop, fZNear, fZFar) end


---@public XG_ClearAABB00
---@param vMins XVECTOR3
---@param vMaxs XVECTOR3
---@return void
function XG_ClearAABB(vMins, vMaxs) end


---@public 用 vPoint 数据更新 AABB 包围盒的数据。例如，如果 vPoint 的 x 分量小于 AABB 包围盒 vMins的 x 分量，
---则将 AABB 包围盒 vMins 顶点的 x 分量更新为 vPoint 的 x 分量，对于 y , z 分量执行一样的操作.
---@param vMins XVECTOR3 AABB包围盒“最小”点
---@param vMaxs XVECTOR3 AABB包围盒“最大”点
---@param vPoint XVECTOR3 用于更新AABB包围盒边界点的向量
---@return void
function XG_AddVertexToAABB(vMins, vMaxs, vPoint) end


---@public 将OBB合并到AABB的最大最小值中
---@param vecMins XVECTOR3 AABB的最小值
---@param vecMaxs XVECTOR3 AABB的最大值
---@param obb  XCusOBB 输入OBB信息
---@return void
function XG_ExpandAABB(vecMins, vecMaxs, obb) end


---@public 将AABB合并到AABB的最大最小值中
---@param vecMins XVECTOR3 AABB的最小值
---@param vecMaxs XVECTOR3 AABB的最大值
---@param subAABB  XCusAABB 输入子AABB信息
---@return void
function XG_ExpandAABB(vecMins, vecMaxs, subAABB) end


---@public XG_BuildAABB00
---@param obb  XCusOBB
---@return XCusAABB
---@return void
function XG_BuildAABB(obb) end


---@public 合并另一个AABB到AABB中
---@param pAABB XCusAABB 合到的AABB
---@param subAABB  XCusAABB 被合并的子AABB
---@return void
function XG_MergeAABB(pAABB, subAABB) end


---@public 更新AABB的中心及长度信息
---@param pAABB XCusAABB AABB信息
---@return void
function XG_CompleteAABB(pAABB) end


---@public 更新OBB的轴上点信息
---@param pOBB XCusOBB OBB信息
---@return void
function XG_CompleteOBB(pOBB) end


---@public 随机生成一个水平向量
---@return XVECTOR3 水平向量
function XG_RandDirH() end


---@public XG_HSVToRGB00
---@param hsvColor XHSVCOLORBASE
---@return number
---@return void
function XG_HSVToRGB(hsvColor) end


---@public XG_RGBToHSV00
---@param rgbColor number
---@return XHSVCOLORBASE
---@return void
function XG_RGBToHSV(rgbColor) end


---@public XG_RGBToHSL00
---@param r number
---@param g number
---@param b number
---@return number
---@return number
---@return number
---@return void
function XG_RGBToHSL(r, g, b) end


---@public XG_DecompressColor00
---@param rgbColor number
---@return number
---@return number
---@return number
---@return number
---@return void
function XG_DecompressColor(rgbColor) end


---@public 计算绕 x 轴旋转的三维矩阵并返回
---@param fRad number
---@return XMATRIX3 绕x轴旋转后的三维变换矩阵
function XG_Matrix3Rotate(fRad) end


---@public 计算矩阵 mat 绕 x 轴旋转后的新矩阵，并将其返回（三维矩阵）
---@param mat XMATRIX3 待旋转的原始矩阵
---@param fRad number
---@return XMATRIX3 矩阵绕x轴旋转后的新矩阵
function XG_Matrix3Rotate(mat, fRad) end


---@public XG_Matrix3Translate00
---@param x number
---@param y number
---@return XMATRIX3
function XG_Matrix3Translate(x, y) end


---@public XG_Matrix3Translate01
---@param mat XMATRIX3
---@param x number
---@param y number
---@return XMATRIX3
function XG_Matrix3Translate(mat, x, y) end


---@public XG_VectorMatrix3x300
---@param v XVECTOR3
---@param mat XMATRIX4
---@return XVECTOR3
function XG_VectorMatrix3x3(v, mat) end


---@public XG_DistSquareToAABB00
---@param vPos XVECTOR3
---@param aabb  XCusAABB
---@return number
function XG_DistSquareToAABB(vPos, aabb) end


---@public XG_TransformAABB00
---@param aabb  XCusAABB
---@param mat XMATRIX4
---@return XCusAABB
function XG_TransformAABB(aabb, mat) end


---@public XG_RayToTriangle00
---@param vStart XVECTOR3
---@param vDelta XVECTOR3
---@param v0 XVECTOR3
---@param v1 XVECTOR3
---@param v2 XVECTOR3
---@param bTwoSides boolean
---@return XVECTOR3
---@return number
---@return boolean
function XG_RayToTriangle(vStart, vDelta, v0, v1, v2, bTwoSides) end


---@public 构建变换矩阵，并将其返回
---@param qRotation XQUATERNION
---@param vTranslation XVECTOR3
---@param vScaling XVECTOR3
---@return XMATRIX4 构建的变换矩阵
function TransformMatrix(qRotation, vTranslation, vScaling) end


---@public XG_CastRay00
---@param pViewport XViewport
---@param vecScreenPoint XVECTOR3
---@return XVECTOR3
---@return XVECTOR3
---@return void
function XG_CastRay(pViewport, vecScreenPoint) end


---@public 将向量 vec1 和 vec2 叉乘，并将结果单位化
---@param vec1 XVECTOR3 用于叉乘的第一个向量
---@param vec2 XVECTOR3 用于叉乘的第二个向量
---@return XVECTOR3 向量叉乘并单位化之后的结果向量
function XG_NormalizedCrossProduct(vec1, vec2) end


---@public 判断给定的向量是否是零向量
---@param vecIn XVECTOR3
---@return boolean 是否是零向量，是零向量返回true，否则返回false
function XG_IsZeroLength(vecIn) end


---@public XG_PointToLineDistance00
---@param vecPoint XVECTOR3
---@param vecLinePoint XVECTOR3
---@param vecLineDirection XVECTOR3
---@return number
---@return number
function XG_PointToLineDistance(vecPoint, vecLinePoint, vecLineDirection) end


---@manual xelua_XEngine_XG_LineLineDistance_manual
---@public XG_LineLineDistance_manual
---@param vecPoint0 XVECTOR3
---@param vecDir0 XVECTOR3
---@param vecPoint1 XVECTOR3
---@param vecDir1 XVECTOR3
---@return number
---@return number
function XG_LineLineDistance(vecPoint0, vecDir0, vecPoint1, vecDir1) end


---@public 计算空间中线与面的交点并返回，此处 vecLineDir 和 vecPlaneNormal 要求单位化
---@param vecLinePoint XVECTOR3 空间中的直线上的一个坐标点
---@param vecLineDir XVECTOR3 空间直线的方向向量(单位化)
---@param vecPlanePoint XVECTOR3 空间中平面上的一个坐标点
---@param vecPlaneNormal XVECTOR3 平面法向量(单位化)
---@return XVECTOR3 直线与平面的交点
function XG_LinePlaneIntersection(vecLinePoint, vecLineDir, vecPlanePoint, vecPlaneNormal) end


---@public 计算空间中线与球的交点并返回，此处 vecLineDir 要求单位化
---@param vecLinePoint XVECTOR3 空间中的直线上的一个坐标点
---@param vecLineDir XVECTOR3 空间直线的方向向量(单位化)
---@param vecSphereCenter XVECTOR3 空间中球的中心点坐标
---@param fRadius number 球的半径
---@return XVECTOR3 直线与球体的交点
function XG_LineSphereIntersection(vecLinePoint, vecLineDir, vecSphereCenter, fRadius) end


---@public 判断变量 a 和 b 是否在一定误差范围内相等(提供了两个接口，支持xfloat32和xfloat64两种类型)
---@param a number
---@param b number
---@param eps number 误差范围(xfloat32类型)
---@return boolean 表示a和b是否相等的标志
function X_Equals(a, b, eps) end


---@public 判断变量 a 和 b 是否在一定误差范围内相等(提供了两个接口，支持xfloat32和xfloat64两种类型)
---@param a number
---@param b number
---@param eps number 误差范围(xfloat64类型)
---@return boolean 表示a和b是否相等的标志
function X_Equals(a, b, eps) end


---@public 判断 x 是否是 2 的 n 次幂
---@param x number
---@return boolean 代表x是否是2的n次幂的标志
function X_IsPowerOfTwo(x) end


---@public X_CeilPowerOfTwo00
---@param x number
---@return number
function X_CeilPowerOfTwo(x) end


---@public X_FloorPowerOfTwo00
---@param x number
---@return number
function X_FloorPowerOfTwo(x) end


---@public X_Srand_Time00
---@return void
function X_Srand_Time() end


---@public X_Srand_00
---@param seed number
---@return void
function X_Srand_(seed) end


---@public X_Rand_00
---@return number
function X_Rand_() end


---@public X_Random_0_to_100
---@return number
function X_Random_0_to_1() end


---@public X_RandInt00
---@param lower number
---@param upper number
---@return number
function X_RandInt(lower, upper) end


---@public X_RandFloat00
---@param lower number
---@param upper number
---@return number
function X_RandFloat(lower, upper) end


---@public [引擎内部模块间调用接口]
---@param x number
---@param z number
---@return number
function XG_CompressDirH(x, z) end


---@public [引擎内部模块间调用接口]
---@param byDir number
---@return XVECTOR3
function XG_DecompressDirH(byDir) end


---@type number @readonly 
XENGINE_DEGREE = 0


---@type number @readonly 
XENGINE_PI = 0


---@type number @readonly 
XENGINE_2PI = 0


---@type XConsoleVariable
g_CVarRenderSceneToTexture = {}


---@type XConsoleVariable
g_CVarRTTWidth = {}


---@type XConsoleVariable
g_CVarRTTHeight = {}


---@type XConsoleVariable
g_CVarEnableSSAA = {}


---@type XConsoleVariable
g_CVarEnableBicubicFilter = {}


---@type XConsoleVariable
g_CVarSSAAScale = {}


---@type XConsoleVariable
g_CVarEnablePostProcess = {}


---@type XConsoleVariable
g_CVarEnableFXAA = {}


---@type XConsoleVariable
g_CVarFXAAPreset = {}


---@type XConsoleVariable
g_CVarEnableBloom = {}


---@type XConsoleVariable
g_CVarBloomColorThreshold = {}


---@type XConsoleVariable
g_CVarBloomSamplerScale = {}


---@type XConsoleVariable
g_CVarEnableBlur = {}


---@type XConsoleVariable
g_CVarBlurIteration = {}


---@type XConsoleVariable
g_CVarEnableFog = {}


---@type XConsoleVariable
g_CVarFogStart = {}


---@type XConsoleVariable
g_CVarFogEnd = {}


---@type XConsoleVariable
g_CVarFogDensity = {}


---@type XConsoleVariable
g_CVarFogColorUpper = {}


---@type XConsoleVariable
g_CVarFogColorLower = {}


---@type XConsoleVariable
g_CVarFogGradientAngleUpper = {}


---@type XConsoleVariable
g_CVarFogGradientAngleLower = {}


---@type XConsoleVariable
g_CVarFogHeightStart = {}


---@type XConsoleVariable
g_CVarFogHeightEnd = {}


---@type XConsoleVariable
g_CVarFogHeightDensity = {}


---@type XConsoleVariable
g_CVarFogDensityUpper = {}


---@type XConsoleVariable
g_CVarFogDensityLower = {}


---@type XConsoleVariable
g_CVarFogHorizontalDensity = {}


---@type XConsoleVariable
g_CVarFogHorizontalPower = {}


---@type XConsoleVariable
g_CVarFogWorldPosHeightOffset = {}


---@type XConsoleVariable
g_CVarDebugDrawPhysics = {}


---@type XConsoleVariable
g_CVarEnableOIT = {}


---@type XConsoleVariable
g_CVarOITLayerNum = {}


---@type XConsoleVariable
g_CVarEnableShadow = {}


---@type XConsoleVariable
g_CVarShadowMapResolution = {}


---@type XConsoleVariable
g_CVarShadowDistance = {}


---@type XConsoleVariable
g_CVarShadowDepthBias = {}


---@type XConsoleVariable
g_CVarShadowSoftness = {}


---@type XConsoleVariable
g_CVarShadowCSMCascadeNum = {}


---@type XConsoleVariable
g_CVarShadowCascadeDistributionExponent = {}


---@type XConsoleVariable
g_CVarShadowSoftTransitionScale = {}


---@type XConsoleVariable
g_CVarShadowStrength = {}


---@type XConsoleVariable
g_CVarShadowColor = {}


---@type XConsoleVariable
g_CVarEnableSSAO = {}


---@type XConsoleVariable
g_CVarSSAOSampleRadius = {}


---@type XConsoleVariable
g_CVarRenderWater = {}


---@type XConsoleVariable
g_CVarEnablePreprocessImageEffect = {}


---@type XConsoleVariable
g_CVarEnablePostprocessImageEffect = {}


---@type XConsoleVariable
g_CVarEnablePostprocessImageEffect_DEBUG = {}


---@type XConsoleVariable
g_CVarBlendShapeNormalMethod = {}


---@type XConsoleVariable
g_CVarAnimInterpSimpleMode = {}


---@type XConsoleVariable
g_CVarAnimCompressSaveMode = {}


---@type XConsoleVariable
g_CVarEnableSoftSkeleton = {}


---@manual xelua_XEngine_XECrypt_manual
---@public XECrypt_manual
---@param operation number
---@param algorithm number
---@param mode number
---@param padding number
---@param key string
---@param key_len number
---@param vector string
---@param vector_len number
---@param input string
---@param input_len number
---@param output string
---@return number
function XECrypt(operation, algorithm, mode, padding, key, key_len, vector, vector_len, input, input_len, output) end


