---@class X2DContact
X2DContact = {}


---@type IX2DRigidBody
X2DContact.pRigidBodyA = {}


---@type IX2DRigidBody
X2DContact.pRigidBodyB = {}


---@type XVECTOR2
X2DContact.ContactNormal = {}


---@class X2DContactListener
X2DContactListener = {}


---@class IX2DPhysicalScene
IX2DPhysicalScene = {}


---@public IX2DPhysicalScene_Tick00
---@param fTime number
---@return void
function IX2DPhysicalScene:Tick(fTime) end


---@public 获取物理场景名称
---@return string
function IX2DPhysicalScene:GetName() end


---@public 设置Tick时速度的迭代次数,默认是6
---@param nVelocityIters number 速度的迭代次数
---@return void
function IX2DPhysicalScene:SetVelocityIterations(nVelocityIters) end


---@public 获取Tick时速度的迭代次数
---@return number 速度的迭代次数
function IX2DPhysicalScene:GetVelocityIterations() end


---@public 设置Tick时位置的迭代次数，默认是2
---@param nPositionIters number 位置的迭代次数
---@return void
function IX2DPhysicalScene:SetPositionIterations(nPositionIters) end


---@public 获取Tick时位置的迭代次数，默认是2
---@return number 位置的迭代次数
function IX2DPhysicalScene:GetPositionIterations() end


---@public 获取场景重力参数，XVECTOR2类型
---@return XVECTOR2
function IX2DPhysicalScene:GetGravity() end


---@public 设置场景重力参数
---@param vGravity XVECTOR2 重力参数,XVECTOR2类型
---@return void
function IX2DPhysicalScene:SetGravity(vGravity) end


---@public 添加一个RigidBody
---@param pDesc  X2DRigidBodyDesc RigidBody参数
---@return IX2DRigidBody 返回创建的RigidBody指针
function IX2DPhysicalScene:CreateRigidBody(pDesc) end


---@public 删除一个RigidBody（内部会Delete）
---@param pBody IX2DRigidBody 要删除的RigidBody指针
---@return void
function IX2DPhysicalScene:DestroyBody(pBody) end


---@public 创建一个Joint
---@param desc  X2DJointDesc Joint描述信息结构体
---@return IX2DJoint
function IX2DPhysicalScene:CreateJoint(desc) end


---@public 删除一个Joint，内部会Delete
---@param pJoint IX2DJoint Joint指针
---@return void
function IX2DPhysicalScene:DestroyJoint(pJoint) end


---@public 设置碰撞监听器
---@param pListener X2DContactListener 监听器类
---@return void
function IX2DPhysicalScene:SetContactListener(pListener) end


