---@type number @enum XClothStretchType
XCST_INVALID = 0


---@type number @enum XClothStretchType
XCST_VERTICAL = 0


---@type number @enum XClothStretchType
XCST_HORIZONTAL = 0


---@type number @enum XClothStretchType
XCST_BENDING = 0


---@type number @enum XClothStretchType
XCST_SHEARING = 0


---Cloth Stretch Param
---@class XClothStretchConfig
XClothStretchConfig = {}


---@public XClothStretchConfig_new00
---@return XClothStretchConfig
function XClothStretchConfig:new() end


---@type number 强度
XClothStretchConfig.fStiffness = 0


---@type number 强度系数
XClothStretchConfig.fStiffnessScale = 0


---@type number 限制系数
XClothStretchConfig.fLimit = 0


---@type number 压力限制
XClothStretchConfig.fCompressionLimit = 0


---Cloth Tether Param
---@class XClothTetherConfig
XClothTetherConfig = {}


---@public XClothTetherConfig_new00
---@return XClothTetherConfig
function XClothTetherConfig:new() end


---@type number 强度
XClothTetherConfig.fStiffness = 0


---@type number 强度系数
XClothTetherConfig.fStretchLimit = 0


---Cloth材质属性
---@class XClothMaterial
XClothMaterial = {}


---@type number stiffness frequency
XClothMaterial.fStiffnessFrequency = 0


---@type number 阻尼系数
XClothMaterial.fDamping = 0


---@type number 位移减弱系数
XClothMaterial.fDrag = 0


---@type number 摩擦系数
XClothMaterial.fFriction = 0


---@type number 质量系数
XClothMaterial.fMassScale = 0


---@type number 解算器频率
XClothMaterial.fSolverFrequency = 0


---@type number 惯性系数
XClothMaterial.fInertiaScale = 0


---@type number 自碰撞厚度
XClothMaterial.fSelfCollisionThickness = 0


---@type number 自碰撞强度
XClothMaterial.fSelfCollisionStiffness = 0


---@type XClothStretchConfig 垂直Stretch参数
XClothMaterial.VerticleStretchConfig = {}


---@type XClothStretchConfig 水平Stretch参数
XClothMaterial.HorizontalStretchConfig = {}


---@type XClothStretchConfig Bend 参数
XClothMaterial.BendingStretchConfig = {}


---@type XClothStretchConfig Shear 参数
XClothMaterial.ShearingStretchConfig = {}


---@type XClothTetherConfig Tether 参数
XClothMaterial.TetherConfig = {}


---@class IXCloth
IXCloth = {}


---@public 释放
---@return void
function IXCloth:Release() end


---@public 获取布料名称
---@return string
function IXCloth:GetName() end


---@public 判断是否渲染
---@return boolean 是否渲染
function IXCloth:IsRender() end


---@public 设置是否渲染
---@param bSet boolean 是否渲染
---@return void
function IXCloth:SetRender(bSet) end


---@public 判断是否开启了模拟
---@return boolean 是否开启了模拟
function IXCloth:IsSimulate() end


---@public 设置是否开启模拟
---@param bSet boolean 是否开启模拟
---@return void
function IXCloth:SetSimulate(bSet) end


---@public 获取布料材质信息
---@return XClothMaterial 布料材质信息
function IXCloth:GetClothMaterial() end


---@public 设置布料材质信息
---@param Material  XClothMaterial 布料材质信息
---@return void
function IXCloth:SetClothMaterial(Material) end


---@public 获取刚体频率（不建议布料绑定后更改此参数）
---@return number 刚体频率
function IXCloth:GetStiffnessFrequency() end


---@public 设置刚体频率（不建议布料绑定后更改此参数）
---@param fStiffnessFrequency number 刚体频率
---@return void
function IXCloth:SetStiffnessFrequency(fStiffnessFrequency) end


---@public 获取拉伸力的约束数据
---@param eType number 拉伸类型
---@return XClothStretchConfig 拉伸力的约束数据
function IXCloth:GetStretchConfig(eType) end


---@public 设置拉伸力的约束数据
---@param eType number 拉伸类型
---@param param  XClothStretchConfig 拉伸力的约束数据
---@return void
function IXCloth:SetStretchConfig(eType, param) end


---@public 获取绳索约束数据
---@return XClothTetherConfig 绳索约束数据
function IXCloth:GetTetherConfig() end


---@public 设置绳索约束数据
---@param config  XClothTetherConfig 绳索约束数据
---@return void
function IXCloth:SetTetherConfig(config) end


---@public 获取阻尼系数，用来降低布料顶点之间的相对速度。此值越大，布料看起来就越“粘稠”。
---@return number 阻尼系数
function IXCloth:GetDamping() end


---@public 设置阻尼系数，用来降低布料顶点之间的相对速度。此值越大，布料看起来就越“粘稠”。
---@param fDamping number 阻尼系数
---@return void
function IXCloth:SetDamping(fDamping) end


---@public 获取三个轴的阻力系数
---@return number 三个轴的阻力系数
function IXCloth:GetDrag() end


---@public 设置三个轴的阻力系数
---@param fDrag number 三个轴的阻力系数
---@return void
function IXCloth:SetDrag(fDrag) end


---@public 获取碰撞表面的摩擦系数
---@return number 碰撞表面的摩擦系数
function IXCloth:GetFriction() end


---@public 设置碰撞表面的摩擦系数
---@param fFriction number 碰撞表面的摩擦系数
---@return void
function IXCloth:SetFriction(fFriction) end


---@public 获取刚体质量缩放系数
---@return number 刚体质量缩放系数
function IXCloth:GetMassScale() end


---@public 设置刚体质量缩放系数
---@param fMassScale number 刚体质量缩放系数
---@return void
function IXCloth:SetMassScale(fMassScale) end


---@public 获取解码器频率。即每秒模拟计算的频率。此值越小，布料越有弹性。
---@return number 解码器频率
function IXCloth:GetSolverFrequency() end


---@public 设置解码器频率。即每秒模拟计算的频率。此值越小，布料越有弹性。
---@param fSolverFrequency number 解码器频率
---@return void
function IXCloth:SetSolverFrequency(fSolverFrequency) end


---@public 获取惯性缩放因子
---@return number 惯性缩放因子
function IXCloth:GetInertiaScale() end


---@public 设置惯性缩放因子
---@param fInertiaScale number 惯性缩放因子
---@return void
function IXCloth:SetInertiaScale(fInertiaScale) end


---@public 获取自碰撞的距离，模拟布料的厚度。自身碰撞可以在布料的任意顶点之间进行碰撞测试，
---每个顶点以半径为SelfCollisionThickness的球体表示。此值越大，减少了布料自缠绕的问题，同时也会阻止布料起皱。
---@return number 自碰撞的距离
function IXCloth:GetSelfCollisionThickness() end


---@public 设置自碰撞的距离，模拟布料的厚度。自身碰撞可以在布料的任意顶点之间进行碰撞测试，
---每个顶点以半径为SelfCollisionThickness的球体表示。此值越大，减少了布料自缠绕的问题，同时也会阻止布料起皱。
---@param fSelfCollisionThickness number 自碰撞的距离
---@return void
function IXCloth:SetSelfCollisionThickness(fSelfCollisionThickness) end


---@public 获取自碰撞的刚度，定义粒子碰撞时分离冲量的强度。
---@return number 自碰撞的刚度
function IXCloth:GetSelfCollisionStiffness() end


---@public 设置自碰撞的刚度，定义粒子碰撞时分离冲量的强度。
---@param fSelfCollisionStiffness number 自碰撞的刚度
---@return void
function IXCloth:SetSelfCollisionStiffness(fSelfCollisionStiffness) end


---@public IXCloth_GetExtraScale00
---@return number
function IXCloth:GetExtraScale() end


---@public IXCloth_SetExtraScale00
---@param fExtraScale number
---@return void
function IXCloth:SetExtraScale(fExtraScale) end


---@public 设置渲染碰撞信息
---@param bRender boolean 是否渲染
---@return void
function IXCloth:SetRenderCollision(bRender) end


---@public IXCloth_SetRenderCollision01
---@param bRender boolean
---@param clr  XCOLORBASE
---@return void
function IXCloth:SetRenderCollision(bRender, clr) end


---@public 设置渲染法线
---@param bRender boolean 是否渲染
---@return void
function IXCloth:SetRenderNormal(bRender) end


---@public IXCloth_SetRenderNormal01
---@param bRender boolean
---@param clr  XCOLORBASE
---@return void
function IXCloth:SetRenderNormal(bRender, clr) end


---@public 设置渲染切线
---@param bRender boolean 是否渲染
---@return void
function IXCloth:SetRenderTangent(bRender) end


---@public IXCloth_SetRenderTangent01
---@param bRender boolean
---@param clr  XCOLORBASE
---@return void
function IXCloth:SetRenderTangent(bRender, clr) end


---@public 设置渲染最大距离
---@param bRender boolean 是否渲染
---@return void
function IXCloth:SetRenderMaxDistance(bRender) end


---@public IXCloth_SetRenderMaxDistance01
---@param bRender boolean
---@param clr  XCOLORBASE
---@return void
function IXCloth:SetRenderMaxDistance(bRender, clr) end


