---@type number @enum EConstraintMotion
CM_FREE = 0


---@type number @enum EConstraintMotion
CM_LIMITED = 0


---@type number @enum EConstraintMotion
CM_LOCKED = 0


---@type number @enum EConstraintMotion
CM_NUM = 0


---@class XConstraintBaseParams
XConstraintBaseParams = {}


---@public XConstraintBaseParams_new00
---@return XConstraintBaseParams
function XConstraintBaseParams:new() end


---@type number Stiffness of the soft constraint. Only used when Soft Constraint is on.
XConstraintBaseParams.Stiffness = 0


---@type number Damping of the soft constraint. Only used when Soft Constraint is on.
XConstraintBaseParams.Damping = 0


---@type number Controls the amount of bounce when the constraint is violated. A restitution value of 1 will bounce back with the same velocity the limit was hit. A value of 0 will stop dead.
XConstraintBaseParams.Restitution = 0


---@type number Determines how close to the limit we have to get before turning the joint on. Larger value will be more expensive, but will do a better job not violating constraints. A smaller value will be more efficient, but easier to violate.
XConstraintBaseParams.ContactDistance = 0


---@type boolean
XConstraintBaseParams.bSoftConstraint = false


---Distance constraint
---@class XLinearConstraint : XConstraintBaseParams
XLinearConstraint = {}


---@public XLinearConstraint_new00
---@return XLinearConstraint
function XLinearConstraint:new() end


---@type number
XLinearConstraint.Limit = 0


---@type number Indicates the linear constraint applied along the X-axis. Free implies no constraint at all. Locked implies no movement along X is allowed. Limited implies the distance in the joint along all active axes must be less than the Distance provided.
XLinearConstraint.XMotion = 0


---@type number Indicates the linear constraint applied along the Y-axis. Free implies no constraint at all. Locked implies no movement along Y is allowed. Limited implies the distance in the joint along all active axes must be less than the Distance provided.
XLinearConstraint.YMotion = 0


---@type number Indicates the linear constraint applied along the Z-axis. Free implies no constraint at all. Locked implies no movement along Z is allowed. Limited implies the distance in the joint along all active axes must be less than the Distance provided.
XLinearConstraint.ZMotion = 0


---Cone constraint
---@class XConeConstraint : XConstraintBaseParams
XConeConstraint = {}


---@public XConeConstraint_new00
---@return XConeConstraint
function XConeConstraint:new() end


---@type number Angle of movement along the XY plane. This defines the first symmetric angle of the cone.
XConeConstraint.Swing1LimitDegrees = 0


---@type number Angle of movement along the XZ plane. This defines the second symmetric angle of the cone.
XConeConstraint.Swing2LimitDegrees = 0


---@type number Indicates whether the Swing1 limit is used.
XConeConstraint.Swing1Motion = 0


---@type number Indicates whether the Swing2 limit is used.
XConeConstraint.Swing2Motion = 0


---Angular roll constraint
---@class XTwistConstraint : XConstraintBaseParams
XTwistConstraint = {}


---@public XTwistConstraint_new00
---@return XTwistConstraint
function XTwistConstraint:new() end


---@type number Symmetric angle of roll along the X-axis.
XTwistConstraint.TwistLimitDegrees = 0


---@type number Indicates whether the Swing1 limit is used.
XTwistConstraint.TwistMotion = 0


---@class IXConstraint
IXConstraint = {}


---@public 获取骨头1的名称
---@return string
function IXConstraint:GetBone1Name() end


---@public 获取骨头2的名称
---@return string
function IXConstraint:GetBone2Name() end


---@public 获取骨头1的位置
---@return XVECTOR3
function IXConstraint:GetBone1Pos() end


---@public 获取骨头1的位置
---@return XVECTOR3
function IXConstraint:GetBone1Pos() end


---@public 获取骨头2的位置
---@return XVECTOR3
function IXConstraint:GetBone2Pos() end


---@public 获取骨头2的位置
---@return XVECTOR3
function IXConstraint:GetBone2Pos() end


---@public 获取骨头1的X轴方向
---@return XVECTOR3
function IXConstraint:GetBone1PriAxis() end


---@public 获取骨头1的X轴方向
---@return XVECTOR3
function IXConstraint:GetBone1PriAxis() end


---@public 获取骨头2的X轴方向
---@return XVECTOR3
function IXConstraint:GetBone2PriAxis() end


---@public 获取骨头2的X轴方向
---@return XVECTOR3
function IXConstraint:GetBone2PriAxis() end


---@public 获取骨头1的Y轴方向
---@return XVECTOR3
function IXConstraint:GetBone1SecAxis() end


---@public 获取骨头1的Y轴方向
---@return XVECTOR3
function IXConstraint:GetBone1SecAxis() end


---@public 获取骨头2的Y轴方向
---@return XVECTOR3
function IXConstraint:GetBone2SecAxis() end


---@public 获取骨头2的Y轴方向
---@return XVECTOR3
function IXConstraint:GetBone2SecAxis() end


---@public 获取线性约束参数
---@return  XLinearConstraint 线性约束参数
function IXConstraint:GetLinearConstraint() end


---@public 获取线性约束参数
---@return XLinearConstraint 线性约束参数
function IXConstraint:GetLinearConstraint() end


---@public 获取角度约束参数
---@return  XConeConstraint 角度约束参数
function IXConstraint:GetConeConstraint() end


---@public 获取角度约束参数
---@return XConeConstraint 角度约束参数
function IXConstraint:GetConeConstraint() end


---@public 获取扭曲约束参数
---@return  XTwistConstraint 扭曲约束参数
function IXConstraint:GetTwistConstraint() end


---@public 获取扭曲约束参数
---@return XTwistConstraint 扭曲约束参数
function IXConstraint:GetTwistConstraint() end


