---@type number @enum PhysicsResourceType
PRT_STATIC = 0


---@type number @enum PhysicsResourceType
PRT_SKELETAL = 0


---@type number @enum PhysicsResourceType
PRT_NUM = 0


---@class IXPhysicsRes
IXPhysicsRes = {}


---@public 获取物理资源类型
---PRT_SKELETAL：骨骼模型物理资源，在模型转换时生成，包括碰撞体和约束关节
---@return number 物理资源类型，PRT_STATIC：静态物理资源，在模型转换时生成，包括碰撞Mesh，碰撞凸包等。
function IXPhysicsRes:GetType() end


---@public 获取资源路径
---@return string 资源路径
function IXPhysicsRes:GetName() end


---@public 释放资源，引用计数减1
---@return void
function IXPhysicsRes:Release() end


---@class IXSkeletalPhysicsRes : IXPhysicsRes
IXSkeletalPhysicsRes = {}


---@type number @enum EPhysResFitVertWeight 考虑顶点所蒙皮的所有骨头（无论权重大小）
IXSkeletalPhysicsRes.EVW_ANY_WEIGHT = 0


---@type number @enum EPhysResFitVertWeight 考虑最大权重的骨头
IXSkeletalPhysicsRes.EVW_DOMINANT_WEIGHT = 0


---@class IXSkeletalPhysicsRes__XPhysResCreateParams
local IXSkeletalPhysicsRes__XPhysResCreateParams = {}
IXSkeletalPhysicsRes.XPhysResCreateParams = IXSkeletalPhysicsRes__XPhysResCreateParams


---@public IXSkeletalPhysicsRes_XPhysResCreateParams_new00
---@return IXSkeletalPhysicsRes__XPhysResCreateParams
function IXSkeletalPhysicsRes__XPhysResCreateParams:new() end


---@type number
IXSkeletalPhysicsRes__XPhysResCreateParams.fMinBoneSize = 0


---@type number
IXSkeletalPhysicsRes__XPhysResCreateParams.fMinWeldSize = 0


---@type number
IXSkeletalPhysicsRes__XPhysResCreateParams.eVertWeight = 0


---@type number
IXSkeletalPhysicsRes__XPhysResCreateParams.eAngularConstraintMode = 0


---@type boolean
IXSkeletalPhysicsRes__XPhysResCreateParams.bAutoOrientToBone = false


---@type boolean
IXSkeletalPhysicsRes__XPhysResCreateParams.bCreateConstraints = false


---@type boolean
IXSkeletalPhysicsRes__XPhysResCreateParams.bWalkPastSmall = false


---@type boolean
IXSkeletalPhysicsRes__XPhysResCreateParams.bBodyForAll = false


---@type string[]
IXSkeletalPhysicsRes__XPhysResCreateParams.aPhysicsBones = {}


---@class IXSkeletalPhysicsRes__XPhyConstraintBoneNames
local IXSkeletalPhysicsRes__XPhyConstraintBoneNames = {}
IXSkeletalPhysicsRes.XPhyConstraintBoneNames = IXSkeletalPhysicsRes__XPhyConstraintBoneNames


---@type string 骨骼1的名称
IXSkeletalPhysicsRes__XPhyConstraintBoneNames.strBone1Name = ''


---@type string 骨骼2的名称
IXSkeletalPhysicsRes__XPhyConstraintBoneNames.strBone2Name = ''


---@public 获取模型文件路径名
---@return string
function IXSkeletalPhysicsRes:GetModelFile() end


---@public 从Model初始化骨骼物理资源
---@param szSkinModelFile string 模型文件路径名
---@param Params  IXSkeletalPhysicsRes::XPhysResCreateParams 骨骼物理参数
---@return boolean 是否初始化成功
function IXSkeletalPhysicsRes:InitFromSkinModel(szSkinModelFile, Params) end


---@public 创建骨架刚体
---@param szBoneName string 骨头名称
---@return boolean 是否创建成功
function IXSkeletalPhysicsRes:CreateSkeletalBody(szBoneName) end


---@public 删除骨架刚体
---@param szBoneName string 骨头名称
---@return void
function IXSkeletalPhysicsRes:RemoveSkeletalBody(szBoneName) end


---@public 创建两个骨头的约束
---@param szBone1Name string 骨头1名称
---@param szBone2Name string 骨头2名称
---@return boolean 是否创建成功
function IXSkeletalPhysicsRes:CreateConstraint(szBone1Name, szBone2Name) end


---@public 删除两个骨头的约束
---@param szBone1Name string 骨头1名称
---@param szBone2Name string 骨头2名称
---@return void
function IXSkeletalPhysicsRes:RemoveConstraint(szBone1Name, szBone2Name) end


---@public 获取骨架刚体
---@param szBoneName string 骨头名称
---@return IXSkeletalBody 骨架刚体
function IXSkeletalPhysicsRes:GetSkeletalBody(szBoneName) end


---@public 获取两个骨头的约束
---@param szBone1Name string 骨头1名称
---@param szBone2Name string 骨头2名称
---@return IXConstraint 两个骨头的约束
function IXSkeletalPhysicsRes:GetConstraint(szBone1Name, szBone2Name) end


---@public 获取资源中所有绑定了刚体的骨骼名称
---@return string[]
---@return void
function IXSkeletalPhysicsRes:GetAllBoneName() end


---@public 获取资源中所有关节绑定的骨骼名称对
---@return XPhyConstraintBoneNames[]
---@return void
function IXSkeletalPhysicsRes:GetAllConstraintBoneNames() end


