---******************** ********************************
---@class IXPhysicsScene
IXPhysicsScene = {}


---@public 获取物理场景名称
---@return string
function IXPhysicsScene:GetName() end


---@public 将布料添加到场景中
---@param pCloth IXCloth pCloth布料指针
---@return boolean 失败情况：布料已添加到其他场景
function IXPhysicsScene:AddCloth(pCloth) end


---@public 将一组布料添加到场景中
---@param aCloth IXCloth[] aCloth布料数组
---@return boolean 任意一个布料添加失败返回xfalse
function IXPhysicsScene:AddCloth(aCloth) end


---@public 将布料从场景中移除
---@param pCloth IXCloth pCloth布料指针
---@return void
function IXPhysicsScene:RemoveCloth(pCloth) end


---@public 将一个刚体添加到场景中
---@param pRigidBody IXRigidBody pRigidBody刚体指针
---@return boolean 失败情况：刚体已添加到其他场景
function IXPhysicsScene:AddRigidBody(pRigidBody) end


---@public 将刚体从场景中移除
---@param pRigidBody IXRigidBody pRigidBody刚体指针
---@return void
function IXPhysicsScene:RemoveRigidBody(pRigidBody) end


---@public 获取场景重力参数，并返回
---@return XVECTOR3
function IXPhysicsScene:GetGravity() end


---@public 设置场景重力参数
---@param vGravity XVECTOR3
---@return void
function IXPhysicsScene:SetGravity(vGravity) end


