---@class XSphylShapeElem
XSphylShapeElem = {}


---@type XVECTOR3
XSphylShapeElem.vCenter = {}


---@type XQUATERNION
XSphylShapeElem.qRotation = {}


---@type number
XSphylShapeElem.fRadius = 0


---@type number Cylinder height
XSphylShapeElem.fLength = 0


---@public XSphylShapeElem_new00
---@return XSphylShapeElem
function XSphylShapeElem:new() end


---@class IXSkeletalBody
IXSkeletalBody = {}


---@public 获取骨头名称
---@return string 骨头名称字符串
function IXSkeletalBody:GetBoneName() end


---@public 判断是否开启模拟物理
---@return boolean 是否开启模拟物理
function IXSkeletalBody:IsSimulatePhysics() end


---@public 设置是否开启模拟物理
---@param bSimulatePhysics boolean 是否开启模拟物理
---@return void
function IXSkeletalBody:SetSimulatePhysics(bSimulatePhysics) end


---@public 获取物理融合权重
---@return number 物理融合权重（xfloat32类型）
function IXSkeletalBody:GetPhysicsBlendWeight() end


---@public 设置物理融合权重
---@param fPhysicsBlendWeight number 物理融合权重（xfloat32类型）
---@return void
function IXSkeletalBody:SetPhysicsBlendWeight(fPhysicsBlendWeight) end


---@public 获取刚体形状表面材质
---@return  XShapeMaterial 刚体形状表面材质
function IXSkeletalBody:GetMaterial() end


---@public 设置刚体形状表面材质
---@param mat  XShapeMaterial 刚体形状表面材质
---@return void
function IXSkeletalBody:SetMaterial(mat) end


---@public 判断刚体是否启用了重力
---@return boolean
function IXSkeletalBody:IsGravityEnabled() end


---@public 设置刚体是否启用重力
---@param bSet boolean
---@return void
function IXSkeletalBody:SetGravityEnabled(bSet) end


---@public IXSkeletalBody_GetDensity00
---@return number
function IXSkeletalBody:GetDensity() end


---@public IXSkeletalBody_SetDensity00
---@param fDensity number
---@return void
function IXSkeletalBody:SetDensity(fDensity) end


---@public 获取刚体线速度阻尼
---@return number
function IXSkeletalBody:GetLinearDamping() end


---@public 设置刚体线速度阻尼
---@param fLinearDamping number
---@return void
function IXSkeletalBody:SetLinearDamping(fLinearDamping) end


---@public 获取刚体角速度阻尼
---@return number
function IXSkeletalBody:GetAngularDamping() end


---@public 获取刚体角速度阻尼
---@param fAngularDamping number
---@return void
function IXSkeletalBody:SetAngularDamping(fAngularDamping) end


---@public 设置刚体移动速度（注意：如果未开启模拟,无效）
---@param vVelocity XVECTOR3 刚体移动速度
---@return void
function IXSkeletalBody:SetLinearVelocity(vVelocity) end


---@public 获取刚体移动速度（注意：如果未开启模拟,无效）
---@return XVECTOR3 刚体移动速度
function IXSkeletalBody:GetLinearVelocity() end


---@public 设置是否为Kinematic类型，不受场景中其他物体影响，可以被用户控制并影响其他物体
---@param bSet boolean true:设置为Kinematic类型;false:设置为非Kinematic类型
---@return void
function IXSkeletalBody:SetKinematic(bSet) end


---@public 获取是否为Kinematic类型
---@return boolean 是否为Kinematic类型
function IXSkeletalBody:IsKinematic() end


---@public 设置Kinematic物体的变换矩阵
---@param matrix XMATRIX4
---@return void
function IXSkeletalBody:SetKinematicTransform(matrix) end


---@public 获取碰撞过滤
---@return number 默认是0xFFFF
function IXSkeletalBody:GetFilterData() end


---@public 设置碰撞过滤
---@param nFilter number 碰撞过滤
---@return void
function IXSkeletalBody:SetFilterData(nFilter) end


---@public 给当前刚体添加形状
---@param ShapeElem  XSphylShapeElem 添加的形状信息
---@return void
function IXSkeletalBody:AttachShape(ShapeElem) end


---@public 清空形状数据
---@return void
function IXSkeletalBody:DetachAllShapes() end


---@public 获取所有形状
---@return XSphylShapeElem[] 所有形状数组
function IXSkeletalBody:GetShapes() end


---@public 获取所有形状
---@return XSphylShapeElem[] 所有形状数组
function IXSkeletalBody:GetShapes() end


---@public 设置某个对应索引的形状
---@param nShapeIndex number 形状索引
---@param ShapeElem  XSphylShapeElem 形状信息
---@return void
function IXSkeletalBody:SetShape(nShapeIndex, ShapeElem) end


---@public IXSkeletalBody_DebugDraw00
---@param pModelIns IXModelInstance
---@return void
function IXSkeletalBody:DebugDraw(pModelIns) end


---@public IXSkeletalBody_DebugDraw01
---@param pModelIns IXModelInstance
---@param Color  XCOLORBASE
---@return void
function IXSkeletalBody:DebugDraw(pModelIns, Color) end


