---@class XUIButton : XUIWidget
XUIButton = {}


---@public 创建并返回一个空的控件实例的指针
---@return XUIButton 控件指针
function XUIButton:Create() end


---@public 创建并返回一个控件实例
---@param strNormalTexture string 常态背景图片
---@param eTextureType number 相对路径/绝对路径
---@return XUIButton 控件指针
function XUIButton:Create(strNormalTexture, eTextureType) end


---@public 设置是否具有选中状态
---@param bCheckable boolean 是否具有可选中状态
---@return void
function XUIButton:SetCheckable(bCheckable) end


---@public 获取是否具有选中状态
---@return boolean 是否具有可选中状态
function XUIButton:IsCheckable() end


---@public 设置选中状态
---@param bChecked boolean 选中状态
---@return void
function XUIButton:SetChecked(bChecked) end


---@public 获取当前选中状态
---@return boolean 当前选中状态
function XUIButton:IsChecked() end


---@public 设置开启点击时动画，缩放和位移
---@param bSet boolean 是否开启
---@return void
function XUIButton:SetEnableAnim(bSet) end


---@public 获取当前是否开启了点击时动画
---@return boolean 是否开启
function XUIButton:IsEnableAnim() end


---@public XUIButton_SetAnimScale00
---@param fScale number
---@return void
function XUIButton:SetAnimScale(fScale) end


---@public XUIButton_GetAnimScale00
---@return number
function XUIButton:GetAnimScale() end


---@public XUIButton_SetAnimTrans00
---@param vTrans XVECTOR2
---@return void
function XUIButton:SetAnimTrans(vTrans) end


---@public XUIButton_GetAnimTrans00
---@return XVECTOR2
function XUIButton:GetAnimTrans() end


---@type number @enum AudioTriggerType
XUIButton.XUI_BEGAN = 0


---@type number @enum AudioTriggerType
XUIButton.XUI_ENDED = 0


---@type number @enum AudioTriggerType
XUIButton.XUI_CANCELED = 0


---@public XUIButton_IsEnableAudio00
---@return boolean
function XUIButton:IsEnableAudio() end


---@public XUIButton_SetEnableAudio00
---@param bSet boolean
---@return void
function XUIButton:SetEnableAudio(bSet) end


---@public XUIButton_GetAudioPath00
---@return string
function XUIButton:GetAudioPath() end


---@public XUIButton_SetAudioPath00
---@param strAudioPath string
---@return void
function XUIButton:SetAudioPath(strAudioPath) end


---@public XUIButton_GetAudioTriggerType00
---@return number
function XUIButton:GetAudioTriggerType() end


---@public XUIButton_SetAudioTriggerType00
---@param eType number
---@return void
function XUIButton:SetAudioTriggerType(eType) end


---@public XUIButton_PlayAudio00
---@return void
function XUIButton:PlayAudio() end


---@public XUIButton_StopAudio00
---@return void
function XUIButton:StopAudio() end


---@public 获取图片
---@return XUIImage
function XUIButton:GetImage() end


---@public 加载常态纹理
---@param strTexture string 正常状态纹理的名字
---@param eTextureType number 纹理类型
---@return void
function XUIButton:LoadNormalTexture(strTexture, eTextureType) end


---@public 加载按下状态纹理
---@param strTexture string 按下状态纹理的名字
---@param eTextureType number 纹理类型
---@return void
function XUIButton:LoadPressedTexture(strTexture, eTextureType) end


---@public 加载禁用状态纹理
---@param strTexture string 禁用状态纹理的名字
---@param eTextureType number 纹理类型
---@return void
function XUIButton:LoadDisabledTexture(strTexture, eTextureType) end


---@public 加载选中状态纹理
---@param strTexture string 选中状态纹理的名字
---@param eTextureType number 纹理类型
---@return void
function XUIButton:LoadCheckedTexture(strTexture, eTextureType) end


---@public 获取常态纹理
---@return string 常态纹理名字
function XUIButton:GetNormalTexture() end


---@public 获取按下状态纹理
---@return string 按下状态纹理名字
function XUIButton:GetPressedTexture() end


---@public 获取禁用状态纹理
---@return string 禁用状态纹理名字
function XUIButton:GetDisabledTexture() end


---@public 获取选中状态纹理
---@return string 选中状态纹理名字
function XUIButton:GetCheckedTexture() end


