---@class XUIComboBox : XUIWidget
XUIComboBox = {}


---@type number @enum EventType
XUIComboBox.SELECTED_CHANGED = 0


---@public XUIComboBox_new00
---@return XUIComboBox
function XUIComboBox:new() end


---@public 创建并返回一个空的控件实例的指针
---@return XUIComboBox 控件指针
function XUIComboBox:Create() end


---@public 创建并返回一个控件实例
---@param strEditBoxBackgroundTexture string 编辑框背景图片
---@param strButtonTexture string 确定按钮图片
---@param strButtonSelectedTexture string 确定按钮被点击时的图片
---@param strListViewBackgroundTexture string 下拉列表背景图片
---@param strItemBackgroundTexture string 下拉项背景图片
---@param strItemBackgroundSerlectedTexture string 下拉项被选中时的背景图片
---@param eTextureType number 相对路径/绝对路径
---@return XUIComboBox 控件指针
function XUIComboBox:Create(strEditBoxBackgroundTexture, strButtonTexture, strButtonSelectedTexture, strListViewBackgroundTexture, strItemBackgroundTexture, strItemBackgroundSerlectedTexture, eTextureType) end


---@public 创建并返回一个空的控件实例的指针
---@param strEditBoxBackgroundTexture string EditBox背景纹理路径
---@param strButtonTexture string Button背景纹理路径
---@param strItemBackgroundTexture string Item背景纹理路径
---@param eTextureType number 纹理类型
---@return XUIComboBox 控件指针
function XUIComboBox:Create(strEditBoxBackgroundTexture, strButtonTexture, strItemBackgroundTexture, eTextureType) end


---@public 加载编辑框背景图片
---@param strEditBoxBackgroundTexture string
---@param eTextureType number
---@return void
function XUIComboBox:LoadEditBoxBackgroundTexture(strEditBoxBackgroundTexture, eTextureType) end


---@public 加载确定按钮背景图片
---@param strButtonNormalTexture string
---@param eTextureType number
---@return void
function XUIComboBox:LoadButtonNormalTexture(strButtonNormalTexture, eTextureType) end


---@public 加载确定按钮被选中时的背景图片
---@param strButtonSelectedTexture string
---@param eTextureType number
---@return void
function XUIComboBox:LoadButtonSelectedTexture(strButtonSelectedTexture, eTextureType) end


---@public 加载下拉列表背景图片
---@param strListViewBackgroundTexture string
---@param eTextureType number
---@return void
function XUIComboBox:LoadListViewBackgroundTexture(strListViewBackgroundTexture, eTextureType) end


---@public 加载下拉项背景图片
---@param strItemBackgroundTexture string
---@param eTextureType number
---@return void
function XUIComboBox:LoadItemBackgroundTexture(strItemBackgroundTexture, eTextureType) end


---@public 获取编辑框背景图片
---@return string
function XUIComboBox:GetEditBoxBackgroundTexture() end


---@public 获取确定按钮背景图片
---@return string
function XUIComboBox:GetButtonNormalTexture() end


---@public 获取确定按钮被选中时的背景图片
---@return string
function XUIComboBox:GetButtonSelectedTexture() end


---@public 获取下拉列表背景图片
---@return string
function XUIComboBox:GetListViewBackgroundTexture() end


---@public 获取下拉项背景图片
---@return string
function XUIComboBox:GetItemBackgroundTexture() end


---@public 设置是否允许编辑
---@param bAllowEdit boolean 下拉列表框是否允许直接编辑
---@return void
function XUIComboBox:SetAllowEdit(bAllowEdit) end


---@public 获取是否允许编辑
---@return boolean 返回下拉列表框是否允许直接编辑。
function XUIComboBox:IsAllowEdit() end


---@public 设置每一个下拉项的高度
---@param nHeight number 下拉项高度。
---@return void
function XUIComboBox:SetItemHeight(nHeight) end


---@public 获取每一个下拉项的高度
---@return number 返回下拉项高度。
function XUIComboBox:GetItemHeight() end


---@public 设置字体颜色
---@param color  XCOLORBASE 编辑框内的字体颜色。
---@return void
function XUIComboBox:SetFontColor(color) end


---@public 获取字体颜色
---@return XCOLORBASE 返回编辑框内的字体颜色。
function XUIComboBox:GetFontColor() end


---@public 设置下拉列表的高度
---@param ItemNum number 下拉列表项最多能显示出来几项。
---@return void
function XUIComboBox:SetListViewHeight(ItemNum) end


---@public 获取下拉列表的高度
---@return number 返回下拉列表项最多能显示出来几项。
function XUIComboBox:GetListViewHeight() end


---@public 设置下拉列表显示的数据
---@param str string 用\n表示下一组数据
---@return void
function XUIComboBox:SetStringData(str) end


---@public 获取下拉列表显示的数据
---@return string 返回下拉列表数据集合,用\n表示下一组数据
function XUIComboBox:GetStringData() end


---@public 设置下拉列表显示的数据
---@param vList string[] 显示数据类型为字符串的数组。
---@return void
function XUIComboBox:SetListData(vList) end


---@public 获取下拉列表显示的数据
---@return string[] 返回下拉列表数据集合，类型为字符串数组。
function XUIComboBox:GetListData() end


---@public 设置当前选中数据为 strData字符串
---@param strData string 当前选中数据。
---@return void
function XUIComboBox:SetCurrentData(strData) end


---@public XUIComboBox_SetCurrentData01
---@param strData string
---@param bSafeCheck boolean
---@return void
function XUIComboBox:SetCurrentData(strData, bSafeCheck) end


---@public 获取当前选中的数据
---@return string 返回当前编辑框内显示的字符串。
function XUIComboBox:GetCurrentData() end


---@manual xelua_XEngine_XUIComboBox_AddComboBoxEventListener_manual
---@public XUIComboBox_AddComboBoxEventListener_manual
---@param callback  std::function<void(XUIComboBox*, xint32 nSelectedIndex,  _cstring szContent, XUIComboBox::EventType)>
---@return void
function XUIComboBox:AddComboBoxEventListener(callback) end


