---@class XUIMargin
XUIMargin = {}


---@public XUIMargin_new00
---@return XUIMargin
function XUIMargin:new() end


---@public XUIMargin_new01
---@param l number
---@param t number
---@param r number
---@param b number
---@return XUIMargin
function XUIMargin:new(l, t, r, b) end


---@type number
XUIMargin.fLeft = 0


---@type number
XUIMargin.fRight = 0


---@type number
XUIMargin.fTop = 0


---@type number
XUIMargin.fBottom = 0


---@class XUILayoutParameter
XUILayoutParameter = {}


---@type number @enum Type
XUILayoutParameter.XUI_NONE = 0


---@type number @enum Type 线性布局
XUILayoutParameter.XUI_LINEAR = 0


---@type number @enum Type 相对布局
XUILayoutParameter.XUI_RELATIVE = 0


---@public XUILayoutParameter_new00
---@return XUILayoutParameter
function XUILayoutParameter:new() end


---@public 创建一个XUILayoutParameter实例,并返回
---@return XUILayoutParameter
function XUILayoutParameter:Create() end


---@public 设置LayoutParameter边距参数
---@param margin  XUIMargin 边距
---@return void
function XUILayoutParameter:SetMargin(margin) end


---@public 获取LayoutParameter边距参数
---@return  XUIMargin 边距
function XUILayoutParameter:GetMargin() end


---@public 获取LayoutParameter的Type
---@return number
function XUILayoutParameter:GetLayoutType() end


---@public 克隆一个新的XUILayoutParameter，并返回
---@return XUILayoutParameter
function XUILayoutParameter:Clone() end


---线性布局参数，它是专门为线性排列元素用线性布局管理器
---@class XUILinearLayoutParameter : XUILayoutParameter
XUILinearLayoutParameter = {}


---@type number @enum LinearGravity
XUILinearLayoutParameter.XUI_NONE = 0


---@type number @enum LinearGravity
XUILinearLayoutParameter.XUI_LEFT = 0


---@type number @enum LinearGravity
XUILinearLayoutParameter.XUI_TOP = 0


---@type number @enum LinearGravity
XUILinearLayoutParameter.XUI_RIGHT = 0


---@type number @enum LinearGravity
XUILinearLayoutParameter.XUI_BOTTOM = 0


---@type number @enum LinearGravity
XUILinearLayoutParameter.XUI_CENTER_VERTICAL = 0


---@type number @enum LinearGravity
XUILinearLayoutParameter.XUI_CENTER_HORIZONTAL = 0


---@public XUILinearLayoutParameter_new00
---@return XUILinearLayoutParameter
function XUILinearLayoutParameter:new() end


---@public 创建一个XUILayoutParameter实例,并返回
---@return XUILinearLayoutParameter
function XUILinearLayoutParameter:Create() end


---@public 设置LayoutParameter的LinearGravity参数
---@param eGravity number LinearGravity的引力
---@return void
function XUILinearLayoutParameter:SetGravity(eGravity) end


---@public 获取LayoutParameter的LinearGravity参数，并返回
---@return number
function XUILinearLayoutParameter:GetGravity() end


---@public XUILinearLayoutParameter_CopyProperties00
---@param pParameter XUILayoutParameter
---@return void
function XUILinearLayoutParameter:CopyProperties(pParameter) end


---@public XUILinearLayoutParameter_CreateClonedInstance00
---@return XUILayoutParameter
function XUILinearLayoutParameter:CreateClonedInstance() end


---相对布局参数
---@class XUIRelativeLayoutParameter : XUILayoutParameter
XUIRelativeLayoutParameter = {}


---@type number @enum RelativeAlign
XUIRelativeLayoutParameter.XUI_NONE = 0


---@type number @enum RelativeAlign
XUIRelativeLayoutParameter.XUI_PARENT_TOP_LEFT = 0


---@type number @enum RelativeAlign
XUIRelativeLayoutParameter.XUI_PARENT_TOP_CENTER_HORIZONTAL = 0


---@type number @enum RelativeAlign
XUIRelativeLayoutParameter.XUI_PARENT_TOP_RIGHT = 0


---@type number @enum RelativeAlign
XUIRelativeLayoutParameter.XUI_PARENT_LEFT_CENTER_VERTICAL = 0


---@type number @enum RelativeAlign
XUIRelativeLayoutParameter.XUI_CENTER_IN_PARENT = 0


---@type number @enum RelativeAlign
XUIRelativeLayoutParameter.XUI_PARENT_RIGHT_CENTER_VERTICAL = 0


---@type number @enum RelativeAlign
XUIRelativeLayoutParameter.XUI_PARENT_LEFT_BOTTOM = 0


---@type number @enum RelativeAlign
XUIRelativeLayoutParameter.XUI_PARENT_BOTTOM_CENTER_HORIZONTAL = 0


---@type number @enum RelativeAlign
XUIRelativeLayoutParameter.XUI_PARENT_RIGHT_BOTTOM = 0


---@type number @enum RelativeAlign
XUIRelativeLayoutParameter.XUI_LOCATION_ABOVE_LEFTALIGN = 0


---@type number @enum RelativeAlign
XUIRelativeLayoutParameter.XUI_LOCATION_ABOVE_CENTER = 0


---@type number @enum RelativeAlign
XUIRelativeLayoutParameter.XUI_LOCATION_ABOVE_RIGHTALIGN = 0


---@type number @enum RelativeAlign
XUIRelativeLayoutParameter.XUI_LOCATION_LEFT_OF_TOPALIGN = 0


---@type number @enum RelativeAlign
XUIRelativeLayoutParameter.XUI_LOCATION_LEFT_OF_CENTER = 0


---@type number @enum RelativeAlign
XUIRelativeLayoutParameter.XUI_LOCATION_LEFT_OF_BOTTOMALIGN = 0


---@type number @enum RelativeAlign
XUIRelativeLayoutParameter.XUI_LOCATION_RIGHT_OF_TOPALIGN = 0


---@type number @enum RelativeAlign
XUIRelativeLayoutParameter.XUI_LOCATION_RIGHT_OF_CENTER = 0


---@type number @enum RelativeAlign
XUIRelativeLayoutParameter.XUI_LOCATION_RIGHT_OF_BOTTOMALIGN = 0


---@type number @enum RelativeAlign
XUIRelativeLayoutParameter.XUI_LOCATION_BELOW_LEFTALIGN = 0


---@type number @enum RelativeAlign
XUIRelativeLayoutParameter.XUI_LOCATION_BELOW_CENTER = 0


---@type number @enum RelativeAlign
XUIRelativeLayoutParameter.XUI_LOCATION_BELOW_RIGHTALIGN = 0


---@public XUIRelativeLayoutParameter_new00
---@return XUIRelativeLayoutParameter
function XUIRelativeLayoutParameter:new() end


---@public 创建一个XUILayoutParameter实例,并返回
---@return XUIRelativeLayoutParameter
function XUIRelativeLayoutParameter:Create() end


---@public 设置为LayoutParameter的RelativeAlign参数
---@param eAlign number 相对对齐参数RelativeAlign
---@return void
function XUIRelativeLayoutParameter:SetAlign(eAlign) end


---@public 获取LayoutParameter的RelativeAlign参数
---@return number 相对对齐参数RelativeAlign
function XUIRelativeLayoutParameter:GetAlign() end


---@public 设置相对于控件的名称
---@param strName string 相对控件的名称
---@return void
function XUIRelativeLayoutParameter:SetRelativeToWidgetName(strName) end


---@public 获取相对于控件的名称
---@return string 相对控件的名称
function XUIRelativeLayoutParameter:GetRelativeToWidgetName() end


---@public 为LayoutParameter在相对布局里设置一个名字
---@param strName string
---@return void
function XUIRelativeLayoutParameter:SetRelativeName(strName) end


---@public 获取LayoutParameter在相对布局里的名字，并返回
---@return string
function XUIRelativeLayoutParameter:GetRelativeName() end


