---@class IXUIManager
IXUIManager = {}


---@public 创建UIScene
---@return XUIScene 返回创建的UIScene指针
function IXUIManager:CreateUIScene() end


---@public 移除UIScene
---@param pScene XUIScene 要移除的UIScene指针
---@return void
function IXUIManager:RemoveUIScene(pScene) end


---@public 加载UIScene
---@param szFile string UIScene路径
---@return XUIScene UIScene指针
function IXUIManager:LoadUIScene(szFile) end


---@public 设置分辨率
---@param vResolution XVECTOR2 要设置的分辨率
---@return void
function IXUIManager:SetScreenResolution(vResolution) end


---@public 获取分辨率
---@return XVECTOR2 分辨率
function IXUIManager:GetScreenResolution() end


---@public 设置屏幕比例，在ios上使用[[UIScreen mainScreen]
---@param fScale number
---@return void
function IXUIManager:SetScaleFactor(fScale) end


---@public 获取屏幕比例，并返回
---@return number
function IXUIManager:GetScaleFactor() end


---@public 设置屏幕区域，在ios上使用applicationFrame作为输入，win32暂时不使用
---@param rect  XUIRect 要设置的屏幕区域矩形
---@return void
function IXUIManager:SetRect(rect) end


---@public 获取屏幕区域，并返回
---@return  XUIRect
function IXUIManager:GetRect() end


---@public 领养一个场景，领养后的场景需要手动调用Render和Tick函数。如果不清除UI渲染机制请不要（也不需要）调用该函数。
---@param pScene XUIScene
---@return void
function IXUIManager:AdoptScene(pScene) end


---@public 动画系统
---@return IXUIActionManager
function IXUIManager:GetActionManager() end


---@public 获取字符串hashid
---@param name string
---@return number
function IXUIManager:GetStrID(name) end


---@public 设置是否合批渲染
---@param bEnable boolean 是否合批渲染
---@return void
function IXUIManager:SetBatchEnabled(bEnable) end


---@public 获取是否合批渲染
---@return boolean 是否合批渲染
function IXUIManager:IsBatchEnabled() end


---@public 获取本实例中TTF的默认路径
---@return string
function IXUIManager:GetDefaultTTFPath() end


---@public 设置本实例中TTF的默认路径
---@param strTemp string
---@return void
function IXUIManager:SetDefaultTTFPath(strTemp) end


---@public IXUIManager_SetCurrentPath00
---@param strPath string
---@return void
function IXUIManager:SetCurrentPath(strPath) end


---@public IXUIManager_GetCurrentPath00
---@return string
function IXUIManager:GetCurrentPath() end


---@public IXUIManager_SetTouchMaxNum00
---@param nMaxNum number
---@return void
function IXUIManager:SetTouchMaxNum(nMaxNum) end


---@public IXUIManager_GetTouchMaxNum00
---@return number
function IXUIManager:GetTouchMaxNum() end


---@public IXUIManager_GetTextureCacheInstance00
---@return XUITextureCache
function IXUIManager:GetTextureCacheInstance() end


---@public IXUIManager_GetPrefebManager00
---@return XUIPrefebManager
function IXUIManager:GetPrefebManager() end


