---@class XUIPageView : XUIListView
XUIPageView = {}


---@type number @enum EventType
XUIPageView.TURNING = 0


---@type number @enum TouchDirection
XUIPageView.LEFT = 0


---@type number @enum TouchDirection
XUIPageView.RIGHT = 0


---@type number @enum TouchDirection
XUIPageView.UP = 0


---@type number @enum TouchDirection
XUIPageView.DOWN = 0


---@public 创建并返回一个空的控件实例的指针
---@return XUIPageView 控件指针
function XUIPageView:Create() end


---@public XUIPageView_new00
---@return XUIPageView
function XUIPageView:new() end


---@public 往PageView的最后插入一页,并返回该页的Widget
---@return XUIWidget
function XUIPageView:AddPage() end


---@public 在指定位置插入一页
---@param nIndex number 插入位置索引
---@return XUIWidget
function XUIPageView:InsertPage(nIndex) end


---@public 获取Page控件
---@param nIndex number
---@return XUIWidget
function XUIPageView:GetPageByIndex(nIndex) end


---@public 移动Page
---@param nOldIndex number
---@param nNewIndex number
---@return void
function XUIPageView:MovePage(nOldIndex, nNewIndex) end


---@public 获取Page数量
---@return number
function XUIPageView:GetPageNumber() end


---@public 移除指定页
---@param pPage XUIWidget 被移除的页
---@return void
function XUIPageView:RemovePage(pPage) end


---@public 移除指定索引对应的页
---@param nIndex number 指定索引
---@return void
function XUIPageView:RemovePageAtIndex(nIndex) end


---@public 移除所有页
---@return void
function XUIPageView:RemoveAllPages() end


---@public 滚动到一个指定的页
---@param nIndex number 指定索引
---@return void
function XUIPageView:ScrollToPage(nIndex) end


---@public 滚动到一个指定的页
---@param nIndex number 指定索引
---@param fTime number 滚动时间
---@return void
function XUIPageView:ScrollToPage(nIndex, fTime) end


---@public 设置直接跳转到第几页
---@param nIndex number 指定索引
---@return void
function XUIPageView:JumpToPage(nIndex) end


---@public 获取当前页的索引
---@return number
function XUIPageView:GetCurrentPageIndex() end


---@manual xelua_XEngine_XUIPageView_AddEventListener_manual
---@public XUIPageView_AddEventListener_manual
---@param callback  std::function<void(XUINode*, EventType)>
---@return void
function XUIPageView:AddEventListener(callback) end


---@public 设置小圆点页指示器是否启用
---@param bEnabled boolean 是否启用那个小圆点页指示器
---@return void
function XUIPageView:SetIndicatorEnabled(bEnabled) end


---@public 获取小圆点页指示器是否启用
---@return boolean 是否启用那个小圆点页指示器
function XUIPageView:GetIndicatorEnabled() end


---@public 以描述锚点的方式来设置小圆点页指示器在PageView的哪个地方显示
---@param vPositionAsAnchorPoint XVECTOR2 小圆点页指示器在PageView的哪个地方，范围(0~1)，即XVECTOR2(0.5,0.5)为控件中心点。
---@return void
function XUIPageView:SetIndicatorPositionAsAnchorPoint(vPositionAsAnchorPoint) end


---@public 获取以描述锚点的方式时，小圆点页指示器在PageView的哪个地方显示
---@return XVECTOR2 小圆点页指示器在PageView的哪个地方，范围(0~1)，即XVECTOR2(0.5,0.5)为控件中心点。
function XUIPageView:GetIndicatorPositionAsAnchorPoint() end


---@public 设置小圆点页指示器的位置
---@param vPosition XVECTOR2 小圆点指示器的新坐标。
---@return void
function XUIPageView:SetIndicatorPosition(vPosition) end


---@public 获取小圆点页指示器的位置
---@return XVECTOR2 小圆点指示器的新坐标。
function XUIPageView:GetIndicatorPosition() end


---@public 设置两个小圆点指示器之间的间隔
---@param fSpaceBetweenIndexNodes number 间隔值，单位像素
---@return void
function XUIPageView:SetIndicatorSpaceBetweenIndexNodes(fSpaceBetweenIndexNodes) end


---@public 获取两个小圆点指示器之间的间隔
---@return number 间隔值，单位像素
function XUIPageView:GetIndicatorSpaceBetweenIndexNodes() end


---@public 设置被选中的小圆点指示器的颜色
---@param color  XCOLORBASE 被选中的小圆点颜色。
---@return void
function XUIPageView:SetIndicatorSelectedIndexColor(color) end


---@public 获取被选中的小圆点指示器的颜色
---@return  XCOLORBASE 被选中的小圆点颜色。
function XUIPageView:GetIndicatorSelectedIndexColor() end


---@public 设置小圆点指示器的颜色
---@param color  XCOLORBASE 小圆点颜色。
---@return void
function XUIPageView:SetIndicatorIndexNodesColor(color) end


---@public 获取小圆点指示器的颜色
---@return  XCOLORBASE 返回小圆点颜色。
function XUIPageView:GetIndicatorIndexNodesColor() end


---@public 设置被选中的小圆点指示器的缩放
---@param fIndexNodesScale number 小圆点缩放值。
---@return void
function XUIPageView:SetIndicatorIndexNodesScale(fIndexNodesScale) end


---@public 获取被选中的小圆点指示器的缩放
---@return number 小圆点缩放值。
function XUIPageView:GetIndicatorIndexNodesScale() end


---@public 设置小圆点指示器的图片
---@param strTexName string 要设置的纹理路径。
---@param eTexType number 相对路径/绝对路径。
---@return void
function XUIPageView:SetIndicatorIndexNodesTexture(strTexName, eTexType) end


