---@class XUIProgressBar : XUIWidget
XUIProgressBar = {}


---@type number @enum Direction
XUIProgressBar.XUI_LEFT = 0


---@type number @enum Direction
XUIProgressBar.XUI_RIGHT = 0


---@type number @enum FillMode
XUIProgressBar.XUI_SIMPLE = 0


---@type number @enum FillMode
XUIProgressBar.XUI_RADIAL = 0


---@public 创建并返回一个空的控件实例的指针
---@return XUIProgressBar 控件指针
function XUIProgressBar:Create() end


---@public 创建并返回一个空的控件实例的指针
---@param strTexture string 纹理路径
---@param fPercentage number 进度条默认百分比(范围0~100)。
---@param eTextureType number 纹理类型
---@return XUIProgressBar 控件指针
function XUIProgressBar:Create(strTexture, fPercentage, eTextureType) end


---@public XUIProgressBar_new00
---@return XUIProgressBar
function XUIProgressBar:new() end


---@public 获取进度条图片。
---@return XUIImage 获取进度条图片的XUIImage。
function XUIProgressBar:GetImage() end


---@public 加载纹理
---@param strTexture string 加载的纹理路径
---@param eTextureType number 加载的纹理类型,相对路径/绝对路径
---@return void
function XUIProgressBar:LoadTexture(strTexture, eTextureType) end


---@public 获取已加载的图片路径
---@return string 已加载的图片路径。
function XUIProgressBar:GetTexture() end


---@public 设置进度条往哪边涨。
---@param eDirection number XUI_LEFT往左涨，XUI_RIGHT往右涨。默认往右。要是想往上涨，那么设置成往右涨然后设置进度条顺时针旋转-90度。
---@return void
function XUIProgressBar:SetDirection(eDirection) end


---@public 获取进度条往哪边涨。
---@return number 返回进度条往哪边涨。
function XUIProgressBar:GetDirection() end


---@public 设置进度条当前显示进度。
---@param fPercent number 当前进度。
---@return void
function XUIProgressBar:SetPercent(fPercent) end


---@public 获取进度条当前显示进度。
---@return number 返回当前进度。
function XUIProgressBar:GetPercent() end


---@public 设置进度条FillMode
---@param eFillMode number
---@return void
function XUIProgressBar:SetFillMode(eFillMode) end


---@public 获取进度条当前FillMode
---@return number 返回当前FillMode
function XUIProgressBar:GetFillMode() end


---@public 设置进度条的进度是否自动更新
---@param bAuto boolean
---@return void
function XUIProgressBar:EnableAutoUpdate(bAuto) end


---@public 获取进度条的进度是否自动更新
---@return boolean 当前进度条是否进度更新
function XUIProgressBar:IsAutoUpdate() end


---@public 设置自动更新时的周期，默认10.0s
---@param fPeriod number
---@return void
function XUIProgressBar:SetAutoUpdatePeriod(fPeriod) end


---@public 获取进度条自动更新的周期
---@return number 自动更新的周期
function XUIProgressBar:GetAutoUpdatePeriod() end


---@public 设置自动更新时是否循环，默认循环
---@param bLoop boolean
---@return void
function XUIProgressBar:EnableAutoUpdateLoop(bLoop) end


---@public 获取自动更新时是否循环
---@return boolean 是否循环
function XUIProgressBar:IsAutoUpdateLoop() end


---@public 设置是否反向,仅RADIAL模式有效
---@param bReverse boolean
---@return void
function XUIProgressBar:SetReverse(bReverse) end


---@public 获取是否反向
---@return boolean 是否反向
function XUIProgressBar:IsReverse() end


---@public 预留接口，功能未实现！设置起始角度
---@param fAngle number
---@return void
function XUIProgressBar:SetStartAngle(fAngle) end


---@public 预留接口，功能未实现！获取起始角度
---@return number 起始角度
function XUIProgressBar:GetStartAngle() end


---@public 预留接口，功能未实现！设置结束角度
---@param fAngle number
---@return void
function XUIProgressBar:SetEndAngle(fAngle) end


---@public 预留接口，功能未实现！获取结束角度
---@return number 起始角度
function XUIProgressBar:GetEndAngle() end


---@manual xelua_XEngine_XUIProgressBar_AddValueChangedListener_manual
---@public XUIProgressBar_AddValueChangedListener_manual
---@param callback  std::function<void(XUIProgressBar*, xfloat32 fCurrentValue)>
---@return void
function XUIProgressBar:AddValueChangedListener(callback) end


