---@class XUIRadioButton : XUIAbstractCheckButton
XUIRadioButton = {}


---@type number @enum EventType 选中事件
XUIRadioButton.SELECTED = 0


---@type number @enum EventType 非选中事件
XUIRadioButton.UNSELECTED = 0


---@public 创建并返回一个空的控件实例的指针
---@return XUIRadioButton 控件指针
function XUIRadioButton:Create() end


---@public 创建并返回一个控件实例
---@param strBackGroundNormalTexture string 背景常态图片
---@param strBackGroundSelectedTexture string 背景选中态图片
---@param strCrossTexture string 前景图片
---@param strBackGroundDisabledTexture string 背景禁用态图片
---@param strFrontCrossDisabledTexture string 前景禁用状态图片
---@param eTextureType number 相对路径/绝对路径
---@return XUIRadioButton 控件指针
function XUIRadioButton:Create(strBackGroundNormalTexture, strBackGroundSelectedTexture, strCrossTexture, strBackGroundDisabledTexture, strFrontCrossDisabledTexture, eTextureType) end


---@public 创建并返回一个控件实例
---@param strBackGroundTexture string 背景常态图片
---@param strCrossTexture string 前景图片
---@param eTextureType number 相对路径/绝对路径
---@return XUIRadioButton 控件指针
function XUIRadioButton:Create(strBackGroundTexture, strCrossTexture, eTextureType) end


---@public XUIRadioButton_GetGroup00
---@return XUIRadioButtonGroup
function XUIRadioButton:GetGroup() end


---@manual xelua_XEngine_XUIRadioButton_AddRadioButtonEventListener_manual
---@public XUIRadioButton_AddRadioButtonEventListener_manual
---@param callback  std::function<void(XUINode*, XUIRadioButton::EventType)>
---@return void
function XUIRadioButton:AddRadioButtonEventListener(callback) end


---@class XUIRadioButtonGroup : XUIWidget
XUIRadioButtonGroup = {}


---@type number @enum EventType
XUIRadioButtonGroup.SELECT_CHANGED = 0


---@public 创建并返回一个空的控件实例的指针
---@return XUIRadioButtonGroup 控件指针
function XUIRadioButtonGroup:Create() end


---@manual xelua_XEngine_XUIRadioButtonGroup_AddEventListener_manual
---@public XUIRadioButtonGroup_AddEventListener_manual
---@param callback  std::function<void(XUIRadioButton*pRadioButton, xint32 index, XUIRadioButtonGroup::EventType)>
---@return void
function XUIRadioButtonGroup:AddEventListener(callback) end


---@public XUIRadioButtonGroup_GetSelectedButtonIndex00
---@return number
function XUIRadioButtonGroup:GetSelectedButtonIndex() end


---@public XUIRadioButtonGroup_SetSelectedButton00
---@param nIndex number
---@return void
function XUIRadioButtonGroup:SetSelectedButton(nIndex) end


---@public XUIRadioButtonGroup_SetSelectedButton01
---@param pRadioButton XUIRadioButton
---@return void
function XUIRadioButtonGroup:SetSelectedButton(pRadioButton) end


---@public XUIRadioButtonGroup_SetSelectedButtonWithoutEvent00
---@param nIndex number
---@return void
function XUIRadioButtonGroup:SetSelectedButtonWithoutEvent(nIndex) end


---@public XUIRadioButtonGroup_SetSelectedButtonWithoutEvent01
---@param pRadioButton XUIRadioButton
---@return void
function XUIRadioButtonGroup:SetSelectedButtonWithoutEvent(pRadioButton) end


---@public XUIRadioButtonGroup_AddRadioButton00
---@param pRadioButton XUIRadioButton
---@return void
function XUIRadioButtonGroup:AddRadioButton(pRadioButton) end


---@public XUIRadioButtonGroup_RemoveRadioButton00
---@param pRadioButton XUIRadioButton
---@return void
function XUIRadioButtonGroup:RemoveRadioButton(pRadioButton) end


---@public XUIRadioButtonGroup_RemoveAllRadioButtons00
---@return void
function XUIRadioButtonGroup:RemoveAllRadioButtons() end


---@public XUIRadioButtonGroup_GetNumberOfRadioButtons00
---@return number
function XUIRadioButtonGroup:GetNumberOfRadioButtons() end


---@public XUIRadioButtonGroup_GetRadioButtonByIndex00
---@param nIndex number
---@return XUIRadioButton
function XUIRadioButtonGroup:GetRadioButtonByIndex(nIndex) end


---@public XUIRadioButtonGroup_SetAllowedNoSelection00
---@param bAllowedNoSelection boolean
---@return void
function XUIRadioButtonGroup:SetAllowedNoSelection(bAllowedNoSelection) end


---@public XUIRadioButtonGroup_IsAllowedNoSelection00
---@return boolean
function XUIRadioButtonGroup:IsAllowedNoSelection() end


---@public 当前Group被设置成允许不选中状态时，把当前Group下所有的子Button都设置成不选中状态
---@return void
function XUIRadioButtonGroup:DeselectAll() end


