---@class XUISlider : XUIWidget
XUISlider = {}


---@type number @enum EventType
XUISlider.XUI_ON_PERCENTAGE_CHANGED = 0


---@type number @enum EventType
XUISlider.XUI_ON_SLIDEBALL_DOWN = 0


---@type number @enum EventType
XUISlider.XUI_ON_SLIDEBALL_UP = 0


---@type number @enum EventType
XUISlider.XUI_ON_SLIDEBALL_CANCEL = 0


---@public 创建并返回一个空的控件实例的指针
---@return XUISlider 控件指针
function XUISlider:Create() end


---@public 根据传入的纹理创建一个滑块实例，并返回
---@param strBarTexture string 滑竿纹理路径
---@param strBallNormalTexture string 滑块球纹理路径
---@param eTexType number 纹理类型
---@return XUISlider 创建的滑块实例
function XUISlider:Create(strBarTexture, strBallNormalTexture, eTexType) end


---@public XUISlider_new00
---@return XUISlider
function XUISlider:new() end


---@public 获取滑竿图片指针
---@return XUIImage
function XUISlider:GetBarImage() end


---@public 获取进度条图片指针
---@return XUIImage
function XUISlider:GetProgressBarImage() end


---@public 获取滑块球图片指针
---@return XUIImage
function XUISlider:GetBallImage() end


---@public 加载滑竿纹理图片
---@param strBarTexture string 纹理路径
---@param eTexType number 纹理类型
---@return void
function XUISlider:LoadBarTexture(strBarTexture, eTexType) end


---@public 加载进度条纹理图片
---@param strProgressBarTexture string 纹理路径
---@param eTexType number 纹理类型
---@return void
function XUISlider:LoadProgressBarTexture(strProgressBarTexture, eTexType) end


---@public 加载滑块球常态纹理图片
---@param strBarNormalTexture string 纹理路径
---@param eTexType number 纹理类型
---@return void
function XUISlider:LoadBallNormalTexture(strBarNormalTexture, eTexType) end


---@public 加载滑块球按下状态纹理图片
---@param strBarPressedTexture string 纹理路径
---@param eTexType number 纹理类型
---@return void
function XUISlider:LoadBallPressedTexture(strBarPressedTexture, eTexType) end


---@public 加载滑块球禁用态纹理图片
---@param strBarDisabledTexture string 纹理路径
---@param eTexType number 纹理类型
---@return void
function XUISlider:LoadBallDisabledTexture(strBarDisabledTexture, eTexType) end


---@public 获取滑竿纹理路径名
---@return string
function XUISlider:GetBarTexture() end


---@public 获取进度条纹理路径名
---@return string
function XUISlider:GetProgressBarTexture() end


---@public 获取滑块球常态纹理
---@return string
function XUISlider:GetBallNormalTexture() end


---@public 获取滑块球按下状态纹理
---@return string
function XUISlider:GetBallPressedTexture() end


---@public 获取滑块球禁用纹理
---@return string
function XUISlider:GetBallDisabledTexture() end


---@public 设置进度百分比，取值1-100
---@param nPercent number
---@return void
function XUISlider:SetPercent(nPercent) end


---@public 获取进度百分比
---@return number
function XUISlider:GetPercent() end


---@public 设置进度最大百分比
---@param nMaxPercent number
---@return void
function XUISlider:SetMaxPercent(nMaxPercent) end


---@public 获取进度最大百分比
---@return number
function XUISlider:GetMaxPercent() end


---@manual xelua_XEngine_XUISlider_AddEventListener_manual
---@public XUISlider_AddEventListener_manual
---@param callback  std::function<void(XUINode*, EventType)>
---@return void
function XUISlider:AddEventListener(callback) end


---@public 设置滑块球大小
---@param vSize XVECTOR2
---@return void
function XUISlider:SetBallSize(vSize) end


---@public 获取滑块球大小
---@return XVECTOR2
function XUISlider:GetBallSize() end


---@public 进度条被改变的事件响应函数，不需要手动调用。
---@param event number
---@return void
function XUISlider:PercentChangedEvent(event) end


