---@class XUITexture
XUITexture = {}


---@public 获取合图中小图纹理坐标
---如若不存在，返回{0,0,1,1}
---@param spritename string 小图名称
---@return XVECTOR4
function XUITexture:GetSpriteFrameUV(spritename) end


---@public 获取合图中小图纹理大小
---如若不存在，返回合图大小
---@param spritename string 小图名称
---@return XVECTOR2
function XUITexture:GetSpriteFrameSize(spritename) end


---@public 判断合图中小图是否存在
---@param spritename string 小图名称
---@return boolean
function XUITexture:IsSpriteExist(spritename) end


---@public 判断合图中小图是否旋转
---@param spritename string 小图名称
---@return boolean
function XUITexture:IsSpriteRotate(spritename) end


---@public XUITexture_new00
---@return XUITexture
function XUITexture:new() end


---@class XTexture2DAtlas : XUITexture
XTexture2DAtlas = {}


---@public 获取合图中小图纹理坐标
---如若不存在，返回{0,0,1,1}
---@param spritename string 小图名称
---@return XVECTOR4
function XTexture2DAtlas:GetSpriteFrameUV(spritename) end


---@public 获取合图中小图纹理大小
---如若不存在，返回合图大小
---@param spritename string 小图名称
---@return XVECTOR2
function XTexture2DAtlas:GetSpriteFrameSize(spritename) end


---@public 判断合图中小图是否存在
---@param spritename string 小图名称
---@return boolean
function XTexture2DAtlas:IsSpriteExist(spritename) end


---@public 判断合图中小图是否旋转
---@param spritename string 小图名称
---@return boolean
function XTexture2DAtlas:IsSpriteRotate(spritename) end


---@public XTexture2DAtlas_new00
---@return XTexture2DAtlas
function XTexture2DAtlas:new() end


---@class XUITextureCache
XUITextureCache = {}


---@public 创建UI纹理缓存实例
---@return XUITextureCache
function XUITextureCache:CreateInstance() end


---@public XUITextureCache_new00
---@return XUITextureCache
function XUITextureCache:new() end


---@public 获取或创建UI纹理
---@param textureOrplistpath string 纹理或plist路径
---@param type_ number UI纹理类型
---@return XUITexture
function XUITextureCache:GetOrCreateTexture(textureOrplistpath, type_) end


---@public XUITextureCache_Release00
---@param delete_tex XUITexture
---@return void
function XUITextureCache:Release(delete_tex) end


---@public 释放UI纹理及相关image信息
---@param delete_tex_map xhashtable_xint32_and_XUITexture_p_ ui纹理
---@return void
function XUITextureCache:Release(delete_tex_map) end


---@public 通过小图名称获取plist拼接路径
---@param spriteName string
---@return string
function XUITextureCache:GetComBinePathBySpriteName(spriteName) end


---@public XUITextureCache_GetComBinePathBySpriteName01
---@param spriteName string
---@param plistPath string
---@return string
function XUITextureCache:GetComBinePathBySpriteName(spriteName, plistPath) end


---@public 分离plist路径与小图名称
---plistpath{spritename}
---@param path cppstring
---@param plistpath cppstring
---@param spritename cppstring
---@return boolean
function XUITextureCache:GetPlistPath(path, plistpath, spritename) end


---@public 判断字符串是否plistpath{spritename}格式
---@param xelua_var_56 cppstring
---@return boolean
function XUITextureCache:IsPlistPath(xelua_var_56) end


---@public 利用spritename1 替换listpath{spritename}spritename,并返回替换后字符串
---@param xelua_var_57 cppstring
---@param spritename1 cppstring
---@return cppstring
function XUITextureCache:ReplacePlistSpriteName(xelua_var_57, spritename1) end


---@public plistpath，spritename 拼接plistpath{spritename} 格式并返回
---@param xelua_var_58 cppstring
---@param xelua_var_59 cppstring
---@return cppstring
function XUITextureCache:GetPlistSpriteNameStr(xelua_var_58, xelua_var_59) end


