---此类代表UI场景的组件
---@class XEUISceneComponent : XEPrimitiveComponent
XEUISceneComponent = {}


---@manual xelua_XEngine_XEUISceneComponent_LoadAssetAsync_manual
---@public XEUISceneComponent_LoadAssetAsync_manual
---@param pPath string
---@param Delegate std::function<void( _cstring , XEActorComponent*, ResultType)>
---@return void
function XEUISceneComponent:LoadAssetAsync(pPath, Delegate) end


---@public XEUISceneComponent_GetAssetPath00
---@return string
function XEUISceneComponent:GetAssetPath() end


---@public XEUISceneComponent_GetUIAnimtionAssetPath00
---@return string
function XEUISceneComponent:GetUIAnimtionAssetPath() end


---@public XEUISceneComponent_GetScene00
---@return XUIScene
function XEUISceneComponent:GetScene() end


---@public 删除UI动画资源
---@return void
function XEUISceneComponent:Unload() end


---@public 获取动画控制器
---@return XEUIAnimationInstance 动画控制器
---@attention could be montage animation controller or model-animation controller.
function XEUISceneComponent:GetUIAnimationIns() end


---@public XEUISceneComponent_LoadAnimationAsset00
---@param pPath string
---@return boolean
function XEUISceneComponent:LoadAnimationAsset(pPath) end


---@public 设置UI渲染模式 3d or 2d
---@param xelua_var_66 number
---@return void
function XEUISceneComponent:SetRenderMode(xelua_var_66) end


---@public 设置3D模式下世界尺寸
---@param xelua_var_67 XVECTOR2
---@return void
function XEUISceneComponent:SetSize(xelua_var_67) end


---@public 设置3D模式下是否开启裁剪
---@param xelua_var_68 boolean
---@return void
function XEUISceneComponent:SetMask(xelua_var_68) end


---@public XEUISceneComponent_GetMask00
---@return boolean
function XEUISceneComponent:GetMask() end


---@public XEUISceneComponent_GetSize00
---@return XVECTOR2
function XEUISceneComponent:GetSize() end


---@public XEUISceneComponent_GetRenderMode00
---@return number
function XEUISceneComponent:GetRenderMode() end


---@public XEUISceneComponent_GetPhysicalScene00
---@return IX2DPhysicalScene
function XEUISceneComponent:GetPhysicalScene() end


---@public 获取包含给定世界坐标系点的碰撞体 ,2d物理启用后方可调用
---@param vWorldPos XVECTOR2 UI场景世界坐标
---@return X2DPhysicalColliderComponent X2DPhysicalColliderComponent
function XEUISceneComponent:TestPoint(vWorldPos) end


---@public 获取与给定世界坐标系矩形相交的碰撞体,2d物理启用后方可调用
---@param rect  XUIRect UI场景世界坐标系下矩形
---@return X2DPhysicalColliderComponent[] XArray<X2DPhysicalColliderComponent>
function XEUISceneComponent:TestAABB(rect) end


---@type string @readonly Component类型名
XEUISceneComponent.COMPONENT_TYPENAME = ''


