---AbstractCheckButton是一种特殊的两状态按钮,它任何时刻只会处于"选中"或者"未选中"的状态之一
---@class XUIAbstractCheckButton : XUIWidget
XUIAbstractCheckButton = {}


---@public 加载所有纹理并初始化一个复选框。
---@param strBackGroundNormalTexture string 背景普通状态纹理名
---@param strBackGroundSelectedTexture string 背景选中状态纹理名
---@param strCrossNormalTexture string 勾选状态纹理名
---@param strBackGroundDisabledTexture string 背景禁用状态纹理名
---@param strFrontCrossDisabledTexture string 勾选禁用状态纹理
---@param eTextureType number 纹理类型
---@return void
function XUIAbstractCheckButton:LoadTextures(strBackGroundNormalTexture, strBackGroundSelectedTexture, strCrossNormalTexture, strBackGroundDisabledTexture, strFrontCrossDisabledTexture, eTextureType) end


---@public 加载背景普通状态纹理
---@param strBackGroundNormalTexture string 背景普通状态纹理名
---@param eTextureType number 纹理类型
---@return void
function XUIAbstractCheckButton:LoadBackGroundTexture(strBackGroundNormalTexture, eTextureType) end


---@public 加载背景选中状态纹理
---@param strBackGroundSelectedTexture string 背景选中状态纹理名
---@param eTextureType number 纹理类型
---@return void
function XUIAbstractCheckButton:LoadBackGroundSelectedTexture(strBackGroundSelectedTexture, eTextureType) end


---@public 加载勾选选中状态的纹理
---@param strCrossNormalTexture string 纹理名称
---@param eTextureType number 纹理类型
---@return void
function XUIAbstractCheckButton:LoadFrontCrossTexture(strCrossNormalTexture, eTextureType) end


---@public 加载背景禁用状态纹理
---@param strBackGroundDisabledTexture string 背景选中状态纹理名
---@param eTextureType number 纹理类型
---@return void
function XUIAbstractCheckButton:LoadBackGroundDisabledTexture(strBackGroundDisabledTexture, eTextureType) end


---@public 加载勾选禁用状态纹理
---@param strFrontCrossDisabledTexture string 勾选禁用状态纹理名
---@param eTextureType number 纹理类型
---@return void
function XUIAbstractCheckButton:LoadFrontCrossDisabledTexture(strFrontCrossDisabledTexture, eTextureType) end


---@public 加载前景普通状态纹理
---@param strForeGroundTexture string 勾选禁用状态纹理名
---@param eTextureType number 纹理类型
---@return void
function XUIAbstractCheckButton:LoadForeGroundTexture(strForeGroundTexture, eTextureType) end


---@public 加载前景选中状态纹理
---@param strForeGroundSelectedTexture string 勾选禁用状态纹理名
---@param eTextureType number 纹理类型
---@return void
function XUIAbstractCheckButton:LoadForeGroundSelectedTexture(strForeGroundSelectedTexture, eTextureType) end


---@public 获取背景常态纹理名称，并返回
---@return string
function XUIAbstractCheckButton:GetBackgroundTexture() end


---@public 获取背景选中状态纹理名称，并返回
---@return string
function XUIAbstractCheckButton:GetBackgroundSelectedTexture() end


---@public 获取背景禁用状态纹理名称，并返回
---@return string
function XUIAbstractCheckButton:GetBackgroundDisabledTexture() end


---@public 获取勾选选中状态纹理名称，并返回
---@return string
function XUIAbstractCheckButton:GetFrontCrossTexture() end


---@public 获取勾选禁用状态纹理名称，并返回
---@return string
function XUIAbstractCheckButton:GetFrontCrossDisabledTexture() end


---@public 获取前景常态纹理名称，并返回
---@return string
function XUIAbstractCheckButton:GetForegroundTexture() end


---@public 获取前景选中状态纹理名称，并返回
---@return string
function XUIAbstractCheckButton:GetForegroundSelectedTexture() end


---@public 修改复选框的状态 设置True会使复选框变为“选中状态”，否则传False会使复选框变为“未选中状态”
---@param selected boolean 是否选中
---@return void
function XUIAbstractCheckButton:SetSelected(selected) end


---@public 获取复选框的状态，并返回
---@return boolean
function XUIAbstractCheckButton:IsSelected() end


---@public 通过名称设置选中时出现的Node，仅针对RadioButton的子节点有效
---@param strSelectedNodeName string
---@return void
function XUIAbstractCheckButton:SetSelectedNodeName(strSelectedNodeName) end


---@public 获取复选框的状态，并返回
---@return string
function XUIAbstractCheckButton:GetSelectedNodeName() end


---@public 当用户按下复选框时,按钮将会缩放到一个比例 最后复选框的缩放值等于(复选框原尺寸+ _zoomScale)
---@param scale number 缩放比例
---@return void
function XUIAbstractCheckButton:SetZoomScale(scale) end


---@public 获取缩放比例，并返回
---@return number
function XUIAbstractCheckButton:GetZoomScale() end


---@public 获取背景Image
---@return XUIImage
function XUIAbstractCheckButton:GetBackGroundBoxImage() end


---@public 获取勾选Image
---@return XUIImage
function XUIAbstractCheckButton:GetFrontCrossImage() end


---@public XUIAbstractCheckButton_SetUseForegroundImage00
---@param bUseForegroundImage boolean
---@return void
function XUIAbstractCheckButton:SetUseForegroundImage(bUseForegroundImage) end


---@public XUIAbstractCheckButton_IsUseForegroundImage00
---@return boolean
function XUIAbstractCheckButton:IsUseForegroundImage() end


---@public XUIAbstractCheckButton_UpdateBackgroundImage00
---@return void
function XUIAbstractCheckButton:UpdateBackgroundImage() end


---@public XUIAbstractCheckButton_UpdateFrontCrossImage00
---@return void
function XUIAbstractCheckButton:UpdateFrontCrossImage() end


---@public XUIAbstractCheckButton_UpdateForegroundImage00
---@return void
function XUIAbstractCheckButton:UpdateForegroundImage() end


---@public XUIAbstractCheckButton_SetForePosition00
---@param pos XVECTOR2
---@return void
function XUIAbstractCheckButton:SetForePosition(pos) end


---@public XUIAbstractCheckButton_SetForeContentSize00
---@param size XVECTOR2
---@return void
function XUIAbstractCheckButton:SetForeContentSize(size) end


---@public XUIAbstractCheckButton_GetForePosition00
---@return XVECTOR2
function XUIAbstractCheckButton:GetForePosition() end


---@public XUIAbstractCheckButton_GetForeContentSize00
---@return XVECTOR2
function XUIAbstractCheckButton:GetForeContentSize() end


---@type number @enum AudioTriggerType
XUIAbstractCheckButton.XUI_BEGAN = 0


---@type number @enum AudioTriggerType
XUIAbstractCheckButton.XUI_ENDED = 0


---@type number @enum AudioTriggerType
XUIAbstractCheckButton.XUI_CANCELED = 0


---@public XUIAbstractCheckButton_IsEnableAudio00
---@return boolean
function XUIAbstractCheckButton:IsEnableAudio() end


---@public XUIAbstractCheckButton_SetEnableAudio00
---@param bSet boolean
---@return void
function XUIAbstractCheckButton:SetEnableAudio(bSet) end


---@public XUIAbstractCheckButton_GetAudioPath00
---@return string
function XUIAbstractCheckButton:GetAudioPath() end


---@public XUIAbstractCheckButton_SetAudioPath00
---@param strAudioPath string
---@return void
function XUIAbstractCheckButton:SetAudioPath(strAudioPath) end


---@public XUIAbstractCheckButton_GetAudioTriggerType00
---@return number
function XUIAbstractCheckButton:GetAudioTriggerType() end


---@public XUIAbstractCheckButton_SetAudioTriggerType00
---@param eType number
---@return void
function XUIAbstractCheckButton:SetAudioTriggerType(eType) end


---@public XUIAbstractCheckButton_PlayAudio00
---@return void
function XUIAbstractCheckButton:PlayAudio() end


---@public XUIAbstractCheckButton_StopAudio00
---@return void
function XUIAbstractCheckButton:StopAudio() end


