---@class XUICheckBox : XUIAbstractCheckButton
XUICheckBox = {}


---@type number @enum CheckBoxEventType
XUICheckBox.CHECKBOX_STATE_EVENT_SELECTED = 0


---@type number @enum CheckBoxEventType
XUICheckBox.CHECKBOX_STATE_EVENT_UNSELECTED = 0


---@type number @enum EventType
XUICheckBox.SELECTED = 0


---@type number @enum EventType
XUICheckBox.UNSELECTED = 0


---@public 创建并返回一个空的控件实例的指针
---@return XUICheckBox 空的控件实例的指针
function XUICheckBox:Create() end


---@public 使用一些图片来创建一个复选框
---@param strBackGroundNormalTexture string 背景普通状态纹理
---@param strBackGroundSelectedTexture string 背景选中状态纹理
---@param strCrossTexture string 勾选选中状态纹理
---@param strBackGroundDisabledTexture string 背景禁用状态纹理
---@param strFrontCrossDisabledTexture string 勾选禁用状态纹理
---@param eTextureType number 纹理类型
---@return XUICheckBox 一个复选框实例的指针
function XUICheckBox:Create(strBackGroundNormalTexture, strBackGroundSelectedTexture, strCrossTexture, strBackGroundDisabledTexture, strFrontCrossDisabledTexture, eTextureType) end


---@public 另一个工厂方法，用来创建一个复选框实例。 这种方法使用更少的图片资源来创建一个复选框
---@param strBackGroundTexture string 背景普通状态纹理
---@param strCrossTexture string 勾选选中状态纹理
---@param eTextureType number 纹理类型
---@return XUICheckBox 一个复选框实例的指针
function XUICheckBox:Create(strBackGroundTexture, strCrossTexture, eTextureType) end


---@manual xelua_XEngine_XUICheckBox_AddCheckBoxEventListener_manual
---@public XUICheckBox_AddCheckBoxEventListener_manual
---@param callback  std::function<void(XUINode*, XUICheckBox::EventType)>
---@return void
function XUICheckBox:AddCheckBoxEventListener(callback) end


