---@class XUIEditBox : XUIWidget
XUIEditBox = {}


---@type number @enum KeyboardReturnType
XUIEditBox.XUI_DEFAULT = 0


---@type number @enum KeyboardReturnType
XUIEditBox.XUI_DONE = 0


---@type number @enum KeyboardReturnType
XUIEditBox.XUI_SEND = 0


---@type number @enum KeyboardReturnType
XUIEditBox.XUI_SEARCH = 0


---@type number @enum KeyboardReturnType
XUIEditBox.XUI_GO = 0


---@type number @enum KeyboardReturnType
XUIEditBox.XUI_NEXT = 0


---@type number @enum InputMode
XUIEditBox.XUI_ANY = 0


---@type number @enum InputMode
XUIEditBox.XUI_EMAIL_ADDRESS = 0


---@type number @enum InputMode
XUIEditBox.XUI_NUMERIC = 0


---@type number @enum InputMode
XUIEditBox.XUI_PHONE_NUMBER = 0


---@type number @enum InputMode
XUIEditBox.XUI_URL = 0


---@type number @enum InputMode
XUIEditBox.XUI_DECIMAL = 0


---@type number @enum InputMode
XUIEditBox.XUI_SINGLE_LINE = 0


---@type number @enum InputFlag
XUIEditBox.XUI_PASSWORD = 0


---@type number @enum InputFlag
XUIEditBox.XUI_SENSITIVE = 0


---@type number @enum InputFlag
XUIEditBox.XUI_INITIAL_CAPS_WORD = 0


---@type number @enum InputFlag
XUIEditBox.XUI_INITIAL_CAPS_SENTENCE = 0


---@type number @enum InputFlag
XUIEditBox.XUI_INITIAL_CAPS_ALL_CHARACTERS = 0


---@type number @enum InputFlag
XUIEditBox.XUI_LOWERCASE_ALL_CHARACTERS = 0


---@type number @enum TextHAlignment
XUIEditBox.LEFT = 0


---@type number @enum TextHAlignment
XUIEditBox.CENTER = 0


---@type number @enum TextHAlignment
XUIEditBox.RIGHT = 0


---@public 创建并返回一个空的控件实例的指针
---@return XUIEditBox 控件指针
function XUIEditBox:Create() end


---@public 创建一个固定大小的编辑框
---@param strNormalTexture string 常态纹理图片
---@param eTextureType number 纹理类型，相对路径/绝对路径
---@return XUIEditBox 一个编辑框对象指针,只有当你对返回对象调用retain的时候才需要调用release
function XUIEditBox:Create(strNormalTexture, eTextureType) end


---@public 获取图片
---@return XUIImage
function XUIEditBox:GetImage() end


---@public 加载纹理
---@param strTexture string 纹理路径
---@param eTextureType number 纹理类型
---@return void
function XUIEditBox:LoadTexture(strTexture, eTextureType) end


---@public 获取纹理
---@return string 获取纹理路径名
function XUIEditBox:GetTexture() end


---@public 设置编辑框控件的代理类
---@param pDelegate XUIEditBoxDelegate
---@return void
function XUIEditBox:SetDelegate(pDelegate) end


---@public 获取编辑框控件的代理类
---@return XUIEditBoxDelegate
function XUIEditBox:GetDelegate() end


---@public 设置编辑框中输入的文本
---@param strText string 给定的文本字符串
---@return void
function XUIEditBox:SetText(strText) end


---@public 设置编辑框中输入的文本
---@return string 给定的文本字符串
function XUIEditBox:GetText() end


---@public 设置编辑框的字体。仅支持系统字体
---@param strFont string 字体名称
---@param nFontSize number 字体大小
---@return void
function XUIEditBox:SetFont(strFont, nFontSize) end


---@public 设置编辑框的字体的名字。仅支持系统字体
---@param strFont string 字体名称
---@return void
function XUIEditBox:SetFontName(strFont) end


---@public 获取编辑框的字体的名字。
---@return string 字体名称
function XUIEditBox:GetFontName() end


---@public 设置编辑框的字体的大小。仅支持系统字体
---@param nFontSize number 字体大小
---@return void
function XUIEditBox:SetFontSize(nFontSize) end


---@public 获取编辑框的字体的大小。
---@return number 字体大小
function XUIEditBox:GetFontSize() end


---@public 设置编辑框的字体颜色。
---@param color  XCOLORBASE 字体颜色
---@return void
function XUIEditBox:SetFontColor(color) end


---@public 获取编辑框的字体颜色。
---@return  XCOLORBASE 字体颜色
function XUIEditBox:GetFontColor() end


---@public 设置占位符文本内容
---@param strText string 文本字符串
---@return void
function XUIEditBox:SetPlaceholderText(strText) end


---@public 获取占位符文本内容
---@return string 占位符文本字符串
function XUIEditBox:GetPlaceholderText() end


---@public 设置占位符的字体。仅支持系统字体
---@param strFont string 字体名称
---@param nFontSize number 字体大小
---@return void
function XUIEditBox:SetPlaceholderFont(strFont, nFontSize) end


---@public 设置占位符的字体名称
---@param strFont string 字体名称
---@return void
function XUIEditBox:SetPlaceholderFontName(strFont) end


---@public 获取占位符的字体名称
---@return string 字体名称
function XUIEditBox:GetPlaceholderFontName() end


---@public 设置占位符的字体大小
---@param nFontSize number 字体大小
---@return void
function XUIEditBox:SetPlaceholderFontSize(nFontSize) end


---@public 获取占位符的字体大小
---@return number 字体大小
function XUIEditBox:GetPlaceholderFontSize() end


---@public 设置占位符的字体颜色
---@param color  XCOLORBASE 字体颜色
---@return void
function XUIEditBox:SetPlaceholderFontColor(color) end


---@public 获取占位符的字体颜色
---@return  XCOLORBASE 字体颜色
function XUIEditBox:GetPlaceholderFontColor() end


---@public 设置编辑框的输入模式
---@param eInputMode number 输入模式
---@return void
function XUIEditBox:SetInputMode(eInputMode) end


---@public 获取编辑框的输入模式
---@return number 输入模式
function XUIEditBox:GetInputMode() end


---@public 设置编辑框允许输入的最大长度。 设置这个值默认允许多行输入 可以在Android,iOS和Windows Phone平台使用
---@param nMaxLength number 最大长度
---@return void
function XUIEditBox:SetMaxLength(nMaxLength) end


---@public 获取编辑框允许输入的最大长度
---@return number 最大长度
function XUIEditBox:GetMaxLength() end


---@public 设置编辑框的输入标识，这个标识是EditBox::InputFlag类型
---@param eInputFlag number 输入标识
---@return void
function XUIEditBox:SetInputFlag(eInputFlag) end


---@public 获取编辑框的输入标识
---@return number 输入标识
function XUIEditBox:GetInputFlag() end


---@public 设置编辑框的键盘的Return类型，这个类型的取值为EditBox::KeyboardReturnType常量之一
---@param eReturnType number Return类型
---@return void
function XUIEditBox:SetReturnType(eReturnType) end


---@public 获取编辑框的键盘的Return类型
---@return number Return类型
function XUIEditBox:GetReturnType() end


---@public 设置文本水平对齐方式
---@param eAlignment number XUI_TH_LEFT:左对齐,XUI_TH_CENTER:居中,XUI_TH_RIGHT:右对齐
---@return void
function XUIEditBox:SetTextHorizontalAlignment(eAlignment) end


---@public 获取文本水平对齐方式
---@return number eAlignmentXUI_TH_LEFT:左对齐,XUI_TH_CENTER:居中,XUI_TH_RIGHT:右对齐
function XUIEditBox:GetTextHorizontalAlignment() end


---@public 设置文本垂直对齐方式
---@param eVAlignment number XUI_TV_TOP:上对齐,XUI_TV_CENTER:居中,XUI_TV_BOTTOM:下对齐
---@return void
function XUIEditBox:SetTextVerticalAlignment(eVAlignment) end


---@public 获取文本水平对齐方式
---@return number eAlignmentXUI_TH_LEFT:左对齐,XUI_TH_CENTER:居中,XUI_TH_RIGHT:右对齐
function XUIEditBox:GetTextVerticalAlignment() end


---@public 当下拉项被点击时执行的事件，不需要手动调用。
---@param pNode XUINode
---@param controlEvent number
---@return void
function XUIEditBox:TouchDownAction(pNode, controlEvent) end


---@public 是否在EditBox失去焦点时结束编辑
---@param bSet boolean true:立即结束，false:不会结束。
---@return void
function XUIEditBox:EndEditingWhenLostFocus(bSet) end


---@public 结束输入，并不需要手动调用
---@return void
function XUIEditBox:ForceEndEditing() end


---@public XUIEditBox_SetSelectTextWhenOpenKeyboard00
---@param b boolean
---@return void
function XUIEditBox:SetSelectTextWhenOpenKeyboard(b) end


---@class XUIEditBoxDelegate : XOwnerRecorder
XUIEditBoxDelegate = {}


---@public XUIEditBoxDelegate_new00
---@return XUIEditBoxDelegate
function XUIEditBoxDelegate:new() end


---@type number @enum EditBoxEndAction
XUIEditBoxDelegate.XUI_UNKNOWN = 0


---@type number @enum EditBoxEndAction
XUIEditBoxDelegate.XUI_TAB_TO_NEXT = 0


---@type number @enum EditBoxEndAction
XUIEditBoxDelegate.XUI_TAB_TO_PREVIOUS = 0


---@type number @enum EditBoxEndAction
XUIEditBoxDelegate.XUI_RETURN = 0


---@type number @enum EditBoxEndAction
XUIEditBoxDelegate.XUI_LOST_FOCUS = 0


