---@class XUIGuidePageGroup : XUIWidget
XUIGuidePageGroup = {}


---@public XUIGuidePageGroup_new00
---@return XUIGuidePageGroup
function XUIGuidePageGroup:new() end


---@public 创建一个向导页组，向导页一般是以组为单位使用的。
---@param vGuidePage XUIGuidePage[] 为一个向导页数组。
---@return XUIGuidePageGroup
function XUIGuidePageGroup:Create(vGuidePage) end


---@public 创建一个空的向导页组。
---@return XUIGuidePageGroup
function XUIGuidePageGroup:Create() end


---@public 设置为自动响应触摸事件，即调用后，触摸屏幕任意位置，则会切换到下一页向导页。
---@return void
function XUIGuidePageGroup:SetAutoTouchEventEnabled() end


---@public 设置为当所有向导页播放完毕后，将自己从父节点中移除。
---@param bRemove boolean
---@return void
function XUIGuidePageGroup:SetRemoveSelfWhenEnd(bRemove) end


---@public 获取是否自动移除自己。
---@return boolean 是否自动移除自己。
function XUIGuidePageGroup:GetRemoveSelfWhenEnd() end


---@public 手动跳转到上一向导页
---@return void
function XUIGuidePageGroup:PrevPage() end


---@public 手动跳转到下一向导页
---@return void
function XUIGuidePageGroup:NextPage() end


---@public 添加一页向导页。
---@param pPage XUIGuidePage 要添加的向导页。
---@return void
function XUIGuidePageGroup:AppendGuidePage(pPage) end


---@public 插入一页向导页。
---@param pPage XUIGuidePage 要添加的向导页。
---@param nIndex number 要插入的索引位置。
---@return void
function XUIGuidePageGroup:InsertGuidePage(pPage, nIndex) end


---@public 移除一页向导页。
---@param nIndex number 要移除的向导页索引。
---@return void
function XUIGuidePageGroup:RemoveGuidePage(nIndex) end


---@class XUIGuidePage : XUIWidget
XUIGuidePage = {}


---@public XUIGuidePage_new00
---@return XUIGuidePage
function XUIGuidePage:new() end


---@public 创建一个向导页组，向导页一般是以组为单位使用的。
---@param v2ScreenSize XVECTOR2
---@return XUIGuidePage
function XUIGuidePage:Create(v2ScreenSize) end


---@public 创建一个空的向导页组。
---@return XUIGuidePage
function XUIGuidePage:Create() end


---@public XUIGuidePage_SetMaskSceneSize00
---@param v2ScreenSize XVECTOR2
---@return void
function XUIGuidePage:SetMaskSceneSize(v2ScreenSize) end


---@public 获取遮盖范围大小
---@return XVECTOR2 返回遮盖范围大小
function XUIGuidePage:GetMaskSceneSize() end


---@public XUIGuidePage_SetTargetWidget00
---@param pWidget XUIWidget
---@return void
function XUIGuidePage:SetTargetWidget(pWidget) end


---@public XUIGuidePage_SetTargetWidget01
---@param pWidget XUIWidget
---@param bTouchAllow boolean
---@return void
function XUIGuidePage:SetTargetWidget(pWidget, bTouchAllow) end


---@public XUIGuidePage_GetHighLightWidget00
---@return XUIWidget
function XUIGuidePage:GetHighLightWidget() end


---@public 获取向导页将整个场景遮盖住的效果
---@return number 返回遮盖效果值(0~1)0是不遮盖，1是遮盖成纯黑色。
function XUIGuidePage:GetAlpha() end


---@public XUIGuidePage_SetAlpha00
---@param fAlpha number
---@return void
function XUIGuidePage:SetAlpha(fAlpha) end


---@public XUIGuidePage_GetTouchMaskWidget00
---@return XUIWidget
function XUIGuidePage:GetTouchMaskWidget() end


---@public XUIGuidePage_GetVisibleMaskWidget00
---@return XUIWidget
function XUIGuidePage:GetVisibleMaskWidget() end


