---@class XUIImageArray : XUIWidget
XUIImageArray = {}


---@class XUIImageArray__XUIImageElement
local XUIImageArray__XUIImageElement = {}
XUIImageArray.XUIImageElement = XUIImageArray__XUIImageElement


---@type XVECTOR2
XUIImageArray__XUIImageElement.m_vPosition = {}


---@type XVECTOR2
XUIImageArray__XUIImageElement.m_vSize = {}


---@type number
XUIImageArray__XUIImageElement.m_fRotation = 0


---@type number
XUIImageArray__XUIImageElement.m_fTime = 0


---@type XCOLORBASE
XUIImageArray__XUIImageElement.m_Color = {}


---@type userdata
XUIImageArray__XUIImageElement.m_pUserData = {}


---@public XUIImageArray_Create00
---@return XUIImageArray
function XUIImageArray:Create() end


---@public XUIImageArray_Create01
---@param strTextureName string
---@param texType number
---@return XUIImageArray
function XUIImageArray:Create(strTextureName, texType) end


---@public XUIImageArray_new00
---@return XUIImageArray
function XUIImageArray:new() end


---@public XUIImageArray_LoadTexture00
---@param strTexture string
---@param texType number
---@return boolean
function XUIImageArray:LoadTexture(strTexture, texType) end


---@public XUIImageArray_GetTexturePath00
---@return string
function XUIImageArray:GetTexturePath() end


---@public XUIImageArray_SetNum00
---@param nNum number
---@return void
function XUIImageArray:SetNum(nNum) end


---@public XUIImageArray_GetNum00
---@return number
function XUIImageArray:GetNum() end


---@public XUIImageArray_GetActiveNum00
---@return number
function XUIImageArray:GetActiveNum() end


---@public XUIImageArray_SetLife00
---@param fLife number
---@return void
function XUIImageArray:SetLife(fLife) end


---@public XUIImageArray_GetLife00
---@return number
function XUIImageArray:GetLife() end


---@public XUIImageArray_SetFadeRatio00
---@param fRatio number
---@return void
function XUIImageArray:SetFadeRatio(fRatio) end


---@public XUIImageArray_GetFadeRatio00
---@return number
function XUIImageArray:GetFadeRatio() end


---@public XUIImageArray_AddImage00
---@param vPos XVECTOR2
---@param vSize XVECTOR2
---@param fRotation number
---@param pUserData userdata
---@return void
function XUIImageArray:AddImage(vPos, vSize, fRotation, pUserData) end


---@public XUIImageArray_RemoveImage00
---@param pUserData userdata
---@return void
function XUIImageArray:RemoveImage(pUserData) end


---@public XUIImageArray_UpdateImage00
---@param pData userdata
---@param vPos XVECTOR2
---@param vSize XVECTOR2
---@param fRotation number
---@return void
function XUIImageArray:UpdateImage(pData, vPos, vSize, fRotation) end


---@public XUIImageArray_UpdateImage01
---@param pData userdata
---@param vPos XVECTOR2
---@param vSize XVECTOR2
---@param fRotation number
---@param color  XCOLORBASE
---@return void
function XUIImageArray:UpdateImage(pData, vPos, vSize, fRotation, color) end


---@public XUIImageArray_UpdateImage02
---@param pData userdata
---@param vPos XVECTOR2
---@param fRotation number
---@return void
function XUIImageArray:UpdateImage(pData, vPos, fRotation) end


---@public XUIImageArray_UpdateImage03
---@param pData userdata
---@param vPos XVECTOR2
---@param fRotation number
---@param color  XCOLORBASE
---@return void
function XUIImageArray:UpdateImage(pData, vPos, fRotation, color) end


---@public XUIImageArray_GetImage00
---@param pData userdata
---@return XUIImageArray__XUIImageElement
function XUIImageArray:GetImage(pData) end


---@manual xelua_XEngine_XUIImageArray_SetImageKilledEventListener_manual
---@public XUIImageArray_SetImageKilledEventListener_manual
---@param callback  std::function<void(XUINode*, _userdata )>
---@return void
function XUIImageArray:SetImageKilledEventListener(callback) end


---@public XUIImageArray_SetUseSequence00
---@param bUse boolean
---@return void
function XUIImageArray:SetUseSequence(bUse) end


---@public XUIImageArray_IsUseSequence00
---@return boolean
function XUIImageArray:IsUseSequence() end


---@public XUIImageArray_SetUVTile00
---@param vTile XVECTOR2
---@return void
function XUIImageArray:SetUVTile(vTile) end


---@public XUIImageArray_SetUVTile01
---@param fUTile number
---@param fVTile number
---@return void
function XUIImageArray:SetUVTile(fUTile, fVTile) end


---@public XUIImageArray_GetUVTile00
---@return XVECTOR2
function XUIImageArray:GetUVTile() end


---@public XUIImageArray_SetSequenceFPS00
---@param fFPS number
---@return void
function XUIImageArray:SetSequenceFPS(fFPS) end


---@public XUIImageArray_GetSequenceFPS00
---@return number
function XUIImageArray:GetSequenceFPS() end


---@public XUIImageArray_SetActualFrameNum00
---@param nNum number
---@return void
function XUIImageArray:SetActualFrameNum(nNum) end


---@public XUIImageArray_GetActualFrameNum00
---@return number
function XUIImageArray:GetActualFrameNum() end


---@public XUIImageArray_SetMetaballEnabled00
---@param bEnable boolean
---@return void
function XUIImageArray:SetMetaballEnabled(bEnable) end


---@public XUIImageArray_IsMetaballEnabled00
---@return boolean
function XUIImageArray:IsMetaballEnabled() end


---@public XUIImageArray_SetMetaballRadius00
---@param fRadius number
---@return void
function XUIImageArray:SetMetaballRadius(fRadius) end


---@public XUIImageArray_GetMetaballRadius00
---@return number
function XUIImageArray:GetMetaballRadius() end


---@public XUIImageArray_SetMetaballRadiusExtent00
---@param fRadiusExtent number
---@return void
function XUIImageArray:SetMetaballRadiusExtent(fRadiusExtent) end


---@public XUIImageArray_GetMetaballRadiusExtent00
---@return number
function XUIImageArray:GetMetaballRadiusExtent() end


---@public XUIImageArray_SetMetaballEnergyThreshold00
---@param fEnergyThreshold number
---@return void
function XUIImageArray:SetMetaballEnergyThreshold(fEnergyThreshold) end


---@public XUIImageArray_GetMetaballEnergyThreshold00
---@return number
function XUIImageArray:GetMetaballEnergyThreshold() end


---@public XUIImageArray_SetMetaballColor00
---@param color  XCOLORBASE
---@return void
function XUIImageArray:SetMetaballColor(color) end


---@public XUIImageArray_GetMetaballColor00
---@return  XCOLORBASE
function XUIImageArray:GetMetaballColor() end


