---@class XUILabelCyclicRoll : XUIWidget
XUILabelCyclicRoll = {}


---@type number @enum XUIELabelRollType
XUILabelCyclicRoll.XUI_LABELROLL_LEFT_TO_RIGHT = 0


---@type number @enum XUIELabelRollType
XUILabelCyclicRoll.XUI_LABELROLL_RIGHT_TO_LEFT = 0


---@type number @enum XUIELabelRollType
XUILabelCyclicRoll.XUI_LABELROLL_UP_TO_DOWN = 0


---@type number @enum XUIELabelRollType
XUILabelCyclicRoll.XUI_LABELROLL_DOWN_TO_UP = 0


---@type number @enum XUIELabelRollType
XUILabelCyclicRoll.XUI_LABELROLL_NUM = 0


---@public XUILabelCyclicRoll_CreateRollOfTTF00
---@param eRollType number
---@return XUILabelCyclicRoll
function XUILabelCyclicRoll:CreateRollOfTTF(eRollType) end


---@public XUILabelCyclicRoll_CreateRollOfTTF01
---@param ttfConfig  XUITTFConfig
---@param eRollType number
---@return XUILabelCyclicRoll
function XUILabelCyclicRoll:CreateRollOfTTF(ttfConfig, eRollType) end


---@public XUILabelCyclicRoll_CreateRollOfSys00
---@param eRollType number
---@return XUILabelCyclicRoll
function XUILabelCyclicRoll:CreateRollOfSys(eRollType) end


---@public XUILabelCyclicRoll_CreateRollOfSys01
---@param strSysFontName string
---@param fFontPointSize number
---@param eRollType number
---@return XUILabelCyclicRoll
function XUILabelCyclicRoll:CreateRollOfSys(strSysFontName, fFontPointSize, eRollType) end


---@public XUILabelCyclicRoll_new00
---@param eRollType number
---@return XUILabelCyclicRoll
function XUILabelCyclicRoll:new(eRollType) end


---@public XUILabelCyclicRoll_new01
---@param ttfConfig  XUITTFConfig
---@param eRollType number
---@return XUILabelCyclicRoll
function XUILabelCyclicRoll:new(ttfConfig, eRollType) end


---@public XUILabelCyclicRoll_new02
---@param strSysFontName string
---@param fFontPointSize number
---@param eRollType number
---@return XUILabelCyclicRoll
function XUILabelCyclicRoll:new(strSysFontName, fFontPointSize, eRollType) end


---@public 设置，文本滚动区域
---@param nRollWidth number 滚动区域宽
---@param nRollHeight number 滚动区域高
---@return void
function XUILabelCyclicRoll:SetRollArea(nRollWidth, nRollHeight) end


---@public 获取文本滚动区域高
---@return number 滚动区域高
function XUILabelCyclicRoll:GetRollAreaHeight() end


---@public 获取文本滚动区域宽
---@return number 滚动区域宽
function XUILabelCyclicRoll:GetRollAreaWidth() end


---@public 设置，文本滚动速度
---@param fRollSpeed number 滚动速度
---@return void
function XUILabelCyclicRoll:SetRollSpeed(fRollSpeed) end


---@public 获取文本滚动速度
---@return number 滚动速度
function XUILabelCyclicRoll:GetRollSpeed() end


---@public 设置文本滚动类型
---@param eRollType number 滚动类型
---@return void
function XUILabelCyclicRoll:SetRollType(eRollType) end


---@public 获取文本滚动类型
---@return number 滚动类型
function XUILabelCyclicRoll:GetRollType() end


---@public 设置，是否ContentSize自动适应文本大小;
---开启时：	如果滚动类型为左向右或右向左时，则ContentSize的高度自动与文本高度相等；
---如果滚动类型为上向下或下向上时，则ContentSize的宽度自动与文本宽度相等；
---关闭时：ContentSize = RollArea
---@param bFitText boolean 是否ContentSize自动适应文本大小
---@return void
function XUILabelCyclicRoll:SetFitTextSize(bFitText) end


---@public 判断是否ContentSize自动适应文本大小
---@return boolean
function XUILabelCyclicRoll:IsFitTextSize() end


---@public 设置循环播放周期时间；
---如果设置的循环播放周期时间 < 文字滚动时间， 实际循环播放周期时间 = 文字滚动时间；
---如果设置的循环播放周期时间 > 文字滚动时间， 实际循环播放周期时间 = 设置的循环播放周期时间；
---@param fLoopTime number 循环播放周期时间
---@return void
function XUILabelCyclicRoll:SetLoopTime(fLoopTime) end


---@public 获取循环播放周期时间
---@return number
function XUILabelCyclicRoll:GetLoopTime() end


---@public 滚动控制--暂停
---@return void
function XUILabelCyclicRoll:PauseRoll() end


---@public 滚动控制--恢复
---@return void
function XUILabelCyclicRoll:ResumeRoll() end


---@public 是否在滚动
---@return boolean
function XUILabelCyclicRoll:IsRolling() end


---@public 滚动控制--从头开始
---@return void
function XUILabelCyclicRoll:ResetToStart() end


---@public 设置文本内容
---@param strUtf8Text string
---@return void
function XUILabelCyclicRoll:SetString(strUtf8Text) end


---@public 获取文本内容
---@return string
function XUILabelCyclicRoll:GetString() end


---@public 获取文本内容大小
---@return number
function XUILabelCyclicRoll:GetStringCount() end


---@public 设置文本颜色
---@param clr  XCOLORBASE
---@return void
function XUILabelCyclicRoll:SetTextColor(clr) end


---@public 获取文本颜色
---@return  XCOLORBASE
function XUILabelCyclicRoll:GetTextColor() end


---@public 设置字体大小
---@param fPointSize number
---@return void
function XUILabelCyclicRoll:SetTextPointSize(fPointSize) end


---@public 获取字体大小
---@return number
function XUILabelCyclicRoll:GetTextPointSize() end


