---UI的布局组件
---@class XUILayoutComponent : XUIComponent
XUILayoutComponent = {}


---@type number @enum ResizeMode
XUILayoutComponent.XUI_NONE = 0


---@type number @enum ResizeMode 容器大小随子节点变化
XUILayoutComponent.XUI_CONTAINER = 0


---@type number @enum AxisDirection
XUILayoutComponent.HORIZONTAL = 0


---@type number @enum AxisDirection
XUILayoutComponent.VERTICAL = 0


---@type number @enum LayoutType
XUILayoutComponent.LT_ABSOLUTE = 0


---@type number @enum LayoutType
XUILayoutComponent.LT_VERTICAL = 0


---@type number @enum LayoutType
XUILayoutComponent.LT_HORIZONTAL = 0


---@type number @enum LayoutType
XUILayoutComponent.LT_GRID = 0


---@type number @enum LayoutType
XUILayoutComponent.LT_TREE = 0


---@type number @enum LayoutVAlignment
XUILayoutComponent.LT_LV_TOP = 0


---@type number @enum LayoutVAlignment
XUILayoutComponent.LT_LV_CENTER = 0


---@type number @enum LayoutVAlignment
XUILayoutComponent.LT_LV_BOTTOM = 0


---@type number @enum LayoutHAlignment
XUILayoutComponent.LT_LH_LEFT = 0


---@type number @enum LayoutHAlignment
XUILayoutComponent.LT_LH_CENTER = 0


---@type number @enum LayoutHAlignment
XUILayoutComponent.LT_LH_RIGHT = 0


---@public 创建一个XUILayoutComponent布局组件
---@param pNode XUINode 目标节点
---@return XUILayoutComponent 创建出的XUILayoutComponent组件
function XUILayoutComponent:Create(pNode) end


---@public XUILayoutComponent_Create01
---@return XUILayoutComponent
function XUILayoutComponent:Create() end


---@public 设置左侧的空白填充
---@param fLeft number 左侧填充大小
---@return void
function XUILayoutComponent:SetLeftPadding(fLeft) end


---@public 设置右侧的空白填充
---@param fRight number 右侧填充大小
---@return void
function XUILayoutComponent:SetRightPadding(fRight) end


---@public 设置顶部的空白填充
---@param fTop number 顶部填充大小
---@return void
function XUILayoutComponent:SetTopPadding(fTop) end


---@public 设置底部的空白填充
---@param fBottom number 底部填充大小
---@return void
function XUILayoutComponent:SetBottomPadding(fBottom) end


---@public 获取左侧的空白填充
---@return number 左侧填充大小
function XUILayoutComponent:GetLeftPadding() end


---@public 获取右侧的空白填充
---@return number 右侧填充大小
function XUILayoutComponent:GetRightPadding() end


---@public 获取顶部的空白填充
---@return number 顶部填充大小
function XUILayoutComponent:GetTopPadding() end


---@public 获取底部的空白填充
---@return number 底部填充大小
function XUILayoutComponent:GetBottomPadding() end


---@public 设置XUILayout中，两个控件之间的横向间隔
---@param fSpaceX number 间隔值（单位像素）
---@return void
function XUILayoutComponent:SetSpaceX(fSpaceX) end


---@public 获取XUILayout中，两个控件之间的横向间隔
---@return number 两个控件之间的间隔值（单位像素）
function XUILayoutComponent:GetSpaceX() end


---@public 设置XUILayout中，两个控件之间的纵向间隔
---@param fSpaceY number 间隔值（单位像素）
---@return void
function XUILayoutComponent:SetSpaceY(fSpaceY) end


---@public 获取XUILayout中，两个控件之间的纵向间隔
---@return number 两个控件之间的间隔值（单位像素）
function XUILayoutComponent:GetSpaceY() end


---@public 改变布局类型
---@param eType number 布局类型
---@return void
function XUILayoutComponent:SetLayoutType(eType) end


---@public 获取布局类型
---@return number 布局类型
function XUILayoutComponent:GetLayoutType() end


---@public 设置布局缩放模式
---@param xelua_var_17 number
---@return void
function XUILayoutComponent:SetResizeMode(xelua_var_17) end


---@public XUILayoutComponent_GetResizeMode00
---@return number
function XUILayoutComponent:GetResizeMode() end


---@public 设置网格模式主填充方向
---@param xelua_var_18 number
---@return void
function XUILayoutComponent:SetAxisDirection(xelua_var_18) end


---@public XUILayoutComponent_GetAxisDirection00
---@return number
function XUILayoutComponent:GetAxisDirection() end


---@public XUILayoutComponent_EnableAutoLayout00
---@param xelua_var_19 boolean
---@return void
function XUILayoutComponent:EnableAutoLayout(xelua_var_19) end


---@public XUILayoutComponent_IsAutoLayout00
---@return boolean
function XUILayoutComponent:IsAutoLayout() end


---@public XUILayoutComponent_SetHorizontalAlignment00
---@param h number
---@return void
function XUILayoutComponent:SetHorizontalAlignment(h) end


---@public XUILayoutComponent_SetVerticalAlignment00
---@param h number
---@return void
function XUILayoutComponent:SetVerticalAlignment(h) end


---@public XUILayoutComponent_GetHorizontalAlignment00
---@return number
function XUILayoutComponent:GetHorizontalAlignment() end


---@public XUILayoutComponent_GetVerticalAlignment00
---@return number
function XUILayoutComponent:GetVerticalAlignment() end


---@public XUILayoutComponent_SetBaseLayoutSize00
---@param xelua_var_20 XVECTOR2
---@return void
function XUILayoutComponent:SetBaseLayoutSize(xelua_var_20) end


---@public XUILayoutComponent_GetBaseLayoutSize00
---@return XVECTOR2
function XUILayoutComponent:GetBaseLayoutSize() end


---@public XUILayoutComponent_RequestDoLayout00
---@return void
function XUILayoutComponent:RequestDoLayout() end


---@public XUILayoutComponent_DoLayout00
---@return void
function XUILayoutComponent:DoLayout() end


---@public XUILayoutComponent_SetLineIndent00
---@param fIndent number
---@return void
function XUILayoutComponent:SetLineIndent(fIndent) end


---@public XUILayoutComponent_GetLineIndent00
---@return number
function XUILayoutComponent:GetLineIndent() end


---@public XUILayoutComponent_AutoFitWidthOrHeight00
---@return void
function XUILayoutComponent:AutoFitWidthOrHeight() end


---@type string @readonly 
XUILayoutComponent.COMPONENT_TYPENAME = ''


---@type number @readonly 
XUILayoutComponent.COMPONENT_TYPEID = 0


