---@class XUIListView : XUIScrollView
XUIListView = {}


---@type number @enum Gravity
XUIListView.LEFT = 0


---@type number @enum Gravity
XUIListView.RIGHT = 0


---@type number @enum Gravity
XUIListView.CENTER_HORIZONTAL = 0


---@type number @enum Gravity
XUIListView.TOP = 0


---@type number @enum Gravity
XUIListView.BOTTOM = 0


---@type number @enum Gravity
XUIListView.CENTER_VERTICAL = 0


---@type number @enum EventType
XUIListView.ON_SELECTED_ITEM_START = 0


---@type number @enum EventType
XUIListView.ON_SELECTED_ITEM_END = 0


---@type number @enum MagneticType
XUIListView.NONE = 0


---@type number @enum MagneticType
XUIListView.CENTER = 0


---@type number @enum MagneticType
XUIListView.BOTH_END = 0


---@type number @enum MagneticType
XUIListView.LEFT = 0


---@type number @enum MagneticType
XUIListView.RIGHT = 0


---@type number @enum MagneticType
XUIListView.TOP = 0


---@type number @enum MagneticType
XUIListView.BOTTOM = 0


---@type number @enum XUIListVAlignment
XUIListView.XUI_LV_TOP = 0


---@type number @enum XUIListVAlignment
XUIListView.XUI_LV_CENTER = 0


---@type number @enum XUIListVAlignment
XUIListView.XUI_LV_BOTTOM = 0


---@type number @enum XUIListHAlignment
XUIListView.XUI_LH_LEFT = 0


---@type number @enum XUIListHAlignment
XUIListView.XUI_LH_CENTER = 0


---@type number @enum XUIListHAlignment
XUIListView.XUI_LH_RIGHT = 0


---@public 创建并返回一个空的控件实例的指针
---@return XUIListView 控件指针
function XUIListView:Create() end


---@public 插入一个自定义项到ListView的尾部
---@param pItem XUIWidget 一个Widget
---@return void
function XUIListView:PushBackCustomItem(pItem) end


---@public 插入自定义窗口小控件到ListView中指定索引处
---@param pItem XUIWidget 要插入的一个小控件指针
---@param nIndex number 指定索引
---@return void
function XUIListView:InsertCustomItem(pItem, nIndex) end


---@public 删除ListView最后一个条目
---@return void
function XUIListView:RemoveLastItem() end


---@public 删除ListView中的指定索引的条目
---@param nIndex number 指定索引
---@return void
function XUIListView:RemoveItem(nIndex) end


---@public 删除ListView中所有条目
---@return void
function XUIListView:RemoveAllItems() end


---@public 移动索引为nCurrentIndex到新的位置nNewIndex
---@param nCurrentIndex number 当前位置索引
---@param nNewIndex number 新的位置索引
---@return void
function XUIListView:MoveItem(nCurrentIndex, nNewIndex) end


---@public 获取ListView中的指定索引的条目
---@param nIndex number 指定索引
---@return XUIWidget 返回指定索引的控件指针
function XUIListView:GetItem(nIndex) end


---@public 获取ListView中的所有条目
---@return XUIWidget[] 返回所有条目数组
function XUIListView:GetItems() end


---@public 获取ListView中的指定条目的索引
---@param pItem XUIWidget 指定条目
---@return number 返回指定条目的索引
function XUIListView:GetIndex(pItem) end


---@public 设置ListView引力
---@param eGravity number
---@return void
function XUIListView:SetGravity(eGravity) end


---@public 设置ListView的MagneticType
---@param eMagneticType number
---@return void
function XUIListView:SetMagneticType(eMagneticType) end


---@public 获取ListView的MagneticType
---@return number
function XUIListView:GetMagneticType() end


---@public 设置Magnetic是否允许超出边界
---@param bMagneticAllowedOutOfBoundary boolean
---@return void
function XUIListView:SetMagneticAllowedOutOfBoundary(bMagneticAllowedOutOfBoundary) end


---@public 获取Magnetic是否允许超出边界
---@return boolean
function XUIListView:GetMagneticAllowedOutOfBoundary() end


---@public 设置ListView中每一项之间的边距
---@param fMargin number 边距
---@return void
function XUIListView:SetItemsMargin(fMargin) end


---@public 获取ListView中每一项之间的边距
---@return number 边距
function XUIListView:GetItemsMargin() end


---@public 设置滑动撒手后，滑动条还能自动滑fTime秒
---@param fTime number 滑动撒手后滑动条还能滑多久
---@return void
function XUIListView:SetScrollDuration(fTime) end


---@public 获取滑动撒手后，滑动条还能自动滑fTime秒
---@return number 获取滑动撒手后滑动条还能滑多久
function XUIListView:GetScrollDuration() end


---@public 根据给定位置查询最近的条目
---@param vTargetPosition XVECTOR2 指定的目标位置
---@param vItemAnchorPoint XVECTOR2 指定每个项目的锚点以计算距离
---@return XUIWidget
function XUIListView:GetClosestItemToPosition(vTargetPosition, vItemAnchorPoint) end


---@public 查询当前视图中到特定位置最近的项目
---@param vPositionRatioInView XVECTOR2 指定的目标位置
---@param vItemAnchorPoint XVECTOR2 指定每个项目的锚点以计算距离
---@return XUIWidget
function XUIListView:GetClosestItemToPositionInCurrentView(vPositionRatioInView, vItemAnchorPoint) end


---@public 查询当前listview中的中间条目，并返回
---@return XUIWidget
function XUIListView:GetCenterItemInCurrentView() end


---@public 查询当前listview中的最左侧条目，并返回
---@return XUIWidget
function XUIListView:GetLeftmostItemInCurrentView() end


---@public 查询当前listview中的最右侧条目，并返回
---@return XUIWidget
function XUIListView:GetRightmostItemInCurrentView() end


---@public 查询当前listview中的顶部条目，并返回
---@return XUIWidget
function XUIListView:GetTopmostItemInCurrentView() end


---@public 查询当前listview中的底部条目，并返回
---@return XUIWidget
function XUIListView:GetBottommostItemInCurrentView() end


---@public 跳转到指定条目
---@param nItemIndex number 指定条目索引
---@param vPositionRatioInView XVECTOR2 在列表视图的内容大小中指定比率的位置
---@param vItemAnchorPoint XVECTOR2 指定每个项目的锚点以计算距离
---@return void
function XUIListView:JumpToItem(nItemIndex, vPositionRatioInView, vItemAnchorPoint) end


---@public 滚动到指定条目
---@param nItemIndex number 指定条目索引
---@param vPositionRatioInView XVECTOR2 在列表视图的内容大小中指定比率的位置
---@param vItemAnchorPoint XVECTOR2 指定每个项目的锚点以计算距离
---@return void
function XUIListView:ScrollToItem(nItemIndex, vPositionRatioInView, vItemAnchorPoint) end


---@public 滚动到指定条目
---@param nItemIndex number 指定条目索引
---@param vPositionRatioInView XVECTOR2 在列表视图的内容大小中指定比率的位置
---@param vItemAnchorPoint XVECTOR2 指定每个项目的锚点以计算距离
---@param fTimeInSec number
---@return void
function XUIListView:ScrollToItem(nItemIndex, vPositionRatioInView, vItemAnchorPoint, fTimeInSec) end


---@public 获取当前选中条目的索引，并返回
---@return number
function XUIListView:GetCurSelectedIndex() end


---@public 通过指定索引设置当前选中条目
---@param nItemIndex number
---@return void
function XUIListView:SetCurSelectedIndex(nItemIndex) end


---@manual xelua_XEngine_XUIListView_AddListViewEventListener_manual
---@public XUIListView_AddListViewEventListener_manual
---@param callback  std::function<void(XUINode*, EventType)>
---@return void
function XUIListView:AddListViewEventListener(callback) end


---@manual xelua_XEngine_XUIListView_AddEventListener_manual
---@public XUIListView_AddEventListener_manual
---@param callback  std::function<void(XUINode*, EventType)>
---@return void
function XUIListView:AddEventListener(callback) end


---@public XUIListView_SetHorizontalAlignment00
---@param h number
---@return void
function XUIListView:SetHorizontalAlignment(h) end


---@public XUIListView_SetVerticalAlignment00
---@param h number
---@return void
function XUIListView:SetVerticalAlignment(h) end


---@public XUIListView_GetHorizontalAlignment00
---@return number
function XUIListView:GetHorizontalAlignment() end


---@public XUIListView_GetVerticalAlignment00
---@return number
function XUIListView:GetVerticalAlignment() end


