---富文本元素基类。 它定义了所有的富文本元素的通用属性
---@class XUIRichElement : XOwnerRecorder
XUIRichElement = {}


---@type number @enum Type
XUIRichElement.XUI_TEXT = 0


---@type number @enum Type
XUIRichElement.XUI_IMAGE = 0


---@type number @enum Type
XUIRichElement.XUI_CUSTOM = 0


---@type number @enum Type
XUIRichElement.XUI_NEWLINE = 0


---@public XUIRichElement_new00
---@return XUIRichElement
function XUIRichElement:new() end


---@public 获取类型
---@return string
function XUIRichElement:GetType() end


---@public 通过不同的参数初始化一个富文本元素
---@param tag number 标签值
---@param color  XCOLORBASE 颜色
---@return boolean
function XUIRichElement:Init(tag, color) end


---@public 判断当前富文本元素是否是type类型的富文本元素
---@param type number
---@return boolean 返回是否为传入参数类型的富文本元素。
function XUIRichElement:EqualType(type) end


---@public 设置颜色
---@param color  XCOLORBASE
---@return void
function XUIRichElement:SetColor(color) end


---@public 克隆一个富文本元素，并返回新得到的元素指针
---@return XUIRichElement
function XUIRichElement:Clone() end


---@class XUIRichElementText : XUIRichElement
XUIRichElementText = {}


---@type number @enum italic text
XUIRichElementText.ITALICS_FLAG = 0


---@type number @enum bold text
XUIRichElementText.BOLD_FLAG = 0


---@type number @enum underline
XUIRichElementText.UNDERLINE_FLAG = 0


---@type number @enum strikethrough
XUIRichElementText.STRIKETHROUGH_FLAG = 0


---@type number @enum url of anchor
XUIRichElementText.URL_FLAG = 0


---@type number @enum outline effect
XUIRichElementText.OUTLINE_FLAG = 0


---@type number @enum shadow effect
XUIRichElementText.SHADOW_FLAG = 0


---@type number @enum glow effect
XUIRichElementText.GLOW_FLAG = 0


---@public XUIRichElementText_new00
---@return XUIRichElementText
function XUIRichElementText:new() end


---@public 通过不同的参数初始化一个富文本元素
---@param tag number 标签值
---@param color  XCOLORBASE 颜色
---@param strText string
---@param strfontName string
---@param fFontSize number
---@param nflags number
---@return boolean
function XUIRichElementText:Init(tag, color, strText, strfontName, fFontSize, nflags) end


---@public XUIRichElementText_Init01
---@param tag number
---@param color  XCOLORBASE
---@param strText string
---@param strfontName string
---@param fFontSize number
---@param nflags number
---@param outlineColor  XCOLORBASE
---@param nOutlineSize number
---@return boolean
function XUIRichElementText:Init(tag, color, strText, strfontName, fFontSize, nflags, outlineColor, nOutlineSize) end


---@public 通过多个变量初始化一个XUIRichElementImage类
---@param tag number 标签值
---@param color  XCOLORBASE 颜色
---@param strText string
---@param strfontName string
---@param fFontSize number
---@param nflags number
---@param outlineColor  XCOLORBASE
---@param nOutlineSize number
---@param shadowColor  XCOLORBASE
---@return boolean 是否成功
function XUIRichElementText:Init(tag, color, strText, strfontName, fFontSize, nflags, outlineColor, nOutlineSize, shadowColor) end


---@public 通过多个变量初始化一个XUIRichElementImage类
---@param tag number 标签值
---@param color  XCOLORBASE 颜色
---@param strText string
---@param strfontName string
---@param fFontSize number
---@param nflags number
---@param outlineColor  XCOLORBASE
---@param nOutlineSize number
---@param shadowColor  XCOLORBASE
---@param vShadowOffset XVECTOR2
---@param nShadowBlurRadius number
---@return boolean 是否成功
function XUIRichElementText:Init(tag, color, strText, strfontName, fFontSize, nflags, outlineColor, nOutlineSize, shadowColor, vShadowOffset, nShadowBlurRadius) end


---@public XUIRichElementText_Init04
---@param tag number
---@param color  XCOLORBASE
---@param strText string
---@param strfontName string
---@param fFontSize number
---@param nflags number
---@param outlineColor  XCOLORBASE
---@param nOutlineSize number
---@param shadowColor  XCOLORBASE
---@param vShadowOffset XVECTOR2
---@param nShadowBlurRadius number
---@param glowColor  XCOLORBASE
---@return boolean
function XUIRichElementText:Init(tag, color, strText, strfontName, fFontSize, nflags, outlineColor, nOutlineSize, shadowColor, vShadowOffset, nShadowBlurRadius, glowColor) end


---@public XUIRichElementText_Init200
---@param tag number
---@param color  XCOLORBASE
---@param strText string
---@param strfontName string
---@param fFontSize number
---@param outlineColor  XCOLORBASE
---@param nOutlineSize number
---@param LowerColor  XCOLORBASE
---@param UpperColor  XCOLORBASE
---@param horizontalAlig number
---@param verticalAlig number
---@return boolean
function XUIRichElementText:Init2(tag, color, strText, strfontName, fFontSize, outlineColor, nOutlineSize, LowerColor, UpperColor, horizontalAlig, verticalAlig) end


---@public XUIRichElementText_Init300
---@param tag number
---@param strText string
---@param _TextProperty  XUITextFormat
---@return boolean
function XUIRichElementText:Init3(tag, strText, _TextProperty) end


---@public XUIRichElementText_Create00
---@param tag number
---@param color  XCOLORBASE
---@param strText string
---@param strfontName string
---@param fFontSize number
---@param nflags number
---@return XUIRichElementText
function XUIRichElementText:Create(tag, color, strText, strfontName, fFontSize, nflags) end


---@public XUIRichElementText_Create01
---@param tag number
---@param color  XCOLORBASE
---@param strText string
---@param strfontName string
---@param fFontSize number
---@param nflags number
---@param outlineColor  XCOLORBASE
---@param nOutlineSize number
---@return XUIRichElementText
function XUIRichElementText:Create(tag, color, strText, strfontName, fFontSize, nflags, outlineColor, nOutlineSize) end


---@public XUIRichElementText_Create02
---@param tag number
---@param color  XCOLORBASE
---@param strText string
---@param strfontName string
---@param fFontSize number
---@param nflags number
---@param outlineColor  XCOLORBASE
---@param nOutlineSize number
---@param shadowColor  XCOLORBASE
---@return XUIRichElementText
function XUIRichElementText:Create(tag, color, strText, strfontName, fFontSize, nflags, outlineColor, nOutlineSize, shadowColor) end


---@public 通过多个变量创建一个XUIRichElementImage类
---@param tag number 标签值
---@param color  XCOLORBASE 颜色
---@param strText string
---@param strfontName string
---@param fFontSize number
---@param nflags number
---@param outlineColor  XCOLORBASE
---@param nOutlineSize number
---@param shadowColor  XCOLORBASE
---@param vShadowOffset XVECTOR2
---@param nShadowBlurRadius number
---@return XUIRichElementText 创建的指针
function XUIRichElementText:Create(tag, color, strText, strfontName, fFontSize, nflags, outlineColor, nOutlineSize, shadowColor, vShadowOffset, nShadowBlurRadius) end


---@public 通过多个变量创建一个XUIRichElementImage类
---@param tag number 标签值
---@param color  XCOLORBASE 颜色
---@param strText string
---@param strfontName string
---@param fFontSize number
---@param nflags number
---@param outlineColor  XCOLORBASE
---@param nOutlineSize number
---@param shadowColor  XCOLORBASE
---@param vShadowOffset XVECTOR2
---@param nShadowBlurRadius number
---@param glowColor  XCOLORBASE
---@return XUIRichElementText 创建的指针
function XUIRichElementText:Create(tag, color, strText, strfontName, fFontSize, nflags, outlineColor, nOutlineSize, shadowColor, vShadowOffset, nShadowBlurRadius, glowColor) end


---@public XUIRichElementText_Create05
---@param tag number
---@param color  XCOLORBASE
---@param strText string
---@param strfontName string
---@param fFontSize number
---@return XUIRichElementText
function XUIRichElementText:Create(tag, color, strText, strfontName, fFontSize) end


---@public XUIRichElementText_Create06
---@param tag number
---@param color  XCOLORBASE
---@param strText string
---@param strfontName string
---@param fFontSize number
---@param outlineColor  XCOLORBASE
---@param nOutlineSize number
---@return XUIRichElementText
function XUIRichElementText:Create(tag, color, strText, strfontName, fFontSize, outlineColor, nOutlineSize) end


---@public 创建并返回一个空的控件实例的指针
---@param tag number
---@param color  XCOLORBASE
---@param strText string
---@param strfontName string
---@param fFontSize number
---@param outlineColor  XCOLORBASE
---@param nOutlineSize number
---@param LowerColor  XCOLORBASE
---@return XUIRichElementText 控件指针
function XUIRichElementText:Create(tag, color, strText, strfontName, fFontSize, outlineColor, nOutlineSize, LowerColor) end


---@public XUIRichElementText_Create08
---@param tag number
---@param color  XCOLORBASE
---@param strText string
---@param strfontName string
---@param fFontSize number
---@param outlineColor  XCOLORBASE
---@param nOutlineSize number
---@param LowerColor  XCOLORBASE
---@param UpperColor  XCOLORBASE
---@param horizontalAlig number
---@param verticalAlig number
---@return XUIRichElementText
function XUIRichElementText:Create(tag, color, strText, strfontName, fFontSize, outlineColor, nOutlineSize, LowerColor, UpperColor, horizontalAlig, verticalAlig) end


---@public XUIRichElementText_Create09
---@param tag number
---@param strText string
---@param _TextProperty  XUITextFormat
---@return XUIRichElementText
function XUIRichElementText:Create(tag, strText, _TextProperty) end


---@class XUIRichElementImage : XUIRichElement
XUIRichElementImage = {}


---@public XUIRichElementImage_new00
---@return XUIRichElementImage
function XUIRichElementImage:new() end


---@public 通过不同的参数初始化一个富文本元素
---@param tag number 标签值
---@param color  XCOLORBASE 颜色
---@param filePath string
---@param eTexType number
---@return boolean
function XUIRichElementImage:Init(tag, color, filePath, eTexType) end


---@public XUIRichElementImage_Init01
---@param tag number
---@param color  XCOLORBASE
---@param pImage XUIImage
---@return boolean
function XUIRichElementImage:Init(tag, color, pImage) end


---@public XUIRichElementImage_Create00
---@param tag number
---@param color  XCOLORBASE
---@param filePath string
---@param eTexType number
---@return XUIRichElementImage
function XUIRichElementImage:Create(tag, color, filePath, eTexType) end


---@public XUIRichElementImage_Create01
---@param tag number
---@param color  XCOLORBASE
---@param pImage XUIImage
---@return XUIRichElementImage
function XUIRichElementImage:Create(tag, color, pImage) end


---@public 设置宽度
---@param nWidth number
---@return void
function XUIRichElementImage:SetWidth(nWidth) end


---@public 设置高度
---@param nHeight number
---@return void
function XUIRichElementImage:SetHeight(nHeight) end


---@public XUIRichElementImage_GetImage00
---@return XUIImage
function XUIRichElementImage:GetImage() end


---@class XUIRichElementCustomNode : XUIRichElement
XUIRichElementCustomNode = {}


---@public XUIRichElementCustomNode_new00
---@return XUIRichElementCustomNode
function XUIRichElementCustomNode:new() end


---@public 通过不同的参数初始化一个富文本元素
---@param nTag number
---@param color  XCOLORBASE 颜色
---@param pNode XUINode
---@return boolean
function XUIRichElementCustomNode:Init(nTag, color, pNode) end


---@public XUIRichElementCustomNode_Create00
---@param nTag number
---@param color  XCOLORBASE
---@param pNode XUINode
---@return XUIRichElementCustomNode
function XUIRichElementCustomNode:Create(nTag, color, pNode) end


---@class XUIRichElementNewLine : XUIRichElement
XUIRichElementNewLine = {}


---@public XUIRichElementNewLine_new00
---@return XUIRichElementNewLine
function XUIRichElementNewLine:new() end


---@public XUIRichElementNewLine_Create00
---@param nTag number
---@param color  XCOLORBASE
---@return XUIRichElementNewLine
function XUIRichElementNewLine:Create(nTag, color) end


---@class XUIRichText : XUIWidget
XUIRichText = {}


---@type number @enum WrapMode
XUIRichText.XUI_WRAP_PER_WORD = 0


---@type number @enum WrapMode
XUIRichText.XUI_WRAP_PER_CHAR = 0


---@type number @enum HorizontalAlignment
XUIRichText.XUI_LEFT = 0


---@type number @enum HorizontalAlignment
XUIRichText.XUI_CENTER = 0


---@type number @enum HorizontalAlignment
XUIRichText.XUI_RIGHT = 0


---@type number @enum VerticalAlignment
XUIRichText.XUI_TOP = 0


---@type number @enum VerticalAlignment
XUIRichText.XUI_CENTER = 0


---@type number @enum VerticalAlignment
XUIRichText.XUI_RIGHT = 0


---@type number @enum TextLine
XUIRichText.XUI_NONE = 0


---@type number @enum TextLine
XUIRichText.XUI_DEL = 0


---@type number @enum TextLine
XUIRichText.XUI_UNDER = 0


---@type number @enum TextStyle
XUIRichText.XUI_NONE = 0


---@type number @enum TextStyle
XUIRichText.XUI_OUTLINE = 0


---@type number @enum TextStyle
XUIRichText.XUI_SHADOW = 0


---@type number @enum TextStyle
XUIRichText.XUI_GLOW = 0


---@public XUIRichText_new00
---@return XUIRichText
function XUIRichText:new() end


---@public XUIRichText_Create00
---@return XUIRichText
function XUIRichText:Create() end


---@public 设置富文本字符串
---@param richtextstr string 富文本
---@return void
function XUIRichText:SetRichText(richtextstr) end


---@public XUIRichText_GetRichText00
---@return string
function XUIRichText:GetRichText() end


---@public 在指定位置插入一个RichElement
---@param pElement XUIRichElement 插入的RichElement
---@param nIndex number 指定位置
---@return void
function XUIRichText:InsertElement(pElement, nIndex) end


---@public 添加一个RichElement
---@param pElement XUIRichElement 要添加的RichElement
---@return void
function XUIRichText:AddElement(pElement) end


---@public 删除指定索引的RichElement
---@param nIndex number 指定的索引
---@param bClean boolean
---@return void
function XUIRichText:RemoveElement(nIndex, bClean) end


---@public 删除指定的RichElement
---@param pElement XUIRichElement 指定的元素指针
---@param bClean boolean
---@return void
function XUIRichText:RemoveElement(pElement, bClean) end


---@public 获取指定索引的RichElement
---不存在，返回nullptr
---@param nIndex number 指定的索引
---@return XUIRichElement
function XUIRichText:GetRichTextElement(nIndex) end


---@public 在富文本中新启一行，相当于加了个'\n'
---@return void
function XUIRichText:NewLine() end


---@public 获取所有元素数目
---@return number
function XUIRichText:GetElementsNum() end


---@public 设置每个RichElement的垂直间隔
---@param fSpace number 间隔值
---@return void
function XUIRichText:SetVerticalSpace(fSpace) end


---@public XUIRichText_GetVerticalSpace00
---@return number
function XUIRichText:GetVerticalSpace() end


---@public XUIRichText_SetWrapMode00
---@param eWrapMode number
---@return void
function XUIRichText:SetWrapMode(eWrapMode) end


---@public XUIRichText_GetWrapMode00
---@return number
function XUIRichText:GetWrapMode() end


---@public XUIRichText_SetVAlignmentInLine00
---@param eAlignment number
---@return void
function XUIRichText:SetVAlignmentInLine(eAlignment) end


---@public XUIRichText_GetVAlignmentInLine00
---@return number
function XUIRichText:GetVAlignmentInLine() end


---@public 设置文本颜色
---@param clr  XCOLORBASE 文本颜色
---@return void
function XUIRichText:SetTextColor(clr) end


---@public 获取文本颜色
---@return  XCOLORBASE 返回文本颜色
function XUIRichText:GetTextColor() end


---@public 设置文本渐变颜色-上层颜色
---@param clr  XCOLORBASE 文本上层颜色
---@return void
function XUIRichText:SetTextUpperColor(clr) end


---@public 获取文本渐变颜色-上层颜色
---@return  XCOLORBASE 返回文本上层颜色
function XUIRichText:GetTextUpperColor() end


---@public 设置文本渐变颜色-下层颜色
---@param clr  XCOLORBASE 文本下层颜色
---@return void
function XUIRichText:SetTextLowerColor(clr) end


---@public 获取文本渐变颜色-下层颜色
---@return  XCOLORBASE 返回文本下层颜色
function XUIRichText:GetTextLowerColor() end


---@public 设置字体大小
---@param fPointSize number
---@return void
function XUIRichText:SetTextPointSize(fPointSize) end


---@public 获取字体大小
---@return number
function XUIRichText:GetTextPointSize() end


---@public 设置文本水平对齐方式
---@param hAlign number 水平对齐
---@return void
function XUIRichText:SetHAlignMent(hAlign) end


---@public 设置文本垂直对齐方式
---@param vAlign number 垂直对齐
---@return void
function XUIRichText:SetVAlignMent(vAlign) end


---@public 获取文本水平对齐方式
---@return number 水平对齐方式
function XUIRichText:GetHAlignment() end


---@public 获取文本垂直对齐方式
---@return number 垂直对齐方式
function XUIRichText:GetVAlignment() end


---@public 设置文本描边颜色
---@param clrOutLine  XCOLORBASE 描边颜色
---@return void
function XUIRichText:SetOutlineColor(clrOutLine) end


---@public 获取文本描边颜色
---@return  XCOLORBASE 返回描边颜色
function XUIRichText:GetOutlineColor() end


---@public 设置文本描边宽度
---@param nOutlineSize number
---@return void
function XUIRichText:SetOutlineSize(nOutlineSize) end


---@public 获取文本描边宽度
---@return number 返回描边颜色
function XUIRichText:GetOutlineSize() end


---@public 获取文本描边宽度
---设置文本的字间距, 仅TTF文字支持
---@param fAdditionalKerning number 字间距值
---@return void 返回描边颜色
function XUIRichText:SetAdditionalKerning(fAdditionalKerning) end


---@public 获取文本的字间距, 仅TTF文字支持
---@return number
function XUIRichText:GetAdditionalKerning() end


---@public 更改字体
---@param strPath string
---@return void
function XUIRichText:SetTTFFontPath(strPath) end


---@public XUIRichText_GetTTFFontPath00
---@return string
function XUIRichText:GetTTFFontPath() end


---@public XUIRichText_IsSaveRichTextStr00
---@return boolean
function XUIRichText:IsSaveRichTextStr() end


---@public XUIRichText_SetSaveRichTextStr00
---@param bsave boolean
---@return void
function XUIRichText:SetSaveRichTextStr(bsave) end


---@public 重新排列所有的RichElement。 常内部调用
---@return void
function XUIRichText:FormatText() end


---@public 获取实际大小
---@return XVECTOR2 实际大小
function XUIRichText:GetActualSize() end


