---代表3D场景中的虚拟相机
---用来捕获3D世界中的渲染图元，如果想要将当前相机Actor起作用，
---前提必须调用XEViewport类的AttachCamera函数将Actor内部的相机实例绑定到视口。
---@class XECameraActor : XEActor
XECameraActor = {}


---@public 视口恢复激活的相机
---@param pViewportWithWorld XEViewport 当前世界绑定的视口指针.
---@return boolean
function XECameraActor:RestoreActiveCameraInViewport(pViewportWithWorld) end


---@public 获取世界的一个激活的相机
---@param pWorld  XEWorld 相机所在世界
---@return XBaseCamera
function XECameraActor:GetOneActiveCamera(pWorld) end


---@public 激活当前相机Actor(在场景中起作用)
---@return boolean 是否激活成功
function XECameraActor:MarkAsActiveCamera() end


---@public 把当前相机应用到系统/场景相机（绑定到当前世界视口上）
---@return boolean 是否应用成功
function XECameraActor:ApplyAsSystemCamera() end


---@type string @readonly Actor类型名
XECameraActor.ACTOR_TYPENAME = ''


