---@class XEGroundGridActor : XEActor
XEGroundGridActor = {}


---@type number @enum eGridType
XEGroundGridActor.EGRID_XZ = 0


---@type number @enum eGridType
XEGroundGridActor.EGRID_XY = 0


---@type number @enum eGridType
XEGroundGridActor.EGRID_YZ = 0


---@type number @enum eGridType
XEGroundGridActor.EGRID_NUM = 0


---@public 设置地面网格Actor为静态/动态
---@param bDynamic boolean 表示静态/动态.
---@return void
function XEGroundGridActor:SetDynamic(bDynamic) end


---@public 获取地面网格Actor静态/动态的状态
---@return boolean 地面网格Actor静态/动态的状态.
function XEGroundGridActor:IsDynamic() end


---@public 设置地面网格Actor类型（XZ平面/XY平面/YZ平面）
---@param type number 表示地面网格类型（XZ平面/XY平面/YZ平面）.
---@return void
function XEGroundGridActor:SetGridType(type) end


---@public 获取地面网格Actor类型
---@return number 地面网格Actor类型.
function XEGroundGridActor:GetGridType() end


---@public 获取地面网格Actor所有类型数组
---@return string[] 地面网格Actor所有类型数组.
function XEGroundGridActor:GetGridTypeDescs() end


---@public 获取地面网格Actor颜色
---@return XCOLORBASE 地面网格Actor颜色.
function XEGroundGridActor:GetColor() end


---@public 设置地面网格Actor颜色
---@param color  XCOLORBASE 地面网格Actor颜色.
---@return void
function XEGroundGridActor:SetColor(color) end


---@public 更新网格
---@return void
function XEGroundGridActor:UpdateGrid() end


---@public 渲染网格开关
---@param bEnable boolean
---@return void
function XEGroundGridActor:SetRenderGridEnable(bEnable) end


---@public 网格渲染是否开启
---@return boolean
function XEGroundGridActor:IsRenderGridEnable() end


---@type string @readonly Actor类型名
XEGroundGridActor.ACTOR_TYPENAME = ''


