---此类代表带动画的骨骼模型组件
---用于管理骨骼动画、蒙太奇动画资源以及动画融合等。
---@class XEAnimatableModelComponent : XEModelComponent
XEAnimatableModelComponent = {}


---@class XEAnimatableModelComponent__AnimLayerData
local XEAnimatableModelComponent__AnimLayerData = {}
XEAnimatableModelComponent.AnimLayerData = XEAnimatableModelComponent__AnimLayerData


---@type number @enum 
XEAnimatableModelComponent__AnimLayerData.AnimLayerDataIndexNone = 0


---@type number @enum 
XEAnimatableModelComponent__AnimLayerData.AnimLayerDataIndexNotSet = 0


---@type number 索引
XEAnimatableModelComponent__AnimLayerData.nLayerIndex = 0


---@type string 路径
XEAnimatableModelComponent__AnimLayerData.szPath = ''


---@type boolean 是否被激活
XEAnimatableModelComponent__AnimLayerData.bActive = false


---@type boolean 是否是蒙太奇资源
XEAnimatableModelComponent__AnimLayerData.bIsMontageAsset = false


---@public XEAnimatableModelComponent_AnimLayerData_new00
---@return XEAnimatableModelComponent__AnimLayerData
function XEAnimatableModelComponent__AnimLayerData:new() end


---@public XEAnimatableModelComponent_new00
---@return XEAnimatableModelComponent
function XEAnimatableModelComponent:new() end


---@class XEAnimatableModelComponent__ModelAnimController : XEAnimController
local XEAnimatableModelComponent__ModelAnimController = {}
XEAnimatableModelComponent.ModelAnimController = XEAnimatableModelComponent__ModelAnimController


---@public XEAnimatableModelComponent_ModelAnimController_new00
---@return XEAnimatableModelComponent__ModelAnimController
function XEAnimatableModelComponent__ModelAnimController:new() end


---@public XEAnimatableModelComponent_ModelAnimController_new01
---@param pModelComponent XEAnimatableModelComponent
---@return XEAnimatableModelComponent__ModelAnimController
function XEAnimatableModelComponent__ModelAnimController:new(pModelComponent) end


---@public 获取原始动画播放控制器
---@return XAnimMultiLayer
function XEAnimatableModelComponent__ModelAnimController:GetPrimitiveAnimController() end


---@public 从外部设置原始动画播放控制器
---@param pPlayer XAnimMultiLayer 外部已经创建好的控制器
---@return void
---@attention 一般来说，pPlayer要在外部维护释放删除
function XEAnimatableModelComponent__ModelAnimController:AssignCustomPrimitiveAnimController(pPlayer) end


---@public 获取原始动画播放控制器
---@return XAnimMultiLayer
function XEAnimatableModelComponent__ModelAnimController:GetCustomPrimitiveAnimController() end


---@public 设置动画播放器结束时间
---@param fEndTime number
---@return void
function XEAnimatableModelComponent__ModelAnimController:SetAnimEndTime(fEndTime) end


---@public 获取动画资源长度
---@param pSeqName string 动画资源名称
---@return number
function XEAnimatableModelComponent__ModelAnimController:GetSequenceDuration(pSeqName) end


---@public 获取融合动画层某一资源的长度
---@param pBlendLayerName string 融合层名称
---@param pSeqName string 动画资源名称
---@return number
function XEAnimatableModelComponent__ModelAnimController:GetBlendSequenceDuration(pBlendLayerName, pSeqName) end


---@public 激活所有层
---@return void
function XEAnimatableModelComponent__ModelAnimController:ActiveAllLayers() end


---@public 把所有层设为非激活态
---@return void
function XEAnimatableModelComponent__ModelAnimController:DeactiveAllLayers() end


---@public 设置动画模型组件指针
---@param pCmp XEAnimatableModelComponent
---@return void
function XEAnimatableModelComponent__ModelAnimController:SetAnimatableModelComponent(pCmp) end


---@public 获取动画模型组件指针
---@return XEAnimatableModelComponent
function XEAnimatableModelComponent__ModelAnimController:GetAnimatableModelComponent() end


---@public 如果不存在动画控制器，创建一个动画控制器，并返回
---@return XEAnimController
function XEAnimatableModelComponent:AssignAnimationController() end


---@public 获取动画控制器（seq动画控制器）
---@return XEAnimController
function XEAnimatableModelComponent:GetExplicitAnimationController() end


---@public 添加seq动画资源到动画控制器上
---@param pPath string 动画资源路径
---@param bActive boolean 是否激活所在的Layer
---@param bPlay boolean 是否自动播放
---@param bExclusively boolean 是否仅激活一个Layer，如果为true，表示当前仅激活一个layer，其他都置为非激活态
---@param bIsMontageAsset boolean 添加的是否是蒙太奇中的seq动画(一般由上层其他调用的地方传下来)
---@return XAnimMultiLayer 动画控制器（具有多层动画的控制器）
function XEAnimatableModelComponent:AddAnimSequence(pPath, bActive, bPlay, bExclusively, bIsMontageAsset) end


---@public 添加融合动画资源到动画控制器的某一层上
---@param pLayerName string 要添加动画的层
---@param pPath string 动画资源路径
---@param fStartTime number 设置添加的动画开始时间
---@param fEndTime number 设置添加的动画结束时间
---@param eBlendType number 动画融合类型
---@param bActive boolean 是否激活所在的Layer
---@param bPlay boolean 是否自动播放
---@param bExclusively boolean 是否仅激活一个Layer，如果为true，表示当前仅激活一个layer，其他都置为非激活态
---@return XAnimMultiLayer 动画控制器（具有多层动画的控制器）
function XEAnimatableModelComponent:AddAnimBlendSequence(pLayerName, pPath, fStartTime, fEndTime, eBlendType, bActive, bPlay, bExclusively) end


---@public 设置融合动画中某个片段的起始时间
---@param pLayerName string 动画所在的层name
---@param pPath string 动画片段资源路径
---@param fStartTime number 设置动画片段开始时间
---@param fEndTime number 设置动画片段结束时间
---@return void
function XEAnimatableModelComponent:SetAnimBlendTime(pLayerName, pPath, fStartTime, fEndTime) end


---@public 添加一个空层（不加动画资源）
---@param pLayerName string 要添加的层name
---@param bActive boolean 是否激活所在的Layer
---@param bPlay boolean 是否自动播放
---@param bExclusively boolean 是否仅激活一个Layer，如果为true，表示当前仅激活一个layer，其他都置为非激活态
---@return XAnimMultiLayer
function XEAnimatableModelComponent:AddLayer(pLayerName, bActive, bPlay, bExclusively) end


---@public 移除当前动画控制器的所有层的所有动画资源
---@return void
function XEAnimatableModelComponent:RemoveAllAnimSequence() end


---@public 激活一个动画层
---@param pLayerName string 要激活的层name
---@param bPlay boolean 是否自动播放
---@param bExclusively boolean 是否仅激活一个Layer，如果为true，表示当前仅激活一个layer，其他都置为非激活态
---@return void
function XEAnimatableModelComponent:ActiveLayer(pLayerName, bPlay, bExclusively) end


---@public 激活所有层
---@param bPlay boolean
---@return void
function XEAnimatableModelComponent:ActiveAllLayers(bPlay) end


---@public 把某一动画层设置为不激活态
---@param pLayerName string 要去激活的层name
---@return void
function XEAnimatableModelComponent:DeacitveLayer(pLayerName) end


---@public 把所有动画层设为非激活态
---@return void
function XEAnimatableModelComponent:DeacitveAllLayers() end


---@public 判断当前是否有激活态的层
---@return boolean 如果有，返回true，没有，返回false
function XEAnimatableModelComponent:HasActiveLayer() end


---@public 判断当前是否有某一层
---@param pLayerName string 要判断的层name
---@return boolean 如果有，返回true，没有，返回false
function XEAnimatableModelComponent:HasLayer(pLayerName) end


---@public 获取到第一个激活状态的层
---@return string 如果取到，返回层name，没有取到，返回NULL
function XEAnimatableModelComponent:GetFirstActiveLayerName() end


---@public 通过层name获取到层数据AnimLayerData
---@param pLayerName string
---@return XEAnimatableModelComponent__AnimLayerData
function XEAnimatableModelComponent:GetAnimLayerData(pLayerName) end


---@public 通过层索引获取到层数据AnimLayerData
---@param nLayerIndex number
---@return XEAnimatableModelComponent__AnimLayerData
function XEAnimatableModelComponent:GetAnimLayerData(nLayerIndex) end


---@public 获取层数据列表
---@return AnimLayerData[]
function XEAnimatableModelComponent:GetAnimLayerArray() end


---@public XEAnimatableModelComponent_SetUsedAsPlayer00
---@param bUsedAsPlayer boolean
---@return void
function XEAnimatableModelComponent:SetUsedAsPlayer(bUsedAsPlayer) end


---@public XEAnimatableModelComponent_IsUsedAsPlayer00
---@return boolean
function XEAnimatableModelComponent:IsUsedAsPlayer() end


---@public XEAnimatableModelComponent_SetCucolorisColor00
---@param color  XCOLORBASE
---@return void
function XEAnimatableModelComponent:SetCucolorisColor(color) end


---@public XEAnimatableModelComponent_GetCucolorisColor00
---@return  XCOLORBASE
function XEAnimatableModelComponent:GetCucolorisColor() end


---@public 设置是否渲染所有刚体
---@param bRender boolean 是否渲染
---@return void
function XEAnimatableModelComponent:SetRenderBodyShapeDebug(bRender) end


---@public 获取是否渲染所有刚体的状态
---@return boolean
function XEAnimatableModelComponent:IsRenderBodyShapeDebug() end


---@public 创建物理骨骼根实例
---@return void
function XEAnimatableModelComponent:BuildPhysicsSkeletalRootInstance() end


---@public 销毁物理骨骼根实例
---@return boolean
function XEAnimatableModelComponent:DestroyPhysicsSkeletalRootInstance() end


---@public 骨骼物理实例指针指向pIns
---@param pIns IXSkeletalPhysicsInstance 外部创建的骨骼物理实例
---@return void
function XEAnimatableModelComponent:SetIXSkeletalPhysicsInstance(pIns) end


---@public 获取骨骼物理实例指针
---@return IXSkeletalPhysicsInstance 骨骼物理实例指针
function XEAnimatableModelComponent:GetIXSkeletalPhysicsInstance() end


---@public 获取物理骨骼根实例
---@return XEPhysicsSkeletalRootInstance 物理骨骼根实例指针
function XEAnimatableModelComponent:GetPhysicsSkeletalRootInstance() end


---@public 创建骨骼物理实例指针
---@return boolean
function XEAnimatableModelComponent:CreateSkeletalPhysicsInstance() end


---@public 是否是内部创建的原始动画控制器
---@return boolean
function XEAnimatableModelComponent:IsInnerPrimitiveAnimController() end


---@public 标记为是否是内部创建的原始动画控制器
---@param bMark boolean xtrue:内部创建的，不需要手动释放；xfalse:外部创建的，需要外部自己释放
---@return void
function XEAnimatableModelComponent:MarkAsInnerPrimitiveAnimController(bMark) end


---@type string @readonly Component类型名
XEAnimatableModelComponent.COMPONENT_TYPENAME = ''


