---补丁（贴片）组件
---用于给模型贴眉毛、胡子等。
---@attention
---1. UV补丁模型制作方式：依照原模型UV展开图，制作同样形状的补丁网格，使补丁网格的顶点的位置值xy，等于原模型顶点的uv值；
---2. 补丁方式，要求补丁模型不可以存在拆分，否则逻辑会过于复杂。
---3. UV补丁方式，对uv精度要求很高，所以尽量不要在UV展开图上出现距离太近顶点；
---4. 补丁模型的位置，除了按原模型UV展开图对齐外；还要求，三角网格的各边能完全对上；（在顶点一一对应的前提下，可能因为拆分四边形顺序不一样，而导致三角网格线不对应；）
---@class XEMeshAppliqueComponent : XEActorComponent
XEMeshAppliqueComponent = {}


---@type number @enum XEPasteType 通过UV匹配
XEMeshAppliqueComponent.XE_APLQ_PT_UV = 0


---@type number @enum XEPasteType
XEMeshAppliqueComponent.XE_APLQ_PT_NUM = 0


---@class XEMeshAppliqueComponent__XEAppliqueInfo
local XEMeshAppliqueComponent__XEAppliqueInfo = {}
XEMeshAppliqueComponent.XEAppliqueInfo = XEMeshAppliqueComponent__XEAppliqueInfo


---@type string
XEMeshAppliqueComponent__XEAppliqueInfo.strAppliqueModelFile = ''


---@type string 原模型被补的skin名字 （不是路径，暴露给编辑器）
XEMeshAppliqueComponent__XEAppliqueInfo.strOriginSkin = ''


---@type string 原模型被补的mesh（暴露给编辑器）
XEMeshAppliqueComponent__XEAppliqueInfo.strOriginMeshName = ''


---@type number 补丁方式， XE_APLQ_PT_UV： 通过UV匹配
XEMeshAppliqueComponent__XEAppliqueInfo.eType = 0


---@type XVECTOR2 位置转UV的偏移，只有在 eType == XE_APLQ_PT_UV时有效
XEMeshAppliqueComponent__XEAppliqueInfo.vPosToUVOffset = {}


---@type number 位置转UV的缩放
XEMeshAppliqueComponent__XEAppliqueInfo.fPosToUVScale = 0


---@type number
XEMeshAppliqueComponent__XEAppliqueInfo.fUVMatchDevi = 0


---@type number 补丁网格，每个顶点向外位移距离，（理论上补丁网格和原模型会完全贴附，但是可能由于计算误差，导致由微小的间隙而出现的Z冲突，此值为补救方法。原模型为静态模型时，现状是不需要此值）（暴露给编辑器）
XEMeshAppliqueComponent__XEAppliqueInfo.fExpansionMesh = 0


---@public XEMeshAppliqueComponent_XEAppliqueInfo_new00
---@return XEMeshAppliqueComponent__XEAppliqueInfo
function XEMeshAppliqueComponent__XEAppliqueInfo:new() end


---@class XEMeshAppliqueComponent__XEMeshAppliqueOperater
local XEMeshAppliqueComponent__XEMeshAppliqueOperater = {}
XEMeshAppliqueComponent.XEMeshAppliqueOperater = XEMeshAppliqueComponent__XEMeshAppliqueOperater


---@type number
XEMeshAppliqueComponent__XEMeshAppliqueOperater.nRefRenderMeshIndex = 0


---@type number
XEMeshAppliqueComponent__XEMeshAppliqueOperater.nOriginRenderMeshIndex = 0


---@type number[]
XEMeshAppliqueComponent__XEMeshAppliqueOperater.vToOriginVertexIndexs = {}


---@public XEMeshAppliqueComponent_XEMeshAppliqueOperater_new00
---@return XEMeshAppliqueComponent__XEMeshAppliqueOperater
function XEMeshAppliqueComponent__XEMeshAppliqueOperater:new() end


---@public XEMeshAppliqueComponent_XEMeshAppliqueOperater_Release00
---@return void
function XEMeshAppliqueComponent__XEMeshAppliqueOperater:Release() end


---@class XEMeshAppliqueComponent__XEAppliqueOperater
local XEMeshAppliqueComponent__XEAppliqueOperater = {}
XEMeshAppliqueComponent.XEAppliqueOperater = XEMeshAppliqueComponent__XEAppliqueOperater


---@type XEMeshAppliqueComponent::XEAppliqueInfo
XEMeshAppliqueComponent__XEAppliqueOperater.inputInfo = {}


---@type number
XEMeshAppliqueComponent__XEAppliqueOperater.nOriginSkinIndex = 0


---@type number
XEMeshAppliqueComponent__XEAppliqueOperater.nOriginRawMeshIndex = 0


---@type XEModelComponent
XEMeshAppliqueComponent__XEAppliqueOperater.pRefModelComponent = {}


---@type string
XEMeshAppliqueComponent__XEAppliqueOperater.strRefSkin = ''


---@type number
XEMeshAppliqueComponent__XEAppliqueOperater.nRefSkinIndex = 0


---@type XEMeshAppliqueOperater[]
XEMeshAppliqueComponent__XEAppliqueOperater.vMeshAppliqueOperaters = {}


---@public XEMeshAppliqueComponent_XEAppliqueOperater_new00
---@return XEMeshAppliqueComponent__XEAppliqueOperater
function XEMeshAppliqueComponent__XEAppliqueOperater:new() end


---@public XEMeshAppliqueComponent_XEAppliqueOperater_Release00
---@return void
function XEMeshAppliqueComponent__XEAppliqueOperater:Release() end


---@public XEMeshAppliqueComponent_new00
---@return XEMeshAppliqueComponent
function XEMeshAppliqueComponent:new() end


---@type string @readonly Component类型名
XEMeshAppliqueComponent.COMPONENT_TYPENAME = ''


---@public 在该组件的父组件对应的模型skin的Mesh上粘贴补丁
---@param info  XEMeshAppliqueComponent::XEAppliqueInfo 要粘贴的补丁信息
---@return  XEMeshAppliqueComponent__XEAppliqueOperater 粘贴成功，返回补丁指针，失败返回NULL
function XEMeshAppliqueComponent:PasteMeshApplique(info) end


---@public 根据补丁指针移除补丁
---@param pAppliqueOper  XEMeshAppliqueComponent::XEAppliqueOperater 要移除的补丁指针
---@return boolean 是否移除成功
function XEMeshAppliqueComponent:RemoveMeshApplique(pAppliqueOper) end


---@public 根据补丁索引移除补丁
---@param nIndex number 要移除的补丁索引
---@return boolean 是否移除成功
function XEMeshAppliqueComponent:RemoveMeshApplique(nIndex) end


---@public 获取粘贴的补丁指针数组
---@return XEAppliqueOperater[]
function XEMeshAppliqueComponent:GetAppliqueOperaters() end


---@public 获取粘贴的补丁指针数组
---@return XEAppliqueOperater[]
function XEMeshAppliqueComponent:GetAppliqueOperaters() end


