---用于对模型描边的专用组件
---@attention:
---对模型描边需要两个pass,一个是渲染轮廓线，一个风格化渲染。当前引擎不支持多pass,所以此处需要另一个Component专门用来渲染轮廓线。
---又因为当前引擎不支持在模型实例上,单独修改材质属性（实例skin对应材质修改，会同时影响其他同模板的实例），所以此处创建特定的Component
---来处理这些逻辑。 如果之后不管在引擎层，还是XECore层，支持了材质的单独编辑，或者可以考虑去掉此Component，也或者考虑使用上的方便，而保留此
---Component;
---当前此component的描边，支持骨骼动画的同步处理；
---@class XEOutlineComponent : XEAnimatableModelComponent
XEOutlineComponent = {}


---@public XEOutlineComponent_new00
---@return XEOutlineComponent
function XEOutlineComponent:new() end


---@type string @readonly Component类型名
XEOutlineComponent.COMPONENT_TYPENAME = ''


---@public 更新描边
---@return boolean
function XEOutlineComponent:UpdateOutline() end


---@public 设置描边线的宽度
---@param fLineWidth number 线宽值
---@param bApplyToMtl boolean bApplyToMtl是否应用到材质
---@return void
function XEOutlineComponent:SetOutlineWidth(fLineWidth, bApplyToMtl) end


---@public 获取描边线的宽度
---@return number
function XEOutlineComponent:GetOutlineWidth() end


---@public 设置描边线的颜色
---@param color  XCOLORBASE 线颜色
---@param bApplyToMtl boolean bApplyToMtl是否应用到材质
---@return void
function XEOutlineComponent:SetOutlineColor(color, bApplyToMtl) end


---@public 获取描边线的颜色
---@return  XCOLORBASE
function XEOutlineComponent:GetOutlineColor() end


