---@class XEProjectileMovement
XEProjectileMovement = {}


---@type number @enum ETargetingLocationType
XEProjectileMovement.Null = 0


---@type number @enum ETargetingLocationType
XEProjectileMovement.LiteralTransform = 0


---@type number @enum ETargetingLocationType
XEProjectileMovement.ActorTransform = 0


---@type number @enum ETargetingLocationType
XEProjectileMovement.SocketTransform = 0


---@type number @enum ETargetingLocationType
XEProjectileMovement.Max = 0


---@class XEProjectileMovementComponent : XEActorComponent
XEProjectileMovementComponent = {}


---@public XEProjectileMovementComponent_new00
---@return XEProjectileMovementComponent
function XEProjectileMovementComponent:new() end


---@type string @readonly 
XEProjectileMovementComponent.COMPONENT_TYPENAME = ''


---@public XEProjectileMovementComponent_GetTypeName00
---@return string
function XEProjectileMovementComponent:GetTypeName() end


---@public 设置速度
---@param NewVelocity XVECTOR3
---@return void
function XEProjectileMovementComponent:SetVelocityInLocalSpace(NewVelocity) end


---@public 获取最大限制速度
---@return number
function XEProjectileMovementComponent:GetMaxSpeed() end


---@public XEProjectileMovementComponent_SetMaxSpeed00
---@param maxSpeed number
---@return void
function XEProjectileMovementComponent:SetMaxSpeed(maxSpeed) end


---@public 获取浮力
---@return number
function XEProjectileMovementComponent:GetBuoyancy() end


---@public XEProjectileMovementComponent_SetBuoyancy00
---@param buoyancy number
---@return void
function XEProjectileMovementComponent:SetBuoyancy(buoyancy) end


---@public 是否应用重力
---@return boolean
function XEProjectileMovementComponent:ShouldApplyGravity() end


---@public 设置重力系数
---@param gravityScale number
---@return void
function XEProjectileMovementComponent:SetGravityScale(gravityScale) end


---@public 通过给定的时间和初速度计算速度
---@param InitialVelocity XVECTOR3
---@param DeltaTime number
---@return XVECTOR3
function XEProjectileMovementComponent:ComputeVelocity(InitialVelocity, DeltaTime) end


---@public 获得重力
---@return number
function XEProjectileMovementComponent:GetGravityZ() end


---@public 是否停止模拟
---@return boolean
function XEProjectileMovementComponent:HasStoppedSimulation() end


---@public XEProjectileMovementComponent_GetSimulationTimeStep00
---@param RemainingTime number
---@param Iterations number
---@return number
function XEProjectileMovementComponent:GetSimulationTimeStep(RemainingTime, Iterations) end


---@public XEProjectileMovementComponent_ShouldUseSubStepping00
---@return boolean
function XEProjectileMovementComponent:ShouldUseSubStepping() end


---@public 停止模拟
---@param HitResult  XEHitResult
---@return void
function XEProjectileMovementComponent:StopSimulating(HitResult) end


---@public 设置方向和速度
---@param velocity XVECTOR3
---@return void
function XEProjectileMovementComponent:SetVelocity(velocity) end


---@public 设置初始速度大小
---@param initSpeed number
---@return void
function XEProjectileMovementComponent:SetInitSpeed(initSpeed) end


---@public 设置是否朝着目标投射
---@param isHomeProj boolean
---@return void
function XEProjectileMovementComponent:SetIsHomingProjectile(isHomeProj) end


---@public 限制方向到平面上
---@param Direction XVECTOR3
---@return XVECTOR3
function XEProjectileMovementComponent:ConstrainDirectionToPlane(Direction) end


---@public 限制位置到平面上
---@param Location XVECTOR3
---@return XVECTOR3
function XEProjectileMovementComponent:ConstrainLocationToPlane(Location) end


---@public 限制法线到平面上
---@param Normal XVECTOR3
---@return XVECTOR3
function XEProjectileMovementComponent:ConstrainNormalToPlane(Normal) end


---@public 计算滚动向量
---@param Delta XVECTOR3
---@param Time number
---@param Normal XVECTOR3
---@param Hit  XEHitResult
---@return XVECTOR3
function XEProjectileMovementComponent:ComputeSlideVector(Delta, Time, Normal, Hit) end


---@public 获取平面限制法线
---@return XVECTOR3
function XEProjectileMovementComponent:GetPlaneConstraintNormal() end


---@public XEProjectileMovementComponent_GetPlaneConstraintOrigin00
---@return XVECTOR3
function XEProjectileMovementComponent:GetPlaneConstraintOrigin() end


---@public XEProjectileMovementComponent_SetPlaneConstraintNormal00
---@param PlaneNormal XVECTOR3
---@return void
function XEProjectileMovementComponent:SetPlaneConstraintNormal(PlaneNormal) end


---@public XEProjectileMovementComponent_SetPlaneConstraintOrigin00
---@param PlaneOrigin XVECTOR3
---@return void
function XEProjectileMovementComponent:SetPlaneConstraintOrigin(PlaneOrigin) end


---@public XEProjectileMovementComponent_SetPlaneConstraintEnabled00
---@param bEnabled boolean
---@return void
function XEProjectileMovementComponent:SetPlaneConstraintEnabled(bEnabled) end


---@public XEProjectileMovementComponent_SafeMoveUpdatedComponent00
---@param Delta XVECTOR3
---@param NewRotation XQUATERNION
---@param bSweep boolean
---@param OutHit XEHitResult
---@return boolean
function XEProjectileMovementComponent:SafeMoveUpdatedComponent(Delta, NewRotation, bSweep, OutHit) end


---@public XEProjectileMovementComponent_GetPenetrationAdjustment00
---@param Hit  XEHitResult
---@return XVECTOR3
function XEProjectileMovementComponent:GetPenetrationAdjustment(Hit) end


---@public 穿透计算
---@param Adjustment XVECTOR3
---@param Hit  XEHitResult
---@param NewRotation XQUATERNION
---@return boolean
function XEProjectileMovementComponent:ResolvePenetration(Adjustment, Hit, NewRotation) end


---@public 设置投射目标Actor名称
---@param strName string
---@return void
function XEProjectileMovementComponent:SetHomingTargetActorName(strName) end


---@public 设置投射目标Actor
---@param pActor XEActor
---@return void
function XEProjectileMovementComponent:SetHomingTargetActor(pActor) end


---@public 设置投射目标位置
---@param pos XVECTOR3
---@return void
function XEProjectileMovementComponent:SetTargetPosition(pos) end


---@public 获取投射目标位置
---@return XVECTOR3
function XEProjectileMovementComponent:GetTargetPosition() end


---@public 设置投射目标位置类型
---@param type number
---@return void
function XEProjectileMovementComponent:SetLocationType(type) end


---@public 获取投射目标位置类型
---@return number
function XEProjectileMovementComponent:GetLocationType() end


---@public 设置投射目标位置偏移
---@param offset XVECTOR3
---@return void
function XEProjectileMovementComponent:SetTargetPosOffset(offset) end


---@public 获取投射目标位置偏移
---@return XVECTOR3
function XEProjectileMovementComponent:GetTargetPosOffset() end


---@public 获取投射目标Actor绑定插槽名称
---@return string
function XEProjectileMovementComponent:GetHomingTargetActorSocketName() end


---@public 设置投射目标Actor绑定插槽名称
---@param strName string
---@return void
function XEProjectileMovementComponent:SetHomingTargetActorSocketName(strName) end


