---@class XEAnimAssetCacheManager
XEAnimAssetCacheManager = {}


---@public 添加一个动画资源到缓存，调用该函数后，返回的动画序列实例计数引用将会+1,请进行释放（可调用SubRefAnimationSequence）
---@param szAssetPath string 动画资产路径（.seq),如果为montage
---@param bCache boolean
---@return XAnimationSequence 动画实例
function XEAnimAssetCacheManager:LoadAnimAsset(szAssetPath, bCache) end


---@public 添加一个动画资源到缓存，调用该函数后，返回的动画序列实例计数引用将会+1,请进行释放（可调用SubRefAnimationSequence）
---@param szAssetPath string 动画资产路径（.montage),缓存Montage中包含的动画
---@param bCache boolean
---@return XAnimationSequence[] 动画实例，缓存Montage实例中所用的多个动画实例
function XEAnimAssetCacheManager:LoadAnimSetAssets(szAssetPath, bCache) end


---@public 获取动画缓存个数
---@return number 缓存个数
function XEAnimAssetCacheManager:GetAnimAssetCacheCount() end


---@public 从动画缓存释放一个动画资产
---@param szAssetPath string 缓存路径,如果为NULL，则释放所有
---@return boolean 成功/失败
function XEAnimAssetCacheManager:Release(szAssetPath) end


---@public 释放动画集
---@param szAssetPath string 包含动画的动画集资源路径，如montage
---@return boolean 成功/失败
function XEAnimAssetCacheManager:ReleaseAnimSet(szAssetPath) end


---@public 释放一次动画引用计数， 导出使用
---@param pAnimSeq XAnimationSequence
---@return void
function XEAnimAssetCacheManager:SubRefAnimationSequence(pAnimSeq) end


