---动画控制器类
---@class XEAnimController : XEAnimControllerBase
XEAnimController = {}


---@public XEAnimController_new00
---@return XEAnimController
function XEAnimController:new() end


---@public 跳到动画播放起始处。手动模式：t = 播放区域起始处；非手动模式：t = 0
---@return void
function XEAnimController:NavigateToHead() end


---@public 跳到动画播放末尾处。手动模式：t = 播放区域末尾处；非手动模式：t = 动画长度
---@return void
function XEAnimController:NavigateToTail() end


---@public 通知监听者跳跃到cur time
---@return void
function XEAnimController:BroadcastStepMove() end


---@public 通知监听者当前的播放状态改变为state
---@param state number 动画控制状态Unknow/Play/Pause/Stop
---@return void
function XEAnimController:BroadcastPlayState(state) end


---@public 通知监听者一次播放结束，警告：试图在回调函数中删除控制器对象，将删除不成功！ 请在函数体外进行删除操作，例如在下一帧删除
---@param bReversePlaying boolean
---@return void
function XEAnimController:BroadcastPlayOneTimeFinished(bReversePlaying) end


---@public 通知监听者播放结束, 警告：在回调函数中删除控制器对象，将删除不成功！请在函数体外进行删除操作，例如在下一帧删除
---@return void
function XEAnimController:BroadcastPlayFinished() end


---@public 获取当前时刻
---@return number
function XEAnimController:GetCurTime() end


---@public 设置动画手动播放区域起始时间，一般编辑器端使用
---@param nTime number
---@return void
function XEAnimController:SetManaulStartTime(nTime) end


---@public 获取动画手动播放区域起始时间，一般编辑器端使用
---@return number
function XEAnimController:GetManualStartTime() end


---@public 设置动画手动播放区域结束时间，一般编辑器端使用
---@param nTime number
---@return void
function XEAnimController:SetManualEndTime(nTime) end


---@public 获取动画手动播放区域结束时间，一般编辑器端使用
---@return number
function XEAnimController:GetManualEndTime() end


---@public 设置动画是否是手动模式
---@param bManual boolean 是否为手动模式，true:手动模式（一般编辑器端使用）；false:非手动模式。
---@return void
function XEAnimController:SetManualTimeMode(bManual) end


---@public 获取动画是否是手动模式
---@return boolean
function XEAnimController:IsManualTimeMode() end


---@public 这个变量是为了保证在Listener的响应函数里，如果没有先UnloadAnimation，就再次调用LoadAnimation导致错误的情况！
---@return boolean
---@attention forbidden to delete this in callback, if it is true!
function XEAnimController:IsCallbackSafeLocked() end


---@public 如果模型组件pComponent不存在动画控制器，创建一个动画控制器，并返回;如果已经存在，直接返回
---@param pComponent XEModelComponent
---@return XEAnimController
function XEAnimController:AssginAnimControllerForModelComponent(pComponent) end


---@public 如果模型组件pComponent动画播放列表不存在，创建一个（调用的是XEModelComponent::AssignAnimPlayList()）
---@param pComponent XEModelComponent
---@return XEAnimComponentPlayList 动画播放列表指针
function XEAnimController:AssginAnimListForModelComponent(pComponent) end


---@public 给某个模型组件加载单个动画资源（可以是.seq or .montage or .blend）
---@param pAssetName string 这里需要是动画资源路径
---@param pComponent XEModelComponent 要加载动画的模型组件
---@return boolean 是否加载成功
function XEAnimController:LoadAnimation(pAssetName, pComponent) end


---@public 卸载某个模型组件的所有动画资源
---@param pComponent XEModelComponent 要卸载动画的模型组件
---@return boolean 是否卸载成功
function XEAnimController:UnloadAnimation(pComponent) end


---@public 给某个模型组件加载一层动画资源（可以是.seq or .montage）
---@param pLayerName string 要加载的层名称
---@param arrAreaNames string[] 要加载的动画区域名称数组
---@param arrAssetNames string[] 要加载的动画路径名称数组
---@param pComponent XEModelComponent 要加载动画的模型组件
---@param bReload boolean 是否需要重新加载该层动画资源，true:需要重新加载（如果该层动画不存在，或者该层动画有增减变化，则需要重新加载）；false:不需要重新加载
---@return boolean 是否加载成功
function XEAnimController:LoadLayerAnimations(pLayerName, arrAreaNames, arrAssetNames, pComponent, bReload) end


---@public 卸载某个模型组件的某层动画资源
---@param pLayerName string 要卸载的层名称
---@param pComponent XEModelComponent 要卸载动画的模型组件
---@return boolean 是否卸载成功
function XEAnimController:UnloadLayerAnimations(pLayerName, pComponent) end


