---Montage根节点类，封装了蒙太奇动画一些相关逻辑
---@class XEAnimMontage : XEAnimMonBase
XEAnimMontage = {}


---@public XEAnimMontage_new00
---@return XEAnimMontage
function XEAnimMontage:new() end


---@public 初始化
---@param strAssetPath string
---@return void
function XEAnimMontage:Initialize(strAssetPath) end


---@public 在当前蒙太奇动画中查找名为strTrackName的子轨道（只查找直接子轨道，不会查找子孙）
---@param strTrackName string
---@return XEAnimMonTrack
function XEAnimMontage:FindTrack(strTrackName) end


---@public 设置动画末尾是否循环播放
---@param bSet boolean
---@return void
function XEAnimMontage:SetLoopAtEnd(bSet) end


---@public 设置动画末尾循环播放起始时间
---@param nTime number
---@return void
function XEAnimMontage:SetLoopAtEndStartTime(nTime) end


---@public 获取与其关联的模型资源路径
---@return string
function XEAnimMontage:GetSkinModelAssetPath() end


---@public 获取蒙太奇动画资源路径
---@return string
function XEAnimMontage:GetAssetPath() end


---@public 判断动画末尾是否循环播放
---@return boolean
function XEAnimMontage:IsLoopAtEnd() end


---@public 设置手动播放动画区域起始时间
---@param nTime number
---@return void
function XEAnimMontage:SetManaulStartTime(nTime) end


---@public 获取手动播放动画区域起始时间
---@return number
function XEAnimMontage:GetManualStartTime() end


---@public 设置手动播放动画区域结束时间
---@param nTime number
---@return void
function XEAnimMontage:SetManualEndTime(nTime) end


---@public 获取手动播放动画区域结束时间
---@return number
function XEAnimMontage:GetManualEndTime() end


---@public 设置动画播放模式是否是手动模式
---@param bManual boolean
---@return void
function XEAnimMontage:SetManualTimeMode(bManual) end


---@public 获取动画播放模式是否是手动模式
---@return boolean
function XEAnimMontage:IsManualTimeMode() end


---@public 设置当前蒙太奇动画是否被改变
---@param bSet boolean
---@return void
function XEAnimMontage:SetModified(bSet) end


---@public 获取当前蒙太奇动画是否被改变
---@return boolean
function XEAnimMontage:IsModified() end


---@public 设置事件可分发（在实例中构建事件分发器）
---@param bEnable boolean
---@return void
function XEAnimMontage:SetEventDispatcherEnable(bEnable) end


---@public 获取当前是否启用事件分发
---@return boolean
function XEAnimMontage:IsEventDispatcherEnable() end


---@public 设置事件分发器绑定脚本资产文件
---@param szAssetPath string
---@return void
function XEAnimMontage:SetEventDispatcherScriptAssetPath(szAssetPath) end


---@public 获取事件分发器绑定脚本资产文件
---@return string
function XEAnimMontage:GetEventDispatcherScriptAssetPath() end


---@public 设置事件分发器中绑定脚本事件是否可以tick
---@param bTickable boolean
---@return void
function XEAnimMontage:SetEventDispatcherScriptTickable(bTickable) end


---@public 获取事件分发器中绑定脚本事件tickable
---@return boolean
function XEAnimMontage:IsEventDispatcherScriptTickable() end


---@public 获取动画末尾循环播放起始时间
---如果不为空且为非手动模式，返回在动画长度内的起始时间。
---@param pAnimMonController  XEAnimMonController 动画控制播放器指针
---@return number 如果pAnimMonController为空，同GetLoopAtEndStartTime();如果不为空且为手动模式，返回在手动播放区域的起始时间;
function XEAnimMontage:GetLoopAtEndStartTime(pAnimMonController) end


