---插槽节点类
---插槽节点依附于骨头节点或者父插槽节点下，一个插槽节点可以设置自身的相对父节点的矩阵信息，
---当骨头运动时，插槽矩阵会参与到计算中来，得出一个最终世界矩阵，并且作用到插槽上绑定的组件上。
---您可以为一个插槽绑定一个组件，组件的类型可以是“模型组件”或者“粒子系统组件”。
---@class XEBindSocket : XEUserNode
XEBindSocket = {}


---@public XEBindSocket_new00
---@return XEBindSocket
function XEBindSocket:new() end


---@class XEBindSocket__XEPhysicsMaterial
local XEBindSocket__XEPhysicsMaterial = {}
XEBindSocket.XEPhysicsMaterial = XEBindSocket__XEPhysicsMaterial


---@type number 静摩擦系数
XEBindSocket__XEPhysicsMaterial.fStaticFriction = 0


---@type number 动摩擦系数
XEBindSocket__XEPhysicsMaterial.fDynamicFriction = 0


---@type number 弹性系数
XEBindSocket__XEPhysicsMaterial.fRestitution = 0


---@public XEBindSocket_XEPhysicsMaterial_new00
---@return XEBindSocket__XEPhysicsMaterial
function XEBindSocket__XEPhysicsMaterial:new() end


---@class XEBindSocket__XEPhysicsInfo
local XEBindSocket__XEPhysicsInfo = {}
XEBindSocket.XEPhysicsInfo = XEBindSocket__XEPhysicsInfo


---@type number 刚体类型
XEBindSocket__XEPhysicsInfo.eType = 0


---@type boolean 是否开启重力影响
XEBindSocket__XEPhysicsInfo.bEnableGravity = false


---@type number 线速度阻尼系数， [0, X_MAX_FLT32]
XEBindSocket__XEPhysicsInfo.fLinearDamping = 0


---@type number 角速度阻尼系数， [0, X_MAX_FLT32]
XEBindSocket__XEPhysicsInfo.fAngularDamping = 0


---@type number 物体质量，单位kg
XEBindSocket__XEPhysicsInfo.fMass = 0


---@type boolean 是否开启了CCD属性（仅当Type为Dynamic时有效），高速物体应开启CCD来避免隧穿效应
XEBindSocket__XEPhysicsInfo.bCCD = false


---@type XVECTOR3 线速度
XEBindSocket__XEPhysicsInfo.vLinearVelocity = {}


---@type XVECTOR3 角速度
XEBindSocket__XEPhysicsInfo.vAngularVelocity = {}


---@type XEBindSocket::XEPhysicsMaterial 物理材质属性
XEBindSocket__XEPhysicsInfo.mPhysMat = {}


---@public XEBindSocket_XEPhysicsInfo_new00
---@return XEBindSocket__XEPhysicsInfo
function XEBindSocket__XEPhysicsInfo:new() end


---@public 获取当前插槽节点依附的骨头节点指针，如果当前节点依附的是一个插槽，那么返回的是依附的插槽依附的骨头节点
---@return XEBone
function XEBindSocket:GetXEBone() end


---@public 获取插槽绑定的预览资源路径
---@return string
function XEBindSocket:GetPreviewingAssetPath() end


---@public 获取插槽预览资源类型
---@return string
function XEBindSocket:GetPreviewingAssetType() end


---@public 获取插槽添加的预览动画资源路径
---@return string
function XEBindSocket:GetPreviewingSeqAssetPath() end


---@public 获取插槽预览动画是否为自动播放模式
---@return boolean
function XEBindSocket:GetPreviewingSeqAuto() end


---@public 获取插槽预览动画是否为循环播放模式
---@return boolean
function XEBindSocket:GetPreviewingSeqLoop() end


---@public 获取插槽预览动画是否为按顺序播放模式
---@return boolean
function XEBindSocket:GetPreviewingSeqInTurnsPlay() end


---@public 获取插槽预览动画播放速率
---@return number
function XEBindSocket:GetPreviewingSeqPlayRate() end


---@public 获取插槽绑定的物理资源路径
---@return string
function XEBindSocket:GetPhysicsAssetPath() end


---@public 获取插槽绑定资源的基本物理属性
---@return XEBindSocket__XEPhysicsInfo
function XEBindSocket:GetPhysicsInfo() end


---@public 设置插槽绑定的预览资源路径
---@param strPath string
---@return void
function XEBindSocket:SetPreviewingAssetPath(strPath) end


---@public 设置插槽绑定的预览资源类型
---@param strType string
---@return void
function XEBindSocket:SetPreviewingAssetType(strType) end


---@public 设置插槽添加的预览动画资源路径
---@param strPath string
---@return void
function XEBindSocket:SetPreviewingSeqAssetPath(strPath) end


---@public 设置插槽预览动画是否为自动播放模式
---@param bAuto boolean
---@return void
function XEBindSocket:SetPreviewingSeqAuto(bAuto) end


---@public 设置插槽预览动画是否为循环播放模式
---@param bLoop boolean
---@return void
function XEBindSocket:SetPreviewingSeqLoop(bLoop) end


---@public 设置插槽预览动画是否为按顺序播放模式
---@param bInTurnsPlay boolean
---@return void
function XEBindSocket:SetPreviewingSeqInTurnsPlay(bInTurnsPlay) end


---@public 设置插槽预览动画播放速率
---@param fPlayRate number
---@return void
function XEBindSocket:SetPreviewingSeqPlayRate(fPlayRate) end


---@public 设置插槽绑定的物理资源路径
---@param strPath string
---@return void
function XEBindSocket:SetPhysicsAssetPath(strPath) end


---@public 获取插槽绑定的软骨资源路径
---@return string
function XEBindSocket:GetSoftBoneAssetPath() end


---@public 设置插槽绑定的软骨资源路径
---@param strPath string
---@return void
function XEBindSocket:SetSoftBoneAssetPath(strPath) end


---@public 设置插槽的基本物理属性
---@param info XEBindSocket::XEPhysicsInfo
---@return void
function XEBindSocket:SetPhysicsInfo(info) end


---@public 获取插槽相对父节点的矩阵信息
---@return XETransform
function XEBindSocket:GetRelativeTransform() end


---@public 设置是否需要预览组件属性，一般编辑器端使用
---@param bEnable boolean
---@return void
function XEBindSocket:SetEnablePreviewing(bEnable) end


---@public 判断是否需要预览组件属性，一般编辑器端使用
---@return boolean
function XEBindSocket:IsEnablePreviewing() end


---@public 设置起始时间
---@param nTime number
---@return void
function XEBindSocket:SetStartTime(nTime) end


---@public 获取起始时间
---@return number
function XEBindSocket:GetStartTime() end


---@public 获取实例关联的模板副本
---@param pBindSocketIns XEBindSocketInstance
---@return XEBindSocket
function XEBindSocket:GetBindInstanceForTemplateNode(pBindSocketIns) end


