---@class XEBone : XEUserNode
XEBone = {}


---@public 设置引擎骨头实例指针
---@param pBone XBone
---@return void
function XEBone:SetBone(pBone) end


---@public 获取引擎骨头实例指针
---@return XBone
function XEBone:GetBone() end


---@public 创建插槽
---@param pFromOccupidSocketName string 已经被占用的插槽节点名称，如果不为空，使用此名称；否则，创建一个新插槽名称
---@param bAddToBoneNode boolean 是否添加到该骨头节点下。注意，如果不添加到该骨头节点下，请保证正确管理了该插槽节点
---@return XEBindSocket
function XEBone:CreateSocket(pFromOccupidSocketName, bAddToBoneNode) end


---@public 为“虚拟骨头节点（节点名称带有dummy字符串）”创建一个插槽
---@return XEBindSocket
function XEBone:BuildDummySocket() end


---@public 移除某个插槽
---@param pSocket XEBindSocket 要移除的插槽节点指针
---@return void
function XEBone:RemoveSocket(pSocket) end


---@public 获取当前骨头索引
---@return number
function XEBone:GetBoneIndex() end


---@public 获取当前骨头对应的骨架指针
---@return XESkeleton
function XEBone:GetXESkeleton() end


---@public 移除物理刚体pBody
---@param pBody XEPhysicsSkeletalBody
---@return void
function XEBone:RemoveBody(pBody) end


