---@class XEAnimTimeAreaBase
XEAnimTimeAreaBase = {}


---@type number @enum eAnimTimeAreaType 未知类型
XEAnimTimeAreaBase.ATA_UNKNOWN = 0


---@type number @enum eAnimTimeAreaType seq动画区域
XEAnimTimeAreaBase.ATA_XANIMATION = 0


---@type number @enum eAnimTimeAreaType Montage动画区域
XEAnimTimeAreaBase.ATA_MONTAGE = 0


---@public 获取动画长度
---@return number
function XEAnimTimeAreaBase:GetAnimationLength() end


---@public 获取动画区域名称
---@return string
function XEAnimTimeAreaBase:GetAreaName() end


---@public 设置动画区域名称
---@param szName string
---@return void
function XEAnimTimeAreaBase:SetAreaName(szName) end


---@public 获取动画区域所在Layer名称
---@return string
function XEAnimTimeAreaBase:GetAreaLayerName() end


---@public 设置动画区域所在Layer名称
---@param strName string
---@return void
function XEAnimTimeAreaBase:SetAreaLayerName(strName) end


---@public 获取动画区域起始时间
---@return number
function XEAnimTimeAreaBase:GetStartTime() end


---@public 设置动画区域起始时间
---@param fStartTime number
---@return void
function XEAnimTimeAreaBase:SetStartTime(fStartTime) end


---@public 获取动画区域结束时间
---@return number
function XEAnimTimeAreaBase:GetEndTime() end


---@public 设置动画区域结束时间
---@param fEndTime number
---@return void
function XEAnimTimeAreaBase:SetEndTime(fEndTime) end


---@public 获取动画区域动画的起始采样时间
---@return number
function XEAnimTimeAreaBase:GetSampleClipStartTime() end


---@public 设置动画区域动画的起始采样时间
---@param fStartTime number
---@return void
function XEAnimTimeAreaBase:SetSampleClipStartTime(fStartTime) end


---@public 获取动画区域动画的终止采样时间
---@return number
function XEAnimTimeAreaBase:GetSampleClipEndTime() end


---@public 设置动画区域动画的终止采样时间
---@param fEndTime number
---@return void
function XEAnimTimeAreaBase:SetSampleClipEndTime(fEndTime) end


---@public 获取动画区域类型
---@return number
function XEAnimTimeAreaBase:GetType() end


---基本动画区域，从XEAnimTimeAreaBase派生（seq动画）
---@class XEAnimtionTimeArea : XEAnimTimeAreaBase
XEAnimtionTimeArea = {}


---蒙太奇动画区域，从XEAnimTimeAreaBase派生（montage动画）
---@class XEAnimMontageTimeArea : XEAnimTimeAreaBase
XEAnimMontageTimeArea = {}


---@public 获取相关联的蒙太奇动画实例指针
---@return XEAnimMontageInstance
function XEAnimMontageTimeArea:GetMontageInstance() end


---@public 通过名称获取动画区域
---@param szName string
---@return XEAnimtionTimeArea
function XEAnimMontageTimeArea:GetAnimTimeAreaByName(szName) end


---@class XEAnimBlendLayer : XSkelBlendShapeAnimController
XEAnimBlendLayer = {}


---@type number @enum EInterBlendType
XEAnimBlendLayer.EIBT_INVAlID = 0


---@type number @enum EInterBlendType 线性
XEAnimBlendLayer.EIBT_LINEAR = 0


---@type number @enum EInterBlendType sin_in
XEAnimBlendLayer.EIBT_SIN_IN = 0


---@type number @enum EInterBlendType sin_out
XEAnimBlendLayer.EIBT_SIN_OUT = 0


---@type number @enum EInterBlendType sin_in_out
XEAnimBlendLayer.EIBT_SIN_IN_OUT = 0


---@type number @enum EInterBlendType
XEAnimBlendLayer.EIBT_NUM = 0


---@public 计算融合因子
---@param fStart number 起始点
---@param fEnd number 结束点
---@param fCur number 当前点
---@param eType number 融合曲线类型
---@return number 结果
function XEAnimBlendLayer:ComputeLinearFactor(fStart, fEnd, fCur, eType) end


---@public XEAnimBlendLayer_new00
---@param szName string
---@param pAsset IXAnimationBase
---@return XEAnimBlendLayer
function XEAnimBlendLayer:new(szName, pAsset) end


---@public 设置动画区域起始时间
---@param fTime number
---@return void
function XEAnimBlendLayer:SetStartTime(fTime) end


---@public 设置动画区域结束时间
---@param fTime number
---@return void
function XEAnimBlendLayer:SetEndTime(fTime) end


---@public 在当前layer上添加seq动画区域
---@param szName string seq动画区域名称
---@param pAsset IXAnimationBase 加载seq资源返回的指针
---@return XEAnimtionTimeArea seq动画区域指针
function XEAnimBlendLayer:AddAnimationAsset(szName, pAsset) end


---@public 在当前layer上添加montage动画区域
---@param szName string montage动画区域
---@param pModelComponent XEModelComponent montage动画关联的ModelComponent
---@param pAssetPath string 动画资源路径
---@return XEAnimMontageTimeArea montage动画区域指针
function XEAnimBlendLayer:AddMontageAsset(szName, pModelComponent, pAssetPath) end


---@public 删除动画区域资源
---@param szName string 要删除的动画区域资源名称
---@return boolean 是否删除成功
---@attention 构造函数中设置进来的动画资源，也可以被删掉（用于动画融合的逻辑）
function XEAnimBlendLayer:RemoveAnimationAsset(szName) end


---@public 通过名字获取动画区域资源
---@param szName string 动画区域名称
---@return XEAnimTimeAreaBase 动画区域指针
function XEAnimBlendLayer:GetTimeAreaByName(szName) end


---@public 获取动画区域资源数量
---@return number 动画区域资源数量
function XEAnimBlendLayer:GetTimeAreaNum() end


---@public 通过索引获取动画区域资源
---@param nIndex number 动画区域索引
---@return XEAnimTimeAreaBase 动画区域指针
function XEAnimBlendLayer:GetTimeAreaByIndex(nIndex) end


---@public 设置融合类型
---@param eType number
---@return void
function XEAnimBlendLayer:SetInterBlendType(eType) end


---@public 获取融合类型
---@return number
function XEAnimBlendLayer:GetInterBlendType() end


---@public 更新当前layer的起始时间
---@return void
function XEAnimBlendLayer:UpdateLayerStartEndTime() end


---多层动画控制器
---@class XELayersAnimaPlay : XBlendShapeAnim
XELayersAnimaPlay = {}


---@type number @enum eExtendAnimationType 未知类型
XELayersAnimaPlay.EAT_UNKNOWN = 0


---@type number @enum eExtendAnimationType seq
XELayersAnimaPlay.EAT_PRIMITIVE_SEQ = 0


---@type number @enum eExtendAnimationType montage
XELayersAnimaPlay.EAT_MONTAGE = 0


---@public XELayersAnimaPlay_new00
---@param pIns IXModelInstance
---@return XELayersAnimaPlay
function XELayersAnimaPlay:new(pIns) end


---@public XELayersAnimaPlay_new01
---@param pModelComponent XEModelComponent
---@return XELayersAnimaPlay
function XELayersAnimaPlay:new(pModelComponent) end


---@public 添加一个Layer
---@param extType number
---@param szLayerName string Layer名称
---@param szAssetPath string
---@return number Layer索引
function XELayersAnimaPlay:AddLayer(extType, szLayerName, szAssetPath) end


---@public 更新时间线
---@return void
function XELayersAnimaPlay:UpdateTimeLine() end


---@public 设置相关联的组件（montage动画）
---@param pComponent XEModelComponent
---@return void
function XELayersAnimaPlay:SetModelComponent(pComponent) end


---@public 获取相关联的组件（montage动画）
---@return XEModelComponent
function XELayersAnimaPlay:GetModelComponent() end


---@public 创建两层动画达到融合效果（融合之后是2层，默认使最后0.5s作为融合区域，并使用sin_in_out类型）
---@param layer1Name string 第一个Layer的名称
---@param asset1Path string 第一个动画资源路径
---@param layer2Name string 第二个Layer的名称
---@param asset2Path string 第二个动画资源路径
---@return boolean 是否成功
function XELayersAnimaPlay:BlendAndSetTwoLayers(layer1Name, asset1Path, layer2Name, asset2Path) end


---@public 创建两层动画达到融合效果（融合之后是1层，默认使最后0.5s作为融合区域，并使用sin_in_out类型）
---@param layerName string Layer的名称
---@param area1Name string 第一个动画区域名称
---@param asset1Path string 第一个动画资源路径
---@param area2Name string 第二个动画区域名称
---@param asset2Path string 第二个动画资源路径
---@return boolean 是否成功
function XELayersAnimaPlay:BlendAndSetTwoAreaInALayer(layerName, area1Name, asset1Path, area2Name, asset2Path) end


---@public 添加一层新动画，让它以指定时刻为开始点，并让它与已有层动画达到融合效果（使用sin_in_out类型）
---@param newLayerName string Layer的名称
---@param assetPath string 动画资源路径
---@param fTimestamp number 指定添加的时间戳，单位(秒)
---@param fAnimSampleClipStartOffset number 动画采样起始裁剪偏移量（实际裁剪为起始时间+偏移量）
---@param fAnimSampleClipEndOffset number 动画采样终止裁剪量（实际裁剪为终止时间-偏移量）
---@param fCrossTime number 动画接受外部设置的最长融合时间（默认最长为0.5s,取动画时长0.2的最小值)，如果该值为非正，则动画不融合
---@return boolean 是否成功
function XELayersAnimaPlay:BlendAnimIntoTimelineAtTimstamp(newLayerName, assetPath, fTimestamp, fAnimSampleClipStartOffset, fAnimSampleClipEndOffset, fCrossTime) end


---@public 添加一层新动画，让它以当前时刻为开始点，并让它与已有层动画达到融合效果（使用sin_in_out类型）
---@param newLayerName string Layer的名称
---@param assetPath string 动画资源路径
---@param fAnimSampleClipStartOffsest number
---@param fAnimSampleClipEndOffset number 动画采样终止裁剪量（实际裁剪为终止时间-偏移量）
---@return boolean 是否成功
function XELayersAnimaPlay:BlendAnimIntoCurrentTimeline(newLayerName, assetPath, fAnimSampleClipStartOffsest, fAnimSampleClipEndOffset) end


---@public 获取层的动画起始时间（秒s）
---@param layerName string Layer的名称
---@param bGetActualClipStartTime boolean 是否获取动画实际的裁剪起始时间
---@return number 层起始时间
function XELayersAnimaPlay:GetLayerAnimStartTime(layerName, bGetActualClipStartTime) end


---@public 获取层的动画结束时间（秒s）
---@param layerName string Layer的名称
---@param bGetActualClipEndTime boolean
---@return number 层结束时间
function XELayersAnimaPlay:GetLayerAnimEndTime(layerName, bGetActualClipEndTime) end


---@public 获取层指定区域动画起始时间（秒s）
---@param layerName string Layer的名称
---@param areaName string 区域名称
---@param bGetActualClipStartTime boolean 是否获取动画实际的裁剪起始时间
---@return number 区域起始时间
function XELayersAnimaPlay:GetAreaAnimStartTime(layerName, areaName, bGetActualClipStartTime) end


---@public 获取层指定区域动画的结束时间（秒s）
---@param layerName string Layer的名称
---@param areaName string 区域名称
---@param bGetActualClipEndTime boolean
---@return number 层区域结束时间
function XELayersAnimaPlay:GetAreaAnimEndTime(layerName, areaName, bGetActualClipEndTime) end


