---骨架类
---您可以利用3DsMax来为模型创建骨架。
---@class XESkeleton : XEUserNode
XESkeleton = {}


---@public XESkeleton_new00
---@return XESkeleton
function XESkeleton:new() end


---@public 初始化
---@param pSkeletonModelPath string
---@return boolean
function XESkeleton:Initialize(pSkeletonModelPath) end


---@public 更新骨架模板
---@return void
function XESkeleton:UpdatePhysicsSkeltalNodeForSkeleton() end


---@public 获取当前骨架上绑定的所有插槽
---@return XEBindSocket[]
---@return number 插槽个数
function XESkeleton:GetBindSockets() end


---@public 获取当前骨架上绑定的所有插槽名称
---@return string[]
---@return number 插槽名称个数
function XESkeleton:GetSocketNames() end


---@public 获取当前骨架上绑定的某个插槽指针
---@param sokcetName string [in]要获取的插槽名称
---@return XEBindSocket 插槽指针
function XESkeleton:GetBindSocket(sokcetName) end


---@public 获取当前骨架上某个骨头指针
---@param boneName string [in]要获取的骨头名称
---@return XEBone 骨头指针
function XESkeleton:GetBone(boneName) end


---@public 获取所有children骨头
---@return XEBone[]
function XESkeleton:GetRootBones() end


---@public 判断组件是否使用的同一个骨架资源  (会加载资源，有效率开销)
---@param pSkeletonModelPath string 模型资源路径
---@return boolean 如果返回true，是同一个；返回false，不是同一个
function XESkeleton:IsWithTheSameSkeleton(pSkeletonModelPath) end


---@public 获取模型的骨架资源路径 (会加载资源，有效率开销)
---@param pSkeletonModelPath string 模型资源路径
---@return string 模型的骨架资源路径
function XESkeleton:GetSkeletonPathOfModel(pSkeletonModelPath) end


---@public 获取模型资源路径
---@return string
function XESkeleton:GetAssetPath() end


---@public 获取骨架资源路径
---@return string
function XESkeleton:GetSkeletonAssetPath() end


---@public 获取引擎骨架指针
---@return XSkeleton
function XESkeleton:GetXSkeletonTemplate() end


---@public XESkeleton_GetXSkeletonTemplate01
---@return  XSkeleton
function XESkeleton:GetXSkeletonTemplate() end


---@public 获取引擎模型指针
---@return XModel
function XESkeleton:GetXModelTemplate() end


---@public 设置当前骨架是否被修改
---@param bModify boolean
---@return void
function XESkeleton:SetIsModify(bModify) end


---@public 获取当前骨架是否被修改
---@return boolean
function XESkeleton:GetIsModify() end


---@public 获取骨架的物理资源
---@return string
function XESkeleton:GetPhyAssetPath() end


---@public 设置骨架的物理资源
---@param szPhyAssetPath string
---@return void
function XESkeleton:SetPhyAssetPath(szPhyAssetPath) end


