---@class XECustomMeshVertex
XECustomMeshVertex = {}


---@public XECustomMeshVertex_new00
---@return XECustomMeshVertex
function XECustomMeshVertex:new() end


---@type XVECTOR3
XECustomMeshVertex.Position = {}


---@type XVECTOR2
XECustomMeshVertex.Texcoord = {}


---@class XECustomPrimtiveMeshData
XECustomPrimtiveMeshData = {}


---@public 设置顶点数据
---@param vVertices XECustomMeshVertex[]
---@return void
function XECustomPrimtiveMeshData:SetVertex(vVertices) end


---@public 设置顶点索引数据
---@param vIndices number[] 顶点索引数组，每个索引的类型为xuint16
---@return void
function XECustomPrimtiveMeshData:SetIndex(vIndices) end


---@public 获取该顶点集合的AABB包围盒
---@return  XCusAABB 返回该顶点集合的包围盒
function XECustomPrimtiveMeshData:GetAABB() end


---@class XECustomPrimtive
XECustomPrimtive = {}


---@public 创建一个Mesh，用于填充需要渲染的顶点和顶点索引数据
---@return XECustomPrimtiveMeshData 返回创建的Mesh数据的指针
function XECustomPrimtive:CreateMesh() end


---@public 移除一个已经被创建的Mesh数据
---@param pMeshData XECustomPrimtiveMeshData 要移除的Mesh数据
---@return void
function XECustomPrimtive:RemoveMesh(pMeshData) end


---@public 获取当前Mesh总数
---@return number 返回当前Mesh总数
function XECustomPrimtive:GetMeshesNum() end


---@public 根据索引获取已经被创建的Mesh数据
---@param nIndex number Mesh数据的索引值，范围为0~N，N是当前Mesh总数
---@return XECustomPrimtiveMeshData
function XECustomPrimtive:GetMeshByIndex(nIndex) end


---@public 设置渲染时使用的材质实例，一般不会手动更改，默认的材质实例为渲染半透明模型的材质实例
---@param pMaterialIns IXMaterialInstance
---@param bReleaseWhenDelted boolean 当该Primtive被销毁时，是否需要帮忙释放pMaterialIns。如果不需要释放就传xfalse，需要就传xtrue
---@return void
function XECustomPrimtive:SetMaterialIns(pMaterialIns, bReleaseWhenDelted) end


---@public XECustomPrimtive_SetMaterialIns01
---@param strMaterialTemp string
---@param bReleaseWhenDelted boolean
---@return void
function XECustomPrimtive:SetMaterialIns(strMaterialTemp, bReleaseWhenDelted) end


---@public XECustomPrimtive_SetMaterialNormal00
---@return void
function XECustomPrimtive:SetMaterialNormal() end


---@public XECustomPrimtive_SetMaterialTransparent00
---@return void
function XECustomPrimtive:SetMaterialTransparent() end


---@public 获取渲染时使用的材质实例，默认的材质实例为渲染半透明模型的材质实例
---@return IXMaterialInstance 返回当前使用的材质实例
function XECustomPrimtive:GetMaterialIns() end


---@public XECustomPrimtive_SetMaterialTextureByName00
---@param strParamName string
---@param strTexturePath string
---@return void
function XECustomPrimtive:SetMaterialTextureByName(strParamName, strTexturePath) end


---@public 获取当前Primtive所依附的Component，通常情况是XECustomMeshComponent类型的Cmoponent
---@return XEActorComponent 返回当前依附的Component
function XECustomPrimtive:GetComponent() end


