---@class IXEDressup
IXEDressup = {}


---@class IXEDressup__AddedSkin
local IXEDressup__AddedSkin = {}
IXEDressup.AddedSkin = IXEDressup__AddedSkin


---@type string skin文件路径
IXEDressup__AddedSkin.strSkinfile = ''


---@type string 相关联的骨头资源路径
IXEDressup__AddedSkin.strRefSkeletonPath = ''


---@public 释放资源
---@return void
function IXEDressup:Release() end


---@public 添加skin
---@param szSkinFile string skin文件路径名
---@param szSkeletonPath string 骨头路径，可以为NULL
---@param strLoadLog string
---@return boolean 是否添加成功
function IXEDressup:AddSkin(szSkinFile, szSkeletonPath, strLoadLog) end


---@public 移除skin
---@param szSkinFile string skin文件路径名
---@return void
function IXEDressup:RemoveSkin(szSkinFile) end


---@public 清空skin
---@return boolean
function IXEDressup:RemoveAllSkins() end


---@public 替换skin
---@param szSrcSkinFile string 源skin文件路径名
---@param szDestSkinFile string 目标skin文件路径名
---@param szSkeletonPath string 骨头路径，可以为NULL
---@return boolean 是否替换成功
function IXEDressup:ReplaceSkin(szSrcSkinFile, szDestSkinFile, szSkeletonPath) end


---@public 获取TemplateSkinModel文件名
---@return string 文件名
function IXEDressup:GetTemplateSkinModelFile() end


---@public 获取已添加的Skin信息数组
---@return AddedSkin[] 已添加的Skin信息数组
function IXEDressup:GetAddedSkins() end


---@public 获取已删除的Skin信息数组
---@return string[] 已删除的Skin信息数组
function IXEDressup:GetRemovedSkins() end


---@public 模糊查询到有某个关键字的skin
---@param szKeyword string
---@return  IXEDressup__AddedSkin AddedSkin对象，为空则没有
function IXEDressup:FindAddedSkinLike(szKeyword) end


---@public 是否有指定皮肤
---@param szSkinFile string 源skin文件路径名
---@return boolean true/fase
function IXEDressup:HasSkin(szSkinFile) end


---@public 获取Dressup文件路径名
---@return string Dressup文件路径名
function IXEDressup:GetDressupFile() end


---@public 获取SkinModel
---@return XModel
function IXEDressup:GetSkinModel() end


---@class IXEDressupManager
IXEDressupManager = {}


---@public 创建Dressup
---@param szDressupFile string Dressup资源文件路径
---@param szSkinModelFile string SkinModel资源文件路径
---@return IXEDressup 返回创建的IXEDressup指针
function IXEDressupManager:CreateDressup(szDressupFile, szSkinModelFile) end


---@public 获取Dressup
---@param szDressupFile string Dressup资源文件路径
---@param bReload boolean 是否重新加载，默认为false
---@param strLoadLog string
---@return IXEDressup
function IXEDressupManager:GetDressup(szDressupFile, bReload, strLoadLog) end


---@public 克隆Dressup
---@param pSrcDressup  IXEDressup 要克隆的Dressup指针
---@param szDestDressupFile string Dressup资源路径名
---@return IXEDressup 克隆的Dressup指针
function IXEDressupManager:CloneDressup(pSrcDressup, szDestDressupFile) end


---@public 释放Dressup
---@param pDressup IXEDressup 要释放的IXEDressup指针
---@return void
function IXEDressupManager:ReleaseDressup(pDressup) end


---@public 重新加载Dressup
---@param szDressupFile string IXEDressup文件资源路径
---@return void
function IXEDressupManager:ReloadDressup(szDressupFile) end


---@public 判断Dressup是否存在 （内在+硬盘）
---@param szDressupFile string IXEDressup文件资源路径
---@return boolean
function IXEDressupManager:IsDressupExist(szDressupFile) end


