---@class OrbitPanView
OrbitPanView = {}


---@public OrbitPanView_new00
---@param pVp XEViewport
---@return OrbitPanView
function OrbitPanView:new(pVp) end


---@public 设置相机看的目标点坐标
---@param vLookAt XVECTOR3 看的目标点坐标
---@return void
function OrbitPanView:SetLookAt(vLookAt) end


---@public 设置鼠标敏感度
---@param fVal number 敏感度大小，默认为0.2f
---@return void
function OrbitPanView:SetMouseSensitivity(fVal) end


---@public 设置视点距离
---@param fVal number 视点距离，默认为4.0f
---@return void
function OrbitPanView:SetLookAtDistance(fVal) end


---@public 获取鼠标敏感度
---@return number 敏感度大小
function OrbitPanView:GetMouseSensitivity() end


---@public 获取视点距离
---@return number 视点距离
function OrbitPanView:GetLookAtDistance() end


---@public 获取相机看的目标点坐标
---@return XVECTOR3 看的目标点坐标
function OrbitPanView:GetLookAt() end


---@public 更新View
---@param bUsingCallbackFunc boolean 是否使用回调函数，如果为xtrue,相机看的目标点依赖于回调函数，默认为true
---@return void
function OrbitPanView:UpdateView(bUsingCallbackFunc) end


---@public 绕关注点旋转相机
---@param nDeltaX number Pitch角的鼠标偏移值
---@param nDeltaY number Yaw角的鼠标偏移值
---@return void
function OrbitPanView:RatateAround(nDeltaX, nDeltaY) end


---@public 设置Pitch角（绕x轴，右方向，俯仰角）的范围
---@param fMinEulerRadian number Pitch的最小值
---@param fMaxEulerRadian number Pitch的最大值
---@param bEnable boolean 是否启用Pitch角限制
---@return void
function OrbitPanView:SetPitchLimit(fMinEulerRadian, fMaxEulerRadian, bEnable) end


---@public 设置Yaw角(绕y轴，上方向，偏航角)的范围
---@param fMinEulerRadian number Yaw的最小值
---@param fMaxEulerRadian number Yaw的最大值
---@param bEnable boolean 是否启用Yaw角限制
---@return void
function OrbitPanView:SetYawLimit(fMinEulerRadian, fMaxEulerRadian, bEnable) end


---@public 设置是否将限制应用在当前相机的姿态角上
---为xfalse时，则设置的限制量为相机的最终姿态角，并对此进行限制
---@param bSet boolean 为xtrue时，将以当前相机的姿态角为基础，对限制角度的偏移量进行限制（此时设置的限制量为偏移量）
---@return void
function OrbitPanView:SetLimitAtCurrentAngle(bSet) end


---@public 获取是否将限制应用在当前相机的姿态角上
---@return boolean
function OrbitPanView:IsLimitAtCurrentAngle() end


---视口类，表示窗口中绘制输出区域，是一个3D视口，此类记录当前视口绑定的相机、绑定的世界以及指定视口上渲染内容的枚举类型等
---@class XEViewport
XEViewport = {}


---@type number @enum XVPType 透视视口
XEViewport.XVP_PERS = 0


---@type number @enum XVPType 顶视口
XEViewport.XVP_TOP = 0


---@type number @enum XVPType 侧视口
XEViewport.XVP_LEFT = 0


---@type number @enum XVPType 前视口
XEViewport.XVP_FRONT = 0


---@type number @enum XVPType
XEViewport.XVP_CAMERA = 0


---@type number @enum XVPType
XEViewport.XVP_NUM = 0


---@type number @enum XVPType
XEViewport.XVP_BACK = 0


---@type number @enum XVPFpsRenderPos 左上角
XEViewport.XVP_LEFTTOP = 0


---@type number @enum XVPFpsRenderPos 左下角
XEViewport.XVP_LEFTBOTTOM = 0


---@type number @enum XVPFpsRenderPos 右上角
XEViewport.XVP_RIGHTTOP = 0


---@type number @enum XVPFpsRenderPos 右下角
XEViewport.XVP_RIGHTBOTTOM = 0


---@type number @enum XVPARenOpt 坐标轴
XEViewport.XVPA_RendCoord = 0


---@type number @enum XVPARenOpt Fps
XEViewport.XVPA_RendFps = 0


---@type number @enum XVPARenOpt 相机位置
XEViewport.XVPA_CameraPos = 0


---@type number @enum XVPARenOpt 预览模式
XEViewport.XVPA_PreviewMode = 0


---@type number @enum XVPARenOpt Engine state group
XEViewport.XVPA_StateGroup = 0


---@type number @enum XVPARenOpt Prefab模式
XEViewport.XVPA_PrefabMode = 0


---@type number @enum XVPARenOpt
XEViewport.XVPA_DefaultRenOpt = 0


---@type number @enum XVPARenOpt
XEViewport.XVPA_DefaultRenOpt = 0


---@public 获取视口类型对应的名称
---@param eType number 视口类型
---@return string 视口类型对应的名称
function XEViewport:GetVPTypeName(eType) end


---@public 调整大小
---@return void
function XEViewport:Resize() end


---@public XEViewport_Resize01
---@param nWidth number
---@param nHeight number
---@return void
function XEViewport:Resize(nWidth, nHeight) end


---@public XEViewport_Resize02
---@param nX number
---@param nY number
---@param nWidth number
---@param nHeight number
---@return void
function XEViewport:Resize(nX, nY, nWidth, nHeight) end


---@public XEViewport_UpdateAttachedCameraAspect00
---@return void
function XEViewport:UpdateAttachedCameraAspect() end


---@public 获取视口名称
---@return string
function XEViewport:GetName() end


---@public 获取引擎视口指针
---@return XViewport
function XEViewport:GetXViewport() end


---@public 判断是否是激活状态
---@return boolean
function XEViewport:IsActive() end


---@public 设置激活状态
---@param bActive boolean
---@return void
function XEViewport:SetActive(bActive) end


---@public 获取视口类型
---@return number
function XEViewport:GetType() end


---@public 获取当前视口的渲染选项
---@return number
function XEViewport:GetAddRenderOption() end


---@public 设置当前视口的渲染选项
---@param nOption number
---@return void
function XEViewport:SetAddRenderOption(nOption) end


---@public 该视口绑定一个世界
---@param pWorld XEWorld
---@return void
function XEViewport:AttachWorld(pWorld) end


---@public 获取该视口绑定的世界指针
---@return XEWorld
function XEViewport:GetAttachWorld() end


---@public 获取该视口的工作相机，即附加相机
---@return XBaseCamera
function XEViewport:GetWorkCamera() end


---@public 获取该视口的工作相机，即附加相机
---@return XBaseCamera
function XEViewport:GetAttachCamera() end


---@public 获取该视口对应的窗口
---@return IXPlatformWindow
function XEViewport:GetPresentWindow() end


---@public 设置该视口对应的窗口
---@param pWindow IXPlatformWindow
---@return void
function XEViewport:SetPresentWindow(pWindow) end


---@public 设置该视口的附加相机，并把该相机设置为场景相机
---@param pAttachCamera XBaseCamera
---@return void
function XEViewport:AttachCamera(pAttachCamera) end


---@public 设置该视口自己相机的属性
---@param pCamera XBaseCamera
---@return void
function XEViewport:SetOwnerCameraParam(pCamera) end


---@public 把视口附加相机指针指向视口自己的相机，并把视口的自己相机设置为场景相机
---@return void
function XEViewport:AttachToOwnerCamera() end


---@public 获取场景相机指针
---@return XBaseCamera
function XEViewport:GetOwnerCamera() end


---@public 设置视口附加渲染项中的相机位置信息的渲染颜色
---@param r number
---@param g number
---@param b number
---@param a number
---@return void
function XEViewport:SetCameraPosTextColor(r, g, b, a) end


---@public 设置视口附加渲染项中的相机位置信息的渲染颜色
---@param color  XCOLORBASE
---@return void
function XEViewport:SetCameraPosTextColor(color) end


---@public 设置视口附加渲染项中的fps信息的渲染颜色
---@param r number
---@param g number
---@param b number
---@param a number
---@return void
function XEViewport:SetFpsTextColor(r, g, b, a) end


---@public 设置视口附加渲染项中的fps信息的渲染颜色
---@param color  XCOLORBASE
---@return void
function XEViewport:SetFpsTextColor(color) end


---@public 设置fps渲染位置
---@param FpsRenderpos number
---@return void
function XEViewport:SetFpsRenderPos(FpsRenderpos) end


---@public 获取fps渲染位置
---@return number
function XEViewport:GetFpsRenderPos() end


---@public 设置视口附加渲染项中的Prefab信息的渲染颜色
---@param r number
---@param g number
---@param b number
---@param a number
---@return void
function XEViewport:SetPrefabTextColor(r, g, b, a) end


---@public 设置视口附加渲染项中的Prefab信息的渲染颜色
---@param color  XCOLORBASE
---@return void
function XEViewport:SetPrefabTextColor(color) end


---@public 获取字体开始渲染的Y值
---@return number
function XEViewport:GetRenderY() end


---@public 获取视口的宽
---@return number
function XEViewport:GetViewportWidth() end


---@public 获取视口的高
---@return number
function XEViewport:GetViewportHeight() end


---@public 获取OrbitPanView指针
---@return OrbitPanView
function XEViewport:GetOribitPanView() end


---@public 获取当前窗口设备像素比devicePixelRatio
---@return number
function XEViewport:GetWindowScale() end


---@public 设置统计的单一信息, 当strInfo为空时，统计当前所有
---@param strInfo string
---@return void
function XEViewport:SetStatInfo(strInfo) end


---@public XEViewport_SetStatDisplayColor00
---@param groupColor  XCOLORBASE
---@param statColor  XCOLORBASE
---@return void
function XEViewport:SetStatDisplayColor(groupColor, statColor) end


---@public XEViewport_GetStatDisplayColor00
---@param outGroupColor XCOLORBASE
---@param outStatColor XCOLORBASE
---@return void
function XEViewport:GetStatDisplayColor(outGroupColor, outStatColor) end


---@class XEViewportManager
XEViewportManager = {}


---@public 创建视口
---@param eType number 视口类型
---@param strName string 视口名称
---@param pWindow IXPlatformWindow 视口相关联的窗口指针
---@param fWindowScale number 窗口的设备像素比
---@return XEViewport 返回创建的视口指针
function XEViewportManager:CreateXEViewport(eType, strName, pWindow, fWindowScale) end


---@public 删除视口
---@param strName string 视口名称
---@return void
function XEViewportManager:DeleteXEViewport(strName) end


---@public 通过名称获取视口
---@param strName string 视口名称
---@return XEViewport 视口指针
function XEViewportManager:GetXEViewport(strName) end


---@public 通过世界指针获取视口
---@param pWorld  XEWorld 世界指针
---@return XEViewport 视口指针
function XEViewportManager:GetXEViewport(pWorld) end


---@public XEViewportManager_GetXEViewport02
---@param pWorld  XEWorld
---@param eViewportType number
---@return XEViewport
function XEViewportManager:GetXEViewport(pWorld, eViewportType) end


---@public 通过窗口获取视口
---@param pWin  IXPlatformWindow 窗口指针
---@return XEViewport 视口指针
function XEViewportManager:GetXEViewport(pWin) end


---@public XEViewportManager_GetXEViewport04
---@param pWin  IXPlatformWindow
---@param eViewportType number
---@return XEViewport
function XEViewportManager:GetXEViewport(pWin, eViewportType) end


---@public XEViewportManager_GetAllXEViewports00
---@param pWin  IXPlatformWindow
---@return XEViewport[]
function XEViewportManager:GetAllXEViewports(pWin) end


---@public 通过底层XViewport指针获取XEViewport
---@param pViewPort  XViewport XViewport指针
---@return XEViewport XEViewport视口指针
function XEViewportManager:GetXEViewport(pViewPort) end


---@public 通过XBaseCamera指针获取关联的XEViewport列表
---@param pCamera  XBaseCamera XBaseCamera指针
---@return XEViewport[] 关联的XEViewport列表
function XEViewportManager:GetRefXEViewport(pCamera) end


---@public 通过WorldName获取关联的XEViewport指针
---@param strWorldName string WorldName
---@return XEViewport XEViewport指针
function XEViewportManager:GetXEViewportByWorldName(strWorldName) end


