---@class XEMatFxDistributionParameter : XEUserNode
XEMatFxDistributionParameter = {}


---@type number @enum MatFxLockAxesType
XEMatFxDistributionParameter.NONE = 0


---@type number @enum MatFxLockAxesType
XEMatFxDistributionParameter.XY = 0


---@type number @enum MatFxLockAxesType
XEMatFxDistributionParameter.XZ = 0


---@type number @enum MatFxLockAxesType
XEMatFxDistributionParameter.YZ = 0


---@type number @enum MatFxLockAxesType
XEMatFxDistributionParameter.XYZ = 0


---@type number @enum MatFxDistributionGroup
XEMatFxDistributionParameter.DISTRIBUTION_GROUP_FLOAT = 0


---@type number @enum MatFxDistributionGroup
XEMatFxDistributionParameter.DISTRIBUTION_GROUP_VECTOR = 0


---@type number @enum MatFxDistributionGroup
XEMatFxDistributionParameter.DISTRIBUTION_GROUP_FLOAT_CONTAIN_CURVE = 0


---@type number @enum MatFxDistributionGroup
XEMatFxDistributionParameter.DISTRIBUTION_GROUP_VECTOR_CONTAIN_CURVE = 0


---@type number @enum MatFxPointDistribution
XEMatFxDistributionParameter.DISTRIBUTION_FLOAT_CONSTANT = 0


---@type number @enum MatFxPointDistribution
XEMatFxDistributionParameter.DISTRIBUTION_FLOAT_CONSTANT_CURVE = 0


---@type number @enum MatFxPointDistribution
XEMatFxDistributionParameter.DISTRIBUTION_FLOAT_UNIFORM = 0


---@type number @enum MatFxPointDistribution
XEMatFxDistributionParameter.DISTRIBUTION_FLOAT_UNIFORM_CURVE = 0


---@type number @enum MatFxPointDistribution
XEMatFxDistributionParameter.DISTRIBUTION_VECTOR_CONSTANT = 0


---@type number @enum MatFxPointDistribution
XEMatFxDistributionParameter.DISTRIBUTION_VECTOR_CONSTANT_CURVE = 0


---@type number @enum MatFxPointDistribution
XEMatFxDistributionParameter.DISTRIBUTION_VECTOR_UNIFORM = 0


---@type number @enum MatFxPointDistribution
XEMatFxDistributionParameter.DISTRIBUTION_VECTOR_UNIFORM_CURVE = 0


---@public XEMatFxDistributionParameter_new00
---@return XEMatFxDistributionParameter
function XEMatFxDistributionParameter:new() end


---@public 设置是否启用曲线编辑
---@param bEnable boolean
---@return void
function XEMatFxDistributionParameter:SetEnable(bEnable) end


---@public 判断是否启用曲线编辑
---@return boolean
function XEMatFxDistributionParameter:IsEnable() end


---@public 设置生效时延（s）
---@param fTime number
---@return void
function XEMatFxDistributionParameter:SetDelayTime(fTime) end


---@public 获取生效时延（s）
---@return number
function XEMatFxDistributionParameter:GetDelayTime() end


---@public 设置点的分布类型
---@param mpd number
---@return void
function XEMatFxDistributionParameter:SetPointDistribution(mpd) end


---@public 获取点的分布类型
---@return number
function XEMatFxDistributionParameter:GetPointDistribution() end


---@public 设置点的分布组别
---@param mdg number
---@return void
function XEMatFxDistributionParameter:SetPointDistributionGroup(mdg) end


---@public 获取点的分布组别
---@return number
function XEMatFxDistributionParameter:GetPointDistributionGroup() end


---@public 设置材质曲线文件保存路径
---@param pFilePath string
---@return void
function XEMatFxDistributionParameter:SetDistributionFilePath(pFilePath) end


---@public 获取材质曲线文件保存路径
---@return string
function XEMatFxDistributionParameter:GetDistributionFilePath() end


---@public 设置锁定轴类型
---@param nCurveIndex number
---@param clat number
---@return void
function XEMatFxDistributionParameter:SetLockAxesType(nCurveIndex, clat) end


---@public 获取锁定轴类型
---@param nCurveIndex number
---@return number
function XEMatFxDistributionParameter:GetLockAxesType(nCurveIndex) end


---@public 设置是否开启循环
---@param bLoop boolean
---@return void
function XEMatFxDistributionParameter:SetCurveLoop(bLoop) end


---@public 判断是否开启循环
---@return boolean
function XEMatFxDistributionParameter:IsCurveLoop() end


---@public 设置是否开启反向周期（呼吸效果）
---@param bBreathing boolean
---@return void
function XEMatFxDistributionParameter:SetCurveBreating(bBreathing) end


---@public 获取是否开启反向周期（呼吸效果）
---@return boolean
function XEMatFxDistributionParameter:IsCurveBreathing() end


---@public 设置循环起始偏移时间
---@param fOffset number
---@return void
function XEMatFxDistributionParameter:SetCurveLoopOffset(fOffset) end


---@public 获取循环起始偏移时间
---@return number
function XEMatFxDistributionParameter:GetCurveLoopOffset() end


---@public 设置效果持续时间
---@param fDuration number
---@return void
function XEMatFxDistributionParameter:SetFxDurationTime(fDuration) end


---@public 获取效果持续时间
---@return number
function XEMatFxDistributionParameter:GetFxDurationTime() end


---@public 获取材质参数名称
---@return string
function XEMatFxDistributionParameter:GetMatParamName() end


---@public 设置材质参数名称
---@param pName string
---@return void
function XEMatFxDistributionParameter:SetMatparamName(pName) end


---@public 获取参数子索引
---@return number
function XEMatFxDistributionParameter:GetMatParamSubIndex() end


---@public 设置参数子索引
---@param nSubIndex number
---@return void
function XEMatFxDistributionParameter:SetMatParamSubIndex(nSubIndex) end


---@public 设置初始化参数，从材质实例中来
---@param pMaterialIns IXMaterialInstance
---@param pParamName string
---@param nParamSubIndex number
---@return boolean
function XEMatFxDistributionParameter:SetMatParam(pMaterialIns, pParamName, nParamSubIndex) end


---@public 获取根节点
---@return XEMaterialFx
function XEMatFxDistributionParameter:GetMaterialFx() end


---@public 判断分布类型是否是曲线
---@return boolean
function XEMatFxDistributionParameter:IsCurve() end


---@public 判断分布类型是否是Float类型
---@return boolean
function XEMatFxDistributionParameter:IsDistributionFloat() end


---@public 判断分布类型是否是Vector类型
---@return boolean
function XEMatFxDistributionParameter:IsDistributionVector() end


---@public 判断分布类型是否是Uniform类型
---@return boolean
function XEMatFxDistributionParameter:IsUniform() end


