---@class XEAnimSocketMounter : XEUserNode
XEAnimSocketMounter = {}


---@public XEAnimSocketMounter_new00
---@return XEAnimSocketMounter
function XEAnimSocketMounter:new() end


---@public 初始化函数
---@param strAssetPath string 挂点资源路径（.mount）
---@param strMountModelPath string 模型资源路径（.mdl）
---@return void
function XEAnimSocketMounter:Initialize(strAssetPath, strMountModelPath) end


---@public 绑定并创建所有骨架上的socket模板克隆体
---@return boolean 绑定是否成功
function XEAnimSocketMounter:BindAllXESockets() end


---@public 解除绑定并删除所有骨架上的socket模板克隆体
---@return boolean 绑定是否成功
function XEAnimSocketMounter:UnBindAllXESockets() end


---@public 绑定并创建socket模板克隆体
---@param strSocketName string 插槽名字
---@return XEBindSocket 槽点的指针
function XEAnimSocketMounter:BindXESocket(strSocketName) end


---@public 解除并删除socket模板克隆体
---@param socketName string
---@return boolean 解除绑定是否成功
function XEAnimSocketMounter:UnbindXESocket(socketName) end


---@public 获取绑定的socket克隆体
---@param nBindIndex number socket对象序号
---@return XEBindSocket
function XEAnimSocketMounter:GetBindXESocket(nBindIndex) end


---@public 获取绑定的socket克隆体
---@param strSocketName string socket对象名称
---@return XEBindSocket
function XEAnimSocketMounter:GetBindXESocket(strSocketName) end


---@public 在骨骼上添加一个新的绑定插槽
---@param parentName string 骨骼的名字
---@param socketName string 插槽的名字
---@return XEBindSocket
function XEAnimSocketMounter:AddNewBindSocketToSkeleton(parentName, socketName) end


---@public 获取模型文件的地址
---@return string 模型文件的地址
function XEAnimSocketMounter:GetSkinModelAssetPath() end


---@public 获取骨骼文件的地址
---@return string 骨骼文件的地址
function XEAnimSocketMounter:GetSkeleteonAssetPath() end


---@public 获取挂点文件的地址
---@return string 挂点文件的地址
function XEAnimSocketMounter:GetAssetPath() end


---@public 获取编辑的模型文件的地址
---@return string 编辑的模型文件的地址
function XEAnimSocketMounter:GetEditSkinModelAssetPath() end


---@public 设置是否渲染骨头
---@param bEnable boolean
---@return void
function XEAnimSocketMounter:SetEnableRenderBone(bEnable) end


---@public 获取是否渲染骨头
---@return boolean 是否渲染骨头
function XEAnimSocketMounter:IsEnableRenderBone() end


---@public 设置是否有修改
---@param bSet boolean
---@return void
function XEAnimSocketMounter:SetModified(bSet) end


---@public 获取是否有修改
---@return boolean 是否有修改
function XEAnimSocketMounter:IsModified() end


---@public 更新挂点的资源文件路径
---@param strPath string
---@return void
function XEAnimSocketMounter:UpdateAssetPath(strPath) end


---@public 合并一个挂点模板到当前模板
---@param strMounterAssetPath string 其他挂点模板文件路径
---@return void
function XEAnimSocketMounter:MergeOtherMounter(strMounterAssetPath) end


---@public 释放合并的挂点模板数据
---@param szMounterAssetPath string 要释放的挂点模板文件路径，如果为空，则释放所有
---@return boolean
function XEAnimSocketMounter:ReleaseMergeMounter(szMounterAssetPath) end


