---@class XEPatchNodeGraph : XEPatchNode
XEPatchNodeGraph = {}


---@public XEPatchNodeGraph_new00
---@return XEPatchNodeGraph
function XEPatchNodeGraph:new() end


---@public 获取图实例
---@return XEPatchGraph
function XEPatchNodeGraph:GetSubGraph() end


---@public 获取模板图id
---@return number
function XEPatchNodeGraph:GetTemplateGraphId() end


---@public 查找指定图
---@param szAssetPath string
---@param nGraphType number
---@return XEPatchGraph[]
---@return void
function XEPatchNodeGraph:FindGraph(szAssetPath, nGraphType) end


---@public XEPatchNodeGraph_FindGraph01
---@param nGraphId number
---@return XEPatchGraph[]
---@return void
function XEPatchNodeGraph:FindGraph(nGraphId) end


---@public 获取指定类型的图实例
---@param nGraphType number 待查找的图类型
---@return XEPatchGraph[]
---@return void
function XEPatchNodeGraph:GetChildrenGraphs(nGraphType) end


---@public 获取图实例所属的节点
---@param pGraph XEPatchGraph 图实例指针
---@return XEPatchGraphNode 图实例所属的直接节点指针
function XEPatchNodeGraph:GetOwnerNodeForGraph(pGraph) end


---@public 从子图上查找节点
---@param szNodeTypeName string 节点类型名
---@param szNodeTitleName string 节点名称
---@return XEPatchGraphNode[] 从子图上找到的节点列表
function XEPatchNodeGraph:FindNodes(szNodeTypeName, szNodeTitleName) end


---@public 从子图上查找节点
---@param arrNodeTypes string[] 节点类型名列表
---@return XEPatchGraphNode[] 从子图上找到的节点列表
function XEPatchNodeGraph:FindNodes(arrNodeTypes) end


---@public 从子图上查找节点
---@param nId number 节点id
---@return XEPatchGraphNode 从子图上找到的节点
function XEPatchNodeGraph:FindNodeById(nId) end


---@public 资源重加载
---@param pPath string
---@return boolean
function XEPatchNodeGraph:ReloadAsset(pPath) end


---@public 加载图资产
---@param pPath string
---@return boolean
function XEPatchNodeGraph:LoadAsset(pPath) end


---@public 卸载图
---@return boolean
function XEPatchNodeGraph:UnLoadGraph() end


