---@type number @enum ECanCreateConnectionResponse
CONNECT_RESPONSE_MAKE = 0


---@type number @enum ECanCreateConnectionResponse
CONNECT_RESPONSE_DISALLOW = 0


---@type number @enum ECanCreateConnectionResponse
CONNECT_RESPONSE_BREAK_OTHERS_A = 0


---@type number @enum ECanCreateConnectionResponse
CONNECT_RESPONSE_BREAK_OTHERS_B = 0


---@type number @enum ECanCreateConnectionResponse
CONNECT_RESPONSE_BREAK_OTHERS_AB = 0


---@type number @enum ECanCreateConnectionResponse
CONNECT_RESPONSE_MAKE_WITH_CONVERSION_NODE = 0


---@type number @enum ECanCreateConnectionResponse
CONNECT_RESPONSE_MAX = 0


---@class XEPinConnectionResponse
XEPinConnectionResponse = {}


---@public XEPinConnectionResponse_new00
---@return XEPinConnectionResponse
function XEPinConnectionResponse:new() end


---@public XEPinConnectionResponse_new01
---@param InResponse number
---@param InMessage string
---@return XEPinConnectionResponse
function XEPinConnectionResponse:new(InResponse, InMessage) end


---@public If a connection can be made without breaking existing connections
---@return boolean
function XEPinConnectionResponse:CanSafeConnect() end


---@public XEPinConnectionResponse_IsFatal00
---@return boolean
function XEPinConnectionResponse:IsFatal() end


---@public XEPinConnectionResponse_SetFatal00
---@return void
function XEPinConnectionResponse:SetFatal() end


---@type string
XEPinConnectionResponse.Message = ''


---@type number
XEPinConnectionResponse.Response = 0


---@class XEPGraphSchema : XEPatchGraphNode
XEPGraphSchema = {}


---@type number @enum eCompileStatus
XEPGraphSchema.ECS_READY = 0


---@type number @enum eCompileStatus
XEPGraphSchema.ECS_COMPILING = 0


---@type number @enum eCompileStatus
XEPGraphSchema.ECS_COMPILED = 0


---@public very beginning of running the graph
---@return void
function XEPGraphSchema:StartRun() end


---@public end run, very ending of running the graph
---@return void
function XEPGraphSchema:EndRun() end


---@public execute the construct flow
---@return void
function XEPGraphSchema:OnGraphConstruct() end


---@public to find the begin-run flow nodes in the graph
---@return void
function XEPGraphSchema:OnGraphBeginRun() end


---@public to find and execute the other flows exist in the graph
---@return void
function XEPGraphSchema:OnGraphRunningLoop() end


---@public to find the end-run flow nodes in the graph
---@return void
function XEPGraphSchema:OnGraphEndRun() end


---@public execute the destruct flow
---@return void
function XEPGraphSchema:OnGraphDestruct() end


---@public Setup the fsm
---@return void
function XEPGraphSchema:SetupFsm() end


---@public Compile the graph and run
---@return boolean
function XEPGraphSchema:CompileGraph() end


---@public Clean Compile the graph
---@return boolean
function XEPGraphSchema:CleanCompileGraph() end


---@public Get the correct register level for rendering, the owner level by default
---@return XELevel
function XEPGraphSchema:GetRegisterLevel() end


---@public whether compiled
---@return boolean
function XEPGraphSchema:IsGraphCompiled() end


---@public whether compiling
---@return boolean
function XEPGraphSchema:IsGraphCompiling() end


---@public Determine if a connection can be created between two pins.
---@param A  XEPatchGraphPin
---@param B  XEPatchGraphPin
---@return  XEPinConnectionResponse emptystringiftheconnectionislegal,otherwiseamessagedescribingwhytheconnectionwouldfail.
function XEPGraphSchema:CanCreateConnection(A, B) end


---@public Handles double-clicking on a pin<->pin connection
---@param pPinA XEPatchGraphPin
---@param pPinB XEPatchGraphPin
---@return XEPatchGraphNode
function XEPGraphSchema:OnPinConnectionDoubleCicked(pPinA, pPinB) end


---@public set schema order
---@param nOrder number
---@return void
function XEPGraphSchema:SetOrder(nOrder) end


---@public get schema order
---@return number
function XEPGraphSchema:GetOrder() end


---@public apply the order, may need to be rebuild the effect for the graph
---@param bGatherOtherSchemaInRegisterLevel boolean trueforgatheringthesortingotherschema(s)inthesameregisterlevel,falseforgatheringinitsownerlevel
---@return void
function XEPGraphSchema:ApplyOrder(bGatherOtherSchemaInRegisterLevel) end


---@public to get all the graphs with the same register level
---@param bIncludeSubGraph boolean indicatewhetherincludethesubgraphornot
---@return XEPatchGraph[]
---@return number accountofthegraphs
function XEPGraphSchema:GetGraphsInTheSameRegisterLevel(bIncludeSubGraph) end


