---@class XEPatchGraphManager
XEPatchGraphManager = {}


---@public 创建一个图实例，并将实例添加到图实例列表
---@param pId number 图id，默认为NULL
---@return XEPatchGraph
function XEPatchGraphManager:CreatePatchGraph(pId) end


---@public 释放一个图实例，并从图实例列表中移除
---@param pGraph XEPatchGraph
---@return boolean
function XEPatchGraphManager:ReleasePatchGraph(pGraph) end


---@public 释放一个图实例，并从图实例列表中移除
---@param nGraphId number
---@return boolean
function XEPatchGraphManager:ReleasePatchGraph(nGraphId) end


---@public 往m_aPatchGraph列表中添加指定图实例
---@param pGraph XEPatchGraph
---@return boolean
function XEPatchGraphManager:AddPatchGraph(pGraph) end


---@public 从m_aPatchGraph列表中移除指定图实例，仅从列表中移除，不释放资源
---@param pGraph XEPatchGraph
---@return boolean
function XEPatchGraphManager:RemovePatchGraph(pGraph) end


---@public 获取所有的图实例
---@param bTravelSubNode boolean 是否包含节点内的图实例
---@return XEPatchGraph[]
---@return void
function XEPatchGraphManager:GetAllPatchGraphs(bTravelSubNode) end


---@public 获取所有的节点内的子图实例
---@return XEPatchGraph[]
---@return void
function XEPatchGraphManager:GetAllChildPatchGraphs() end


---@public 加载并创建图实例
---@param szAssetPath string
---@return XEPatchGraph
function XEPatchGraphManager:LoadPatchGraph(szAssetPath) end


---@public 查找图实例
---@param nGraphId number
---@param bTravelSubNode boolean
---@return XEPatchGraph[]
function XEPatchGraphManager:FindPatchGraph(nGraphId, bTravelSubNode) end


---@public 查找关联资产路径的图实例
---@param szAssetPath string
---@param bTravelSubNode boolean
---@param eType number
---@return XEPatchGraph[]
function XEPatchGraphManager:FindPatchGraph(szAssetPath, bTravelSubNode, eType) end


---@public 获取所属的Level
---@return XELevel
function XEPatchGraphManager:GetOwnerLevel() end


---@public 获取所属的世界
---@return XEWorld
function XEPatchGraphManager:GetOwnerWorld() end


---@public 获取子图所属的节点
---@param pSubGraph XEPatchGraph
---@return XEPatchGraphNode
function XEPatchGraphManager:GetOwnerNode(pSubGraph) end


---@public 递归往上查找图类型为Graph的图实例
---@param pSubGraph XEPatchGraph
---@return XEPatchGraph
function XEPatchGraphManager:FindParentGraph(pSubGraph) end


