---@class XEPatchGraphNode
XEPatchGraphNode = {}


---@public XEPatchGraphNode_GetTypeName00
---@return string
function XEPatchGraphNode:GetTypeName() end


---@public XEPatchGraphNode_GetKeywords00
---@return string
function XEPatchGraphNode:GetKeywords() end


---@public XEPatchGraphNode_SetKeywords00
---@param strKw string
---@return void
function XEPatchGraphNode:SetKeywords(strKw) end


---@public XEPatchGraphNode_GetNodeTitle00
---@return string
function XEPatchGraphNode:GetNodeTitle() end


---@public XEPatchGraphNode_SetNodeTitle00
---@param strTitle string
---@return void
function XEPatchGraphNode:SetNodeTitle(strTitle) end


---@public XEPatchGraphNode_RemovePinAt00
---@param PinIndex number
---@param PinDirection number
---@param eDrivenType number
---@return void
function XEPatchGraphNode:RemovePinAt(PinIndex, PinDirection, eDrivenType) end


---@public XEPatchGraphNode_GetPinDisplayName00
---@param Pin  XEPatchGraphPin
---@return string
function XEPatchGraphNode:GetPinDisplayName(Pin) end


---@public XEPatchGraphNode_Modify00
---@return void
function XEPatchGraphNode:Modify() end


---@public XEPatchGraphNode_OnPinRemoved00
---@param pInRemovedPin XEPatchGraphPin
---@return void
function XEPatchGraphNode:OnPinRemoved(pInRemovedPin) end


---@public XEPatchGraphNode_OnPinDisconnected00
---@param pFrom XEPatchGraphPin
---@param pTo XEPatchGraphPin
---@return void
function XEPatchGraphNode:OnPinDisconnected(pFrom, pTo) end


---@public XEPatchGraphNode_OnPinConnected00
---@param pFrom XEPatchGraphPin
---@param pTo XEPatchGraphPin
---@return void
function XEPatchGraphNode:OnPinConnected(pFrom, pTo) end


---@public XEPatchGraphNode_NodeConnectionListChanged00
---@return void
function XEPatchGraphNode:NodeConnectionListChanged() end


---@public XEPatchGraphNode_PinConnectionListChanged00
---@param pPin XEPatchGraphPin
---@return void
function XEPatchGraphNode:PinConnectionListChanged(pPin) end


---@public XEPatchGraphNode_DisableNode00
---@param bApplyToInnerSystem boolean
---@return void
function XEPatchGraphNode:DisableNode(bApplyToInnerSystem) end


---@public XEPatchGraphNode_EnableNode00
---@param bApplyToInnerSystem boolean
---@return void
function XEPatchGraphNode:EnableNode(bApplyToInnerSystem) end


---@public fsm is ready to execute the flow nodes, do something in this "construct" function
---will do the constructing of the connecting param-driven pins by default
---@return void
function XEPatchGraphNode:OnExecConstruct() end


---@public fsm has been executed the flow nodes, do something in this "destruct" function
---will do the destructing of the connecting param-driven pins by default
---@return void
function XEPatchGraphNode:OnExecDestruct() end


---@public Clone the node
---@return XEPatchGraphNode
function XEPatchGraphNode:Clone() end


---@public Create a new pin on this node and return the new pin
---@param Dir number
---@param PinName string
---@param Index number
---@param eDrivenType number
---@return XEPatchGraphPin
function XEPatchGraphNode:CreatePin(Dir, PinName, Index, eDrivenType) end


---@public XEPatchGraphNode_BreakAllNodeLinks00
---@return void
function XEPatchGraphNode:BreakAllNodeLinks() end


---@public XEPatchGraphNode_SetGraph00
---@param pGraph XEPatchGraph
---@return void
function XEPatchGraphNode:SetGraph(pGraph) end


---@public XEPatchGraphNode_GetGraph00
---@return XEPatchGraph
function XEPatchGraphNode:GetGraph() end


---@public XEPatchGraphNode_GetAllPins00
---@param eDrivenType number
---@return XEPatchGraphPin[]
function XEPatchGraphNode:GetAllPins(eDrivenType) end


---@public XEPatchGraphNode_GetPinAt00
---@param Index number
---@param eDrivenType number
---@return XEPatchGraphPin
function XEPatchGraphNode:GetPinAt(Index, eDrivenType) end


---@public Create a new pin on this node and return the new pin
---@param arrOutputNodes XEPatchGraphNode[] thefinallink-tonodesthatwalk-throughthenodes.
---@param eDrivenType number
---@return XEPatchGraphNode thelastfinallink-tonode
function XEPatchGraphNode:GetFinalOutputNode(arrOutputNodes, eDrivenType) end


---@public XEPatchGraphNode_GetSchema00
---@return XEPGraphSchema
function XEPatchGraphNode:GetSchema() end


---@public XEPatchGraphNode_IsNodeEnabled00
---@return boolean
function XEPatchGraphNode:IsNodeEnabled() end


---@public XEPatchGraphNode_IsNodeValid00
---@return boolean
function XEPatchGraphNode:IsNodeValid() end


---@public XEPatchGraphNode_GetPinIndex00
---@param pPin XEPatchGraphPin
---@return number
function XEPatchGraphNode:GetPinIndex(pPin) end


---@public XEPatchGraphNode_RemovePin00
---@param pPin XEPatchGraphPin
---@return boolean
function XEPatchGraphNode:RemovePin(pPin) end


---@public XEPatchGraphNode_HasPin00
---@param pPin XEPatchGraphPin
---@return boolean
function XEPatchGraphNode:HasPin(pPin) end


---@public XEPatchGraphNode_FindPin00
---@param PinName string
---@param Direction number
---@param eDrivenType number
---@return XEPatchGraphPin
function XEPatchGraphNode:FindPin(PinName, Direction, eDrivenType) end


---@public XEPatchGraphNode_FindPinById00
---@param PinId number
---@return XEPatchGraphPin
function XEPatchGraphNode:FindPinById(PinId) end


---@public XEPatchGraphNode_FindPinByIndexAndDirection00
---@param nIndex number
---@param Direction number
---@param eDrivenType number
---@return XEPatchGraphPin
function XEPatchGraphNode:FindPinByIndexAndDirection(nIndex, Direction, eDrivenType) end


---@public XEPatchGraphNode_FindPinsByDirection00
---@param Direction number
---@param eDrivenType number
---@return XEPatchGraphPin[]
function XEPatchGraphNode:FindPinsByDirection(Direction, eDrivenType) end


---@public 以上游->下游的连接顺序解出到该节点的节点队列
---@param eDrivenType number
---@return XEPatchGraphNode[]
---@return number
function XEPatchGraphNode:ResoloveConnectStreamNodes(eDrivenType) end


---@public XEPatchGraphNode_IsDeleted00
---@return boolean
function XEPatchGraphNode:IsDeleted() end


---@public XEPatchGraphNode_SetDeleted00
---@param bDeleted boolean
---@return void
function XEPatchGraphNode:SetDeleted(bDeleted) end


---@public to determine if link to another node
---@param pNode XEPatchGraphNode
---@param eDrivenType number
---@return number 0:Nolinks,1:directlink,2:indirectlink
function XEPatchGraphNode:IsNodeLinked(pNode, eDrivenType) end


---@public if exist the driven param pin, return true
---@return boolean
function XEPatchGraphNode:IsFlowDrivenNode() end


---@public XEPatchGraphNode_IsModified00
---@return boolean
function XEPatchGraphNode:IsModified() end


---@public XEPatchGraphNode_IsInitialized00
---@return boolean
function XEPatchGraphNode:IsInitialized() end


