---物理骨骼所绑定的刚体节点模板类
---@class XEPhysicsSkeletalBody : XEUserNode
XEPhysicsSkeletalBody = {}


---@public XEPhysicsSkeletalBody_new00
---@return XEPhysicsSkeletalBody
function XEPhysicsSkeletalBody:new() end


---@public 获取刚体绑定的骨骼的名字
---@return string 返回骨骼的名字
function XEPhysicsSkeletalBody:GetBoneNameWithBody() end


---@public 为骨骼绑定刚体
---@param pBody IXSkeletalBody 骨骼刚体的指针
---@return void
function XEPhysicsSkeletalBody:SetIXSkeletalBody(pBody) end


---@public 返回骨骼绑定刚体
---@return IXSkeletalBody 骨骼刚体的指针
function XEPhysicsSkeletalBody:GetIXSkeletalBody() end


---@public 创建刚体模型形状
---@return void
function XEPhysicsSkeletalBody:CreateShapeElem() end


---@public 更新刚体模型形状
---@param pBody IXSkeletalBody
---@return void
function XEPhysicsSkeletalBody:UpdateShapeElem(pBody) end


---@public 返回刚体形状的节点
---@param strShapeNodeName string
---@return XEPhysicsShapeElem 物理形状的节点指针
function XEPhysicsSkeletalBody:IsExistXEPhysicsShapeElemNode(strShapeNodeName) end


---@public 获取物理骨骼的根节点
---@return XEPhysicsSkeletalRoot 根节点指针
function XEPhysicsSkeletalBody:GetPhysicsSkeletalRoot() end


---@public 获取绑定同一个关节上骨骼名称
---@return XPhyConstraintBoneNames[] 以两个有约束关系的骨骼为一组的数组
function XEPhysicsSkeletalBody:GetBindConstraintNamePair() end


---@public 将两个骨骼形成约束关系添加到数组中
---@param szBone1Name string
---@param szBone2Name string
---@return void
function XEPhysicsSkeletalBody:AddBindConstraintNamePair(szBone1Name, szBone2Name) end


---@public 将记录着相互约束关系的两个骨骼从数组中移除
---@param szBone1Name string
---@param szBone2Name string
---@return void
function XEPhysicsSkeletalBody:RemoveBindConstraintNamePair(szBone1Name, szBone2Name) end


---@public 清空记录着约束关系的数组内容
---@return void
function XEPhysicsSkeletalBody:ClearBindConstraintNamePair() end


---@public 移除关节模板
---@param pConstraintTemp XEUserNode
---@return void
function XEPhysicsSkeletalBody:RemoveConstraintTemplate(pConstraintTemp) end


---@public 当前刚体节点关联的关节节点，例如根据BodyNode1和BodyNode2创建了一个约束，则不包含约束节点的刚体节点下会记录关节节点名称
---@param strConstraintNodeName string 关节的名称
---@return void
function XEPhysicsSkeletalBody:AddRefConstraintNodeName(strConstraintNodeName) end


---@public 获取所有关节节点的名字
---@return string[] 返回所有约束节点的名字的数组
function XEPhysicsSkeletalBody:GetAllRefConstraintNodeNames() end


---@public 删除特定名字的关节节点
---@param strConstraintNodeName string 关节节点的名字
---@return void
function XEPhysicsSkeletalBody:ClearRefConstraintNodeName(strConstraintNodeName) end


---@public XEPhysicsSkeletalBody_ClearAllRefConstraintNodeNames00
---@return void
function XEPhysicsSkeletalBody:ClearAllRefConstraintNodeNames() end


