---@class X2DRigidBodyComponent : XUIComponent
X2DRigidBodyComponent = {}


---@public 创建一个X2DRigidBodyComponent布局组件
---@param pNode XUINode 目标节点
---@return X2DRigidBodyComponent 创建出的X2DRigidBodyComponent组件
function X2DRigidBodyComponent:Create(pNode) end


---@public 刚体类型：X_Static,  X_Kinematic,  X_Dynamic
---@param eType number
---@return X2DRigidBodyComponent
function X2DRigidBodyComponent:SetBodyType(eType) end


---@public X2DRigidBodyComponent_GetBodyType00
---@return number
function X2DRigidBodyComponent:GetBodyType() end


---@public 如果此刚体永远都不应该进入睡眠，那么设置这个属性为 false。
---需要注意这将使 CPU 占用率提高。
---@param bAllowSleep boolean
---@return X2DRigidBodyComponent
function X2DRigidBodyComponent:SetAllowSleep(bAllowSleep) end


---@public X2DRigidBodyComponent_IsAllowSleep00
---@return boolean
function X2DRigidBodyComponent:IsAllowSleep() end


---@public 缩放应用在此刚体上的重力值
---@param fGravityScale number
---@return X2DRigidBodyComponent
function X2DRigidBodyComponent:SetGravityScale(fGravityScale) end


---@public X2DRigidBodyComponent_GetGravityScale00
---@return number
function X2DRigidBodyComponent:GetGravityScale() end


---@public Linear damping 用于衰减刚体的线性速度。衰减系数可以大于 1，但是当衰减系数比较大的时候，衰减的效果会变得比较敏感。
---@param fLinearDamping number
---@return X2DRigidBodyComponent
function X2DRigidBodyComponent:SetLinearDamping(fLinearDamping) end


---@public X2DRigidBodyComponent_GetLinearDamping00
---@return number
function X2DRigidBodyComponent:GetLinearDamping() end


---@public Angular damping 用于衰减刚体的角速度。衰减系数可以大于 1，但是当衰减系数比较大的时候，衰减的效果会变得比较敏感。
---@param fAngularDamping number
---@return X2DRigidBodyComponent
function X2DRigidBodyComponent:SetAngularDamping(fAngularDamping) end


---@public X2DRigidBodyComponent_GetAngularDamping00
---@return number
function X2DRigidBodyComponent:GetAngularDamping() end


---@public 刚体在世界坐标下的线性速度。
---@return X2DRigidBodyComponent
function X2DRigidBodyComponent:SetLinearVelocity() end


---@public X2DRigidBodyComponent_SetLinearVelocity01
---@param vLinearVelocity XVECTOR2
---@return X2DRigidBodyComponent
function X2DRigidBodyComponent:SetLinearVelocity(vLinearVelocity) end


---@public X2DRigidBodyComponent_GetLinearVelocity00
---@return XVECTOR2
function X2DRigidBodyComponent:GetLinearVelocity() end


---@public X2DRigidBodyComponent_GetLinearVelocityFromWorldPoint00
---@param vLinearVelocity XVECTOR2
---@return XVECTOR2
function X2DRigidBodyComponent:GetLinearVelocityFromWorldPoint(vLinearVelocity) end


---@public 刚体的角速度
---@param fAngularVelocity number
---@return X2DRigidBodyComponent
function X2DRigidBodyComponent:SetAngularVelocity(fAngularVelocity) end


---@public X2DRigidBodyComponent_GetAngularVelocity00
---@return number
function X2DRigidBodyComponent:GetAngularVelocity() end


---@public 是否禁止此刚体进行旋转
---@param bFixedRotation boolean
---@return X2DRigidBodyComponent
function X2DRigidBodyComponent:SetFixedRotation(bFixedRotation) end


---@public X2DRigidBodyComponent_GetFixedRotation00
---@return boolean
function X2DRigidBodyComponent:GetFixedRotation() end


---@public 是否禁止此刚体进行旋转
---设置刚体的激活状态。一个非激活状态下的刚体是不会被模拟和碰撞的，不管它是否处于睡眠状态下。
---如果刚体处于激活状态下，所有夹具会被添加到 粗测阶段（broad-phase）。
---如果刚体处于非激活状态下，所有夹具会被从 粗测阶段（broad-phase）中移除。
---在非激活状态下的夹具不会参与到碰撞，射线，或者查找中
---链接到非激活状态下刚体的关节也是非激活的。
---@param bActive boolean
---@return X2DRigidBodyComponent
function X2DRigidBodyComponent:SetActive(bActive) end


---@public X2DRigidBodyComponent_IsActive00
---@return boolean
function X2DRigidBodyComponent:IsActive() end


---@public 将一个给定的世界坐标系下的点转换为刚体本地坐标系下的点
---@param worldPos XVECTOR2 worldPos-XVECTOR2
---@return XVECTOR2 XVECTOR2相对body原点的局部坐标.
function X2DRigidBodyComponent:GetLocalPosition(worldPos) end


---@public 将一个给定的刚体本地坐标系下的点转换为世界坐标系下的点
---@param localdPos XVECTOR2
---@return XVECTOR2 XVECTOR2
function X2DRigidBodyComponent:GetWorldPosition(localdPos) end


---@public Get the world coordinates of a vector given the local coordinates.
---@param localVector XVECTOR2
---@return XVECTOR2
function X2DRigidBodyComponent:GetWorldVector(localVector) end


---@public 将一个给定的世界坐标系下的点转换为刚体本地坐标系下的点
---@param worldVector XVECTOR2
---@return XVECTOR2
function X2DRigidBodyComponent:GetLocalVector(worldVector) end


---@public 获取刚体世界坐标系下的原点值
---@return XVECTOR2
function X2DRigidBodyComponent:GetWorldPosition() end


---@public 获取刚体世界坐标系下的旋转值。
---@return number
function X2DRigidBodyComponent:GetWorldRotation() end


---@public Get the local position of the center of mass.
---获取刚体本地坐标系下的质心
---@return XVECTOR2
function X2DRigidBodyComponent:GetLocalCenter() end


---@public 获取刚体世界坐标系下的质心
---@return XVECTOR2
function X2DRigidBodyComponent:GetWorldCenter() end


---@public 获取刚体上指定点的线性速度
---@param worldPoint XVECTOR2
---@return XVECTOR2
function X2DRigidBodyComponent:GetLinearVelocityFromWorldPos(worldPoint) end


---@public 获取刚体的质量。
---@return number
function X2DRigidBodyComponent:GetMass() end


---@public 获取刚体本地坐标系下原点的旋转惯性
---@return number
function X2DRigidBodyComponent:GetInertia() end


---@public 同步节点的世界坐标到 box2d 刚体的坐标上。
---@return X2DRigidBodyComponent
function X2DRigidBodyComponent:SyncPosition() end


---@public 同步节点的世界旋转角度值到 box2d 刚体的旋转值上。
---@return X2DRigidBodyComponent
function X2DRigidBodyComponent:SyncRotation() end


---@public 给刚体施加一个力
---@param force XVECTOR2 力的作用位置
---@param point XVECTOR2
---@param wake boolean 是否唤醒刚体
---@return X2DRigidBodyComponent
function X2DRigidBodyComponent:ApplyForce(force, point, wake) end


---@public 在刚体重心位置施加一个力
---@param force XVECTOR2 力的方向和大小
---@param wake boolean 是否唤醒刚体
---@return X2DRigidBodyComponent
function X2DRigidBodyComponent:ApplyForceToCenter(force, wake) end


---@public 给刚体施加一个扭矩
---@param torque number 扭矩大小
---@param wake boolean 是否唤醒刚体
---@return X2DRigidBodyComponent
function X2DRigidBodyComponent:ApplyTorque(torque, wake) end


---@public 给刚体施加一个线速度变化
---@param impulse XVECTOR2
---@param point XVECTOR2
---@param wake boolean 是否唤醒刚体
---@return X2DRigidBodyComponent
function X2DRigidBodyComponent:ApplyLinearImpulse(impulse, point, wake) end


---@public 给刚体重心施加一个线速度变化
---@param impulse XVECTOR2
---@param wake boolean 是否唤醒刚体
---@return X2DRigidBodyComponent
function X2DRigidBodyComponent:ApplyLinearImpulseToCenter(impulse, wake) end


---@public 给刚体施加角速度变化
---@param impulse number 变化量
---@param wake boolean 是否唤醒刚体
---@return X2DRigidBodyComponent
function X2DRigidBodyComponent:ApplyAngularImpulse(impulse, wake) end


---@public 设置刚体是否为Bullet类型, Bullet类型可以防止高速物体穿透现象
---@param flag boolean Bullet类型
---@return X2DRigidBodyComponent
function X2DRigidBodyComponent:SetBullet(flag) end


---@public 获取是否为Bullet类型
---@return boolean Bullet类型
function X2DRigidBodyComponent:IsBullet() end


---@public 是否唤醒刚体
---@param flag boolean 是否唤醒刚体
---@return X2DRigidBodyComponent
function X2DRigidBodyComponent:SetAwake(flag) end


---@public 获取唤醒状态
---@return boolean 是否唤醒状态
function X2DRigidBodyComponent:IsAwake() end


---@public X2DRigidBodyComponent_ResetVelocity00
---@return void
function X2DRigidBodyComponent:ResetVelocity() end


---@public X2DRigidBodyComponent_GetRigidBody00
---@return IX2DRigidBody
function X2DRigidBodyComponent:GetRigidBody() end


---@public X2DRigidBodyComponent_SetEnabledContactListener00
---@param bEnable boolean
---@return void
function X2DRigidBodyComponent:SetEnabledContactListener(bEnable) end


---@public X2DRigidBodyComponent_IsEnabledContactListener00
---@return boolean
function X2DRigidBodyComponent:IsEnabledContactListener() end


---@manual xelua_XEngine_X2DRigidBodyComponent_SetBeginContactListener_manual
---@public X2DRigidBodyComponent_SetBeginContactListener_manual
---@param callback  ContactFunc
---@return void
function X2DRigidBodyComponent:SetBeginContactListener(callback) end


---@manual xelua_XEngine_X2DRigidBodyComponent_SetEndContactListener_manual
---@public X2DRigidBodyComponent_SetEndContactListener_manual
---@param callback  ContactFunc
---@return void
function X2DRigidBodyComponent:SetEndContactListener(callback) end


---@manual xelua_XEngine_X2DRigidBodyComponent_SetPreSolveListener_manual
---@public X2DRigidBodyComponent_SetPreSolveListener_manual
---@param callback  ContactFunc
---@return void
function X2DRigidBodyComponent:SetPreSolveListener(callback) end


---@manual xelua_XEngine_X2DRigidBodyComponent_SetPostSolveListener_manual
---@public X2DRigidBodyComponent_SetPostSolveListener_manual
---@param callback  ContactFunc
---@return void
function X2DRigidBodyComponent:SetPostSolveListener(callback) end


---@public X2DRigidBodyComponent_GetPhysicalScene00
---@return IX2DPhysicalScene
function X2DRigidBodyComponent:GetPhysicalScene() end


---@type string @readonly 
X2DRigidBodyComponent.COMPONENT_TYPENAME = ''


---@type number @readonly 
X2DRigidBodyComponent.COMPONENT_TYPEID = 0


