---@class XEPrimitiveComponent : XEActorComponent
XEPrimitiveComponent = {}


---@public XEPrimitiveComponent_new00
---@return XEPrimitiveComponent
function XEPrimitiveComponent:new() end


---@public 清空当前组件的骨骼物理资源并释放，移除刚体
---@return void
function XEPrimitiveComponent:EmptyPhysics() end


---@public 设置物理资源路径
---@param szPath string 物理资源路径
---@return void
function XEPrimitiveComponent:SetPhysicalAssetPath(szPath) end


---@public 获取物理资源路径
---@return string 物理资源路径
function XEPrimitiveComponent:GetPhysicalAssetPath() end


---@public 加载物理资源
---@param pPath string 资源路径
---@return boolean 是否成功
function XEPrimitiveComponent:LoadPhysicalAsset(pPath) end


---@public XEPrimitiveComponent_LoadPhysicalAsset01
---@param pPath string
---@param eType number
---@return boolean
function XEPrimitiveComponent:LoadPhysicalAsset(pPath, eType) end


---@public 判断是否已经加载了物理资源
---@return boolean
function XEPrimitiveComponent:IsLoadedPhysicalRes() end


---@public 移除物理资源
---@return boolean 是否移除成功
function XEPrimitiveComponent:RemovePhysicalAsset() end


---@public 判断刚体是否启用了重力
---@return boolean
function XEPrimitiveComponent:IsGravityEnabled() end


---@public 设置刚体是否启用重力
---@param bSet boolean
---@return void
function XEPrimitiveComponent:SetGravityEnabled(bSet) end


---@public XEPrimitiveComponent_GetShapeMaterial00
---@return XShapeMaterial
---@return boolean
function XEPrimitiveComponent:GetShapeMaterial() end


---@public XEPrimitiveComponent_SetShapeMaterial00
---@param shapeMaterial  XShapeMaterial
---@return void
function XEPrimitiveComponent:SetShapeMaterial(shapeMaterial) end


---@public 判断是否进行物理模拟
---@return boolean
function XEPrimitiveComponent:IsSimulatePhysics() end


---@public 设置是否进行物理模拟
---@param bSimulate boolean
---@return void
function XEPrimitiveComponent:SetSimulatePhysics(bSimulate) end


---@public 获取刚体质量
---@return number
function XEPrimitiveComponent:GetMass() end


---@public 设置刚体质量
---@param f number
---@return void
function XEPrimitiveComponent:SetMass(f) end


---@public 获取刚体线速度阻尼
---@return number
function XEPrimitiveComponent:GetLinearDamping() end


---@public 设置刚体线速度阻尼
---@param fLinearDamping number
---@return void
function XEPrimitiveComponent:SetLinearDamping(fLinearDamping) end


---@public 获取刚体角速度阻尼
---@return number
function XEPrimitiveComponent:GetAngularDamping() end


---@public 获取刚体角速度阻尼
---@param fAngularDamping number
---@return void
function XEPrimitiveComponent:SetAngularDamping(fAngularDamping) end


---@public 获取刚体类型
---@return number
function XEPrimitiveComponent:GetRigidType() end


---@public 设置刚体类型
---@param nSel number
---@return void
function XEPrimitiveComponent:SetRigidType(nSel) end


---@public 获取刚体类型名称列表
---@return string[] 刚体类型名称列表
function XEPrimitiveComponent:GetRigidTypeNameList() end


---@public 判断是否启用连续碰撞检测
---@return boolean
function XEPrimitiveComponent:IsCCDEnabled() end


---@public 设置是否启用连续碰撞检测
---@param bSet boolean
---@return void
function XEPrimitiveComponent:SetRigidCCDEnabled(bSet) end


---@public 获取刚体移动速度
---@return XVECTOR3
function XEPrimitiveComponent:GetLinearVelocity() end


---@public 设置刚体移动速度
---@param vVelocity XVECTOR3
---@return void
function XEPrimitiveComponent:SetLinearVelocity(vVelocity) end


---@public 获取刚体角速度
---@return XVECTOR3
function XEPrimitiveComponent:GetAngularVelocity() end


---@public 设置刚体角速度
---@param vVelocity XVECTOR3
---@return void
function XEPrimitiveComponent:SetAngularVelocity(vVelocity) end


---@public XEPrimitiveComponent_GetSkeletalPhysicsInstance00
---@return IXSkeletalPhysicsInstance
function XEPrimitiveComponent:GetSkeletalPhysicsInstance() end


---@public 获取非骨骼刚体对象
---@return IXRigidBody
function XEPrimitiveComponent:GetRigidBody() end


---@type string @readonly 组件名称
XEPrimitiveComponent.COMPONENT_TYPENAME = ''


