---过场动画根节点类
---@class XESequencer : XESeqBase
XESequencer = {}


---@public 获取过场动画资源路径
---@return string
function XESequencer:GetAssetPath() end


---@public 设置过场动画手动播放开始时间
---@param nTime number
---@return void
function XESequencer:SetManaulStartTime(nTime) end


---@public 获取过场动画手动播放开始时间
---@return number
function XESequencer:GetManualStartTime() end


---@public 设置过场动画手动播放结束时间
---@param nTime number
---@return void
function XESequencer:SetManualEndTime(nTime) end


---@public 获取过场动画手动播放结束时间
---@return number
function XESequencer:GetManualEndTime() end


---@public 设置过场动画是否为手动播放模式
---@param bManual boolean
---@return void
function XESequencer:SetManualTimeMode(bManual) end


---@public 判断过场动画是否为手动播放模式
---@return boolean
function XESequencer:IsManualTimeMode() end


---@public 设置过场动画是否被修改
---@param bSet boolean
---@return void
function XESequencer:SetModified(bSet) end


---@public 获取过场动画是否被修改
---@return boolean
function XESequencer:IsModified() end


---@public 获取过场动画中某个绑定的Actor
---@param pActorName string 要获取的绑定Actor名字
---@return XESeqBinding 找到的绑定Actor指针
function XESequencer:GetBindingForActor(pActorName) end


---@public 在过场动画中创建一个绑定节点
---@param szBindingType string 绑定节点类型
---@return XESeqBinding 创建的绑定节点指针
function XESequencer:CreateBinding(szBindingType) end


---@public 设置如果根据Actor的Id没有找到，是否可以根据名称寻找
---@param bEnable boolean
---@return void
function XESequencer:SetFindActorByNameEnableIfNotFoundById(bEnable) end


---@public 当前是否可以根据Actor的名称寻找，如果根据Actor的Id没有找到
---@return boolean
function XESequencer:IsFindActorByNameEnableIfNotFoundById() end


---@public 设置动画末尾是否循环播放
---@param bSet boolean
---@return void
function XESequencer:SetLoopAtEnd(bSet) end


---@public 判断动画末尾是否循环播放
---@return boolean
function XESequencer:IsLoopAtEnd() end


---@public 设置动画末尾循环播放起始时间
---@param nTime number
---@return void
function XESequencer:SetLoopAtEndStartTime(nTime) end


---@public 获取动画末尾循环播放起始时间，这个返回的是SetLoopAtEndStartTime设置的固定时间
---@return number
function XESequencer:GetLoopAtEndStartTime() end


---@public 获取动画末尾循环播放起始时间
---如果不为空且为非手动模式，返回在动画长度内的起始时间。
---@param pSeqAnimController  XESeqAnimController
---@return number 如果pAnimMonController为空，同GetLoopAtEndStartTime();如果不为空且为手动模式，返回在手动播放区域的起始时间;
function XESequencer:GetLoopAtEndStartTime(pSeqAnimController) end


---@public 设置事件可分发（在实例中构建事件分发器）
---@param bEnable boolean
---@return void
function XESequencer:SetEventDispatcherEnable(bEnable) end


---@public 获取当前是否启用事件分发
---@return boolean
function XESequencer:IsEventDispatcherEnable() end


---@public 设置事件分发器绑定脚本资产文件
---@param szAssetPath string
---@return void
function XESequencer:SetEventDispatcherScriptAssetPath(szAssetPath) end


---@public 获取事件分发器绑定脚本资产文件
---@return string
function XESequencer:GetEventDispatcherScriptAssetPath() end


---@public 设置事件分发器中绑定脚本事件是否可以tick
---@param bTickable boolean
---@return void
function XESequencer:SetEventDispatcherScriptTickable(bTickable) end


---@public 获取事件分发器中绑定脚本事件tickable
---@return boolean
function XESequencer:IsEventDispatcherScriptTickable() end


