---过场动画根节点对应的实例类
---@class XESequencerInstance : XESeqBaseInstance
XESequencerInstance = {}


---@public XESequencerInstance_new00
---@param pNodeTl XESequencer
---@return XESequencerInstance
function XESequencerInstance:new(pNodeTl) end


---@public 获取对应模板指针
---@return XESequencer
function XESequencerInstance:GetSequencerTemplate() end


---@public 把关卡指针设置给节点管理器
---@param pLevel XELevel
---@return void
function XESequencerInstance:AcceptLevel(pLevel) end


---@public 从节点管理器中取到关联的世界指针
---@return XEWorld
function XESequencerInstance:GetWorld() end


---@public 从节点管理器中取到关联的关卡指针
---@return XELevel
function XESequencerInstance:GetLevel() end


---@public 释放所有BindingActor的动画资源
---@return void
function XESequencerInstance:ReleaseAllAnimResources() end


---@public 判断指定Actor是否有效
---@param pActor XEActor 指定Actor指针
---@return boolean 是否有效
function XESequencerInstance:VerifyActor(pActor) end


---@public 设置是否可tick
---@param bTickable boolean 是否可tick
---@return void
function XESequencerInstance:EnableTick(bTickable) end


---@public 获取是否可tick
---@return boolean
function XESequencerInstance:IsTickable() end


---@public 由idString 查找过场动画关联的Actor，如果不存在，则尝试从ActorName中查找
---@param szIdString string Actor的idString
---@param szActorName string Actor的名称
---@return XEActor
function XESequencerInstance:SafeFindBindingActor(szIdString, szActorName) end


---@public 由idString 查找过场动画关联绑定Actor的轨道，如果不存在，则尝试从ActorName中查找
---@param szIdString string Actor的idString
---@param szActorName string Actor的名称
---@return XESeqBindingActorInstance
function XESequencerInstance:FindTrackOfBindingActor(szIdString, szActorName) end


---@public 获取动画播放控制器
---@return XESeqAnimController 动画播放控制器指针
function XESequencerInstance:GetSeqAnimController() end


---@public 设置动画内限定的Actor绑定对象
---@param pActor XEActor
---@return void
function XESequencerInstance:SetBindActor(pActor) end


---@public 获取Actor对象容器
---@return XEActor
function XESequencerInstance:GetBindActor() end


---@class XESequencerInstance__XESequencerInstanceEventDispatcher
local XESequencerInstance__XESequencerInstanceEventDispatcher = {}
XESequencerInstance.XESequencerInstanceEventDispatcher = XESequencerInstance__XESequencerInstanceEventDispatcher


---@public [运行时]指定节点主动参数修改
---@param pSeqBaseInstance XESeqBaseInstance
---@param pData  XEVariant
---@return void
function XESequencerInstance__XESequencerInstanceEventDispatcher:DoModify(pSeqBaseInstance, pData) end


---@public 执行播放状态变化响应
---@param strStatusName string
---@return void
function XESequencerInstance__XESequencerInstanceEventDispatcher:DoPlayControlStateChanged(strStatusName) end


---@public 在一个Lua模板文件中响应播放pause/resume/stop
---@param strScriptFile string
---@param bEventTickable boolean
---@return void
function XESequencerInstance__XESequencerInstanceEventDispatcher:SetupHandleScript(strScriptFile, bEventTickable) end


---@public 释放资源
---@return void
function XESequencerInstance__XESequencerInstanceEventDispatcher:Release() end


---@public 设置脚本事件是否可响应tick
---@param bEnable boolean
---@return void
function XESequencerInstance__XESequencerInstanceEventDispatcher:SetTickable(bEnable) end


---@public XESequencerInstance_XESequencerInstanceEventDispatcher_GetSequenceInstance00
---@return XESequencerInstance
function XESequencerInstance__XESequencerInstanceEventDispatcher:GetSequenceInstance() end


---@public XESequencerInstance_XESequencerInstanceEventDispatcher_IsEventTickable00
---@return boolean
function XESequencerInstance__XESequencerInstanceEventDispatcher:IsEventTickable() end


---@public 需要安装中断实现器才能响应分发效果
---@param strScriptFile string
---@param bEventTickable boolean
---@return void
function XESequencerInstance:SetupEventDispatcher(strScriptFile, bEventTickable) end


---@public 获取事件分发器
---@return XESequencerInstance__XESequencerInstanceEventDispatcher
function XESequencerInstance:GetEventDispatcher() end


