---@class XESoftBoneChain
XESoftBoneChain = {}


---@public 读取软骨信息:加载一个prefab，一次性读取所有属性
---@param szFile string prefab文件（xml）
---@return boolean
function XESoftBoneChain:LoadPropertyPrefab(szFile) end


---@public 获取所有数组
---@return XESoftBone[] 软骨数组
function XESoftBoneChain:GetSoftBones() end


---@public 更新
---@param fDelta number 更新间隔
---@param pBaseCamera XBaseCamera
---@return void
function XESoftBoneChain:Tick(fDelta, pBaseCamera) end


---@public 获得根骨骼
---@return XBone XBone根骨骼
function XESoftBoneChain:GetRootBone() end


---@public 获取软骨信息:更新频率,1秒钟更新多少次
---@return number 更新频率
function XESoftBoneChain:GetUpdateRate() end


---@public 设置软骨信息:更新频率,1秒钟更新多少次
---@param fUpdateRate number 更新频率
---@return void
function XESoftBoneChain:SetUpdateRate(fUpdateRate) end


---@public 获取软骨信息:阻尼
---@return number 阻尼
function XESoftBoneChain:GetDamping() end


---@public 设置软骨信息:阻尼
---@param fDamping number 阻尼
---@return void
function XESoftBoneChain:SetDamping(fDamping) end


---@public 设置软骨信息:阻尼曲线
---@param szFile string
---@return boolean
function XESoftBoneChain:LoadDampingCurve(szFile) end


---@public 获取软骨信息:阻尼曲线资源文件
---@return string 阻尼曲线资源文件
function XESoftBoneChain:GetDampingCurveFile() end


---@public 获取软骨信息:弹性
---@return number 弹性
function XESoftBoneChain:GetElasticity() end


---@public 设置软骨信息:弹性
---@param fElasticity number 弹性
---@return void
function XESoftBoneChain:SetElasticity(fElasticity) end


---@public 设置软骨信息:弹性曲线
---@param szFile string
---@return boolean
function XESoftBoneChain:LoadElasticityCurve(szFile) end


---@public 获取软骨信息:弹性曲线资源文件
---@return string 弹性曲线资源文件
function XESoftBoneChain:GetElasticityCurveFile() end


---@public 获取软骨信息:刚度
---@return number 刚度
function XESoftBoneChain:GetStiffness() end


---@public 设置软骨信息:刚度
---@param fStiffness number 刚度
---@return void
function XESoftBoneChain:SetStiffness(fStiffness) end


---@public 设置软骨信息:刚度曲线
---@param szFile string
---@return boolean
function XESoftBoneChain:LoadStiffnessCurve(szFile) end


---@public 获取软骨信息:刚度曲线资源文件
---@return string 刚度曲线资源文件
function XESoftBoneChain:GetStiffnessCurveFile() end


---@public 获取软骨信息:惰性
---@return number 惰性
function XESoftBoneChain:GetInert() end


---@public 设置软骨信息:惰性
---@param fInert number 惰性
---@return void
function XESoftBoneChain:SetInert(fInert) end


---@public 设置软骨信息:惰性曲线
---@param szFile string
---@return boolean
function XESoftBoneChain:LoadInertCurve(szFile) end


---@public 获取软骨信息:惰性曲线资源文件
---@return string 惰性曲线资源文件
function XESoftBoneChain:GetInertCurveFile() end


---@public 获取软骨信息:半径
---@return number 半径
function XESoftBoneChain:GetRadius() end


---@public 设置软骨信息:半径
---@param fRadius number 半径
---@return void
function XESoftBoneChain:SetRadius(fRadius) end


---@public 设置软骨信息:半径曲线
---@param szFile string
---@return boolean
function XESoftBoneChain:LoadRadiusCurve(szFile) end


---@public 获取软骨信息:半径曲线资源文件
---@return string 半径曲线资源文件
function XESoftBoneChain:GetRadiusCurveFile() end


---@public 获取软骨信息:EndLength
---@return number EndLength
function XESoftBoneChain:GetEndLength() end


---@public 设置软骨信息:EndLength
---@param fEndLength number EndLength
---@return void
function XESoftBoneChain:SetEndLength(fEndLength) end


---@public 获取软骨信息:EndOffset
---@return XVECTOR3 EndOffset
function XESoftBoneChain:GetEndOffset() end


---@public 设置软骨信息:EndOffset
---@param vEndOffset XVECTOR3 EndOffset
---@return void
function XESoftBoneChain:SetEndOffset(vEndOffset) end


---@public 获取软骨信息:重力
---@return XVECTOR3 重力
function XESoftBoneChain:GetGravity() end


---@public 设置软骨信息:重力
---@param vGravity XVECTOR3 重力
---@return void
function XESoftBoneChain:SetGravity(vGravity) end


---@public 获取软骨信息:附加力
---@return XVECTOR3 附加力
function XESoftBoneChain:GetForce() end


---@public 设置软骨信息:附加力
---@param vForce XVECTOR3 附加力
---@return void
function XESoftBoneChain:SetForce(vForce) end


---@type number @enum FreezeAxis
XESoftBoneChain.FreezeAxis_None = 0


---@type number @enum FreezeAxis
XESoftBoneChain.FreezeAxis_X = 0


---@type number @enum FreezeAxis
XESoftBoneChain.FreezeAxis_Y = 0


---@type number @enum FreezeAxis
XESoftBoneChain.FreezeAxis_Z = 0


---@public 获取软骨信息:轴向限制
---@return number 轴向限制
function XESoftBoneChain:GetFreezeAxis() end


---@public 设置软骨信息:轴向限制
---@param eFreeAxis number 轴向限制
---@return void
function XESoftBoneChain:SetFreezeAxis(eFreeAxis) end


---@public 需要从哪些骨骼上取碰撞体,获取这些骨骼名称
---@return string[] eFreeAxis轴向限制
function XESoftBoneChain:GetColliderBoneNames() end


---@public 设置骨骼名称的数量
---@param nNum number
---@return void
function XESoftBoneChain:SetColliderBoneNum(nNum) end


---@public 设置需要获取的某个骨骼的名称
---@param nIndex number
---@param szName string
---@return void
function XESoftBoneChain:SetColliderBoneName(nIndex, szName) end


---@public 是否随距离失效
---@return boolean 是否随距离失效
function XESoftBoneChain:GetDistanceDisable() end


---@public 设置是否随距离失效
---@param bSet boolean
---@return void
function XESoftBoneChain:SetDistanceDisable(bSet) end


---@public 设置是否随距离失效
---@return number
function XESoftBoneChain:GetDistanceToCamera() end


---@public 设置失效距离
---@param fDistance number 失效距离
---@return void
function XESoftBoneChain:SetDistanceToCamera(fDistance) end


---@type number @enum PlaneDirection
XESoftBoneChain.X = 0


---@type number @enum PlaneDirection
XESoftBoneChain.X_ = 0


---@type number @enum PlaneDirection
XESoftBoneChain.Y = 0


---@type number @enum PlaneDirection
XESoftBoneChain.Y_ = 0


---@type number @enum PlaneDirection
XESoftBoneChain.Z = 0


---@type number @enum PlaneDirection
XESoftBoneChain.Z_ = 0


---@public 获取软骨信息:是否是面碰撞
---@return boolean 是否是面碰撞
function XESoftBoneChain:IsPlaneCollider() end


---@public 设置软骨信息:是否是面碰撞
---@param bPlaneCollider boolean 是否是面碰撞
---@return void
function XESoftBoneChain:SetPlaneCollider(bPlaneCollider) end


---@public 获取软骨信息:面碰撞半径
---@return number 面碰撞半径
function XESoftBoneChain:GetPlaneRadius() end


---@public 设置软骨信息:面碰撞半径
---@param fPlaneRadius number 面碰撞半径
---@return void
function XESoftBoneChain:SetPlaneRadius(fPlaneRadius) end


---@public 设置软骨信息:面碰撞半径曲线
---@param szFile string 面碰撞半径曲线
---@return boolean
function XESoftBoneChain:LoadPlaneRadiusCurve(szFile) end


---@public 获取软骨信息:面碰撞半径曲线资源文件
---@return string 面碰撞半径曲线资源文件
function XESoftBoneChain:GetPlaneRadiusCurveFile() end


---@public 获取软骨信息:面碰撞方向
---@return number 面碰撞方向
function XESoftBoneChain:GetPlaneDirection() end


---@public 设置软骨信息:面碰撞方向
---@param eDirection number 面碰撞方向
---@return void
function XESoftBoneChain:SetPlaneDirection(eDirection) end


---@public 获取软骨信息:面碰撞偏移
---@return number 面碰撞偏移
function XESoftBoneChain:GetPlaneOffset() end


---@public 设置软骨信息:面碰撞偏移
---@param fPlaneOffset number 面碰撞偏移
---@return void
function XESoftBoneChain:SetPlaneOffset(fPlaneOffset) end


---@public 绑定一个模型上的骨骼碰状体
---@param pModelComponent XEModelComponent
---@return void
function XESoftBoneChain:BindModelComponentColliders(pModelComponent) end


---@public 取消骨骼碰撞体ModelCompoennt
---@return void
function XESoftBoneChain:RemoveModelComponentColliders() end


---@public 重置所有软骨位置
---@return void
function XESoftBoneChain:ResetSoftBonePosition() end


---@public 设置权重值
---@param fWeight number 权重值
---@return void
function XESoftBoneChain:SetWeight(fWeight) end


---@public 获取权重值
---@return number 权重值
function XESoftBoneChain:GetWeight() end


---@public XESoftBoneChain_SetExclusionBoneNames00
---@param aExclusionName string[]
---@return void
function XESoftBoneChain:SetExclusionBoneNames(aExclusionName) end


---@class XESoftSkeleton
XESoftSkeleton = {}


---@public XESoftSkeleton_new00
---@param pModelInstance IXModelInstance
---@return XESoftSkeleton
function XESoftSkeleton:new(pModelInstance) end


---@type number @enum LoadErrorCode
XESoftSkeleton.Load_Success = 0


---@type number @enum LoadErrorCode 模型与软骨文件不匹配
XESoftSkeleton.Load_Error_NotMatch = 0


---@type number @enum LoadErrorCode 文件错误
XESoftSkeleton.Load_Error_File = 0


---@type number @enum LoadErrorCode 未知错误
XESoftSkeleton.Load_Error_Other = 0


---@public XESoftSkeleton_Load00
---@param szFile string
---@return number
function XESoftSkeleton:Load(szFile) end


---@public 获取Asset文件路径
---@return string XString资源文件路径
function XESoftSkeleton:GetAssetPath() end


---@public 更新
---@param fDelta number 更新间隔
---@param pBaseCamera XBaseCamera
---@return void
function XESoftSkeleton:Tick(fDelta, pBaseCamera) end


---@type number @enum AddSoftBoneErrorCode
XESoftSkeleton.AddSoftBone_Success = 0


---@type number @enum AddSoftBoneErrorCode
XESoftSkeleton.AddSoftBone_Error_Conflict = 0


---@type number @enum AddSoftBoneErrorCode
XESoftSkeleton.AddSoftBone_Error_BeyondMaxNum = 0


---@type number @enum AddSoftBoneErrorCode
XESoftSkeleton.AddSoftBone_Error_Other = 0


---@public 设置一条软骨
---@param szBoneName string 根骨骼名称
---@return number xbool是否设置成功
function XESoftSkeleton:AddSoftBoneChain(szBoneName) end


---@public 取消一条软骨
---@param szBoneName string 根骨骼名称
---@return boolean 是否成功移除
function XESoftSkeleton:RemoveSoftBoneChain(szBoneName) end


---@public XESoftSkeleton_GetSoftBoneChainNum00
---@return number
function XESoftSkeleton:GetSoftBoneChainNum() end


---@public XESoftSkeleton_GetSoftBoneChain00
---@param nIndex number
---@return XESoftBoneChain
function XESoftSkeleton:GetSoftBoneChain(nIndex) end


---@public 根据根骨骼名字获取一条软骨
---@param szBoneName string 根骨骼名称
---@return XESoftBoneChain
function XESoftSkeleton:GetSoftBoneChain(szBoneName) end


---@public 根据任意一个子骨骼名字获取一条软骨
---@param szBoneName string 根骨骼名称
---@return XESoftBoneChain
function XESoftSkeleton:GetSoftBoneChainWithAnyChildBone(szBoneName) end


---@public 设置是否起作用
---@param bEnable boolean 是否起作用
---@return void
function XESoftSkeleton:Enable(bEnable) end


---@public 获取是否起作用
---@return boolean 是否起作用
function XESoftSkeleton:IsEnable() end


---@public 重置软骨位置到当前骨骼位置
---@return void
function XESoftSkeleton:Reset() end


---@public 绑定一个模型上的骨骼碰状体
---@param pModelComponent XEModelComponent
---@return void
function XESoftSkeleton:BindModelComponentColliders(pModelComponent) end


---@public 取消骨骼碰撞体ModelCompoennt
---@return void
function XESoftSkeleton:RemoveModelComponentColliders() end


---@public 更新所有软骨的属性
---@return void
function XESoftSkeleton:UpdateProperty() end


