---@class XEUIAnimation : XEUIAnimBase
XEUIAnimation = {}


---@public XEUIAnimation_new00
---@return XEUIAnimation
function XEUIAnimation:new() end


---@class XEUIAnimation__NodeManager : XETreeNode__Manager
local XEUIAnimation__NodeManager = {}
XEUIAnimation.NodeManager = XEUIAnimation__NodeManager


---@public 初始化函数
---@param strAssetPath string 动画资源路径（.uixanim）
---@return void
function XEUIAnimation:Initialize(strAssetPath) end


---@public 获取子节点中绑定特定UI控件的节点
---@param pUINodeName string UI节点名称
---@return XEUIAnimBinding UI动画节点
function XEUIAnimation:GetBindingForUINode(pUINodeName) end


---@public 在UI动画中创建一个绑定节点
---@param szBindingType string 绑定节点类型
---@return XEUIAnimBinding 创建的绑定节点指针
function XEUIAnimation:CreateBinding(szBindingType) end


---@public 获取UI动画资源路径
---@return string
function XEUIAnimation:GetAssetPath() end


---@public 设置UI动画手动播放开始时间
---@param nTime number
---@return void
function XEUIAnimation:SetManaulStartTime(nTime) end


---@public 获取UI动画手动播放开始时间
---@return number
function XEUIAnimation:GetManualStartTime() end


---@public 设置UI动画手动播放结束时间
---@param nTime number
---@return void
function XEUIAnimation:SetManualEndTime(nTime) end


---@public 获取UI动画手动播放结束时间
---@return number
function XEUIAnimation:GetManualEndTime() end


---@public 设置UI动画是否为手动播放模式
---@param bManual boolean
---@return void
function XEUIAnimation:SetManualTimeMode(bManual) end


---@public 判断UI动画是否为手动播放模式
---@return boolean
function XEUIAnimation:IsManualTimeMode() end


---@public 设置过场动画是否被修改
---@param bSet boolean
---@return void
function XEUIAnimation:SetModified(bSet) end


---@public 获取过场动画是否被修改
---@return boolean
function XEUIAnimation:IsModified() end


---@public 在UI动画中创建一个轨道也就是创建一个子节点
---@param szTrackType string 轨道类型
---@return XETrackBase 创建的轨道指针
function XEUIAnimation:CreateTrack(szTrackType) end


