---@class XEFaceTrakcerDataDriver
XEFaceTrakcerDataDriver = {}


---@public XEFaceTrakcerDataDriver_new00
---@return XEFaceTrakcerDataDriver
function XEFaceTrakcerDataDriver:new() end


---@type number @enum ERenderFacePointNumType
XEFaceTrakcerDataDriver.ERFPN_96 = 0


---@type number @enum ERenderFacePointNumType
XEFaceTrakcerDataDriver.ERFPN_137 = 0


---@type number @enum ERenderFacePointNumType
XEFaceTrakcerDataDriver.ERPN_NUM = 0


---@public 设置是否允许绘制Landmark
---@param bEnable boolean
---@return void
function XEFaceTrakcerDataDriver:SetRenderLandmarksEnable(bEnable) end


---@public 获取是否允许绘制Landmark
---@return boolean
function XEFaceTrakcerDataDriver:IsRenderLandmarksEnable() end


---@public 设置Landmark颜色
---@param color  XCOLORBASE
---@return void
function XEFaceTrakcerDataDriver:SetLandmarkColor(color) end


---@public 获取Landmark颜色
---@return  XCOLORBASE
function XEFaceTrakcerDataDriver:GetLandmarkColor() end


---@public 设置是否绘制人脸矩形区域
---@param bEnable boolean
---@return void
function XEFaceTrakcerDataDriver:SetRenderFaceRectEnable(bEnable) end


---@public 是否绘制人脸矩形区域
---@return boolean
function XEFaceTrakcerDataDriver:IsRenderFaceRectEnable() end


---@public 设置是否绘制手势矩形区域
---@param bEnable boolean
---@return void
function XEFaceTrakcerDataDriver:SetRenderGestureRectEnable(bEnable) end


---@public 是否绘制手势矩形区域
---@return boolean
function XEFaceTrakcerDataDriver:IsRenderGestureRectEnable() end


---@public 获取人脸矩形区域
---@return XVECTOR4
function XEFaceTrakcerDataDriver:GetFaceRect() end


---@public 设置人脸矩形区域的颜色
---@param color  XCOLORBASE
---@return void
function XEFaceTrakcerDataDriver:SetFaceRectColor(color) end


---@public 获取人脸矩形区域的颜色
---@return  XCOLORBASE
function XEFaceTrakcerDataDriver:GetFaceRectColor() end


---@public 设置手势矩形区域的颜色
---@param color  XCOLORBASE
---@return void
function XEFaceTrakcerDataDriver:SetGestureRectColor(color) end


---@public 获取手势矩形区域的颜色
---@return  XCOLORBASE
function XEFaceTrakcerDataDriver:GetGestureRectColor() end


---@public 获取手势类型，如比心
---@return number
function XEFaceTrakcerDataDriver:GetGestureType() end


---@public 获取手势的范围
---@return XVECTOR4
---@return boolean
function XEFaceTrakcerDataDriver:GetGesutreRect() end


---@public 获取表情类型，如张嘴
---@return number
function XEFaceTrakcerDataDriver:GetEmotionAnimationType() end


---@public 设置是否绘制landmark的索引
---@param bEnable boolean
---@return void
function XEFaceTrakcerDataDriver:SetRenderLandmarkIndexEnable(bEnable) end


---@public 是否绘制landmark的索引
---@return boolean
function XEFaceTrakcerDataDriver:IsRenderLandmarkIndexEnable() end


---@public 设置是否绘制landmark的数字
---@param color  XCOLORBASE
---@return void
function XEFaceTrakcerDataDriver:SetLandmarkNumColor(color) end


---@public 是否绘制landmark的数字
---@return  XCOLORBASE
function XEFaceTrakcerDataDriver:GetLandmarkNumColor() end


---@public 设置Actor Owner
---@param pActor XEActor
---@return void
function XEFaceTrakcerDataDriver:SetActorOwner(pActor) end


---@public 获取Actor Owner
---@return XEActor
function XEFaceTrakcerDataDriver:GetActorOwner() end


---@public 获取绘制人脸点的数量类型
---@return number
function XEFaceTrakcerDataDriver:GetRenderFacePointNumType() end


---@public 将当前人脸矩阵平面变换到矩形面上
---@param planeRectWorldPoint XVECTOR3[] 矩形面上的四个世界坐标点
---@return XVECTOR3[]
---@return XMATRIX4
---@return XMATRIX4 对物体应用在目标平面上的变换矩阵，该矩阵与原始参考平面中的物体变换矩阵对应
function XEFaceTrakcerDataDriver:TransformFaceMatrixToRectPlane(planeRectWorldPoint) end


---@public 获取绘制人脸点数量的所有类型
---@return string[]
function XEFaceTrakcerDataDriver:GetAllRenderFacePointNumTypeList() end


---@public 根据人脸点数量类型获取对应的字符串
---@param eType number
---@return string
function XEFaceTrakcerDataDriver:GetRenderFacePointNumTypeNameForType(eType) end


---@public 根据字符串获取对应的人脸点数量类型
---@param str string
---@return number
function XEFaceTrakcerDataDriver:GetRenderFacePointNumTypeForName(str) end


---@public 获取所有的landmark坐标(非线程安全)
---@param bCopyReshape boolean 表示是否采用变形后的点
---@return number[] 所有landmark列表，列表按照x1,x2...xn，y1,y2,..yn的顺序排列
function XEFaceTrakcerDataDriver:GetLandMark(bCopyReshape) end


---@public 拷贝所有的landmark坐标(线程安全)
---@param bCopyReshape boolean 表示是否采用变形后的点
---@return number[]
---@return void
function XEFaceTrakcerDataDriver:CopyLandMark(bCopyReshape) end


---@public 获取指定索引的landmark坐标
---@param nPointIndex number landmark索引
---@param bCopyReshape boolean 表示是否采用变形后的点
---@return XVECTOR2 指定索引landmark的坐标（x,y）
function XEFaceTrakcerDataDriver:GetLandMarkPoint(nPointIndex, bCopyReshape) end


---@public 获取世界空间下人脸变换矩阵
---@param pCamera XBaseCamera
---@return XMATRIX4
---@return boolean 是否获取成功
function XEFaceTrakcerDataDriver:GetFaceMatrixOnWorldSpace(pCamera) end


---@public 获取人头的欧拉角
---@return XVECTOR3
function XEFaceTrakcerDataDriver:GetEulerAngle() end


---@public 获取人脸FaceRig的欧拉角
---@return XVECTOR3
function XEFaceTrakcerDataDriver:GetFaceRigEulerAngle() end


---@public 获取人头的FaceRig数据
---@param nPointIndex number
---@return number
function XEFaceTrakcerDataDriver:GetFaceRigPoint(nPointIndex) end


---@public 获取人头的FaceRig数据数组(非线程安全)
---@return number[]
function XEFaceTrakcerDataDriver:GetFaceRigPoints() end


---@public 拷贝FaceRig 数据(线程安全)
---@return number[]
---@return void
function XEFaceTrakcerDataDriver:CopyFaceRigPoints() end


---@public 获取人头的FaceRig数据个数
---@return number
function XEFaceTrakcerDataDriver:GetFaceRigPointNum() end


---@public 世界空间的人脸矩阵
---@return XMATRIX4
function XEFaceTrakcerDataDriver:GetFaceWorldMatrix() end


---@public 设置该跟踪器在指定subview中运行，当在subview中运行时，相机需要指定为subview中相机
---@param strSubviewName string
---@return void
function XEFaceTrakcerDataDriver:SetSubviewName(strSubviewName) end


---@public 获取该路径器的subview名称
---@return string
function XEFaceTrakcerDataDriver:GetSubviewName() end


---@public 更新一次实际使用的人脸矩阵，不改变原本矩阵
---@param matToMerge XMATRIX4
---@return void
function XEFaceTrakcerDataDriver:UpdateAndMergeTransform(matToMerge) end


---@public 获取人脸矩阵(内部基于CV算法传入的人脸矩阵计算)
---@return XMATRIX4
function XEFaceTrakcerDataDriver:GetFaceMatrix() end


---@public 设置人脸原始矩阵
---@param mat4 XMATRIX4
---@return void
function XEFaceTrakcerDataDriver:SetFaceMatrix(mat4) end


---@public 获取landmark点渲染的变换矩阵
---@return XMATRIX4
function XEFaceTrakcerDataDriver:GetLandmarkPointTransformMatrix() end


---@public 设置landmark点渲染的变换矩阵
---@param mat4 XMATRIX4
---@return void
function XEFaceTrakcerDataDriver:SetLandmarkPointTransformMatrix(mat4) end


---@public 变换的landmark屏幕点, 使用内部设置的变换矩阵
---@param pViewport XEViewport
---@param vLandmarkScreenPoint XVECTOR2
---@return XVECTOR3
function XEFaceTrakcerDataDriver:TransformLandmarkPoint(pViewport, vLandmarkScreenPoint) end


---@public 获取基于137个关键点模型的所有的landmark坐标
---@param bCopyReshape boolean 表示是否采用变形后的点
---@return number[] 所有landmark列表，列表按照x1,x2...xn，y1,y2,..yn的顺序排列
function XEFaceTrakcerDataDriver:GetLandMark137(bCopyReshape) end


---@public 获取基于104个关键点模型的所有的landmark坐标
---@return number[] 所有landmark列表，列表按照x1,x2...xn，y1,y2,..yn的顺序排列
function XEFaceTrakcerDataDriver:GetLandMark104() end


---@public 拷贝基于137个关键点模型的所有的landmark坐标
---@param bCopyReshape boolean 表示是否采用变形后的点
---@return number[]
---@return void
function XEFaceTrakcerDataDriver:CopyLandMark137(bCopyReshape) end


---@public 从外部设置一个原始点的坐标[模拟facetracker]
---@param nPointIndex number landmark索引
---@param vecPoint XVECTOR2
---@return boolean 指定索引landmark的坐标（x,y）
function XEFaceTrakcerDataDriver:SetLandMarkPoint(nPointIndex, vecPoint) end


---@public 获取基于137个关键点模型的指定索引的landmark坐标
---@param nPointIndex number landmark索引
---@param bCopyReshape boolean 表示是否采用变形后的点
---@return XVECTOR2 指定索引landmark的坐标（x,y）
function XEFaceTrakcerDataDriver:GetLandMarkPoint137(nPointIndex, bCopyReshape) end


---@public 获取基于104个关键点模型的指定索引的landmark坐标
---@param nPointIndex number landmark索引
---@return XVECTOR2 指定索引landmark的坐标（x,y）
function XEFaceTrakcerDataDriver:GetLandMarkPoint104(nPointIndex) end


---@public XEFaceTrakcerDataDriver_GetFaceRotation00
---@return XQUATERNION
function XEFaceTrakcerDataDriver:GetFaceRotation() end


---@public XEFaceTrakcerDataDriver_GetFaceLocation00
---@return XVECTOR3
function XEFaceTrakcerDataDriver:GetFaceLocation() end


---@public XEFaceTrakcerDataDriver_GetFaceScale00
---@return XVECTOR3
function XEFaceTrakcerDataDriver:GetFaceScale() end


---@public XEFaceTrakcerDataDriver_GetCameraViewMatrixInverse00
---@return XMATRIX4
function XEFaceTrakcerDataDriver:GetCameraViewMatrixInverse() end


---人脸追踪器
---This class represents a Face Track actor and contains sub-actors that follow faces and do not follow faces.
---The actors that follow faces are attached actors.These actors can be gotten by GetChildActors.
---The position actors only be showed or hidden by face detection status.These actors can be gotten by GetPositionActors.
---如果场景中需要创建头饰、2D序列帧或美妆时，务必至少创建一个人脸追踪器
---NOTE:
---1. 此Actor不能Attach 到任何类型Actor（包括XEFaceTrackerActor）
---2. 第一次向XEFaceTrackerActor绑定子Actor时，会自动创建一个名称为m_strFaceMaskName的face mask（XEStaticMeshActor）。
---3. 从XEFaceTrackerActor移除所有绑定的子Actor后，会自动释放已创建的名为m_strFaceMaskName的face mask（XEStaticMeshActor）。
---4. 获取XEFaceTrackerActor所绑定的所有子Actor中包含自动创建的名为m_strFaceMaskName的子actor。
---5. XEFaceTrackerActor内部会自动创建和释放名为m_strFaceMaskName的子Actor，外部尽量不要干预此actor的释放，否则可能出错。
---@class XEFaceTrackerActor : XEActor
XEFaceTrackerActor = {}


---@public XEFaceTrackerActor_new00
---@return XEFaceTrackerActor
function XEFaceTrackerActor:new() end


---@type number @enum XEFilterPathType
XEFaceTrackerActor.EFP_CUSTOM = 0


---@type number @enum XEFilterPathType
XEFaceTrackerActor.EEP_POSITION = 0


---@type number @enum XEFilterPathType
XEFaceTrackerActor.EEP_TRACKING = 0


---@type number @enum ETrackType
XEFaceTrackerActor.ETT_NONE = 0


---@type number @enum ETrackType
XEFaceTrackerActor.ETT_POSITION = 0


---@type number @enum ETrackType
XEFaceTrackerActor.ETT_ATTACH = 0


---@public XEFaceTrackerActor_GetTypeName00
---@return string
function XEFaceTrackerActor:GetTypeName() end


---@public XEFaceTrackerActor_GetActorShortName00
---@return string
function XEFaceTrackerActor:GetActorShortName() end


---@public 是否检测到当前指定的表情
---@param nFaceExpressCode number
---@return boolean
function XEFaceTrackerActor:IsMatchFaceExpress(nFaceExpressCode) end


---@public Get position actors attaching to this actor
---@return XEActor[] positionactors
function XEFaceTrackerActor:GetPositionActors() end


---@public XEFaceTrackerActor_GetPositionActors01
---@return XEActor[]
function XEFaceTrackerActor:GetPositionActors() end


---@public Get actors that track faces and do not track faces.
---@param aAttachedActors XEActor[] Anoutparam.Representsactorsthattrackfacesanddonottrackfaces
---@return boolean whetherissuccessful
function XEFaceTrackerActor:GetAllActorsInFaceTracker(aAttachedActors) end


---@public Whether the face mask actor exists
---@return boolean whetherissuccessful
function XEFaceTrackerActor:HasFaceMaskActor() end


---@public 获取人脸Mask Actor
---@return XEActor 人脸MaskActor
function XEFaceTrackerActor:GetFaceMaskActor() end


---@public 添加人脸Mask Actor
---@return boolean 是否添加成功
function XEFaceTrackerActor:AddFaceMaskActor() end


---@public 移除人脸Mask Actor
---@return boolean 是否移除成功
function XEFaceTrackerActor:RemoveFaceMaskActor() end


---@public 是否绑定了子Actor或ETT_POSITION类型的Actor
---@return boolean 内部是否绑定了Actor
function XEFaceTrackerActor:HasActor() end


---@public 是否绑定了指定的Actor
---@param pActor XEActor
---@return boolean 内部是否绑定了Actor
function XEFaceTrackerActor:HasActor(pActor) end


---@public 设置是否启用了CV检测
---@param bEnable boolean
---@return void
function XEFaceTrackerActor:SetEnableMMCVCore(bEnable) end


---@public 是否启用了CV检测
---@return boolean
function XEFaceTrackerActor:IsEnableMMCVCore() end


---@public 设置是否运行时隐藏当前Actor及关联的子Actor
---@param bHide boolean
---@return void
function XEFaceTrackerActor:SetHideActorsInGame(bHide) end


---@public 设置Face Mask的mdl路径
---@param strPath string
---@return void
function XEFaceTrackerActor:SetFaceMaskMdlPath(strPath) end


---@public 获取face mask 的mdl路径
---@return string
function XEFaceTrackerActor:GetFaceMaskMdlPath() end


---@public 设置Face Mask的显隐
---@param bVisible boolean
---@return void
function XEFaceTrackerActor:SetFaceMaskVisible(bVisible) end


---@public 获取Face Mask的显隐
---@return boolean
function XEFaceTrackerActor:IsFaceMaskVisible() end


---@public 设置人脸矩阵是否手动更新到应用矩阵中
---@param bManually boolean
---@return void
function XEFaceTrackerActor:SetUpdateManaully(bManually) end


---@public 获取人脸矩阵是否手动更新到应用矩阵中
---@return boolean
function XEFaceTrackerActor:IsUpdateManaully() end


---@public 设置关联的人脸索引
---@param nIndex number
---@return void
function XEFaceTrackerActor:SetAttachFaceIndex(nIndex) end


---@public 获取关联的人脸索引
---@return number
function XEFaceTrackerActor:GetAttachFaceIndex() end


---@public 根据路径操作类型，获取筛选路径字符串
---@param eFilterPath number
---@return string
function XEFaceTrackerActor:GetFilterPath(eFilterPath) end


---@public 获取人脸mask Actor的名字
---@return string
function XEFaceTrackerActor:GetFaceMaskActorName() end


---@public 是否检测到人脸
---@return boolean
function XEFaceTrackerActor:IsDetectFace() end


---@public 应用Actor的跟踪模式：没有设置/位置跟随/不跟随
---@param pActor XEActor
---@return void
function XEFaceTrackerActor:ApplyActorFollowMode(pActor) end


---@public 从PositionActor列表中移除 Actor
---@param pActor XEActor
---@return void
function XEFaceTrackerActor:RemoveActorFromPositionList(pActor) end


---@public 判断PositionActor列表中是否包含Actor
---@param pActor XEActor
---@return boolean
function XEFaceTrackerActor:HasActorInPostionList(pActor) end


---@type string @readonly 
XEFaceTrackerActor.ACTOR_TYPENAME = ''


---@type string @readonly 
XEFaceTrackerActor.ACTOR_SHORT_NAME = ''


---@public 注册可以挂载到当前Actor的子Socket Actor
---@param strChildSocketActorType string
---@return void
function XEFaceTrackerActor:RegisterChildSocketActorType(strChildSocketActorType) end


---@public 获取可以挂载到当前Actor的子Socket Actor
---@return string[]
function XEFaceTrackerActor:GetChildSocketActorTypeList() end


---@public 注册不受脸部状态改变影响的子Socket Actor类型
---@param strChildSocketActorType string
---@return void
function XEFaceTrackerActor:RegisterDisableFaceCtrlChildSocketActorType(strChildSocketActorType) end


---@public 获取不受脸部状态改变影响的子Socket Actor类型
---@return string[]
function XEFaceTrackerActor:GetDisableFaceCtrlChildSocketActorTypeList() end


---@public XEFaceTrackerActor_EnsureFacetrakcerActorExistInLevel00
---@param pLevel XELevel
---@return XEFaceTrackerActor
function XEFaceTrackerActor:EnsureFacetrakcerActorExistInLevel(pLevel) end


---@public XEFaceTrackerActor_GetOneValidFacetrakcerActorInLevel00
---@param pLevel XELevel
---@return XEFaceTrackerActor
function XEFaceTrackerActor:GetOneValidFacetrakcerActorInLevel(pLevel) end


