---此类Actor代表一个滤镜链,允许包含多个滤镜节点
---@class XEImgFilterChainActor : XEMagicCoreActorBase
XEImgFilterChainActor = {}


---@public XEImgFilterChainActor_new00
---@return XEImgFilterChainActor
function XEImgFilterChainActor:new() end


---@public 获取滤镜链构建器
---@return XEFilterChainBuilder
function XEImgFilterChainActor:GetFilterChainBuilder() end


---@public 注入一个新节点到滤镜链主干。
---主干滤镜节点会自动生成一个目标输出，并作为下一个主干滤镜节点的目标输入。
---@param pFilterInsToInject XEFilterInstance 滤镜实例节点
---@param eIjOption number
---@param nInjectIndex number 如果声明注入模式为指定位置，则该参数有效，表示注入的位置
---@param bRebuild boolean
---@return boolean
function XEImgFilterChainActor:Inject(pFilterInsToInject, eIjOption, nInjectIndex, bRebuild) end


---@public 设置节点输出到其他节点（将会修改主干形状）, 支持本节点多输出
---@param pFilterIns XEFilterInstance 要处理的节点
---@param pOutputToFilterIns XEFilterInstance 输出到的节点
---@param bRebuild boolean 是否重建节点图
---@return boolean
function XEImgFilterChainActor:SetFilterInstanceOutputTo(pFilterIns, pOutputToFilterIns, bRebuild) end


---@public 设置节点输出到其他节点（将会修改主干形状）
---@param pFilterIns XEFilterInstance 要处理的节点
---@param pOutputToFilterIns XEFilterInstance 输出到的节点
---@param nOutputSlot number 指定节点的输出槽索引，默认为0
---@param bRebuild boolean 是否重建节点图
---@return boolean
function XEImgFilterChainActor:SetFilterInstanceOutputToWithSlot(pFilterIns, pOutputToFilterIns, nOutputSlot, bRebuild) end


---@public 刷新构建图
---@return void
function XEImgFilterChainActor:RefreshFilterGraph() end


---@public XEImgFilterChainActor_EnsureFilterChainActorExistInLevel00
---@param pLevel XELevel
---@return XEImgFilterChainActor
function XEImgFilterChainActor:EnsureFilterChainActorExistInLevel(pLevel) end


---@public XEImgFilterChainActor_GetOneActiveFilterChainActorInLevel00
---@param pLevel XELevel
---@return XEImgFilterChainActor
function XEImgFilterChainActor:GetOneActiveFilterChainActorInLevel(pLevel) end


---@public XEImgFilterChainActor_GetTypeName00
---@return string
function XEImgFilterChainActor:GetTypeName() end


---@public XEImgFilterChainActor_GetActorShortName00
---@return string
function XEImgFilterChainActor:GetActorShortName() end


---@type string @readonly 
XEImgFilterChainActor.ACTOR_TYPENAME = ''


---@type string @readonly 
XEImgFilterChainActor.ACTOR_SHORT_NAME = ''


