---此类型Actor封装了一个滤镜节点 ，代表某个具体的滤镜节点
---@class XEImgFilterUnitActor : XEMagicCoreActorBase
XEImgFilterUnitActor = {}


---@public XEImgFilterUnitActor_new00
---@return XEImgFilterUnitActor
function XEImgFilterUnitActor:new() end


---@public 获取滤镜节点注入器
---@return XEFilterUnitInjector
function XEImgFilterUnitActor:GetFilterUnitInjector() end


---@public 注入一个新节点到滤镜链主干。
---主干滤镜节点会自动生成一个目标输出，并作为下一个主干滤镜节点的目标输入。
---@param pFilterInsToInject XEFilterInstance 滤镜实例节点
---@param eIjmode number 注入模式，可为合并到滤镜链，独立存在
---@param eIjOption number
---@param nInjectIndex number 如果声明注入模式为指定位置，则该参数有效，表示注入的位置
---@param bRebuild boolean
---@return boolean
function XEImgFilterUnitActor:Inject(pFilterInsToInject, eIjmode, eIjOption, nInjectIndex, bRebuild) end


---@public 设置节点输出到其他节点（将会修改主干形状）, 支持本节点多输出
---@param pFilterIns XEFilterInstance 要处理的节点
---@param pOutputToFilterUnitActor XEImgFilterUnitActor 输出到的滤镜单元Actor
---@param bRebuild boolean 是否重建节点图
---@return boolean
function XEImgFilterUnitActor:SetFilterInstanceOutputTo(pFilterIns, pOutputToFilterUnitActor, bRebuild) end


---@public 设置节点输出到其他节点（将会修改主干形状）
---@param pFilterIns XEFilterInstance 要处理的节点
---@param pOutputToFilterUnitActor XEImgFilterUnitActor 输出到的滤镜单元Actor
---@param nOutputSlot number 指定节点的输出槽索引，默认为0
---@param bRebuild boolean 是否重建节点图
---@return boolean
function XEImgFilterUnitActor:SetFilterInstanceOutputToWithSlot(pFilterIns, pOutputToFilterUnitActor, nOutputSlot, bRebuild) end


---@public XEImgFilterUnitActor_GetTypeName00
---@return string
function XEImgFilterUnitActor:GetTypeName() end


---@public XEImgFilterUnitActor_GetActorShortName00
---@return string
function XEImgFilterUnitActor:GetActorShortName() end


---@type string @readonly 
XEImgFilterUnitActor.ACTOR_TYPENAME = ''


---@type string @readonly 
XEImgFilterUnitActor.ACTOR_SHORT_NAME = ''


