---@class XEFilter : XEUserNode
XEFilter = {}


---@public XEFilter_new00
---@return XEFilter
function XEFilter:new() end


---@public XEFilter_GetTypeName00
---@return string
function XEFilter:GetTypeName() end


---@type string @readonly 
XEFilter.NODE_TYPENAME = ''


---@public 设置节点类型（前向滤镜节点、后向滤镜节点）
---@param fnt number
---@return void
function XEFilter:SetFilterNodeType(fnt) end


---@public 节点类型（前向滤镜节点、后向滤镜节点）
---@return number
function XEFilter:GetFilterNodeType() end


---@public 设置滤镜节点的主分组类型
---@param eFilterGroupType number
---@return void
function XEFilter:SetFilterGroupType(eFilterGroupType) end


---@public 获取滤镜节点的主分组类型
---@return number
function XEFilter:GetFilterGroupType() end


---@public 设置是否启用当前节点
---@param bEnabled boolean
---@return void
function XEFilter:SetEnabled(bEnabled) end


---@public 是否启用当前节点
---@return boolean
function XEFilter:IsEnabled() end


---@public 设置所有材质参数组成的字符串
---@param pContent string
---@return void
function XEFilter:SetMaterialInsParamContent(pContent) end


---@public 获取所有材质参数组成的字符串
---@return string
function XEFilter:GetMaterialInsParamContent() end


---@public 获取Shader资源信息
---@return XEFilterUtility__XEFilterShaderAsset
function XEFilter:GetFilterShaderAsset() end


---@public 获取关联的人脸索引
---@return number
function XEFilter:GetFaceTrackerIndex() end


---@public 设置关联的人脸索引
---@param nIndex number
---@return void
function XEFilter:SetFaceTrackerIndex(nIndex) end


---@public 设置当前滤镜渲染类型，是基于屏幕还是人脸区域
---@param eType number
---@return void
function XEFilter:SetFacePartType(eType) end


---@public 获取当前滤镜渲染类型
---@return number
function XEFilter:GetFacePartType() end


---@public 设置节点是否将输入源作为背景拷贝
---@param bEnable boolean
---@return void
function XEFilter:SetCopyOriginAsBackgroundEnable(bEnable) end


---@public 查询节点是否将输入源作为背景拷贝
---@return boolean
function XEFilter:IsCopyOriginAsBackgroundEnable() end


---@public 设置缓存节点为自动缓存
---@param bAuto boolean
---@return void
function XEFilter:SetAutoFrameCache(bAuto) end


---@public 查询缓存节点是否为自动缓存
---@return boolean
function XEFilter:IsAutoFrameCache() end


---@public 设置缓存节点的最大帧数
---@param nMax number
---@return void
function XEFilter:SetFrameCacheMaxNum(nMax) end


---@public 获取缓存节点的最大帧数
---@return number
function XEFilter:GetMaxCacheFrame() end


---@public 设置缓存节点缓存一帧的帧间隔周期,ms
---@param nInterval number
---@return void
function XEFilter:SetFrameCacheInterval(nInterval) end


---@public 获取缓存节点缓存一帧的帧间隔周期
---@return number
function XEFilter:GetCacheFrameInterval() end


---@public 设置该节点是否接受输入的原始纹理采样
---@param bAccept boolean
---@return void
function XEFilter:SetAcceptOriginInputSampler(bAccept) end


---@public 获取该节点是否可接受输入的原始纹理采样
---@return boolean
function XEFilter:IsAcceptOriginInputSampler() end


---@public 设置该节点是否接受主链的前一个节点作为第一个原始纹理采样输入
---@param bAccept boolean
---@return void
function XEFilter:SetAcceptPreMainNodeAsFirstInputSampler(bAccept) end


---@public 获取该节点是否可接受主链的前一个节点作为第一个原始纹理采样输入
---@return boolean
function XEFilter:IsAcceptPreMainNodeAsFirstInputSampler() end


---@type number @enum CodeOption
XEFilter.CODE_ALL = 0


---@type number @enum CodeOption
XEFilter.CODE_MATERIAL = 0


---@type number @enum CodeOption
XEFilter.CODE_SHADER_VS = 0


---@type number @enum CodeOption
XEFilter.CODE_SHADER_PS = 0


---@public 设置当前材质Pass索引
---@param nPassIndex number
---@return void
function XEFilter:SetCurPassIndex(nPassIndex) end


---@public 获取当前材质Pass索引
---@return number
function XEFilter:GetCurPassIndex() end


---@public 根据文件类型，重新加载文件内容并返回
---@param eCodeOption number
---@return string
function XEFilter:ReLoadCode(eCodeOption) end


---@public 根据文件类型，获取文件内容
---@param eCodeOption number
---@return string
function XEFilter:GetCodeBuffer(eCodeOption) end


---@public 设置指定文件类型的内容
---@param eCodeOption number
---@param pCodeBuffer string
---@return void
function XEFilter:SetCodeBuffer(eCodeOption, pCodeBuffer) end


---@public 获取指定文件类型的文件路径
---@param eCodeOption number
---@return string
function XEFilter:GetAssetPathCodeFile(eCodeOption) end


