---滤镜链节点构建器
---@class XEFilterChainBuilder
XEFilterChainBuilder = {}


---@public 是否隐藏
---@param bEnable boolean
---@return void
function XEFilterChainBuilder:SetEnable(bEnable) end


---@public 加载一个滤镜链资源并创建滤镜链实例对象，文件类型为xfc
---@param pAssetPath string 表示相对于xscene的路径
---@return boolean 是否加载成功
function XEFilterChainBuilder:AttachFilterChainAsset(pAssetPath) end


---@public 释放当前关联的滤镜链实例对象
---@return void
function XEFilterChainBuilder:DetachFilterChainInstance() end


---@public 在内存中创建一个滤镜链实例对象
---@return XEFilterContainerInstance 滤镜链实例对象
function XEFilterChainBuilder:AssignFilterChain() end


---@public 获取滤镜链实例对象
---@return XEFilterContainerInstance
function XEFilterChainBuilder:GetFilterContainerInstance() end


---@public 获取滤镜链资源路径
---@return string
function XEFilterChainBuilder:GetFilterContainerAssetPath() end


---@public 实例化滤镜链上的所有滤镜节点
---@return boolean
function XEFilterChainBuilder:ApplyFilterChain() end


---@public 清空并释放滤镜链上的所有滤镜节点
---@return void
function XEFilterChainBuilder:ClearFilterChain() end


---@public 重新实例化滤镜链上的所有滤镜节点
---@return boolean
function XEFilterChainBuilder:RebuildFilterChain() end


---@public 移除一个滤镜节点实例
---@param szNodeName string 节点名称
---@param szNodeType string 节点的类型，如果为空，则不限制
---@param bRemoveTemlate boolean 是否移除模板
---@param bRefreshGraph boolean 是否刷新图
---@return boolean
function XEFilterChainBuilder:RemoveFilterNodeInstance(szNodeName, szNodeType, bRemoveTemlate, bRefreshGraph) end


---@public 移除一个滤镜节点实例
---@param pFilterIns XEFilterInstance 节点实例名称
---@param bRemoveTemlate boolean 是否移除模板
---@param bRefreshGraph boolean 是否刷新图
---@return boolean
function XEFilterChainBuilder:RemoveFilterNodeInstance(pFilterIns, bRemoveTemlate, bRefreshGraph) end


---@public 查找一个滤镜节点实例
---@param szNodeName string 节点名称
---@param szNodeType string 节点的类型，如果为空，则不限制
---@param pNodeContext XETreeNode 指明要查找的节点所在的树中的任意一个节点，如果指定，则查找在该树上的满足条件的节点，否则不作限制
---@return XEFilterInstance
function XEFilterChainBuilder:FindFilterNodeInstance(szNodeName, szNodeType, pNodeContext) end


---@public 获取所属Actor
---@return XEActor
function XEFilterChainBuilder:GetActorOwner() end


---@public 设置是否激活当前当前滤镜链
---@param bActive boolean
---@return void
function XEFilterChainBuilder:SetActive(bActive) end


---@public 是否激活当前当前滤镜链
---@return boolean
function XEFilterChainBuilder:IsActive() end


---@public 设置是否运行时构建滤镜链实例
---@return boolean
function XEFilterChainBuilder:IsBuildInTime() end


---@public 使滤镜节点图应用选项（注册到引擎滤镜图中）
---@param option number 要生效的图构建对象应用选项
---@return void
function XEFilterChainBuilder:SetGraphBuilderApplyOption(option) end


---@public 获取图构建选项
---@return number
function XEFilterChainBuilder:GetGraphBuilderApplyOption() end


