---此类代表一个滤镜容器模板
---@class XEFilterContainer : XEUserNode
XEFilterContainer = {}


---@public XEFilterContainer_new00
---@return XEFilterContainer
function XEFilterContainer:new() end


---@type number @enum EGraphBuilderApplyOption
XEFilterContainer.GBA_NONE = 0


---@type number @enum EGraphBuilderApplyOption
XEFilterContainer.GBA_PRE_PROCESS = 0


---@type number @enum EGraphBuilderApplyOption
XEFilterContainer.GBA_POST_PROCESS = 0


---@type number @enum EGraphBuilderApplyOption
XEFilterContainer.GBA_CUSTOM_PROCESS = 0


---@type number @enum EGraphBuilderApplyOption
XEFilterContainer.GBA_CUSTOM_AND_PRE_PROCESS = 0


---@type number @enum EGraphBuilderApplyOption
XEFilterContainer.GBA_ALL = 0


---@public 初始化
---@param strAssetPath string
---@return void
function XEFilterContainer:Initialize(strAssetPath) end


---@public 获取滤镜资源路径
---@return string
function XEFilterContainer:GetAssetPath() end


---@public 更新滤镜资源路径
---@param szAssetPath string
---@return void
function XEFilterContainer:UpdateFileAssetPath(szAssetPath) end


---@public 设置是否修改
---@param bSet boolean
---@return void
function XEFilterContainer:SetModified(bSet) end


---@public 是否修改
---@return boolean
function XEFilterContainer:IsModified() end


---@public 使滤镜节点图应用选项（注册到引擎滤镜图中）
---@param option number 要生效的图构建对象应用选项
---@return void
function XEFilterContainer:SetGraphBuilderApplyOption(option) end


---@public 获取图构建选项
---@return number
function XEFilterContainer:GetGraphBuilderApplyOption() end


---@public 前、后、手动处理构建图是否应用
---@return boolean
function XEFilterContainer:IsPreprocessApplyOptionValid() end


---@public XEFilterContainer_IsPostprocessApplyOptionValid00
---@return boolean
function XEFilterContainer:IsPostprocessApplyOptionValid() end


---@public XEFilterContainer_IsCustomprocessApplyOptionValid00
---@return boolean
function XEFilterContainer:IsCustomprocessApplyOptionValid() end


---@public 前、后、手动处理构建图是否应用
---@param pFilterParentNode XEUserNode 父节点
---@param pFilterTl string 滤镜模板类型名，如果为空，则创建XEFilter类型的节点
---@return XEFilter 创建的滤镜模板节点
function XEFilterContainer:CreateFilter(pFilterParentNode, pFilterTl) end


---@public XEFilterContainer_GetTypeName00
---@return string
function XEFilterContainer:GetTypeName() end


---@type string @readonly 
XEFilterContainer.NODE_TYPENAME = ''


---@type string @readonly 
XEFilterContainer.SUFFIX = ''


