---@class XEFilterUnitInjector
XEFilterUnitInjector = {}


---@type number @enum eFilterUnitType
XEFilterUnitInjector.FUT_COMMON = 0


---@type number @enum eFilterUnitType
XEFilterUnitInjector.FUT_MAKEUP_EYEBROW = 0


---@type number @enum eFilterUnitType
XEFilterUnitInjector.FUT_MAKEUP_PUPIL = 0


---@type number @enum eFilterUnitType
XEFilterUnitInjector.FUT_MAKEUP_EYEZONE = 0


---@type number @enum eFilterUnitType
XEFilterUnitInjector.FUT_MAKEUP_LIPS = 0


---@type number @enum eFilterUnitType
XEFilterUnitInjector.FUT_MAKEUP_CHEEK_RED = 0


---@type number @enum eFilterUnitType
XEFilterUnitInjector.FUT_MAKEUP_SHADOW = 0


---@type number @enum eFilterUnitType
XEFilterUnitInjector.FUT_FACESHAPE_EYE = 0


---@type number @enum eFilterUnitType
XEFilterUnitInjector.FUT_FACESHAPE_FACE = 0


---@type number @enum eFilterUnitType
XEFilterUnitInjector.FUT_BEAUTI_WHITENING = 0


---@type number @enum eFilterUnitType
XEFilterUnitInjector.FUT_BEAUTI_SMOOTHING = 0


---@type number @enum eFilterUnitType
XEFilterUnitInjector.FUT_LOOKUP = 0


---@type number @enum eFilterUnitType
XEFilterUnitInjector.FUT_FRAME_TRANSFORM_BACKGROUND_ONLY = 0


---@type number @enum eFilterUnitType
XEFilterUnitInjector.FUT_FRAME_TRANSFORM_USER_TEXTURE_ONLY = 0


---@type number @enum eFilterUnitType
XEFilterUnitInjector.FUT_FRAME_TRANSFORM_BLEND_BACKGROUND_USER_TEXTURE = 0


---@type number @enum eFilterUnitType
XEFilterUnitInjector.FUT_MAGIC_FILTER_FX = 0


---@public XEFilterUnitInjector_new00
---@return XEFilterUnitInjector
function XEFilterUnitInjector:new() end


---@type number @enum eInjectMode
XEFilterUnitInjector.INM_MERGE = 0


---@type number @enum eInjectMode
XEFilterUnitInjector.INM_STANDALONE = 0


---@public 释放资源
---@return void
function XEFilterUnitInjector:Release() end


---@public 设置当前Actor及关联滤镜节点的名称
---@param szActorName string
---@param pContext XEWorld
---@return boolean
function XEFilterUnitInjector:OnActorNameUpdate(szActorName, pContext) end


---@public 将外部任意滤镜节点实例添加到指定滤镜链Actor if eOption is INO_SPECIFIC, then nInjectToIndex is in use.
---@param pFilterIns XEFilterInstance 任意滤镜节点实例
---@param pFilterChainBuilder XEFilterChainBuilder 表示要添加到的滤镜链构建器
---@param eOption number
---@param nInjectToIndex number 当eOption为INO_SPECIFIC有效，表示添加滤镜节点的位置
---@param bRebuildChain boolean
---@return boolean 是否成功
function XEFilterUnitInjector:InjectToFilterChainBuilder(pFilterIns, pFilterChainBuilder, eOption, nInjectToIndex, bRebuildChain) end


---@public 从原始滤镜链Actor上移除当前关联的滤镜节点
---@return boolean
function XEFilterUnitInjector:TakeOutFromFilterChainBuilder() end


---@public 绑定的滤镜链Actor是否存在于世界
---@return boolean
function XEFilterUnitInjector:IsValidInWorld() end


---@public 设置滤镜类型，并构建具体的滤镜模板和实例
---@param fut number
---@return void
function XEFilterUnitInjector:SetFilterUnitType(fut) end


---@public 获取滤镜类型
---@return number
function XEFilterUnitInjector:GetFilterUnitType() end


---@public 设置所属的Actor
---@param pActor XEActor
---@return void
function XEFilterUnitInjector:SetActorOwner(pActor) end


---@public 获取所属的Actor
---@return XEActor
function XEFilterUnitInjector:GetActorOwner() end


---@public 获取滤镜链构建器
---@return XEFilterChainBuilder
function XEFilterUnitInjector:GetFilterChainBuilder() end


---@public 获取滤镜模板
---@return XEFilter
function XEFilterUnitInjector:GetFilterTemplate() end


---@public 获取滤镜实例
---@return XEFilterInstance
function XEFilterUnitInjector:GetFilterInstance() end


---@public 创建一些默认类型的滤镜，如美白磨皮
---@return void
function XEFilterUnitInjector:SetupFilterDetails() end


---@public 设置滤镜注入模式
---@param im number
---@return void
function XEFilterUnitInjector:SetFilterInjectMode(im) end


---@public 获取滤镜注入模式
---@return number
function XEFilterUnitInjector:GetFilterInjectMode() end


---@public 应用滤镜注入模式（产生滤镜图构建器）
---@param option number
---@param bRebuildChain boolean
---@return void
function XEFilterUnitInjector:ApplyFilterInjectMode(option, bRebuildChain) end


