---本类代表用于构建引擎节点图结构的处理器
---@class XEGraphBuilderProcess
XEGraphBuilderProcess = {}


---@public 重设渲染图
---@return void
function XEGraphBuilderProcess:ResetupImageEffectGraph() end


---@public 释放引擎滤镜渲染图结构
---@return void
function XEGraphBuilderProcess:ClearGraph() end


---@public 重新构建引擎滤镜渲染图结构
---@return void
function XEGraphBuilderProcess:RebuildGraph() end


---@public 是否释放了引擎滤镜渲染图结构
---@return boolean
function XEGraphBuilderProcess:IsCleared() end


---@public 清空Primitive渲染Node
---@return void
function XEGraphBuilderProcess:ClearPrimitives() end


---本类代表 根据滤镜链节点生成对应滤镜渲染节点图的选择器（也称构建器） ，即根据滤镜节点生成渲染节点图
---@class XEGraphBuilderSelector
XEGraphBuilderSelector = {}


---@public XEGraphBuilderSelector_new00
---@return XEGraphBuilderSelector
function XEGraphBuilderSelector:new() end


---@public 根据滤镜链实例指针构建滤镜渲染图
---@param pContainerIns XEFilterContainerInstance 滤镜链实例对象
---@param eFilterNodeType number 表示滤镜链类型（前置、后置）
---@return boolean 是否创建成功
function XEGraphBuilderSelector:ReBuildGraphNodeFromFilterContainerIns(pContainerIns, eFilterNodeType) end


---@public 重新创建滤镜实例的渲染节点，本质上是重新创建材质实例
---@param pFilterIns XEFilterInstance 滤镜实例对象
---@return boolean 是否创建成功
function XEGraphBuilderSelector:ReBuildGraphNodeFromFilterIns(pFilterIns) end


---@public 清空/释放滤镜链实例指针对应的滤镜渲染图
---@param pContainerIns XEFilterContainerInstance 滤镜链实例对象
---@param eFilterNodeType number 表示滤镜链类型（前置、后置）
---@return void
function XEGraphBuilderSelector:ClearGraphNodeForFilterContainerIns(pContainerIns, eFilterNodeType) end


