---@class XEMagicCoreUtility
XEMagicCoreUtility = {}


---@type number @enum ETextureAssetType
XEMagicCoreUtility.TAT_NONE = 0


---@type number @enum ETextureAssetType 序列帧是由多个纹理组成，并且每个纹理代表一帧画面
XEMagicCoreUtility.TAT_MULT_TEXTURE_SINGLE_FRAME = 0


---@type number @enum ETextureAssetType 序列帧有一张纹理组成，此纹理包含m * n帧画面
XEMagicCoreUtility.TAT_SINGLE_TEXRTURE_MULT_FRAME = 0


---@type number @enum ETextureAssetType
XEMagicCoreUtility.TAT_NUM = 0


---@public XEMagicCoreUtility_GetTextureAssetType00
---@param eType number
---@return string
function XEMagicCoreUtility:GetTextureAssetType(eType) end


---@public XEMagicCoreUtility_GetTextureTypeByName00
---@param str string
---@return number
function XEMagicCoreUtility:GetTextureTypeByName(str) end


---@public XEMagicCoreUtility_ConvertScreenToWorld00
---@param pViewPort XViewport
---@param vScreenPos XVECTOR3
---@param vWorld XVECTOR3
---@return boolean
function XEMagicCoreUtility:ConvertScreenToWorld(pViewPort, vScreenPos, vWorld) end


---@public XEMagicCoreUtility_ConvertWorldToScreen00
---@param pViewPort XViewport
---@param vWorld XVECTOR3
---@param vScreenPos XVECTOR2
---@return boolean
function XEMagicCoreUtility:ConvertWorldToScreen(pViewPort, vWorld, vScreenPos) end


---@public XEMagicCoreUtility_ConvertToViewportPixelCenter00
---@param vRectSize XVECTOR2
---@param vNormalizeCenter XVECTOR2
---@return XVECTOR2
function XEMagicCoreUtility:ConvertToViewportPixelCenter(vRectSize, vNormalizeCenter) end


---@public XEMagicCoreUtility_ConvertToNormalizePixelCenter00
---@param vRectSize XVECTOR2
---@param vViewportPixelCenter XVECTOR2
---@return XVECTOR2
function XEMagicCoreUtility:ConvertToNormalizePixelCenter(vRectSize, vViewportPixelCenter) end


---@public 变换NDC顶点坐标（需要考虑投影变换）
---@param pViewport XEViewport
---@param ndcVerties XVECTOR3[]
---@param matNDC XMATRIX4
---@return XVECTOR3[]
function XEMagicCoreUtility:TransformNDCVertex(pViewport, ndcVerties, matNDC) end


---@public XEMagicCoreUtility_ConvertScreenToNDC00
---@param pViewport XEViewport
---@param vScreenPos XVECTOR3
---@return XVECTOR3
function XEMagicCoreUtility:ConvertScreenToNDC(pViewport, vScreenPos) end


---@public XEMagicCoreUtility_ConvertNDCToScreen00
---@param pViewport XEViewport
---@param vNDCPos XVECTOR3
---@return XVECTOR3
function XEMagicCoreUtility:ConvertNDCToScreen(pViewport, vNDCPos) end


---@public XEMagicCoreUtility_ConvertPixelToNDC00
---@param pViewport XEViewport
---@param vPixel XVECTOR3
---@return XVECTOR3
function XEMagicCoreUtility:ConvertPixelToNDC(pViewport, vPixel) end


---@public XEMagicCoreUtility_ConvertNDCToPixel00
---@param pViewport XEViewport
---@param vNDC XVECTOR3
---@return XVECTOR3
function XEMagicCoreUtility:ConvertNDCToPixel(pViewport, vNDC) end


---@public XEMagicCoreUtility_OnActorAttachToFaceTracker00
---@param pActor XEActor
---@return void
function XEMagicCoreUtility:OnActorAttachToFaceTracker(pActor) end


---@public XEMagicCoreUtility_GetTemplateSeqFrameAnimFileDir00
---@param pEngineIns  XEngineInstance
---@return string
function XEMagicCoreUtility:GetTemplateSeqFrameAnimFileDir(pEngineIns) end


---@type number @enum EFacePointNumType
XEMagicCoreUtility.EFPNT_96 = 0


---@type number @enum EFacePointNumType 104
XEMagicCoreUtility.EFPNT_104 = 0


---@type number @enum EFacePointNumType
XEMagicCoreUtility.EFPNT_137 = 0


---@public XEMagicCoreUtility_InitFaceTrackActorBaseInfo00
---@return void
function XEMagicCoreUtility:InitFaceTrackActorBaseInfo() end


---@type number @enum EFrameLoopMode
XEMagicCoreUtility.ELM_NONE = 0


---@type number @enum EFrameLoopMode
XEMagicCoreUtility.ELM_LOOP = 0


---@type number @enum EFrameLoopMode
XEMagicCoreUtility.ELM_NUM = 0


---@public XEMagicCoreUtility_GetAllLoopModeName00
---@return string[]
function XEMagicCoreUtility:GetAllLoopModeName() end


---@public XEMagicCoreUtility_GetLoopModeByName00
---@param strModeName string
---@return number
function XEMagicCoreUtility:GetLoopModeByName(strModeName) end


---@public 实时构建头部纹理（包含Alpha数据），请在桥接类里实现XEDecorationEnvBridgeBase::GetHeadTextureWithMaskBuffer
---@param nBufferID number 可能存在多组纹理缓存，因此需要指定纹理缓存的ID
---@param pBuildToTexture IXTexture2D 如果不为空,动态纹理将会更新数据,并储存到这里.请确保该纹理为动态纹理
---@return IXTexture2D 构建的头部纹理,包含Alpha数据
function XEMagicCoreUtility:BuildHeadTextureFromRGBAData(nBufferID, pBuildToTexture) end


---@public 实时构建头部Alpha纹理，请在桥接类里实现XEDecorationEnvBridgeBase::GetFaceMaskBuffer
---@param pBuildToTexture IXTexture2D 如果不为空,动态纹理将会更新数据,并储存到这里.请确保该纹理为动态纹理
---@return IXTexture2D 构建的头部Alpha纹理
function XEMagicCoreUtility:BuildFaceMaskTextureFromAlphaData(pBuildToTexture) end


---@public XEMagicCoreUtility_GetFaceScaleFactor00
---@param pFaceTrackerActor XEFaceTrackerActor
---@param pViewport XEViewport
---@param vViewportSize XVECTOR2
---@return XVECTOR3
function XEMagicCoreUtility:GetFaceScaleFactor(pFaceTrackerActor, pViewport, vViewportSize) end


---@public XEMagicCoreUtility_GetFaceScaleFactor01
---@param pFaceTrackerDataDriver XEFaceTrakcerDataDriver
---@param pViewport XEViewport
---@param vViewportSize XVECTOR2
---@return XVECTOR3
function XEMagicCoreUtility:GetFaceScaleFactor(pFaceTrackerDataDriver, pViewport, vViewportSize) end


