---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by HongjieFu.
--- DateTime: 2019/8/29 9:06 PM
---

---所有事件监听器的基类
---@class xes__EventListener
local xes__EventListener = {}

---数据事件监听器
---@class xes__DataEventListener : xes__EventListener
local xes__DataEventListener = {}
xe.DataEventListener = xes__DataEventListener

---@public 创建监听器
---@return xes__DataEventListener
function xes__EventListener:Create()
end

---@public 注册回调函数
---@param callback fun(sender:userdata, content:string):void 回调函数
---@param name string 数据名称
---@return void
function xes__DataEventListener:RegisterHandler(callback, name)
end

---手势事件监听器
---@class xes__GestureEventListenerV1 : xes__EventListener
local xes__GestureEventListenerV1 = {}
xe.GestureEventListenerV1 = xes__GestureEventListenerV1

---@public 创建监听器
---@return xes__GestureEventListenerV1
function xes__GestureEventListenerV1:Create()
end

---@public 注册回调函数
---其中callback 回调函数的param的类型会根据注册事件的不同而变化
---param可能包括的类型：
---
---GestureClickParam
---GestureMoveParam
---GestureMove2Param
---GesturePinchParam
---GestureRotate2Param
---
---@param callback fun(sender:userdata,param:any):void @回调函数 | "function(sender, param) end" |
---@param handler number | "xe.Handler.EVENT_GESTURE_CLICK" | "xe.Handler.EVENT_GESTURE_MOVE" | "xe.Handler.EVENT_GESTURE_MOVE2" | "xe.Handler.EVENT_GESTURE_PINCH" | "xe.Handler.EVENT_GESTURE_ROTATE2" |
---@return void
function xes__GestureEventListenerV1:RegisterHandler(callback, handler)
end