---@class XEDevice
XEDevice = {}


---@type number @enum NetworkType
XEDevice.NETWORK_TYPE_UNCONNECTED = 0


---@type number @enum NetworkType
XEDevice.NETWORK_TYPE_CALLULAR = 0


---@type number @enum NetworkType
XEDevice.NETWORK_TYPE_WIFI = 0


---@public 获取设备描述信息
---@return string
function XEDevice:GetDeviceInfo() end


---@public 获取设备型号
---@return string
function XEDevice:GetDeviceModel() end


---@public 获取操作系统版本
---@return string
function XEDevice:GetDeviceSystemVersion() end


---@public 获取应用包名
---@return string
function XEDevice:GetPackageName() end


---@public 获取应用名
---@return string
function XEDevice:GetAppName() end


---@public 获取CPU核心数
---@return number
function XEDevice:GetAvailableProcessors() end


---@public 获取网络状态
---@return number
function XEDevice:GetNetworkType() end


---@public 震动反馈
---@return void
function XEDevice:PerformHapticFeedback() end


---@public 获取应用存储目录
---Android  /data/data/< package name >/files/
---iOS NSHomeDirectory()
---@return string
function XEDevice:GetExternalFilesDir() end


