---@class XBaseTM
XBaseTM = {}


---@public XBaseTM_new00
---@return XBaseTM
function XBaseTM:new() end


---@public XBaseTM_new01
---@param qRot XQUATERNION
---@param vTrans XVECTOR3
---@param vScale XVECTOR3
---@return XBaseTM
function XBaseTM:new(qRot, vTrans, vScale) end


---@public XBaseTM_new02
---@param qRot XQUATERNION
---@param vTrans XVECTOR3
---@param vScale XVECTOR3
---@param vLocalScale XVECTOR3
---@return XBaseTM
function XBaseTM:new(qRot, vTrans, vScale, vLocalScale) end


---@public XBaseTM_new03
---@param mTM XMATRIX4
---@return XBaseTM
function XBaseTM:new(mTM) end


---@public 保存到文件
---@param pFile XFileBase 文件指针
---@return boolean 是否保存成功
function XBaseTM:Save(pFile) end


---@public 从文件中加载
---@param pFile XFileBase 文件指针
---@return boolean 是否加载成功
function XBaseTM:Load(pFile) end


---@public 设置平移信息
---@param vTrans XVECTOR3 平移信息
---@return void
function XBaseTM:SetTrans(vTrans) end


---@public 获取平移信息
---@return XVECTOR3 平移信息
function XBaseTM:GetTrans() end


---@public 设置缩放信息
---@param vScale XVECTOR3
---@return void
function XBaseTM:SetScale(vScale) end


---@public 获取缩放信息
---@return XVECTOR3 缩放信息
function XBaseTM:GetScale() end


---@public 设置本地缩放信息
---@param vScale XVECTOR3
---@return void
function XBaseTM:SetLocalScale(vScale) end


---@public 获取本地缩放信息
---@return XVECTOR3 缩放信息
function XBaseTM:GetLocalScale() end


---@public 获取旋转四元数信息
---@return XQUATERNION 旋转四元数信息
function XBaseTM:GetRotation() end


---@public 设置旋转四元数信息
---@param qRot XQUATERNION 旋转四元数信息
---@return void
function XBaseTM:SetRotation(qRot) end


---@public 转换当前位置、缩放、旋转信息到矩阵，并返回
---@return XMATRIX4 转换后的矩阵
function XBaseTM:CalculateTM() end


---@public 转换当前位置、缩放、旋转信息到矩阵，并在位移上叠加上级的一个缩放量，并返回结果矩阵； 一般为引擎内部使用的函数
---@param vParentLocalScale XVECTOR3
---@return XMATRIX4 转换后的矩阵
function XBaseTM:CalculateTM(vParentLocalScale) end


---@public 转换当前位置、缩放、旋转信息到矩阵，转换计算时不包含本地缩放信息； 一般为引擎内部使用的函数
---@return XMATRIX4 转换后的矩阵
function XBaseTM:CalculateInheritTM() end


---@public 转换当前位置、缩放、旋转信息到矩阵，并在位移上叠加上级的一个缩放量，转换计算时不包含本地缩放信息； 一般为引擎内部使用的函数
---@param vParentLocalScale XVECTOR3
---@return XMATRIX4 转换后的矩阵
function XBaseTM:CalculateInheritTM(vParentLocalScale) end


---@public 将矩阵转成位移、旋转、缩放信息，并覆盖到本结构中
---@param tmTransformMatrix XMATRIX4
---@return void
function XBaseTM:DecomposeTM(tmTransformMatrix) end


---@public 将当前位移、旋转、缩放信息进行逆运算。
---@return void
function XBaseTM:Inverse() end


---@public 获取当前位移、旋转、缩放的逆操作信息。
---@return XBaseTM 当前矩阵进行逆矩阵
function XBaseTM:GetInverse() end


---@public 获取单位化的位移、旋转、缩放信息
---@return  XBaseTM 单位化后的结构
function XBaseTM:GetIdentity() end


---@public 获取零矩阵
---@return  XBaseTM 零矩阵
function XBaseTM:GetZero() end


---@type XVECTOR3
XBaseTM.m_vTrans = {}


---@type XQUATERNION
XBaseTM.m_qRotation = {}


---@type XVECTOR3
XBaseTM.m_vLocalScale = {}


---@type XVECTOR3
XBaseTM.m_vScale = {}


