---@class XBoneControllerBase : XOwnerRecorder
XBoneControllerBase = {}


---@public XBoneControllerBase_new00
---@param pTargetBone XBone
---@return XBoneControllerBase
function XBoneControllerBase:new(pTargetBone) end


---@public ****************************************************************************
---/
---控制器更新骨头矩阵
---@param nDeltaTime number
---@param pTargetBone XBone
---@return XMATRIX4
---@return boolean true:执行成功
function XBoneControllerBase:Update(nDeltaTime, pTargetBone) end


---@public 获取下一个骨头控制器
---@return XBoneControllerBase 下一个骨头控制器
function XBoneControllerBase:GetNextController() end


---@public 设置下一个骨头控制器
---@param pController XBoneControllerBase 下一个骨头控制器
---@return void
function XBoneControllerBase:SetNextController(pController) end


---@public 获取控制器控制的目标骨头
---@return XBone 目标骨头
function XBoneControllerBase:GetTargetBone() end


---@public 获取控制器矩阵信息
---@return XMATRIX4 控制器矩阵信息
function XBoneControllerBase:GetControllerMatrix() end


---@public 设置用户扩展参数
---@param key string 键
---@param value number 值
---@return void
function XBoneControllerBase:SetUserData(key, value) end


---@public XBoneControllerBase_GetUserData00
---@param key string
---@return number
---@return boolean
function XBoneControllerBase:GetUserData(key) end


---@class XBoneScaleController : XBoneControllerBase
XBoneScaleController = {}


---@public XBoneScaleController_new00
---@param pTargetBone XBone
---@return XBoneScaleController
function XBoneScaleController:new(pTargetBone) end


---@public ****************************************************************************
---/
---控制器更新骨头矩阵
---@param nDeltaTime number
---@param pTargetBone XBone
---@return XMATRIX4
---@return boolean true:执行成功
function XBoneScaleController:Update(nDeltaTime, pTargetBone) end


---@public 缩放骨头
---@param scale XVECTOR3 缩放信息
---@param nTransTime number 执行缩放的时刻
---@return boolean 是否执行成功
function XBoneScaleController:Scale(scale, nTransTime) end


---@class XBoneLocalScaleController : XBoneScaleController
XBoneLocalScaleController = {}


---@public XBoneLocalScaleController_new00
---@param pTargetBone XBone
---@return XBoneLocalScaleController
function XBoneLocalScaleController:new(pTargetBone) end


---@public ****************************************************************************
---/
---控制器更新骨头矩阵
---@param nDeltaTime number
---@param pTargetBone XBone
---@return XMATRIX4
---@return boolean true:执行成功
function XBoneLocalScaleController:Update(nDeltaTime, pTargetBone) end


---@class XBoneRotController : XBoneControllerBase
XBoneRotController = {}


---@public XBoneRotController_new00
---@param pTargetBone XBone
---@return XBoneRotController
function XBoneRotController:new(pTargetBone) end


---@public ****************************************************************************
---/
---控制器更新骨头矩阵
---@param nDeltaTime number
---@param pTargetBone XBone
---@return XMATRIX4
---@return boolean true:执行成功
function XBoneRotController:Update(nDeltaTime, pTargetBone) end


---@public 设置骨头旋转值，以及旋转时间，更新时会按时间一步步，步进到此旋转值
---@param qu XQUATERNION 旋转四元数信息
---@param nTransTime number 旋转的时刻
---@return boolean 是否设置成功
function XBoneRotController:Rotate(qu, nTransTime) end


---@class XBonePosController : XBoneControllerBase
XBonePosController = {}


---@public XBonePosController_new00
---@param pTargetBone XBone
---@return XBonePosController
function XBonePosController:new(pTargetBone) end


---@public ****************************************************************************
---/
---控制器更新骨头矩阵
---@param nDeltaTime number
---@param pTargetBone XBone
---@return XMATRIX4
---@return boolean true:执行成功
function XBonePosController:Update(nDeltaTime, pTargetBone) end


---@public 设置骨头平移值，以及平移时间，更新时会按时间一步步，步进到此平移值
---@param vecPos XVECTOR3 平移信息
---@param nTransTime number 执行平移的时刻
---@return boolean 是否设置成功
function XBonePosController:Move(vecPos, nTransTime) end


---@class XBoneMatrixController : XBoneControllerBase
XBoneMatrixController = {}


---@public XBoneMatrixController_new00
---@param pTargetBone XBone
---@return XBoneMatrixController
function XBoneMatrixController:new(pTargetBone) end


---@public ****************************************************************************
---/
---控制器更新骨头矩阵
---@param nDeltaTime number
---@param pTargetBone XBone
---@return XMATRIX4
---@return boolean true:执行成功
function XBoneMatrixController:Update(nDeltaTime, pTargetBone) end


---@public 设置骨头叠加矩阵信息，以及叠加的时间，更新时会按时间一步步步进到此矩阵值
---@param mat XMATRIX4 矩阵信息
---@param nTransTime number 时间值
---@return boolean 是否设置成功
function XBoneMatrixController:CombineMatrix(mat, nTransTime) end


---@public 设置骨头叠加矩阵信息列表，以及各叠加矩阵的时间，更新时会按时间一步步，步进到时间对应的矩阵值
---@param mats XMATRIX4
---@param weights number
---@param nNumMat number
---@param nTransTime number
---@return boolean
function XBoneMatrixController:CombineMatrixList(mats, weights, nNumMat, nTransTime) end


---@class XBoneWorldRotController : XBoneControllerBase
XBoneWorldRotController = {}


---@public XBoneWorldRotController_new00
---@param pTargetBone XBone
---@return XBoneWorldRotController
function XBoneWorldRotController:new(pTargetBone) end


---@public 设置旋转欧拉角信息
---@param vEuler XVECTOR3 旋转欧拉角信息
---@return void
function XBoneWorldRotController:SetRotRadian(vEuler) end


---@class XBoneWorldMatController : XBoneControllerBase
XBoneWorldMatController = {}


---@public XBoneWorldMatController_new00
---@param pTargetBone XBone
---@return XBoneWorldMatController
function XBoneWorldMatController:new(pTargetBone) end


---@public 设置旋转欧拉角信息
---@param vEuler XVECTOR3 旋转欧拉角信息
---@return void
function XBoneWorldMatController:SetRotRadian(vEuler) end


---@public 设置平移信息
---@param vPosition XVECTOR3 平移信息
---@return void
function XBoneWorldMatController:SetTranslate(vPosition) end


---@public 设置缩放信息
---@param vScale XVECTOR3 缩放信息
---@return void
function XBoneWorldMatController:SetScale(vScale) end


