---@class IXBrushPrimitive : IXPrimitiveBase
IXBrushPrimitive = {}


---@type number @enum TEXCOORDMODE 在两个顶点平铺一次
IXBrushPrimitive.TM_VERTEX = 0


---@type number @enum TEXCOORDMODE 一个Shape平铺一次
IXBrushPrimitive.TM_SHAPE = 0


---@type number @enum TEXCOORDMODE 一个ShapeGroup平铺一次
IXBrushPrimitive.TM_SHAPEGROUP = 0


---@public IXBrushPrimitive_new00
---@return IXBrushPrimitive
function IXBrushPrimitive:new() end


---@public 为画刷添加一个路径点
---@param vPoint XVECTOR3 路径点的位置
---@return void
function IXBrushPrimitive:AddPathPoint(vPoint) end


---@public 开始一段新的路径
---@return void
function IXBrushPrimitive:NewPath() end


---@public 获取路径个数
---@return number 路径的个数
function IXBrushPrimitive:GetPathNum() end


---@public 获取某条路径上路径点的个数
---@param nPathIndex number
---@return number 路径点的个数,索引错误返回-1
function IXBrushPrimitive:GetPathPointsNum(nPathIndex) end


---@public 根据索引获取路径点位置
---@param nIndex number 路径点的索引
---@param nPathIndex number
---@return XVECTOR3
---@return boolean 路径点不存在返回xfalse,存在返回xtrue
function IXBrushPrimitive:GetPathPoint(nIndex, nPathIndex) end


---@public 获取指定的整条路径
---@param nPathIndex number 路径的索引
---@return XVECTOR3[] 包含所有路径点的数组
function IXBrushPrimitive:GetPath(nPathIndex) end


---@public 获取指定的整条路径，安全版，效率较低
---@param nPathIndex number 路径的索引
---@return XVECTOR3[]
---@return boolean 路径不存在返回xfalse,存在返回xtrue
function IXBrushPrimitive:GetPath(nPathIndex) end


---@public 移除所有路径点
---@return void
function IXBrushPrimitive:RemoveAllPathPoints() end


---@public 获取ShapeGroup
---@return XBrushShape[] ShapeGroup
function IXBrushPrimitive:GetShapeGroup() end


---@public 获取画刷的材质实例
---@return IXMaterialInstance 画刷材质实例指针
function IXBrushPrimitive:GetMaterialInstance() end


---@public 设置画刷颜色
---@param color  XCOLORBASE 画刷颜色
---@return void
function IXBrushPrimitive:SetColor(color) end


---@public 获取画刷当前的颜色
---@return  XCOLORBASE 画刷当前颜色
function IXBrushPrimitive:GetColor() end


---@public 设置平滑角度，两段路径之间角度的cos值小于该值时会生成额外的顶点用于平滑
---@param fCosAngle number
---@return void
function IXBrushPrimitive:SetSmoothAngle(fCosAngle) end


---@public 获取平滑角度
---@return number 角度Cos阈值
function IXBrushPrimitive:GetSmoothAngle() end


---@class IXBrushManager : XOwnerRecorder
IXBrushManager = {}


---@class IXBrushManager__BrushInitParam
local IXBrushManager__BrushInitParam = {}
IXBrushManager.BrushInitParam = IXBrushManager__BrushInitParam


---@public IXBrushManager_BrushInitParam_new00
---@return IXBrushManager__BrushInitParam
function IXBrushManager__BrushInitParam:new() end


---@type XBrushShape[]
IXBrushManager__BrushInitParam.brushGroup = {}


---@type string @readonly 
IXBrushManager__BrushInitParam.szMtlPath = ''


---@type number
IXBrushManager__BrushInitParam.eTexcoordMode = 0


---@type XCOLORBASE
IXBrushManager__BrushInitParam.color = {}


---@public 创建一个画刷
---@param param  IXBrushManager::BrushInitParam
---@return IXBrushPrimitive 如果创建失败,返回NULL
function IXBrushManager:CreateBrush(param) end


---@public 设置路径点之间的最小间隔,默认是0.1
---@param fDistance number
---@return void
function IXBrushManager:SetPathPointMinDistance(fDistance) end


---@public 获取路径点之间的最小间隔
---@return number 路径点之间的最小间隔,默认是0.1
function IXBrushManager:GetPathPointMinDistance() end


---@public 设置纹理的重复距离
---@param fDistance number 纹理的重复距离.默认是1.0，最小是0.1
---@return void
function IXBrushManager:SetTexcoordLoopDistance(fDistance) end


---@public 获取纹理的重复距离
---@return number 纹理的重复距离.默认是1.0，最小是0.1
function IXBrushManager:GetTexcoordLoopDistance() end


