---@class XRenderSystemCaptureParameter
XRenderSystemCaptureParameter = {}


---@public XRenderSystemCaptureParameter_new00
---@return XRenderSystemCaptureParameter
function XRenderSystemCaptureParameter:new() end


---@type boolean
XRenderSystemCaptureParameter.bCapture = false


---@type number Data, x, y, nWidth, nHeight
XRenderSystemCaptureParameter.x = 0


---@type number
XRenderSystemCaptureParameter.y = 0


---@type number
XRenderSystemCaptureParameter.nWidth = 0


---@type number
XRenderSystemCaptureParameter.nHeight = 0


---@type boolean true if gl format, false if metal/dx format
XRenderSystemCaptureParameter.LeftBottomAsOrigin = false


---@class IXRenderSystemBase : XOwnerRecorder
IXRenderSystemBase = {}


---@public IXRenderSystemBase_new00
---@return IXRenderSystemBase
function IXRenderSystemBase:new() end


---@public 初始化
---@param pParam  XRenderSystemInitializeParameter
---@return boolean 是否初始化成功
function IXRenderSystemBase:Init(pParam) end


---@public 释放资源
---@return void
function IXRenderSystemBase:Release() end


---@public 渲染系统参数
---@param renderParam  XRenderSystemParameter 系统渲染参数
---@return void
function IXRenderSystemBase:RenderSystemRender(renderParam) end


---@public IXRenderSystemBase_FramePresent00
---@return void
function IXRenderSystemBase:FramePresent() end


---@public 渲染系统参数
---@param captureParam  XRenderSystemCaptureParameter 渲染参数
---@return void
function IXRenderSystemBase:SetFrameCapture(captureParam) end


---@public 获取是否支持某种纹理格式
---@param nFmtFlag number 纹理格式标签值
---@return boolean 是否支持
function IXRenderSystemBase:CanSupportTexFormat(nFmtFlag) end


---@public 获取当前纹理格式
---@return number 纹理格式标签值
function IXRenderSystemBase:GetCurTexFormat() end


---@public 获取渲染器类型
---@return number 渲染器类型
function IXRenderSystemBase:GetRendererType() end


---@public 获取引擎渲染到纹理时，纹理对应的索引，opengl环境下是纹理的opengl索引值
---@return number 渲染到纹理时，纹理对应索引
function IXRenderSystemBase:GetRTTID() end


---@public IXRenderSystemBase_GetRTFID00
---@return number
function IXRenderSystemBase:GetRTFID() end


---@public 调整窗口大小
---@param pWin IXPlatformWindow 要调整的窗口对象
---@return void
function IXRenderSystemBase:ResizeWindow(pWin) end


---@public 创建渲染窗口
---@param pWin IXPlatformWindow 渲染窗口
---@return boolean 是否创建成功
function IXRenderSystemBase:CreateRenderWindow(pWin) end


---@public 销毁渲染窗口
---@param pWin IXPlatformWindow 将被销毁的窗口
---@return boolean 如果成功销毁，返回xtrue
function IXRenderSystemBase:DestroyRenderWindow(pWin) end


---@public 切换pWin为当前渲染的窗口
---@param pWin IXPlatformWindow
---@return boolean 如果切换成功，返回xtrue
function IXRenderSystemBase:SwitchCurRenderWindow(pWin) end


---@public 获取当前渲染窗口
---@return IXPlatformWindow 当前渲染窗口
function IXRenderSystemBase:GetCurRenderWindow() end


---@public IXRenderSystemBase_RegisterImageEffectProcessor00
---@param pProcessor XImageEffectProcessor
---@return void
function IXRenderSystemBase:RegisterImageEffectProcessor(pProcessor) end


---@public IXRenderSystemBase_DeregisterImageEffectProcessor00
---@param pProcessor XImageEffectProcessor
---@return void
function IXRenderSystemBase:DeregisterImageEffectProcessor(pProcessor) end


---@public IXRenderSystemBase_GetImageEffectProcessor00
---@return XImageEffectProcessor
function IXRenderSystemBase:GetImageEffectProcessor() end


---@class IXRenderStatGroup : XStatGroup
IXRenderStatGroup = {}


---@type XStatCounterImmediate
IXRenderStatGroup.m_drawCallNum = {}


---@type XStatCounterImmediate
IXRenderStatGroup.m_triangleNum = {}


---@type XCycleCounterAverage
IXRenderStatGroup.m_sceneSetupTime = {}


---@type XCycleCounterAverage
IXRenderStatGroup.m_shadowMapRenderTime = {}


---@type XCycleCounterAverage
IXRenderStatGroup.m_opaqueRenderTime = {}


---@type XCycleCounterAverage
IXRenderStatGroup.m_translucentRenderTime = {}


---@type XCycleCounterAverage
IXRenderStatGroup.m_waterRenderTime = {}


---@type XCycleCounterAverage
IXRenderStatGroup.m_postprocessTime = {}


---@type XCycleCounterAverage
IXRenderStatGroup.m_UIRenderTime = {}


