---@class XViewport
XViewport = {}


---@public XViewport_new00
---@return XViewport
function XViewport:new() end


---@public 初始化
---@param pViewPortParam XVIEWPORTPARAMETER [类型][XVIEWPORTPARAMETER]视口参数
---@return boolean [类型][xbool]是否初始化成功
function XViewport:Init(pViewPortParam) end


---@public 释放当前视口中的资源
---@return boolean [类型][xbool]是否释放成功
function XViewport:Release() end


---@public 设置视口参数
---@param pViewPortParam XVIEWPORTPARAMETER [类型][XVIEWPORTPARAMETER]视口参数
---@return boolean [类型][xbool]是否初始化成功
function XViewport:SetParam(pViewPortParam) end


---@public XViewport_TransformWorldToScreen00
---@param vWorldPoint XVECTOR3
---@return XVECTOR3
---@return boolean
function XViewport:TransformWorldToScreen(vWorldPoint) end


---@public XViewport_InvTransformScreenToWorld00
---@param vScreePoint XVECTOR3
---@return XVECTOR3
---@return boolean
function XViewport:InvTransformScreenToWorld(vScreePoint) end


---@public 给当前视口设置相机
---@param pCamera XBaseCamera [类型][XBaseCamera]相机指针
---@return boolean [类型][xbool]是否设置成功
function XViewport:SetCamera(pCamera) end


---@public 获取当前视口参数
---@return XVIEWPORTPARAMETER [类型][XVIEWPORTPARAMETER]当前视口参数
function XViewport:GetViewportParam() end


---@public 获取当前视口相机
---@return XBaseCamera [类型][XBaseCamera]当前视口相机
function XViewport:GetCamera() end


---@public 获取当前视口缩放矩阵
---@return XMATRIX4 [类型][XMATRIX4]视口缩放矩阵
function XViewport:GetViewScale() end


---@public 获取当前视口背景清除色
---@return number [类型][XCOLOR]视口背景清除色
function XViewport:GetClearColor() end


---@public 设置当前视口背景清除色
---@param clearColor number [类型][XCOLOR]视口背景清除色
---@return void
function XViewport:SetClearColor(clearColor) end


---@public 设置是否启用当前视口背景清除色
---@param bClearColor boolean [类型][xbool]是否启用视口背景清除色
---@return void
function XViewport:EnableClearColor(bClearColor) end


---@public 判断是否启用当前视口背景清除色
---@return boolean [类型][xbool]是否启用视口背景清除色
function XViewport:IsClearColor() end


---@public XViewport_EnableSwapBuffers00
---@param bSwapBuffers boolean
---@return void
function XViewport:EnableSwapBuffers(bSwapBuffers) end


---@public XViewport_IsSwapBuffers00
---@return boolean
function XViewport:IsSwapBuffers() end


