---@class XCameraViewFrustum
XCameraViewFrustum = {}


---@type number @enum 
XCameraViewFrustum.XVF_LEFT = 0


---@type number @enum 
XCameraViewFrustum.XVF_RIGHT = 0


---@type number @enum 
XCameraViewFrustum.XVF_TOP = 0


---@type number @enum 
XCameraViewFrustum.XVF_BOTTOM = 0


---@type number @enum 
XCameraViewFrustum.XVF_NEAR = 0


---@type number @enum 
XCameraViewFrustum.XVF_FAR = 0


---@public XCameraViewFrustum_new00
---@return XCameraViewFrustum
function XCameraViewFrustum:new() end


---@public XCameraViewFrustum_new01
---@param frustum  XCameraViewFrustum
---@return XCameraViewFrustum
function XCameraViewFrustum:new(frustum) end


---@public 初始化
---@param iNumPlane number 平面个数
---@return boolean 是否初始化成功
function XCameraViewFrustum:Init(iNumPlane) end


---@public 初始化
---@param pCamera XBaseCamera 相机对象
---@param fVLeft number 左平面到相机的距离
---@param fVTop number 上平面到相机的距离
---@param fVRight number 右平面到相机的距离
---@param fVBottom number 底平面到相机的距离
---@param bZClip boolean 远平面到相机的距离
---@return boolean 是否初始化成功
function XCameraViewFrustum:Init(pCamera, fVLeft, fVTop, fVRight, fVBottom, bZClip) end


---@public 初始化
---@param pView XViewport 视口对象
---@param iSLeft number 左平面到相机的距离
---@param iSTop number 上平面到相机的距离
---@param iSRight number 右平面到相机的距离
---@param iSBottom number 底平面到相机的距离
---@param bZClip boolean 远平面到相机的距离
---@return boolean 是否初始化成功
function XCameraViewFrustum:Init(pView, iSLeft, iSTop, iSRight, iSBottom, bZClip) end


---@public 释放
---@return void
function XCameraViewFrustum:Release() end


---@public 添加裁剪面
---@param ClipCusPlane  XCusSPlane 裁剪面信息
---@return boolean 是否添加成功
function XCameraViewFrustum:AddClipPlane(ClipCusPlane) end


---@public 添加裁剪面
---@param vPanelNormal XVECTOR3 裁剪面法向量
---@param fDistance number 裁剪面距离原点距离
---@return boolean 是否添加成功
function XCameraViewFrustum:AddClipPlane(vPanelNormal, fDistance) end


---@public 判断AABB包围盒是否在相机视椎体内
---@param vMins XVECTOR3 AABB包围盒“最小”点
---@param vMaxs XVECTOR3 AABB包围盒“最大”点
---@return number 返回1：AABB完全在视椎体内；返回0：AABB与视椎体相交；返回-1：AABB在视椎体外部
function XCameraViewFrustum:IsAABBInViewFrustum(vMins, vMaxs) end


---@public 判断AABB包围盒是否在相机视椎体内
---@param cusAABB  XCusAABB AABB包围盒信息
---@return number 返回1：AABB完全在视椎体内；返回0：AABB与视椎体相交；返回-1：AABB在视椎体外部
function XCameraViewFrustum:IsAABBInViewFrustum(cusAABB) end


---@public 判断球形是否在相机视椎体内
---@param vSphereCenter XVECTOR3 球形中心点坐标
---@param fSphereRadius number 球形半径
---@return number 返回1：球形完全在视椎体内；返回0：球形与视椎体相交；返回-1：球形在视椎体外部
function XCameraViewFrustum:IsSphereInViewFrustum(vSphereCenter, fSphereRadius) end


---@public 判断点是否在相机视椎体内
---@param vPoint XVECTOR3 指定点坐标
---@return boolean 如果在，返回xtrue，否则返回false.
function XCameraViewFrustum:IsPointInViewFrustum(vPoint) end


---@public 获取某个裁剪平面对象指针
---@param iPanelIndex number 裁剪面索引
---@return XCusSPlane 裁剪面对象指针
function XCameraViewFrustum:GetTemporaryPlanePointer(iPanelIndex) end


---@public 获取裁剪面个数
---@return number 裁剪面个数
function XCameraViewFrustum:GetClipPlaneNum() end


---@public 设置指定裁剪面是否有效
---@param iPanelIndex number 裁剪面索引
---@param bEnable boolean 设置是否有效
---@return void
function XCameraViewFrustum:EnableClipPlane(iPanelIndex, bEnable) end


---@public 判断指定裁剪面是否有效
---@param iPanelIndex number 裁剪面索引
---@return boolean 是否有效
function XCameraViewFrustum:IsClipPlaneEnable(iPanelIndex) end


