---@class XEngineInstance
XEngineInstance = {}


---@public XEngineInstance_FrameRender00
---@param pViewport XViewport
---@return void
function XEngineInstance:FrameRender(pViewport) end


---@public XEngineInstance_FramePresent00
---@return void
function XEngineInstance:FramePresent() end


---@public 设置是否渲染引擎调试信息
---@param bShow boolean 是否显示调试信息
---@param pszGroupNames string 调试信息的组名，为NULL时，显示所有调试信息
---@return void
function XEngineInstance:ShowPerfInfos(bShow, pszGroupNames) end


---@public XEngineInstance_StatsFrame00
---@param nStartXPos number
---@param nStartYPos number
---@return void
function XEngineInstance:StatsFrame(nStartXPos, nStartYPos) end


---@public XEngineInstance_StatsFrame01
---@param nStartXPos number
---@param nStartYPos number
---@param groupColor XCOLORBASE
---@return void
function XEngineInstance:StatsFrame(nStartXPos, nStartYPos, groupColor) end


---@public XEngineInstance_StatsFrame02
---@param nStartXPos number
---@param nStartYPos number
---@param groupColor XCOLORBASE
---@param statColor XCOLORBASE
---@return void
function XEngineInstance:StatsFrame(nStartXPos, nStartYPos, groupColor, statColor) end


---@public 获取引擎渲染到纹理时，纹理对应的索引，opengl环境下是纹理的opengl索引值
---@return number 渲染到纹理时，纹理对应索引
function XEngineInstance:GetRTTID() end


---@public 调整渲染窗口大小
---@param pWin IXPlatformWindow 要调整的渲染窗口指针
---@return void
function XEngineInstance:ResizeRenderWindow(pWin) end


---@public 重新加载资源
---@param strFilePath string 加载的资源路径
---@return void
function XEngineInstance:ReloadResource(strFilePath) end


---@public 资源是否已被加载
---@param strFilePath string 资源路径
---@return boolean
function XEngineInstance:IsResourceLoaded(strFilePath) end


---@public XEngineInstance_GetBaseDir00
---@return string
function XEngineInstance:GetBaseDir() end


---@public 获取LibraryDir
---@return string LibraryDir
function XEngineInstance:GetLibraryDir() end


---@public 根据索引获取LibraryDir
---@param nIndex number
---@return string LibraryDir
function XEngineInstance:GetLibraryDir(nIndex) end


---@manual 获取所有的LibraryDir
---@public XEngineInstance_GetLibraryDirs_manual
---@return  XArray<XArray<char> >
function XEngineInstance:GetLibraryDirs() end


---@public 添加一个LibraryDir
---@param szLibraryDir string
---@return void
function XEngineInstance:AddLibraryDir(szLibraryDir) end


---@public XEngineInstance_RemoveLibraryDir00
---@param nIndex number
---@return void
function XEngineInstance:RemoveLibraryDir(nIndex) end


---@public XEngineInstance_RemoveLibraryDir01
---@param szLibraryDir string
---@return void
function XEngineInstance:RemoveLibraryDir(szLibraryDir) end


---@public XEngineInstance_GetDocumentDir00
---@return string
function XEngineInstance:GetDocumentDir() end


---@public XEngineInstance_GetPlatformWindow00
---@return IXPlatformWindow
function XEngineInstance:GetPlatformWindow() end


---@public XEngineInstance_SetPlatformWindow00
---@param pWindow IXPlatformWindow
---@return void
function XEngineInstance:SetPlatformWindow(pWindow) end


---@public XEngineInstance_GetMaterialManager00
---@return IXMaterialManager
function XEngineInstance:GetMaterialManager() end


---@public XEngineInstance_GetUserMaterialManager00
---@return IXMaterialManager
function XEngineInstance:GetUserMaterialManager() end


---@public XEngineInstance_GetLightManager00
---@return IXLightManager
function XEngineInstance:GetLightManager() end


---@public XEngineInstance_GetTextureManager00
---@return IXTextureManager
function XEngineInstance:GetTextureManager() end


---@public XEngineInstance_GetBrushManager00
---@return IXBrushManager
function XEngineInstance:GetBrushManager() end


---@public XEngineInstance_GetRenderer00
---@return IXRenderSystemBase
function XEngineInstance:GetRenderer() end


---@public XEngineInstance_GetModelManager00
---@return IXModelManager
function XEngineInstance:GetModelManager() end


---@public XEngineInstance_GetCanvasBase00
---@return IXCanvasBase
function XEngineInstance:GetCanvasBase() end


---@public XEngineInstance_GetConVarSys00
---@return IXConVarSys
function XEngineInstance:GetConVarSys() end


---@public XEngineInstance_GetAnimationManager00
---@return IXAnimationManager
function XEngineInstance:GetAnimationManager() end


---@public XEngineInstance_GetFxManager00
---@return IFxManager
function XEngineInstance:GetFxManager() end


---@public XEngineInstance_Get2DPhysicalManager00
---@return IX2DPhysicalManager
function XEngineInstance:Get2DPhysicalManager() end


---@public XEngineInstance_GetPhysicalManager00
---@return IXPhysicalManager
function XEngineInstance:GetPhysicalManager() end


---@public XEngineInstance_GetUIManager00
---@return IXUIManager
function XEngineInstance:GetUIManager() end


---@public XEngineInstance_GetGestureManager00
---@return XGestureManager
function XEngineInstance:GetGestureManager() end


---@public XEngineInstance_GetAudioManager00
---@return IXAudioEngine
function XEngineInstance:GetAudioManager() end


---@public XEngineInstance_GetEngineInstanceID00
---@return number
function XEngineInstance:GetEngineInstanceID() end


