---@class XOrthoCamera : XBaseCamera
XOrthoCamera = {}


---@public XOrthoCamera_new00
---@return XOrthoCamera
function XOrthoCamera:new() end


---@public 初始化相机,并分别设置视景体左平面、右平面、上平面、下平面、近平面、远平面到相机的距离。
---正交投影的视椎体是一个长方体或立方体，拥有六个平面。
---@param fLeft number 正交投影时，视椎体左平面到相机的距离。
---@param fRight number 正交投影时，视椎体右平面到相机的距离。
---@param fBottom number 正交投影时，视椎体下平面到相机的距离。
---@param fTop number 正交投影时，视椎体上平面到相机的距离。
---@param fZNear number 正交投影时，视椎体近平面到相机的距离。
---@param fZFar number 正交投影时，视椎体远平面到相机的距离。
---@return boolean 是否初始化成功.
function XOrthoCamera:Init(fLeft, fRight, fBottom, fTop, fZNear, fZFar) end


---@public 释放资源
---@return void
function XOrthoCamera:Release() end


---@public 判断当前相机是否是透视投影相机
---@return boolean 如果是，返回xtrue,否则,返回xfalse.
function XOrthoCamera:IsPerspective() end


---@public 判断当前相机是否是正交投影相机
---@return boolean 如果是，返回xtrue,否则,返回xfalse.
function XOrthoCamera:IsOrthogonal() end


---@public 设置当前相机的参数信息
---@param fLeft number 视椎体左平面到相机的距离。
---@param fRight number 视椎体右平面到相机的距离。
---@param fBottom number 视椎体下平面到相机的距离。
---@param fTop number 视椎体上平面到相机的距离。
---@param fZNear number 视椎体近平面到相机的距离。
---@param fZFar number 视椎体远平面到相机的距离。
---@return boolean 是否设置成功
function XOrthoCamera:SetProjectionParam(fLeft, fRight, fBottom, fTop, fZNear, fZFar) end


---@public 获取当前相机视椎体左平面到相机的距离
---@return number 视椎体左平面到相机的距离
function XOrthoCamera:GetLeft() end


---@public 获取当前相机视椎体右平面到相机的距离
---@return number 视椎体右平面到相机的距离
function XOrthoCamera:GetRight() end


---@public 获取当前相机视椎体上平面到相机的距离
---@return number 视椎体上平面到相机的距离
function XOrthoCamera:GetTop() end


---@public 获取当前相机视椎体下平面到相机的距离
---@return number 视椎体下平面到相机的距离
function XOrthoCamera:GetBottom() end


---@public XOrthoCamera_new01
---@return XOrthoCamera
function XOrthoCamera:new() end


---@public XOrthoCamera_Init01
---@param fLeft number
---@param fRight number
---@param fBottom number
---@param fTop number
---@param fZNear number
---@param fZFar number
---@return boolean
function XOrthoCamera:Init(fLeft, fRight, fBottom, fTop, fZNear, fZFar) end


---@public XOrthoCamera_Release01
---@return void
function XOrthoCamera:Release() end


---@public XOrthoCamera_IsPerspective01
---@return boolean
function XOrthoCamera:IsPerspective() end


---@public XOrthoCamera_IsOrthogonal01
---@return boolean
function XOrthoCamera:IsOrthogonal() end


---@public XOrthoCamera_SetProjectionParam01
---@param fLeft number
---@param fRight number
---@param fBottom number
---@param fTop number
---@param fZNear number
---@param fZFar number
---@return boolean
function XOrthoCamera:SetProjectionParam(fLeft, fRight, fBottom, fTop, fZNear, fZFar) end


---@public XOrthoCamera_GetLeft01
---@return number
function XOrthoCamera:GetLeft() end


---@public XOrthoCamera_GetRight01
---@return number
function XOrthoCamera:GetRight() end


---@public XOrthoCamera_GetTop01
---@return number
function XOrthoCamera:GetTop() end


---@public XOrthoCamera_GetBottom01
---@return number
function XOrthoCamera:GetBottom() end


