---@class IXSkinUpatedListener
IXSkinUpatedListener = {}


---@public IXSkinUpatedListener_Update00
---@param pUpdatedSkin XSkin
---@return void
function IXSkinUpatedListener:Update(pUpdatedSkin) end


---@class XSkin
XSkin = {}


---@class XSkin__XMeshInfo
local XSkin__XMeshInfo = {}
XSkin.XMeshInfo = XSkin__XMeshInfo


---@type string
XSkin__XMeshInfo.strName = ''


---@type number
XSkin__XMeshInfo.nRawMeshIndex = 0


---@type IXMaterialInstance
XSkin__XMeshInfo.pMaterialIns = {}


---@type boolean
XSkin__XMeshInfo.bCloth = false


---@type string
XSkin__XMeshInfo.strClothName = ''


---@type string 用于自动匹配，模型导出时设置，之后不修改
XSkin__XMeshInfo.strClothMaterialName = ''


---@public XSkin_XMeshInfo_new00
---@return XSkin__XMeshInfo
function XSkin__XMeshInfo:new() end


---@public 释放资源
---@return void
function XSkin:Release() end


---@public 获取SkinDatXFile
---@return string SkinDatXFile名
function XSkin:GetSkinDatXFile() end


---@public 根据RenderMesh名称获取对应的RawMesh索引
---@param szMeshName string Mesh名称
---@param nLODIndex number 指定LOD索引,默认为0
---@return number 获取到的对应的RawMesh索引
function XSkin:GetRenderMeshRawIndex(szMeshName, nLODIndex) end


---@public 获取当前Skin对应的骨架文件名称
---@return string 当前Skin对应的骨架文件名称
function XSkin:GetSkeletonFile() end


---@public 获取对应的文件名称
---@return string 对应的文件名称
function XSkin:GetSkinFile() end


---@public 获取当前Skin所有LOD数目
---@return number 当前Skin所有LOD数目
function XSkin:GetLODNum() end


---@public 获取当前Skin指定LOD索引对应的所有RawMesh数目
---@param nLODIndex number 指定LOD索引,默认为0
---@return number 当前Skin所有RawMesh数目
function XSkin:GetRawMeshNum(nLODIndex) end


---@public 根据RawMesh索引和LOD索引获取对应的RawMesh名称
---@param nRawMeshIndex number 指定RawMesh索引
---@param nLODIndex number 指定LOD索引,默认为0
---@return string 对应的RawMesh名称
function XSkin:GetRawMeshName(nRawMeshIndex, nLODIndex) end


---@public 根据Mesh名称和LOD索引获取对应的RawMesh材质实例
---@param szMeshName string Mesh名称
---@param nLODIndex number 指定LOD索引,默认为0
---@return  IXMaterialInstance 对应的RawMesh材质实例
function XSkin:GetRawMeshMtlIns(szMeshName, nLODIndex) end


---@public 根据Mesh名称和LOD索引获取对应的RawMesh材质实例
---@param szMeshName string Mesh名称
---@param nLODIndex number 指定LOD索引,默认为0
---@return IXMaterialInstance 对应的RawMesh材质实例
function XSkin:GetRawMeshMtlIns(szMeshName, nLODIndex) end


---@public 获取当前Skin指定LOD索引对应的所有RenderMesh数目
---@param nLODIndex number 指定LOD索引,默认为0
---@return number 指定LOD索引对应的所有RenderMesh数目
function XSkin:GetRenderMeshNum(nLODIndex) end


---@public 根据RenderMesh索引和LOD索引获取对应的RenderMesh名称
---@param nRenderMeshIndex number
---@param nLODIndex number 指定LOD索引,默认为0
---@return string 对应的RenderMesh名称
function XSkin:GetRenderMeshName(nRenderMeshIndex, nLODIndex) end


---@public 获取当前Skin对应的SkinData
---@return  XSkinData 当前Skin对应的SkinData
function XSkin:GetSkinData() end


---@public 获取当前Skin对应的SkinData
---@return XSkinData 当前Skin对应的SkinData
function XSkin:GetSkinData() end


---@public 设置当前Skin对应的SkinData
---@param szSkinDatXFile string SkinData资源文件
---@return void
function XSkin:SetSkinData(szSkinDatXFile) end


---@public 判断当前Skin是否有morph信息
---@return boolean 有的话，返回xtrue
function XSkin:HasBlendShapeTargets() end


---@public 判断当前Skin是否有morph信息
---@return number 有的话，返回xtrue
function XSkin:GetBlendShapeTargetNum() end


---@public 判断指定RenderMesh是否有morph信息
---@param nRenderMeshIndex number 指定的RenderMesh索引
---@return boolean 有的话，返回xtrue
function XSkin:HasBlendShapeTarget(nRenderMeshIndex) end


---@public 设置当前Skin对应的骨架文件名
---@param szSkeletonFile string Skin对应的骨架文件名
---@return void
function XSkin:SetSkeletonFile(szSkeletonFile) end


---@public 保存当前Skin信息
---@param bRecursive boolean 是否递归遍历数据
---@return void
function XSkin:Save(bRecursive) end


---@public 添加当前Skin更新的监听者
---@param pListener IXSkinUpatedListener 要添加的监听者指针
---@return void
function XSkin:AddSkinUpdatedListener(pListener) end


---@public 移除当前Skin的某个监听者
---@param pListener IXSkinUpatedListener 要移除的监听者指针
---@return void
function XSkin:RemoveSkinUpdatedListener(pListener) end


---@public 获取指定RawMesh名称和指定LOD索引对应的RenderMesh起始索引
---@param szRawMeshName string RawMesh名称
---@param nLODIndex number 指定的LOD索引，默认为0.
---@return number 获取到的RenderMesh起始索引
function XSkin:GetCorrespondingRenderMeshStartIndex(szRawMeshName, nLODIndex) end


---@public 获取指定RawMesh名称和指定LOD索引的RenderMesh个数
---@param szRawMeshName string RawMesh名称
---@param nLODIndex number 指定的LOD索引，默认为0.
---@return number 获取到的RenderMesh个数
function XSkin:GetCorrespondingRenderMeshNum(szRawMeshName, nLODIndex) end


---@public 获取当前Skin对应的总的三角面个数
---@return number 总的三角面个数
function XSkin:GetFaceNum() end


---@public 判断某个Mesh是否是布料Mesh
---@param szMeshName string Mesh名称
---@return boolean 是否是布料Mesh
function XSkin:IsCloth(szMeshName) end


---@public 获取某个Mesh对应的布料名称
---@param szMeshName string Mesh名称
---@return string 对应的布料名称
function XSkin:GetClothName(szMeshName) end


---@public 设置某个Mesh对应的布料名称
---@param szMeshName string Mesh名称
---@param szClothName string 布料名称
---@return void
function XSkin:SetClothName(szMeshName, szClothName) end


---@public 获取某个Mesh对应的布料材质名称
---@param szMeshName string Mesh名称
---@return string 对应的布料材质名称
function XSkin:GetClothMaterialName(szMeshName) end


