---@class XSkinData
XSkinData = {}


---@type number @enum XMeshType
XSkinData.XMT_STATIC_MESH = 0


---@type number @enum XMeshType
XSkinData.XMT_SKIN_MESH = 0


---@type number @enum XMeshType
XSkinData.XMT_NUM = 0


---@class XSkinData__BoneNameAndOBB
local XSkinData__BoneNameAndOBB = {}
XSkinData.BoneNameAndOBB = XSkinData__BoneNameAndOBB


---@type string
XSkinData__BoneNameAndOBB.strBoneName = ''


---@type XCusOBB
XSkinData__BoneNameAndOBB.boneOBB = {}


---@class XSkinData__XRawMesh
local XSkinData__XRawMesh = {}
XSkinData.XRawMesh = XSkinData__XRawMesh


---@type number
XSkinData__XRawMesh.nStartVertex = 0


---@type number
XSkinData__XRawMesh.nVertices = 0


---@class XSkinData__IndexPairAndNormal
local XSkinData__IndexPairAndNormal = {}
XSkinData.IndexPairAndNormal = XSkinData__IndexPairAndNormal


---@type number
XSkinData__IndexPairAndNormal.vertexIndex = 0


---@type number
XSkinData__IndexPairAndNormal.uniqueIndex = 0


---@type XVECTOR4
XSkinData__IndexPairAndNormal.normal = {}


---@public 释放当前SkinData中的资源等
---@return void
function XSkinData:Release() end


---@public 获取所有LOD个数
---@return number [类型][xint32]所有LOD个数
function XSkinData:GetLODNum() end


---@public 根据Mesh名称获取对应的RawMesh
---@param szMeshName string
---@param nLODIndex number
---@return  XSkinData__XRawMesh XRawMesh]获取到的RawMesh指针
function XSkinData:GetRawMesh(szMeshName, nLODIndex) end


---@public 根据Mesh名称获取对应的RawMesh
---@param szMeshName string
---@param nLODIndex number
---@return XSkinData__XRawMesh
function XSkinData:GetRawMesh(szMeshName, nLODIndex) end


---@public 获取版本号
---@return number [类型][xint32]版本号
function XSkinData:GetVersion() end


---@public 获取指定LOD对应的所有RenderMesh个数
---@param nLODIndex number
---@return number
function XSkinData:GetRenderMeshNum(nLODIndex) end


---@public 获取指定LOD对应的所有RawMesh个数
---@param nLODIndex number
---@return number
function XSkinData:GetRawMeshNum(nLODIndex) end


---@public 获取指定LOD索引的初始化AABB信息
---@param nLODIndex number
---@return  XCusAABB
function XSkinData:GetInitAABB(nLODIndex) end


---@public 获取当前SkinData对应文件名称
---@return string [类型][constxchar]对应的文件名称
function XSkinData:GetFileName() end


---@public 以2进制方式存储当前skindata信息
---@return void
function XSkinData:SaveBinary() end


---@public 初始化顶点buffer和顶点索引buffer
---@param eMeshType number
---@param nVBSize number
---@param nIBSize number
---@param nLODIndex number
---@return void
function XSkinData:InitVBAndIB(eMeshType, nVBSize, nIBSize, nLODIndex) end


---@public 获取指定LOD的所有骨头名称和OBB信息
---@param nLODIndex number [类型][xint32]指定LOD索引，默认为0
---@return BoneNameAndOBB[] [类型][constXArray<BoneNameAndOBB>]获取到的指定LOD的所有骨头名称和OBB信息数组
function XSkinData:GetBoneNamesAndOBBs(nLODIndex) end


---@public 重新计算Skindata，以及RendeMesh的AABB
---@return void
function XSkinData:UpdateInitAABB() end


