---@class XSys
XSys = {}


---@public XSys_IsFileExist00
---@param szFileName string
---@return boolean
function XSys:IsFileExist(szFileName) end


---@public XSys_DeleteFile00
---@param szFile string
---@return boolean
function XSys:DeleteFile(szFile) end


---@public XSys_CopyFile00
---@param src string
---@param des string
---@param bFailIfExists boolean
---@return boolean
function XSys:CopyFile(src, des, bFailIfExists) end


---@public XSys_MoveFile00
---@param src string
---@param des string
---@return boolean
function XSys:MoveFile(src, des) end


---@public 删除目录及其内部的所有文件
---@param szDir string [类型][constchar]目录
---@return boolean [类型][bool]是否删除成功
function XSys:DeleteDirectory(szDir) end


---@public 创建目录，不会递归创建
---@param szDir string [类型][constchar]目录
---@return boolean [类型][bool]是否成功
function XSys:CreateDirectory(szDir) end


---@public 遍历目录, 输入文件夹结尾没有斜杠，返回的文件名中不包含路径
---@param szDir string
---@return string[]
---@return boolean
function XSys:GetFilesInDirectory(szDir) end


---@public 遍历目录, 输出其中的文件夹名称, 输入文件夹结尾没有斜杠，返回的文件夹中不包含路径，不包含.和..
---@param szDir string
---@return string[]
---@return boolean
function XSys:GetDirectoriesInDirectory(szDir) end


---@public 获取工作目录的绝对路径
---@param szBaseDir string [类型][char]目录
---@return boolean [类型][bool]是否成功
function XSys:GetBaseDirectory(szBaseDir) end


---@public 获取可以写入文档的目录，ios 上并不是所有目录下都能写文件的
---@param szDocumentDir string [类型][char]目录
---@return boolean [类型][bool]是否成功
function XSys:GetDocumentsDirectory(szDocumentDir) end


---@public 获取文件改动的时间戳
---@param szFileName string
---@return number [类型][xuint32]时间戳
function XSys:GetFileTimeStamp(szFileName) end


---@public XSys_GetFileSize00
---@param szFileName string
---@return number
function XSys:GetFileSize(szFileName) end


---@public XSys_ChangeFileAttributes00
---@param szFileName string
---@param mode number
---@return number
function XSys:ChangeFileAttributes(szFileName, mode) end


---@public XSys_GetVersion00
---@return string
---@return boolean
function XSys:GetVersion() end


---@public XSys_GetMilliSecond00
---@return number
function XSys:GetMilliSecond() end


---@public XSys_GetMicroSecond00
---@return number
function XSys:GetMicroSecond() end


---@public XSys_GetTimeSince197000
---@return number
function XSys:GetTimeSince1970() end


---@public 让当前线程睡眠
---@param nMilliSecond number
---@return void
function XSys:Sleep(nMilliSecond) end


---@public 输出信息到调试窗口
---@param szDebugInfo string
---@return void
function XSys:OutputDebug(szDebugInfo) end


---@public XSys_MessageBox00
---@param pTextKey string
---@param pOptionKey string
---@param uType number
---@param timeout number
---@return number
function XSys:MessageBox(pTextKey, pOptionKey, uType, timeout) end


---@public XSys_MessageBox_CText00
---@param pTextKey string
---@param pOptionKey string
---@param uType number
---@param timeout number
---@return number
function XSys:MessageBox_CText(pTextKey, pOptionKey, uType, timeout) end


---@public XSys_CopyDataToPasteboard00
---@param pData string
---@return boolean
function XSys:CopyDataToPasteboard(pData) end


---@public XSys_GetPastebordData00
---@return string
---@return boolean
function XSys:GetPastebordData() end


---@public XSys_IsUnicodeSpace00
---@param ch number
---@return boolean
function XSys:IsUnicodeSpace(ch) end


---@public XSys_IsCJKUnicode00
---@param ch number
---@return boolean
function XSys:IsCJKUnicode(ch) end


---@public XSys_IsUnicodeNonBreaking00
---@param ch number
---@return boolean
function XSys:IsUnicodeNonBreaking(ch) end


---@public XSys_ParseUnicodeFromUTF8Str00
---@param szUTF8 string
---@param pnAdvancedInUtf8Str number
---@param nUtf8StrMaxLen number
---@return number
function XSys:ParseUnicodeFromUTF8Str(szUTF8, pnAdvancedInUtf8Str, nUtf8StrMaxLen) end


---@public XSys_ParseUnicodeFromUTF8StrEx00
---@param szUTF8 string
---@param iParsePos number
---@param piParsedHeadPos number
---@param pnUtf8ByteCounts number
---@param nUtf8StrMaxLen number
---@return number
function XSys:ParseUnicodeFromUTF8StrEx(szUTF8, iParsePos, piParsedHeadPos, pnUtf8ByteCounts, nUtf8StrMaxLen) end


---@public XSys_UTF16Len00
---@param sz16 number
---@return number
function XSys:UTF16Len(sz16) end


---@public XSys_UTF8ToUTF16LE00
---@param sz16 number
---@param sz8 string
---@return number
function XSys:UTF8ToUTF16LE(sz16, sz8) end


---@public XSys_UTF16LEToUTF800
---@param sz8 string
---@param sz16 number
---@return number
function XSys:UTF16LEToUTF8(sz8, sz16) end


---@public XSys_CPPTextToGB231200
---@param szDest string
---@param szSrc string
---@param iSrcLen number
---@param nDestBufferMaxSize number
---@return number
function XSys:CPPTextToGB2312(szDest, szSrc, iSrcLen, nDestBufferMaxSize) end


---@public XSys_GB2312ToCPPText00
---@param szDest string
---@param szSrc string
---@param iSrcLen number
---@param nDestBufferMaxSize number
---@return number
function XSys:GB2312ToCPPText(szDest, szSrc, iSrcLen, nDestBufferMaxSize) end


---@public XSys_GB2312ToUTF800
---@param szDest string
---@param szSrc string
---@param iSrcLen number
---@param nDestBufferMaxSize number
---@return number
function XSys:GB2312ToUTF8(szDest, szSrc, iSrcLen, nDestBufferMaxSize) end


---@public XSys_UTF8ToGB231200
---@param szDest string
---@param szSrc string
---@param iSrcLen number
---@param nDestBufferMaxSize number
---@return number
function XSys:UTF8ToGB2312(szDest, szSrc, iSrcLen, nDestBufferMaxSize) end


---@public XSys_GB2132ToFileNameEncoding00
---@param szDest string
---@param szSrc string
---@param nDestBufferMaxSize number
---@return number
function XSys:GB2132ToFileNameEncoding(szDest, szSrc, nDestBufferMaxSize) end


---@public XSys_UTF8TOUTF3200
---@param szDest number
---@param szSrc string
---@param iSrcLen number
---@param nDestBufferMaxSize number
---@return number
function XSys:UTF8TOUTF32(szDest, szSrc, iSrcLen, nDestBufferMaxSize) end


---@public XSys_AccessFile00
---@param path string
---@param mode number
---@return number
function XSys:AccessFile(path, mode) end


---@public XSys_SetFileSize00
---@param fd number
---@param size number
---@return number
function XSys:SetFileSize(fd, size) end


---@public XSys_XtoInt6400
---@param szString string
---@return number
function XSys:XtoInt64(szString) end


---@public XSys_StrCmpNoCase00
---@param sz1 string
---@param sz2 string
---@return number
function XSys:StrCmpNoCase(sz1, sz2) end


---@public XSys_Strlwr00
---@param str string
---@return string
function XSys:Strlwr(str) end


---@public XSys_Strupr00
---@param str string
---@return string
function XSys:Strupr(str) end


---@public XSys_IsNan00
---@param f number
---@return boolean
function XSys:IsNan(f) end


