---矩形区域
---@class XUIRect
XUIRect = {}


---@type XVECTOR2 起始点
XUIRect.origin = {}


---@type XVECTOR2 矩形宽高
XUIRect.size = {}


---@public XUIRect_new00
---@return XUIRect
function XUIRect:new() end


---@public XUIRect_new01
---@param x number
---@param y number
---@param width number
---@param height number
---@return XUIRect
function XUIRect:new(x, y, width, height) end


---@public XUIRect_new02
---@param pos XVECTOR2
---@param dimension XVECTOR2
---@return XUIRect
function XUIRect:new(pos, dimension) end


---@public XUIRect_new03
---@param other  XUIRect
---@return XUIRect
function XUIRect:new(other) end


---@public 设置矩形的x,y,矩形的宽度和高度
---@param x number
---@param y number
---@param width number
---@param height number
---@return void
function XUIRect:SetRect(x, y, width, height) end


---@public 得到矩形最小的X
---@return number
function XUIRect:GetMinX() end


---@public 中心点的X坐标
---@return number
function XUIRect:GetMidX() end


---@public 得到矩形最大的X
---@return number
function XUIRect:GetMaxX() end


---@public 得到矩形最小的Y
---@return number
function XUIRect:GetMinY() end


---@public 中心点的Y坐标
---@return number
function XUIRect:GetMidY() end


---@public 得到矩形最大的Y
---@return number
function XUIRect:GetMaxY() end


---@public 判断给定rect和当前rect是否相等
---@param rect  XUIRect 给定的rect
---@return boolean 是否相等
function XUIRect:Equals(rect) end


---@public 判断给定的点是否在当前矩形内部
---@param point XVECTOR2 给定的点坐标
---@return boolean 是否在内部
function XUIRect:ContainsPoint(point) end


---@public 判断给定的矩形和当前矩形是否相交
---@param rect  XUIRect 给定的矩形
---@return boolean 是否相交
function XUIRect:IntersectsRect(rect) end


---@public 计算一个最小矩形,其可以包含this和参数rect矩形,将其分配给自己
---@param rect  XUIRect 另一个要包含的矩形
---@return void
function XUIRect:Merge(rect) end


---@type  XUIRect @readonly 零矩形
XUIRect.ZERO = {}


